use pokerust::*;

mod common;

fn test_full_list<T: Endpoint>(json: &str) {
    let _m = common::make_mock(
        &format!("/api/v2/{}/?offset=0&limit=9999", T::ENDPOINT),
        json,
    );
    T::full_list().unwrap();
}

// https://pokeapi.co/api/v2/ability/?offset=0&limit=9999
static FULL_ABILITY_LIST_JSON: &str = r#"{"count":293,"next":null,"previous":null,"results":[{"name":"stench","url":"https://pokeapi.co/api/v2/ability/1/"},{"name":"drizzle","url":"https://pokeapi.co/api/v2/ability/2/"},{"name":"speed-boost","url":"https://pokeapi.co/api/v2/ability/3/"},{"name":"battle-armor","url":"https://pokeapi.co/api/v2/ability/4/"},{"name":"sturdy","url":"https://pokeapi.co/api/v2/ability/5/"},{"name":"damp","url":"https://pokeapi.co/api/v2/ability/6/"},{"name":"limber","url":"https://pokeapi.co/api/v2/ability/7/"},{"name":"sand-veil","url":"https://pokeapi.co/api/v2/ability/8/"},{"name":"static","url":"https://pokeapi.co/api/v2/ability/9/"},{"name":"volt-absorb","url":"https://pokeapi.co/api/v2/ability/10/"},{"name":"water-absorb","url":"https://pokeapi.co/api/v2/ability/11/"},{"name":"oblivious","url":"https://pokeapi.co/api/v2/ability/12/"},{"name":"cloud-nine","url":"https://pokeapi.co/api/v2/ability/13/"},{"name":"compound-eyes","url":"https://pokeapi.co/api/v2/ability/14/"},{"name":"insomnia","url":"https://pokeapi.co/api/v2/ability/15/"},{"name":"color-change","url":"https://pokeapi.co/api/v2/ability/16/"},{"name":"immunity","url":"https://pokeapi.co/api/v2/ability/17/"},{"name":"flash-fire","url":"https://pokeapi.co/api/v2/ability/18/"},{"name":"shield-dust","url":"https://pokeapi.co/api/v2/ability/19/"},{"name":"own-tempo","url":"https://pokeapi.co/api/v2/ability/20/"},{"name":"suction-cups","url":"https://pokeapi.co/api/v2/ability/21/"},{"name":"intimidate","url":"https://pokeapi.co/api/v2/ability/22/"},{"name":"shadow-tag","url":"https://pokeapi.co/api/v2/ability/23/"},{"name":"rough-skin","url":"https://pokeapi.co/api/v2/ability/24/"},{"name":"wonder-guard","url":"https://pokeapi.co/api/v2/ability/25/"},{"name":"levitate","url":"https://pokeapi.co/api/v2/ability/26/"},{"name":"effect-spore","url":"https://pokeapi.co/api/v2/ability/27/"},{"name":"synchronize","url":"https://pokeapi.co/api/v2/ability/28/"},{"name":"clear-body","url":"https://pokeapi.co/api/v2/ability/29/"},{"name":"natural-cure","url":"https://pokeapi.co/api/v2/ability/30/"},{"name":"lightning-rod","url":"https://pokeapi.co/api/v2/ability/31/"},{"name":"serene-grace","url":"https://pokeapi.co/api/v2/ability/32/"},{"name":"swift-swim","url":"https://pokeapi.co/api/v2/ability/33/"},{"name":"chlorophyll","url":"https://pokeapi.co/api/v2/ability/34/"},{"name":"illuminate","url":"https://pokeapi.co/api/v2/ability/35/"},{"name":"trace","url":"https://pokeapi.co/api/v2/ability/36/"},{"name":"huge-power","url":"https://pokeapi.co/api/v2/ability/37/"},{"name":"poison-point","url":"https://pokeapi.co/api/v2/ability/38/"},{"name":"inner-focus","url":"https://pokeapi.co/api/v2/ability/39/"},{"name":"magma-armor","url":"https://pokeapi.co/api/v2/ability/40/"},{"name":"water-veil","url":"https://pokeapi.co/api/v2/ability/41/"},{"name":"magnet-pull","url":"https://pokeapi.co/api/v2/ability/42/"},{"name":"soundproof","url":"https://pokeapi.co/api/v2/ability/43/"},{"name":"rain-dish","url":"https://pokeapi.co/api/v2/ability/44/"},{"name":"sand-stream","url":"https://pokeapi.co/api/v2/ability/45/"},{"name":"pressure","url":"https://pokeapi.co/api/v2/ability/46/"},{"name":"thick-fat","url":"https://pokeapi.co/api/v2/ability/47/"},{"name":"early-bird","url":"https://pokeapi.co/api/v2/ability/48/"},{"name":"flame-body","url":"https://pokeapi.co/api/v2/ability/49/"},{"name":"run-away","url":"https://pokeapi.co/api/v2/ability/50/"},{"name":"keen-eye","url":"https://pokeapi.co/api/v2/ability/51/"},{"name":"hyper-cutter","url":"https://pokeapi.co/api/v2/ability/52/"},{"name":"pickup","url":"https://pokeapi.co/api/v2/ability/53/"},{"name":"truant","url":"https://pokeapi.co/api/v2/ability/54/"},{"name":"hustle","url":"https://pokeapi.co/api/v2/ability/55/"},{"name":"cute-charm","url":"https://pokeapi.co/api/v2/ability/56/"},{"name":"plus","url":"https://pokeapi.co/api/v2/ability/57/"},{"name":"minus","url":"https://pokeapi.co/api/v2/ability/58/"},{"name":"forecast","url":"https://pokeapi.co/api/v2/ability/59/"},{"name":"sticky-hold","url":"https://pokeapi.co/api/v2/ability/60/"},{"name":"shed-skin","url":"https://pokeapi.co/api/v2/ability/61/"},{"name":"guts","url":"https://pokeapi.co/api/v2/ability/62/"},{"name":"marvel-scale","url":"https://pokeapi.co/api/v2/ability/63/"},{"name":"liquid-ooze","url":"https://pokeapi.co/api/v2/ability/64/"},{"name":"overgrow","url":"https://pokeapi.co/api/v2/ability/65/"},{"name":"blaze","url":"https://pokeapi.co/api/v2/ability/66/"},{"name":"torrent","url":"https://pokeapi.co/api/v2/ability/67/"},{"name":"swarm","url":"https://pokeapi.co/api/v2/ability/68/"},{"name":"rock-head","url":"https://pokeapi.co/api/v2/ability/69/"},{"name":"drought","url":"https://pokeapi.co/api/v2/ability/70/"},{"name":"arena-trap","url":"https://pokeapi.co/api/v2/ability/71/"},{"name":"vital-spirit","url":"https://pokeapi.co/api/v2/ability/72/"},{"name":"white-smoke","url":"https://pokeapi.co/api/v2/ability/73/"},{"name":"pure-power","url":"https://pokeapi.co/api/v2/ability/74/"},{"name":"shell-armor","url":"https://pokeapi.co/api/v2/ability/75/"},{"name":"air-lock","url":"https://pokeapi.co/api/v2/ability/76/"},{"name":"tangled-feet","url":"https://pokeapi.co/api/v2/ability/77/"},{"name":"motor-drive","url":"https://pokeapi.co/api/v2/ability/78/"},{"name":"rivalry","url":"https://pokeapi.co/api/v2/ability/79/"},{"name":"steadfast","url":"https://pokeapi.co/api/v2/ability/80/"},{"name":"snow-cloak","url":"https://pokeapi.co/api/v2/ability/81/"},{"name":"gluttony","url":"https://pokeapi.co/api/v2/ability/82/"},{"name":"anger-point","url":"https://pokeapi.co/api/v2/ability/83/"},{"name":"unburden","url":"https://pokeapi.co/api/v2/ability/84/"},{"name":"heatproof","url":"https://pokeapi.co/api/v2/ability/85/"},{"name":"simple","url":"https://pokeapi.co/api/v2/ability/86/"},{"name":"dry-skin","url":"https://pokeapi.co/api/v2/ability/87/"},{"name":"download","url":"https://pokeapi.co/api/v2/ability/88/"},{"name":"iron-fist","url":"https://pokeapi.co/api/v2/ability/89/"},{"name":"poison-heal","url":"https://pokeapi.co/api/v2/ability/90/"},{"name":"adaptability","url":"https://pokeapi.co/api/v2/ability/91/"},{"name":"skill-link","url":"https://pokeapi.co/api/v2/ability/92/"},{"name":"hydration","url":"https://pokeapi.co/api/v2/ability/93/"},{"name":"solar-power","url":"https://pokeapi.co/api/v2/ability/94/"},{"name":"quick-feet","url":"https://pokeapi.co/api/v2/ability/95/"},{"name":"normalize","url":"https://pokeapi.co/api/v2/ability/96/"},{"name":"sniper","url":"https://pokeapi.co/api/v2/ability/97/"},{"name":"magic-guard","url":"https://pokeapi.co/api/v2/ability/98/"},{"name":"no-guard","url":"https://pokeapi.co/api/v2/ability/99/"},{"name":"stall","url":"https://pokeapi.co/api/v2/ability/100/"},{"name":"technician","url":"https://pokeapi.co/api/v2/ability/101/"},{"name":"leaf-guard","url":"https://pokeapi.co/api/v2/ability/102/"},{"name":"klutz","url":"https://pokeapi.co/api/v2/ability/103/"},{"name":"mold-breaker","url":"https://pokeapi.co/api/v2/ability/104/"},{"name":"super-luck","url":"https://pokeapi.co/api/v2/ability/105/"},{"name":"aftermath","url":"https://pokeapi.co/api/v2/ability/106/"},{"name":"anticipation","url":"https://pokeapi.co/api/v2/ability/107/"},{"name":"forewarn","url":"https://pokeapi.co/api/v2/ability/108/"},{"name":"unaware","url":"https://pokeapi.co/api/v2/ability/109/"},{"name":"tinted-lens","url":"https://pokeapi.co/api/v2/ability/110/"},{"name":"filter","url":"https://pokeapi.co/api/v2/ability/111/"},{"name":"slow-start","url":"https://pokeapi.co/api/v2/ability/112/"},{"name":"scrappy","url":"https://pokeapi.co/api/v2/ability/113/"},{"name":"storm-drain","url":"https://pokeapi.co/api/v2/ability/114/"},{"name":"ice-body","url":"https://pokeapi.co/api/v2/ability/115/"},{"name":"solid-rock","url":"https://pokeapi.co/api/v2/ability/116/"},{"name":"snow-warning","url":"https://pokeapi.co/api/v2/ability/117/"},{"name":"honey-gather","url":"https://pokeapi.co/api/v2/ability/118/"},{"name":"frisk","url":"https://pokeapi.co/api/v2/ability/119/"},{"name":"reckless","url":"https://pokeapi.co/api/v2/ability/120/"},{"name":"multitype","url":"https://pokeapi.co/api/v2/ability/121/"},{"name":"flower-gift","url":"https://pokeapi.co/api/v2/ability/122/"},{"name":"bad-dreams","url":"https://pokeapi.co/api/v2/ability/123/"},{"name":"pickpocket","url":"https://pokeapi.co/api/v2/ability/124/"},{"name":"sheer-force","url":"https://pokeapi.co/api/v2/ability/125/"},{"name":"contrary","url":"https://pokeapi.co/api/v2/ability/126/"},{"name":"unnerve","url":"https://pokeapi.co/api/v2/ability/127/"},{"name":"defiant","url":"https://pokeapi.co/api/v2/ability/128/"},{"name":"defeatist","url":"https://pokeapi.co/api/v2/ability/129/"},{"name":"cursed-body","url":"https://pokeapi.co/api/v2/ability/130/"},{"name":"healer","url":"https://pokeapi.co/api/v2/ability/131/"},{"name":"friend-guard","url":"https://pokeapi.co/api/v2/ability/132/"},{"name":"weak-armor","url":"https://pokeapi.co/api/v2/ability/133/"},{"name":"heavy-metal","url":"https://pokeapi.co/api/v2/ability/134/"},{"name":"light-metal","url":"https://pokeapi.co/api/v2/ability/135/"},{"name":"multiscale","url":"https://pokeapi.co/api/v2/ability/136/"},{"name":"toxic-boost","url":"https://pokeapi.co/api/v2/ability/137/"},{"name":"flare-boost","url":"https://pokeapi.co/api/v2/ability/138/"},{"name":"harvest","url":"https://pokeapi.co/api/v2/ability/139/"},{"name":"telepathy","url":"https://pokeapi.co/api/v2/ability/140/"},{"name":"moody","url":"https://pokeapi.co/api/v2/ability/141/"},{"name":"overcoat","url":"https://pokeapi.co/api/v2/ability/142/"},{"name":"poison-touch","url":"https://pokeapi.co/api/v2/ability/143/"},{"name":"regenerator","url":"https://pokeapi.co/api/v2/ability/144/"},{"name":"big-pecks","url":"https://pokeapi.co/api/v2/ability/145/"},{"name":"sand-rush","url":"https://pokeapi.co/api/v2/ability/146/"},{"name":"wonder-skin","url":"https://pokeapi.co/api/v2/ability/147/"},{"name":"analytic","url":"https://pokeapi.co/api/v2/ability/148/"},{"name":"illusion","url":"https://pokeapi.co/api/v2/ability/149/"},{"name":"imposter","url":"https://pokeapi.co/api/v2/ability/150/"},{"name":"infiltrator","url":"https://pokeapi.co/api/v2/ability/151/"},{"name":"mummy","url":"https://pokeapi.co/api/v2/ability/152/"},{"name":"moxie","url":"https://pokeapi.co/api/v2/ability/153/"},{"name":"justified","url":"https://pokeapi.co/api/v2/ability/154/"},{"name":"rattled","url":"https://pokeapi.co/api/v2/ability/155/"},{"name":"magic-bounce","url":"https://pokeapi.co/api/v2/ability/156/"},{"name":"sap-sipper","url":"https://pokeapi.co/api/v2/ability/157/"},{"name":"prankster","url":"https://pokeapi.co/api/v2/ability/158/"},{"name":"sand-force","url":"https://pokeapi.co/api/v2/ability/159/"},{"name":"iron-barbs","url":"https://pokeapi.co/api/v2/ability/160/"},{"name":"zen-mode","url":"https://pokeapi.co/api/v2/ability/161/"},{"name":"victory-star","url":"https://pokeapi.co/api/v2/ability/162/"},{"name":"turboblaze","url":"https://pokeapi.co/api/v2/ability/163/"},{"name":"teravolt","url":"https://pokeapi.co/api/v2/ability/164/"},{"name":"aroma-veil","url":"https://pokeapi.co/api/v2/ability/165/"},{"name":"flower-veil","url":"https://pokeapi.co/api/v2/ability/166/"},{"name":"cheek-pouch","url":"https://pokeapi.co/api/v2/ability/167/"},{"name":"protean","url":"https://pokeapi.co/api/v2/ability/168/"},{"name":"fur-coat","url":"https://pokeapi.co/api/v2/ability/169/"},{"name":"magician","url":"https://pokeapi.co/api/v2/ability/170/"},{"name":"bulletproof","url":"https://pokeapi.co/api/v2/ability/171/"},{"name":"competitive","url":"https://pokeapi.co/api/v2/ability/172/"},{"name":"strong-jaw","url":"https://pokeapi.co/api/v2/ability/173/"},{"name":"refrigerate","url":"https://pokeapi.co/api/v2/ability/174/"},{"name":"sweet-veil","url":"https://pokeapi.co/api/v2/ability/175/"},{"name":"stance-change","url":"https://pokeapi.co/api/v2/ability/176/"},{"name":"gale-wings","url":"https://pokeapi.co/api/v2/ability/177/"},{"name":"mega-launcher","url":"https://pokeapi.co/api/v2/ability/178/"},{"name":"grass-pelt","url":"https://pokeapi.co/api/v2/ability/179/"},{"name":"symbiosis","url":"https://pokeapi.co/api/v2/ability/180/"},{"name":"tough-claws","url":"https://pokeapi.co/api/v2/ability/181/"},{"name":"pixilate","url":"https://pokeapi.co/api/v2/ability/182/"},{"name":"gooey","url":"https://pokeapi.co/api/v2/ability/183/"},{"name":"aerilate","url":"https://pokeapi.co/api/v2/ability/184/"},{"name":"parental-bond","url":"https://pokeapi.co/api/v2/ability/185/"},{"name":"dark-aura","url":"https://pokeapi.co/api/v2/ability/186/"},{"name":"fairy-aura","url":"https://pokeapi.co/api/v2/ability/187/"},{"name":"aura-break","url":"https://pokeapi.co/api/v2/ability/188/"},{"name":"primordial-sea","url":"https://pokeapi.co/api/v2/ability/189/"},{"name":"desolate-land","url":"https://pokeapi.co/api/v2/ability/190/"},{"name":"delta-stream","url":"https://pokeapi.co/api/v2/ability/191/"},{"name":"stamina","url":"https://pokeapi.co/api/v2/ability/192/"},{"name":"wimp-out","url":"https://pokeapi.co/api/v2/ability/193/"},{"name":"emergency-exit","url":"https://pokeapi.co/api/v2/ability/194/"},{"name":"water-compaction","url":"https://pokeapi.co/api/v2/ability/195/"},{"name":"merciless","url":"https://pokeapi.co/api/v2/ability/196/"},{"name":"shields-down","url":"https://pokeapi.co/api/v2/ability/197/"},{"name":"stakeout","url":"https://pokeapi.co/api/v2/ability/198/"},{"name":"water-bubble","url":"https://pokeapi.co/api/v2/ability/199/"},{"name":"steelworker","url":"https://pokeapi.co/api/v2/ability/200/"},{"name":"berserk","url":"https://pokeapi.co/api/v2/ability/201/"},{"name":"slush-rush","url":"https://pokeapi.co/api/v2/ability/202/"},{"name":"long-reach","url":"https://pokeapi.co/api/v2/ability/203/"},{"name":"liquid-voice","url":"https://pokeapi.co/api/v2/ability/204/"},{"name":"triage","url":"https://pokeapi.co/api/v2/ability/205/"},{"name":"galvanize","url":"https://pokeapi.co/api/v2/ability/206/"},{"name":"surge-surfer","url":"https://pokeapi.co/api/v2/ability/207/"},{"name":"schooling","url":"https://pokeapi.co/api/v2/ability/208/"},{"name":"disguise","url":"https://pokeapi.co/api/v2/ability/209/"},{"name":"battle-bond","url":"https://pokeapi.co/api/v2/ability/210/"},{"name":"power-construct","url":"https://pokeapi.co/api/v2/ability/211/"},{"name":"corrosion","url":"https://pokeapi.co/api/v2/ability/212/"},{"name":"comatose","url":"https://pokeapi.co/api/v2/ability/213/"},{"name":"queenly-majesty","url":"https://pokeapi.co/api/v2/ability/214/"},{"name":"innards-out","url":"https://pokeapi.co/api/v2/ability/215/"},{"name":"dancer","url":"https://pokeapi.co/api/v2/ability/216/"},{"name":"battery","url":"https://pokeapi.co/api/v2/ability/217/"},{"name":"fluffy","url":"https://pokeapi.co/api/v2/ability/218/"},{"name":"dazzling","url":"https://pokeapi.co/api/v2/ability/219/"},{"name":"soul-heart","url":"https://pokeapi.co/api/v2/ability/220/"},{"name":"tangling-hair","url":"https://pokeapi.co/api/v2/ability/221/"},{"name":"receiver","url":"https://pokeapi.co/api/v2/ability/222/"},{"name":"power-of-alchemy","url":"https://pokeapi.co/api/v2/ability/223/"},{"name":"beast-boost","url":"https://pokeapi.co/api/v2/ability/224/"},{"name":"rks-system","url":"https://pokeapi.co/api/v2/ability/225/"},{"name":"electric-surge","url":"https://pokeapi.co/api/v2/ability/226/"},{"name":"psychic-surge","url":"https://pokeapi.co/api/v2/ability/227/"},{"name":"misty-surge","url":"https://pokeapi.co/api/v2/ability/228/"},{"name":"grassy-surge","url":"https://pokeapi.co/api/v2/ability/229/"},{"name":"full-metal-body","url":"https://pokeapi.co/api/v2/ability/230/"},{"name":"shadow-shield","url":"https://pokeapi.co/api/v2/ability/231/"},{"name":"prism-armor","url":"https://pokeapi.co/api/v2/ability/232/"},{"name":"neuroforce","url":"https://pokeapi.co/api/v2/ability/233/"},{"name":"mountaineer","url":"https://pokeapi.co/api/v2/ability/10001/"},{"name":"wave-rider","url":"https://pokeapi.co/api/v2/ability/10002/"},{"name":"skater","url":"https://pokeapi.co/api/v2/ability/10003/"},{"name":"thrust","url":"https://pokeapi.co/api/v2/ability/10004/"},{"name":"perception","url":"https://pokeapi.co/api/v2/ability/10005/"},{"name":"parry","url":"https://pokeapi.co/api/v2/ability/10006/"},{"name":"instinct","url":"https://pokeapi.co/api/v2/ability/10007/"},{"name":"dodge","url":"https://pokeapi.co/api/v2/ability/10008/"},{"name":"jagged-edge","url":"https://pokeapi.co/api/v2/ability/10009/"},{"name":"frostbite","url":"https://pokeapi.co/api/v2/ability/10010/"},{"name":"tenacity","url":"https://pokeapi.co/api/v2/ability/10011/"},{"name":"pride","url":"https://pokeapi.co/api/v2/ability/10012/"},{"name":"deep-sleep","url":"https://pokeapi.co/api/v2/ability/10013/"},{"name":"power-nap","url":"https://pokeapi.co/api/v2/ability/10014/"},{"name":"spirit","url":"https://pokeapi.co/api/v2/ability/10015/"},{"name":"warm-blanket","url":"https://pokeapi.co/api/v2/ability/10016/"},{"name":"gulp","url":"https://pokeapi.co/api/v2/ability/10017/"},{"name":"herbivore","url":"https://pokeapi.co/api/v2/ability/10018/"},{"name":"sandpit","url":"https://pokeapi.co/api/v2/ability/10019/"},{"name":"hot-blooded","url":"https://pokeapi.co/api/v2/ability/10020/"},{"name":"medic","url":"https://pokeapi.co/api/v2/ability/10021/"},{"name":"life-force","url":"https://pokeapi.co/api/v2/ability/10022/"},{"name":"lunchbox","url":"https://pokeapi.co/api/v2/ability/10023/"},{"name":"nurse","url":"https://pokeapi.co/api/v2/ability/10024/"},{"name":"melee","url":"https://pokeapi.co/api/v2/ability/10025/"},{"name":"sponge","url":"https://pokeapi.co/api/v2/ability/10026/"},{"name":"bodyguard","url":"https://pokeapi.co/api/v2/ability/10027/"},{"name":"hero","url":"https://pokeapi.co/api/v2/ability/10028/"},{"name":"last-bastion","url":"https://pokeapi.co/api/v2/ability/10029/"},{"name":"stealth","url":"https://pokeapi.co/api/v2/ability/10030/"},{"name":"vanguard","url":"https://pokeapi.co/api/v2/ability/10031/"},{"name":"nomad","url":"https://pokeapi.co/api/v2/ability/10032/"},{"name":"sequence","url":"https://pokeapi.co/api/v2/ability/10033/"},{"name":"grass-cloak","url":"https://pokeapi.co/api/v2/ability/10034/"},{"name":"celebrate","url":"https://pokeapi.co/api/v2/ability/10035/"},{"name":"lullaby","url":"https://pokeapi.co/api/v2/ability/10036/"},{"name":"calming","url":"https://pokeapi.co/api/v2/ability/10037/"},{"name":"daze","url":"https://pokeapi.co/api/v2/ability/10038/"},{"name":"frighten","url":"https://pokeapi.co/api/v2/ability/10039/"},{"name":"interference","url":"https://pokeapi.co/api/v2/ability/10040/"},{"name":"mood-maker","url":"https://pokeapi.co/api/v2/ability/10041/"},{"name":"confidence","url":"https://pokeapi.co/api/v2/ability/10042/"},{"name":"fortune","url":"https://pokeapi.co/api/v2/ability/10043/"},{"name":"bonanza","url":"https://pokeapi.co/api/v2/ability/10044/"},{"name":"explode","url":"https://pokeapi.co/api/v2/ability/10045/"},{"name":"omnipotent","url":"https://pokeapi.co/api/v2/ability/10046/"},{"name":"share","url":"https://pokeapi.co/api/v2/ability/10047/"},{"name":"black-hole","url":"https://pokeapi.co/api/v2/ability/10048/"},{"name":"shadow-dash","url":"https://pokeapi.co/api/v2/ability/10049/"},{"name":"sprint","url":"https://pokeapi.co/api/v2/ability/10050/"},{"name":"disgust","url":"https://pokeapi.co/api/v2/ability/10051/"},{"name":"high-rise","url":"https://pokeapi.co/api/v2/ability/10052/"},{"name":"climber","url":"https://pokeapi.co/api/v2/ability/10053/"},{"name":"flame-boost","url":"https://pokeapi.co/api/v2/ability/10054/"},{"name":"aqua-boost","url":"https://pokeapi.co/api/v2/ability/10055/"},{"name":"run-up","url":"https://pokeapi.co/api/v2/ability/10056/"},{"name":"conqueror","url":"https://pokeapi.co/api/v2/ability/10057/"},{"name":"shackle","url":"https://pokeapi.co/api/v2/ability/10058/"},{"name":"decoy","url":"https://pokeapi.co/api/v2/ability/10059/"},{"name":"shield","url":"https://pokeapi.co/api/v2/ability/10060/"}]}"#;

// https://pokeapi.co/api/v2/berry/?offset=0&limit=9999
static FULL_BERRY_LIST_JSON: &str = r#"{"count":64,"next":null,"previous":null,"results":[{"name":"cheri","url":"https://pokeapi.co/api/v2/berry/1/"},{"name":"chesto","url":"https://pokeapi.co/api/v2/berry/2/"},{"name":"pecha","url":"https://pokeapi.co/api/v2/berry/3/"},{"name":"rawst","url":"https://pokeapi.co/api/v2/berry/4/"},{"name":"aspear","url":"https://pokeapi.co/api/v2/berry/5/"},{"name":"leppa","url":"https://pokeapi.co/api/v2/berry/6/"},{"name":"oran","url":"https://pokeapi.co/api/v2/berry/7/"},{"name":"persim","url":"https://pokeapi.co/api/v2/berry/8/"},{"name":"lum","url":"https://pokeapi.co/api/v2/berry/9/"},{"name":"sitrus","url":"https://pokeapi.co/api/v2/berry/10/"},{"name":"figy","url":"https://pokeapi.co/api/v2/berry/11/"},{"name":"wiki","url":"https://pokeapi.co/api/v2/berry/12/"},{"name":"mago","url":"https://pokeapi.co/api/v2/berry/13/"},{"name":"aguav","url":"https://pokeapi.co/api/v2/berry/14/"},{"name":"iapapa","url":"https://pokeapi.co/api/v2/berry/15/"},{"name":"razz","url":"https://pokeapi.co/api/v2/berry/16/"},{"name":"bluk","url":"https://pokeapi.co/api/v2/berry/17/"},{"name":"nanab","url":"https://pokeapi.co/api/v2/berry/18/"},{"name":"wepear","url":"https://pokeapi.co/api/v2/berry/19/"},{"name":"pinap","url":"https://pokeapi.co/api/v2/berry/20/"},{"name":"pomeg","url":"https://pokeapi.co/api/v2/berry/21/"},{"name":"kelpsy","url":"https://pokeapi.co/api/v2/berry/22/"},{"name":"qualot","url":"https://pokeapi.co/api/v2/berry/23/"},{"name":"hondew","url":"https://pokeapi.co/api/v2/berry/24/"},{"name":"grepa","url":"https://pokeapi.co/api/v2/berry/25/"},{"name":"tamato","url":"https://pokeapi.co/api/v2/berry/26/"},{"name":"cornn","url":"https://pokeapi.co/api/v2/berry/27/"},{"name":"magost","url":"https://pokeapi.co/api/v2/berry/28/"},{"name":"rabuta","url":"https://pokeapi.co/api/v2/berry/29/"},{"name":"nomel","url":"https://pokeapi.co/api/v2/berry/30/"},{"name":"spelon","url":"https://pokeapi.co/api/v2/berry/31/"},{"name":"pamtre","url":"https://pokeapi.co/api/v2/berry/32/"},{"name":"watmel","url":"https://pokeapi.co/api/v2/berry/33/"},{"name":"durin","url":"https://pokeapi.co/api/v2/berry/34/"},{"name":"belue","url":"https://pokeapi.co/api/v2/berry/35/"},{"name":"occa","url":"https://pokeapi.co/api/v2/berry/36/"},{"name":"passho","url":"https://pokeapi.co/api/v2/berry/37/"},{"name":"wacan","url":"https://pokeapi.co/api/v2/berry/38/"},{"name":"rindo","url":"https://pokeapi.co/api/v2/berry/39/"},{"name":"yache","url":"https://pokeapi.co/api/v2/berry/40/"},{"name":"chople","url":"https://pokeapi.co/api/v2/berry/41/"},{"name":"kebia","url":"https://pokeapi.co/api/v2/berry/42/"},{"name":"shuca","url":"https://pokeapi.co/api/v2/berry/43/"},{"name":"coba","url":"https://pokeapi.co/api/v2/berry/44/"},{"name":"payapa","url":"https://pokeapi.co/api/v2/berry/45/"},{"name":"tanga","url":"https://pokeapi.co/api/v2/berry/46/"},{"name":"charti","url":"https://pokeapi.co/api/v2/berry/47/"},{"name":"kasib","url":"https://pokeapi.co/api/v2/berry/48/"},{"name":"haban","url":"https://pokeapi.co/api/v2/berry/49/"},{"name":"colbur","url":"https://pokeapi.co/api/v2/berry/50/"},{"name":"babiri","url":"https://pokeapi.co/api/v2/berry/51/"},{"name":"chilan","url":"https://pokeapi.co/api/v2/berry/52/"},{"name":"liechi","url":"https://pokeapi.co/api/v2/berry/53/"},{"name":"ganlon","url":"https://pokeapi.co/api/v2/berry/54/"},{"name":"salac","url":"https://pokeapi.co/api/v2/berry/55/"},{"name":"petaya","url":"https://pokeapi.co/api/v2/berry/56/"},{"name":"apicot","url":"https://pokeapi.co/api/v2/berry/57/"},{"name":"lansat","url":"https://pokeapi.co/api/v2/berry/58/"},{"name":"starf","url":"https://pokeapi.co/api/v2/berry/59/"},{"name":"enigma","url":"https://pokeapi.co/api/v2/berry/60/"},{"name":"micle","url":"https://pokeapi.co/api/v2/berry/61/"},{"name":"custap","url":"https://pokeapi.co/api/v2/berry/62/"},{"name":"jaboca","url":"https://pokeapi.co/api/v2/berry/63/"},{"name":"rowap","url":"https://pokeapi.co/api/v2/berry/64/"}]}"#;

// https://pokeapi.co/api/v2/berry-firmness/?offset=0&limit=9999
static FULL_BERRY_FIRMNESS_LIST_JSON: &str = r#"{"count":5,"next":null,"previous":null,"results":[{"name":"very-soft","url":"https://pokeapi.co/api/v2/berry-firmness/1/"},{"name":"soft","url":"https://pokeapi.co/api/v2/berry-firmness/2/"},{"name":"hard","url":"https://pokeapi.co/api/v2/berry-firmness/3/"},{"name":"very-hard","url":"https://pokeapi.co/api/v2/berry-firmness/4/"},{"name":"super-hard","url":"https://pokeapi.co/api/v2/berry-firmness/5/"}]}"#;

// https://pokeapi.co/api/v2/berry-flavor/?offset=0&limit=9999
static FULL_BERRY_FLAVOR_LIST_JSON: &str = r#"{"count":5,"next":null,"previous":null,"results":[{"name":"spicy","url":"https://pokeapi.co/api/v2/berry-flavor/1/"},{"name":"dry","url":"https://pokeapi.co/api/v2/berry-flavor/2/"},{"name":"sweet","url":"https://pokeapi.co/api/v2/berry-flavor/3/"},{"name":"bitter","url":"https://pokeapi.co/api/v2/berry-flavor/4/"},{"name":"sour","url":"https://pokeapi.co/api/v2/berry-flavor/5/"}]}"#;

// https://pokeapi.co/api/v2/characteristic/?offset=0&limit=9999
static FULL_CHARACTERISTIC_LIST_JSON: &str = r#"{"count":30,"next":null,"previous":null,"results":[{"url":"https://pokeapi.co/api/v2/characteristic/1/"},{"url":"https://pokeapi.co/api/v2/characteristic/2/"},{"url":"https://pokeapi.co/api/v2/characteristic/3/"},{"url":"https://pokeapi.co/api/v2/characteristic/4/"},{"url":"https://pokeapi.co/api/v2/characteristic/5/"},{"url":"https://pokeapi.co/api/v2/characteristic/6/"},{"url":"https://pokeapi.co/api/v2/characteristic/7/"},{"url":"https://pokeapi.co/api/v2/characteristic/8/"},{"url":"https://pokeapi.co/api/v2/characteristic/9/"},{"url":"https://pokeapi.co/api/v2/characteristic/10/"},{"url":"https://pokeapi.co/api/v2/characteristic/11/"},{"url":"https://pokeapi.co/api/v2/characteristic/12/"},{"url":"https://pokeapi.co/api/v2/characteristic/13/"},{"url":"https://pokeapi.co/api/v2/characteristic/14/"},{"url":"https://pokeapi.co/api/v2/characteristic/15/"},{"url":"https://pokeapi.co/api/v2/characteristic/16/"},{"url":"https://pokeapi.co/api/v2/characteristic/17/"},{"url":"https://pokeapi.co/api/v2/characteristic/18/"},{"url":"https://pokeapi.co/api/v2/characteristic/19/"},{"url":"https://pokeapi.co/api/v2/characteristic/20/"},{"url":"https://pokeapi.co/api/v2/characteristic/21/"},{"url":"https://pokeapi.co/api/v2/characteristic/22/"},{"url":"https://pokeapi.co/api/v2/characteristic/23/"},{"url":"https://pokeapi.co/api/v2/characteristic/24/"},{"url":"https://pokeapi.co/api/v2/characteristic/25/"},{"url":"https://pokeapi.co/api/v2/characteristic/26/"},{"url":"https://pokeapi.co/api/v2/characteristic/27/"},{"url":"https://pokeapi.co/api/v2/characteristic/28/"},{"url":"https://pokeapi.co/api/v2/characteristic/29/"},{"url":"https://pokeapi.co/api/v2/characteristic/30/"}]}"#;

// https://pokeapi.co/api/v2/contest-effect/?offset=0&limit=9999
static FULL_CONTEST_EFFECT_LIST_JSON: &str = r#"{"count":33,"next":null,"previous":null,"results":[{"url":"https://pokeapi.co/api/v2/contest-effect/1/"},{"url":"https://pokeapi.co/api/v2/contest-effect/2/"},{"url":"https://pokeapi.co/api/v2/contest-effect/3/"},{"url":"https://pokeapi.co/api/v2/contest-effect/4/"},{"url":"https://pokeapi.co/api/v2/contest-effect/5/"},{"url":"https://pokeapi.co/api/v2/contest-effect/6/"},{"url":"https://pokeapi.co/api/v2/contest-effect/7/"},{"url":"https://pokeapi.co/api/v2/contest-effect/8/"},{"url":"https://pokeapi.co/api/v2/contest-effect/9/"},{"url":"https://pokeapi.co/api/v2/contest-effect/10/"},{"url":"https://pokeapi.co/api/v2/contest-effect/11/"},{"url":"https://pokeapi.co/api/v2/contest-effect/12/"},{"url":"https://pokeapi.co/api/v2/contest-effect/13/"},{"url":"https://pokeapi.co/api/v2/contest-effect/14/"},{"url":"https://pokeapi.co/api/v2/contest-effect/15/"},{"url":"https://pokeapi.co/api/v2/contest-effect/16/"},{"url":"https://pokeapi.co/api/v2/contest-effect/17/"},{"url":"https://pokeapi.co/api/v2/contest-effect/18/"},{"url":"https://pokeapi.co/api/v2/contest-effect/19/"},{"url":"https://pokeapi.co/api/v2/contest-effect/20/"},{"url":"https://pokeapi.co/api/v2/contest-effect/21/"},{"url":"https://pokeapi.co/api/v2/contest-effect/22/"},{"url":"https://pokeapi.co/api/v2/contest-effect/23/"},{"url":"https://pokeapi.co/api/v2/contest-effect/24/"},{"url":"https://pokeapi.co/api/v2/contest-effect/25/"},{"url":"https://pokeapi.co/api/v2/contest-effect/26/"},{"url":"https://pokeapi.co/api/v2/contest-effect/27/"},{"url":"https://pokeapi.co/api/v2/contest-effect/28/"},{"url":"https://pokeapi.co/api/v2/contest-effect/29/"},{"url":"https://pokeapi.co/api/v2/contest-effect/30/"},{"url":"https://pokeapi.co/api/v2/contest-effect/31/"},{"url":"https://pokeapi.co/api/v2/contest-effect/32/"},{"url":"https://pokeapi.co/api/v2/contest-effect/33/"}]}"#;

// https://pokeapi.co/api/v2/contest-type/?offset=0&limit=9999
static FULL_CONTEST_TYPE_LIST_JSON: &str = r#"{"count":5,"next":null,"previous":null,"results":[{"name":"cool","url":"https://pokeapi.co/api/v2/contest-type/1/"},{"name":"beauty","url":"https://pokeapi.co/api/v2/contest-type/2/"},{"name":"cute","url":"https://pokeapi.co/api/v2/contest-type/3/"},{"name":"smart","url":"https://pokeapi.co/api/v2/contest-type/4/"},{"name":"tough","url":"https://pokeapi.co/api/v2/contest-type/5/"}]}"#;

// https://pokeapi.co/api/v2/egg-group/?offset=0&limit=9999
static FULL_EGG_GROUP_LIST_JSON: &str = r#"{"count":15,"next":null,"previous":null,"results":[{"name":"monster","url":"https://pokeapi.co/api/v2/egg-group/1/"},{"name":"water1","url":"https://pokeapi.co/api/v2/egg-group/2/"},{"name":"bug","url":"https://pokeapi.co/api/v2/egg-group/3/"},{"name":"flying","url":"https://pokeapi.co/api/v2/egg-group/4/"},{"name":"ground","url":"https://pokeapi.co/api/v2/egg-group/5/"},{"name":"fairy","url":"https://pokeapi.co/api/v2/egg-group/6/"},{"name":"plant","url":"https://pokeapi.co/api/v2/egg-group/7/"},{"name":"humanshape","url":"https://pokeapi.co/api/v2/egg-group/8/"},{"name":"water3","url":"https://pokeapi.co/api/v2/egg-group/9/"},{"name":"mineral","url":"https://pokeapi.co/api/v2/egg-group/10/"},{"name":"indeterminate","url":"https://pokeapi.co/api/v2/egg-group/11/"},{"name":"water2","url":"https://pokeapi.co/api/v2/egg-group/12/"},{"name":"ditto","url":"https://pokeapi.co/api/v2/egg-group/13/"},{"name":"dragon","url":"https://pokeapi.co/api/v2/egg-group/14/"},{"name":"no-eggs","url":"https://pokeapi.co/api/v2/egg-group/15/"}]}"#;

// https://pokeapi.co/api/v2/encounter-condition/?offset=0&limit=9999
static FULL_ENCOUNTER_CONDITION_LIST_JSON: &str = r#"{"count":6,"next":null,"previous":null,"results":[{"name":"swarm","url":"https://pokeapi.co/api/v2/encounter-condition/1/"},{"name":"time","url":"https://pokeapi.co/api/v2/encounter-condition/2/"},{"name":"radar","url":"https://pokeapi.co/api/v2/encounter-condition/3/"},{"name":"slot2","url":"https://pokeapi.co/api/v2/encounter-condition/4/"},{"name":"radio","url":"https://pokeapi.co/api/v2/encounter-condition/5/"},{"name":"season","url":"https://pokeapi.co/api/v2/encounter-condition/6/"}]}"#;

// https://pokeapi.co/api/v2/encounter-condition-value/?offset=0&limit=9999
static FULL_ENCOUNTER_CONDITION_VALUE_LIST_JSON: &str = r#"{"count":20,"next":null,"previous":null,"results":[{"name":"swarm-yes","url":"https://pokeapi.co/api/v2/encounter-condition-value/1/"},{"name":"swarm-no","url":"https://pokeapi.co/api/v2/encounter-condition-value/2/"},{"name":"time-morning","url":"https://pokeapi.co/api/v2/encounter-condition-value/3/"},{"name":"time-day","url":"https://pokeapi.co/api/v2/encounter-condition-value/4/"},{"name":"time-night","url":"https://pokeapi.co/api/v2/encounter-condition-value/5/"},{"name":"radar-on","url":"https://pokeapi.co/api/v2/encounter-condition-value/6/"},{"name":"radar-off","url":"https://pokeapi.co/api/v2/encounter-condition-value/7/"},{"name":"slot2-none","url":"https://pokeapi.co/api/v2/encounter-condition-value/8/"},{"name":"slot2-ruby","url":"https://pokeapi.co/api/v2/encounter-condition-value/9/"},{"name":"slot2-sapphire","url":"https://pokeapi.co/api/v2/encounter-condition-value/10/"},{"name":"slot2-emerald","url":"https://pokeapi.co/api/v2/encounter-condition-value/11/"},{"name":"slot2-firered","url":"https://pokeapi.co/api/v2/encounter-condition-value/12/"},{"name":"slot2-leafgreen","url":"https://pokeapi.co/api/v2/encounter-condition-value/13/"},{"name":"radio-off","url":"https://pokeapi.co/api/v2/encounter-condition-value/14/"},{"name":"radio-hoenn","url":"https://pokeapi.co/api/v2/encounter-condition-value/15/"},{"name":"radio-sinnoh","url":"https://pokeapi.co/api/v2/encounter-condition-value/16/"},{"name":"season-spring","url":"https://pokeapi.co/api/v2/encounter-condition-value/17/"},{"name":"season-summer","url":"https://pokeapi.co/api/v2/encounter-condition-value/18/"},{"name":"season-autumn","url":"https://pokeapi.co/api/v2/encounter-condition-value/19/"},{"name":"season-winter","url":"https://pokeapi.co/api/v2/encounter-condition-value/20/"}]}"#;

// https://pokeapi.co/api/v2/encounter-method/?offset=0&limit=9999
static FULL_ENCOUNTER_METHOD_LIST_JSON: &str = r#"{"count":17,"next":null,"previous":null,"results":[{"name":"walk","url":"https://pokeapi.co/api/v2/encounter-method/1/"},{"name":"old-rod","url":"https://pokeapi.co/api/v2/encounter-method/2/"},{"name":"good-rod","url":"https://pokeapi.co/api/v2/encounter-method/3/"},{"name":"super-rod","url":"https://pokeapi.co/api/v2/encounter-method/4/"},{"name":"surf","url":"https://pokeapi.co/api/v2/encounter-method/5/"},{"name":"rock-smash","url":"https://pokeapi.co/api/v2/encounter-method/6/"},{"name":"headbutt","url":"https://pokeapi.co/api/v2/encounter-method/7/"},{"name":"dark-grass","url":"https://pokeapi.co/api/v2/encounter-method/8/"},{"name":"grass-spots","url":"https://pokeapi.co/api/v2/encounter-method/9/"},{"name":"cave-spots","url":"https://pokeapi.co/api/v2/encounter-method/10/"},{"name":"bridge-spots","url":"https://pokeapi.co/api/v2/encounter-method/11/"},{"name":"super-rod-spots","url":"https://pokeapi.co/api/v2/encounter-method/12/"},{"name":"surf-spots","url":"https://pokeapi.co/api/v2/encounter-method/13/"},{"name":"yellow-flowers","url":"https://pokeapi.co/api/v2/encounter-method/14/"},{"name":"purple-flowers","url":"https://pokeapi.co/api/v2/encounter-method/15/"},{"name":"red-flowers","url":"https://pokeapi.co/api/v2/encounter-method/16/"},{"name":"rough-terrain","url":"https://pokeapi.co/api/v2/encounter-method/17/"}]}"#;

// https://pokeapi.co/api/v2/evolution-chain/?offset=0&limit=9999
static FULL_EVOLUTION_CHAIN_LIST_JSON: &str = r#"{"count":419,"next":null,"previous":null,"results":[{"url":"https://pokeapi.co/api/v2/evolution-chain/1/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/2/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/3/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/4/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/5/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/6/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/7/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/8/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/9/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/10/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/11/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/12/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/13/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/14/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/15/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/16/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/17/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/18/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/19/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/20/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/21/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/22/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/23/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/24/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/25/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/26/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/27/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/28/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/29/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/30/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/31/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/32/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/33/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/34/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/35/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/36/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/37/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/38/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/39/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/40/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/41/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/42/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/43/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/44/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/45/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/46/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/47/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/48/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/49/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/50/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/51/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/52/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/53/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/54/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/55/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/56/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/57/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/58/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/59/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/60/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/61/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/62/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/63/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/64/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/65/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/66/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/67/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/68/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/69/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/70/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/71/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/72/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/73/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/74/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/75/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/76/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/77/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/78/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/79/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/80/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/81/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/82/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/83/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/84/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/85/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/86/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/87/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/88/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/89/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/90/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/91/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/92/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/93/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/94/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/95/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/96/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/97/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/98/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/99/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/100/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/101/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/102/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/103/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/104/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/105/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/106/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/107/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/108/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/109/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/110/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/111/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/112/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/113/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/114/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/115/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/116/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/117/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/118/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/119/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/120/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/121/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/122/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/123/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/124/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/125/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/126/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/127/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/128/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/129/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/130/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/131/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/132/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/133/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/134/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/135/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/136/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/137/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/138/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/139/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/140/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/141/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/142/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/143/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/144/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/145/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/146/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/147/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/148/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/149/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/150/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/151/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/152/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/153/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/154/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/155/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/156/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/157/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/158/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/159/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/160/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/161/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/162/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/163/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/164/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/165/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/166/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/167/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/168/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/169/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/170/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/171/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/172/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/173/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/174/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/175/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/176/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/177/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/178/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/179/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/180/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/181/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/182/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/183/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/184/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/185/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/186/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/187/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/188/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/189/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/190/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/191/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/192/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/193/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/194/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/195/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/196/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/197/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/198/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/199/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/200/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/201/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/202/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/203/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/204/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/205/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/206/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/207/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/208/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/209/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/211/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/212/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/213/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/214/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/215/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/216/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/217/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/218/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/219/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/220/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/221/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/223/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/224/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/228/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/229/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/230/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/232/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/233/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/234/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/235/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/236/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/237/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/239/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/240/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/241/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/242/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/243/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/244/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/245/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/246/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/247/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/248/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/249/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/250/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/252/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/253/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/254/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/255/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/256/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/257/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/258/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/259/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/260/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/261/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/262/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/263/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/264/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/265/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/266/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/267/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/268/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/269/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/270/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/271/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/272/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/273/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/274/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/275/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/276/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/277/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/278/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/279/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/280/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/281/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/282/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/283/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/284/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/285/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/286/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/287/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/288/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/289/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/290/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/291/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/292/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/293/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/294/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/295/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/296/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/297/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/298/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/299/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/300/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/301/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/302/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/303/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/304/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/305/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/306/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/307/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/308/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/309/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/310/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/311/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/312/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/313/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/314/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/315/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/316/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/317/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/318/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/319/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/320/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/321/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/322/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/323/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/324/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/325/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/326/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/327/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/328/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/329/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/330/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/331/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/332/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/333/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/334/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/335/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/336/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/337/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/338/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/339/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/340/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/341/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/342/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/343/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/344/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/345/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/346/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/347/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/348/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/349/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/350/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/351/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/352/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/353/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/354/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/355/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/356/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/357/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/358/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/359/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/360/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/361/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/362/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/363/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/364/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/365/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/366/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/367/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/368/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/369/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/370/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/371/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/372/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/373/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/374/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/375/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/376/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/377/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/378/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/379/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/380/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/381/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/382/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/383/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/384/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/385/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/386/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/387/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/388/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/389/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/390/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/391/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/392/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/393/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/394/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/395/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/396/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/397/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/398/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/399/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/400/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/401/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/402/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/403/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/404/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/405/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/406/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/407/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/408/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/409/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/410/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/411/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/412/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/413/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/414/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/415/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/416/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/417/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/418/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/419/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/420/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/421/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/422/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/423/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/424/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/425/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/426/"},{"url":"https://pokeapi.co/api/v2/evolution-chain/427/"}]}"#;

// https://pokeapi.co/api/v2/evolution-trigger/?offset=0&limit=9999
static FULL_EVOLUTION_TRIGGER_LIST_JSON: &str = r#"{"count":4,"next":null,"previous":null,"results":[{"name":"level-up","url":"https://pokeapi.co/api/v2/evolution-trigger/1/"},{"name":"trade","url":"https://pokeapi.co/api/v2/evolution-trigger/2/"},{"name":"use-item","url":"https://pokeapi.co/api/v2/evolution-trigger/3/"},{"name":"shed","url":"https://pokeapi.co/api/v2/evolution-trigger/4/"}]}"#;

// https://pokeapi.co/api/v2/gender/?offset=0&limit=9999
static FULL_GENDER_LIST_JSON: &str = r#"{"count":3,"next":null,"previous":null,"results":[{"name":"female","url":"https://pokeapi.co/api/v2/gender/1/"},{"name":"male","url":"https://pokeapi.co/api/v2/gender/2/"},{"name":"genderless","url":"https://pokeapi.co/api/v2/gender/3/"}]}"#;

// https://pokeapi.co/api/v2/generation/?offset=0&limit=9999
static FULL_GENERATION_LIST_JSON: &str = r#"{"count":7,"next":null,"previous":null,"results":[{"name":"generation-i","url":"https://pokeapi.co/api/v2/generation/1/"},{"name":"generation-ii","url":"https://pokeapi.co/api/v2/generation/2/"},{"name":"generation-iii","url":"https://pokeapi.co/api/v2/generation/3/"},{"name":"generation-iv","url":"https://pokeapi.co/api/v2/generation/4/"},{"name":"generation-v","url":"https://pokeapi.co/api/v2/generation/5/"},{"name":"generation-vi","url":"https://pokeapi.co/api/v2/generation/6/"},{"name":"generation-vii","url":"https://pokeapi.co/api/v2/generation/7/"}]}"#;

// https://pokeapi.co/api/v2/growth-rate/?offset=0&limit=9999
static FULL_GROWTH_RATE_LIST_JSON: &str = r#"{"count":6,"next":null,"previous":null,"results":[{"name":"slow","url":"https://pokeapi.co/api/v2/growth-rate/1/"},{"name":"medium","url":"https://pokeapi.co/api/v2/growth-rate/2/"},{"name":"fast","url":"https://pokeapi.co/api/v2/growth-rate/3/"},{"name":"medium-slow","url":"https://pokeapi.co/api/v2/growth-rate/4/"},{"name":"slow-then-very-fast","url":"https://pokeapi.co/api/v2/growth-rate/5/"},{"name":"fast-then-very-slow","url":"https://pokeapi.co/api/v2/growth-rate/6/"}]}"#;

// https://pokeapi.co/api/v2/item/?offset=0&limit=9999
static FULL_ITEM_LIST_JSON: &str = r#"{"count":954,"next":null,"previous":null,"results":[{"name":"master-ball","url":"https://pokeapi.co/api/v2/item/1/"},{"name":"ultra-ball","url":"https://pokeapi.co/api/v2/item/2/"},{"name":"great-ball","url":"https://pokeapi.co/api/v2/item/3/"},{"name":"poke-ball","url":"https://pokeapi.co/api/v2/item/4/"},{"name":"safari-ball","url":"https://pokeapi.co/api/v2/item/5/"},{"name":"net-ball","url":"https://pokeapi.co/api/v2/item/6/"},{"name":"dive-ball","url":"https://pokeapi.co/api/v2/item/7/"},{"name":"nest-ball","url":"https://pokeapi.co/api/v2/item/8/"},{"name":"repeat-ball","url":"https://pokeapi.co/api/v2/item/9/"},{"name":"timer-ball","url":"https://pokeapi.co/api/v2/item/10/"},{"name":"luxury-ball","url":"https://pokeapi.co/api/v2/item/11/"},{"name":"premier-ball","url":"https://pokeapi.co/api/v2/item/12/"},{"name":"dusk-ball","url":"https://pokeapi.co/api/v2/item/13/"},{"name":"heal-ball","url":"https://pokeapi.co/api/v2/item/14/"},{"name":"quick-ball","url":"https://pokeapi.co/api/v2/item/15/"},{"name":"cherish-ball","url":"https://pokeapi.co/api/v2/item/16/"},{"name":"potion","url":"https://pokeapi.co/api/v2/item/17/"},{"name":"antidote","url":"https://pokeapi.co/api/v2/item/18/"},{"name":"burn-heal","url":"https://pokeapi.co/api/v2/item/19/"},{"name":"ice-heal","url":"https://pokeapi.co/api/v2/item/20/"},{"name":"awakening","url":"https://pokeapi.co/api/v2/item/21/"},{"name":"paralyze-heal","url":"https://pokeapi.co/api/v2/item/22/"},{"name":"full-restore","url":"https://pokeapi.co/api/v2/item/23/"},{"name":"max-potion","url":"https://pokeapi.co/api/v2/item/24/"},{"name":"hyper-potion","url":"https://pokeapi.co/api/v2/item/25/"},{"name":"super-potion","url":"https://pokeapi.co/api/v2/item/26/"},{"name":"full-heal","url":"https://pokeapi.co/api/v2/item/27/"},{"name":"revive","url":"https://pokeapi.co/api/v2/item/28/"},{"name":"max-revive","url":"https://pokeapi.co/api/v2/item/29/"},{"name":"fresh-water","url":"https://pokeapi.co/api/v2/item/30/"},{"name":"soda-pop","url":"https://pokeapi.co/api/v2/item/31/"},{"name":"lemonade","url":"https://pokeapi.co/api/v2/item/32/"},{"name":"moomoo-milk","url":"https://pokeapi.co/api/v2/item/33/"},{"name":"energy-powder","url":"https://pokeapi.co/api/v2/item/34/"},{"name":"energy-root","url":"https://pokeapi.co/api/v2/item/35/"},{"name":"heal-powder","url":"https://pokeapi.co/api/v2/item/36/"},{"name":"revival-herb","url":"https://pokeapi.co/api/v2/item/37/"},{"name":"ether","url":"https://pokeapi.co/api/v2/item/38/"},{"name":"max-ether","url":"https://pokeapi.co/api/v2/item/39/"},{"name":"elixir","url":"https://pokeapi.co/api/v2/item/40/"},{"name":"max-elixir","url":"https://pokeapi.co/api/v2/item/41/"},{"name":"lava-cookie","url":"https://pokeapi.co/api/v2/item/42/"},{"name":"berry-juice","url":"https://pokeapi.co/api/v2/item/43/"},{"name":"sacred-ash","url":"https://pokeapi.co/api/v2/item/44/"},{"name":"hp-up","url":"https://pokeapi.co/api/v2/item/45/"},{"name":"protein","url":"https://pokeapi.co/api/v2/item/46/"},{"name":"iron","url":"https://pokeapi.co/api/v2/item/47/"},{"name":"carbos","url":"https://pokeapi.co/api/v2/item/48/"},{"name":"calcium","url":"https://pokeapi.co/api/v2/item/49/"},{"name":"rare-candy","url":"https://pokeapi.co/api/v2/item/50/"},{"name":"pp-up","url":"https://pokeapi.co/api/v2/item/51/"},{"name":"zinc","url":"https://pokeapi.co/api/v2/item/52/"},{"name":"pp-max","url":"https://pokeapi.co/api/v2/item/53/"},{"name":"old-gateau","url":"https://pokeapi.co/api/v2/item/54/"},{"name":"guard-spec","url":"https://pokeapi.co/api/v2/item/55/"},{"name":"dire-hit","url":"https://pokeapi.co/api/v2/item/56/"},{"name":"x-attack","url":"https://pokeapi.co/api/v2/item/57/"},{"name":"x-defense","url":"https://pokeapi.co/api/v2/item/58/"},{"name":"x-speed","url":"https://pokeapi.co/api/v2/item/59/"},{"name":"x-accuracy","url":"https://pokeapi.co/api/v2/item/60/"},{"name":"x-sp-atk","url":"https://pokeapi.co/api/v2/item/61/"},{"name":"x-sp-def","url":"https://pokeapi.co/api/v2/item/62/"},{"name":"poke-doll","url":"https://pokeapi.co/api/v2/item/63/"},{"name":"fluffy-tail","url":"https://pokeapi.co/api/v2/item/64/"},{"name":"blue-flute","url":"https://pokeapi.co/api/v2/item/65/"},{"name":"yellow-flute","url":"https://pokeapi.co/api/v2/item/66/"},{"name":"red-flute","url":"https://pokeapi.co/api/v2/item/67/"},{"name":"black-flute","url":"https://pokeapi.co/api/v2/item/68/"},{"name":"white-flute","url":"https://pokeapi.co/api/v2/item/69/"},{"name":"shoal-salt","url":"https://pokeapi.co/api/v2/item/70/"},{"name":"shoal-shell","url":"https://pokeapi.co/api/v2/item/71/"},{"name":"red-shard","url":"https://pokeapi.co/api/v2/item/72/"},{"name":"blue-shard","url":"https://pokeapi.co/api/v2/item/73/"},{"name":"yellow-shard","url":"https://pokeapi.co/api/v2/item/74/"},{"name":"green-shard","url":"https://pokeapi.co/api/v2/item/75/"},{"name":"super-repel","url":"https://pokeapi.co/api/v2/item/76/"},{"name":"max-repel","url":"https://pokeapi.co/api/v2/item/77/"},{"name":"escape-rope","url":"https://pokeapi.co/api/v2/item/78/"},{"name":"repel","url":"https://pokeapi.co/api/v2/item/79/"},{"name":"sun-stone","url":"https://pokeapi.co/api/v2/item/80/"},{"name":"moon-stone","url":"https://pokeapi.co/api/v2/item/81/"},{"name":"fire-stone","url":"https://pokeapi.co/api/v2/item/82/"},{"name":"thunder-stone","url":"https://pokeapi.co/api/v2/item/83/"},{"name":"water-stone","url":"https://pokeapi.co/api/v2/item/84/"},{"name":"leaf-stone","url":"https://pokeapi.co/api/v2/item/85/"},{"name":"tiny-mushroom","url":"https://pokeapi.co/api/v2/item/86/"},{"name":"big-mushroom","url":"https://pokeapi.co/api/v2/item/87/"},{"name":"pearl","url":"https://pokeapi.co/api/v2/item/88/"},{"name":"big-pearl","url":"https://pokeapi.co/api/v2/item/89/"},{"name":"stardust","url":"https://pokeapi.co/api/v2/item/90/"},{"name":"star-piece","url":"https://pokeapi.co/api/v2/item/91/"},{"name":"nugget","url":"https://pokeapi.co/api/v2/item/92/"},{"name":"heart-scale","url":"https://pokeapi.co/api/v2/item/93/"},{"name":"honey","url":"https://pokeapi.co/api/v2/item/94/"},{"name":"growth-mulch","url":"https://pokeapi.co/api/v2/item/95/"},{"name":"damp-mulch","url":"https://pokeapi.co/api/v2/item/96/"},{"name":"stable-mulch","url":"https://pokeapi.co/api/v2/item/97/"},{"name":"gooey-mulch","url":"https://pokeapi.co/api/v2/item/98/"},{"name":"root-fossil","url":"https://pokeapi.co/api/v2/item/99/"},{"name":"claw-fossil","url":"https://pokeapi.co/api/v2/item/100/"},{"name":"helix-fossil","url":"https://pokeapi.co/api/v2/item/101/"},{"name":"dome-fossil","url":"https://pokeapi.co/api/v2/item/102/"},{"name":"old-amber","url":"https://pokeapi.co/api/v2/item/103/"},{"name":"armor-fossil","url":"https://pokeapi.co/api/v2/item/104/"},{"name":"skull-fossil","url":"https://pokeapi.co/api/v2/item/105/"},{"name":"rare-bone","url":"https://pokeapi.co/api/v2/item/106/"},{"name":"shiny-stone","url":"https://pokeapi.co/api/v2/item/107/"},{"name":"dusk-stone","url":"https://pokeapi.co/api/v2/item/108/"},{"name":"dawn-stone","url":"https://pokeapi.co/api/v2/item/109/"},{"name":"oval-stone","url":"https://pokeapi.co/api/v2/item/110/"},{"name":"odd-keystone","url":"https://pokeapi.co/api/v2/item/111/"},{"name":"adamant-orb","url":"https://pokeapi.co/api/v2/item/112/"},{"name":"lustrous-orb","url":"https://pokeapi.co/api/v2/item/113/"},{"name":"grass-mail","url":"https://pokeapi.co/api/v2/item/114/"},{"name":"flame-mail","url":"https://pokeapi.co/api/v2/item/115/"},{"name":"bubble-mail","url":"https://pokeapi.co/api/v2/item/116/"},{"name":"bloom-mail","url":"https://pokeapi.co/api/v2/item/117/"},{"name":"tunnel-mail","url":"https://pokeapi.co/api/v2/item/118/"},{"name":"steel-mail","url":"https://pokeapi.co/api/v2/item/119/"},{"name":"heart-mail","url":"https://pokeapi.co/api/v2/item/120/"},{"name":"snow-mail","url":"https://pokeapi.co/api/v2/item/121/"},{"name":"space-mail","url":"https://pokeapi.co/api/v2/item/122/"},{"name":"air-mail","url":"https://pokeapi.co/api/v2/item/123/"},{"name":"mosaic-mail","url":"https://pokeapi.co/api/v2/item/124/"},{"name":"brick-mail","url":"https://pokeapi.co/api/v2/item/125/"},{"name":"cheri-berry","url":"https://pokeapi.co/api/v2/item/126/"},{"name":"chesto-berry","url":"https://pokeapi.co/api/v2/item/127/"},{"name":"pecha-berry","url":"https://pokeapi.co/api/v2/item/128/"},{"name":"rawst-berry","url":"https://pokeapi.co/api/v2/item/129/"},{"name":"aspear-berry","url":"https://pokeapi.co/api/v2/item/130/"},{"name":"leppa-berry","url":"https://pokeapi.co/api/v2/item/131/"},{"name":"oran-berry","url":"https://pokeapi.co/api/v2/item/132/"},{"name":"persim-berry","url":"https://pokeapi.co/api/v2/item/133/"},{"name":"lum-berry","url":"https://pokeapi.co/api/v2/item/134/"},{"name":"sitrus-berry","url":"https://pokeapi.co/api/v2/item/135/"},{"name":"figy-berry","url":"https://pokeapi.co/api/v2/item/136/"},{"name":"wiki-berry","url":"https://pokeapi.co/api/v2/item/137/"},{"name":"mago-berry","url":"https://pokeapi.co/api/v2/item/138/"},{"name":"aguav-berry","url":"https://pokeapi.co/api/v2/item/139/"},{"name":"iapapa-berry","url":"https://pokeapi.co/api/v2/item/140/"},{"name":"razz-berry","url":"https://pokeapi.co/api/v2/item/141/"},{"name":"bluk-berry","url":"https://pokeapi.co/api/v2/item/142/"},{"name":"nanab-berry","url":"https://pokeapi.co/api/v2/item/143/"},{"name":"wepear-berry","url":"https://pokeapi.co/api/v2/item/144/"},{"name":"pinap-berry","url":"https://pokeapi.co/api/v2/item/145/"},{"name":"pomeg-berry","url":"https://pokeapi.co/api/v2/item/146/"},{"name":"kelpsy-berry","url":"https://pokeapi.co/api/v2/item/147/"},{"name":"qualot-berry","url":"https://pokeapi.co/api/v2/item/148/"},{"name":"hondew-berry","url":"https://pokeapi.co/api/v2/item/149/"},{"name":"grepa-berry","url":"https://pokeapi.co/api/v2/item/150/"},{"name":"tamato-berry","url":"https://pokeapi.co/api/v2/item/151/"},{"name":"cornn-berry","url":"https://pokeapi.co/api/v2/item/152/"},{"name":"magost-berry","url":"https://pokeapi.co/api/v2/item/153/"},{"name":"rabuta-berry","url":"https://pokeapi.co/api/v2/item/154/"},{"name":"nomel-berry","url":"https://pokeapi.co/api/v2/item/155/"},{"name":"spelon-berry","url":"https://pokeapi.co/api/v2/item/156/"},{"name":"pamtre-berry","url":"https://pokeapi.co/api/v2/item/157/"},{"name":"watmel-berry","url":"https://pokeapi.co/api/v2/item/158/"},{"name":"durin-berry","url":"https://pokeapi.co/api/v2/item/159/"},{"name":"belue-berry","url":"https://pokeapi.co/api/v2/item/160/"},{"name":"occa-berry","url":"https://pokeapi.co/api/v2/item/161/"},{"name":"passho-berry","url":"https://pokeapi.co/api/v2/item/162/"},{"name":"wacan-berry","url":"https://pokeapi.co/api/v2/item/163/"},{"name":"rindo-berry","url":"https://pokeapi.co/api/v2/item/164/"},{"name":"yache-berry","url":"https://pokeapi.co/api/v2/item/165/"},{"name":"chople-berry","url":"https://pokeapi.co/api/v2/item/166/"},{"name":"kebia-berry","url":"https://pokeapi.co/api/v2/item/167/"},{"name":"shuca-berry","url":"https://pokeapi.co/api/v2/item/168/"},{"name":"coba-berry","url":"https://pokeapi.co/api/v2/item/169/"},{"name":"payapa-berry","url":"https://pokeapi.co/api/v2/item/170/"},{"name":"tanga-berry","url":"https://pokeapi.co/api/v2/item/171/"},{"name":"charti-berry","url":"https://pokeapi.co/api/v2/item/172/"},{"name":"kasib-berry","url":"https://pokeapi.co/api/v2/item/173/"},{"name":"haban-berry","url":"https://pokeapi.co/api/v2/item/174/"},{"name":"colbur-berry","url":"https://pokeapi.co/api/v2/item/175/"},{"name":"babiri-berry","url":"https://pokeapi.co/api/v2/item/176/"},{"name":"chilan-berry","url":"https://pokeapi.co/api/v2/item/177/"},{"name":"liechi-berry","url":"https://pokeapi.co/api/v2/item/178/"},{"name":"ganlon-berry","url":"https://pokeapi.co/api/v2/item/179/"},{"name":"salac-berry","url":"https://pokeapi.co/api/v2/item/180/"},{"name":"petaya-berry","url":"https://pokeapi.co/api/v2/item/181/"},{"name":"apicot-berry","url":"https://pokeapi.co/api/v2/item/182/"},{"name":"lansat-berry","url":"https://pokeapi.co/api/v2/item/183/"},{"name":"starf-berry","url":"https://pokeapi.co/api/v2/item/184/"},{"name":"enigma-berry","url":"https://pokeapi.co/api/v2/item/185/"},{"name":"micle-berry","url":"https://pokeapi.co/api/v2/item/186/"},{"name":"custap-berry","url":"https://pokeapi.co/api/v2/item/187/"},{"name":"jaboca-berry","url":"https://pokeapi.co/api/v2/item/188/"},{"name":"rowap-berry","url":"https://pokeapi.co/api/v2/item/189/"},{"name":"bright-powder","url":"https://pokeapi.co/api/v2/item/190/"},{"name":"white-herb","url":"https://pokeapi.co/api/v2/item/191/"},{"name":"macho-brace","url":"https://pokeapi.co/api/v2/item/192/"},{"name":"exp-share","url":"https://pokeapi.co/api/v2/item/193/"},{"name":"quick-claw","url":"https://pokeapi.co/api/v2/item/194/"},{"name":"soothe-bell","url":"https://pokeapi.co/api/v2/item/195/"},{"name":"mental-herb","url":"https://pokeapi.co/api/v2/item/196/"},{"name":"choice-band","url":"https://pokeapi.co/api/v2/item/197/"},{"name":"kings-rock","url":"https://pokeapi.co/api/v2/item/198/"},{"name":"silver-powder","url":"https://pokeapi.co/api/v2/item/199/"},{"name":"amulet-coin","url":"https://pokeapi.co/api/v2/item/200/"},{"name":"cleanse-tag","url":"https://pokeapi.co/api/v2/item/201/"},{"name":"soul-dew","url":"https://pokeapi.co/api/v2/item/202/"},{"name":"deep-sea-tooth","url":"https://pokeapi.co/api/v2/item/203/"},{"name":"deep-sea-scale","url":"https://pokeapi.co/api/v2/item/204/"},{"name":"smoke-ball","url":"https://pokeapi.co/api/v2/item/205/"},{"name":"everstone","url":"https://pokeapi.co/api/v2/item/206/"},{"name":"focus-band","url":"https://pokeapi.co/api/v2/item/207/"},{"name":"lucky-egg","url":"https://pokeapi.co/api/v2/item/208/"},{"name":"scope-lens","url":"https://pokeapi.co/api/v2/item/209/"},{"name":"metal-coat","url":"https://pokeapi.co/api/v2/item/210/"},{"name":"leftovers","url":"https://pokeapi.co/api/v2/item/211/"},{"name":"dragon-scale","url":"https://pokeapi.co/api/v2/item/212/"},{"name":"light-ball","url":"https://pokeapi.co/api/v2/item/213/"},{"name":"soft-sand","url":"https://pokeapi.co/api/v2/item/214/"},{"name":"hard-stone","url":"https://pokeapi.co/api/v2/item/215/"},{"name":"miracle-seed","url":"https://pokeapi.co/api/v2/item/216/"},{"name":"black-glasses","url":"https://pokeapi.co/api/v2/item/217/"},{"name":"black-belt","url":"https://pokeapi.co/api/v2/item/218/"},{"name":"magnet","url":"https://pokeapi.co/api/v2/item/219/"},{"name":"mystic-water","url":"https://pokeapi.co/api/v2/item/220/"},{"name":"sharp-beak","url":"https://pokeapi.co/api/v2/item/221/"},{"name":"poison-barb","url":"https://pokeapi.co/api/v2/item/222/"},{"name":"never-melt-ice","url":"https://pokeapi.co/api/v2/item/223/"},{"name":"spell-tag","url":"https://pokeapi.co/api/v2/item/224/"},{"name":"twisted-spoon","url":"https://pokeapi.co/api/v2/item/225/"},{"name":"charcoal","url":"https://pokeapi.co/api/v2/item/226/"},{"name":"dragon-fang","url":"https://pokeapi.co/api/v2/item/227/"},{"name":"silk-scarf","url":"https://pokeapi.co/api/v2/item/228/"},{"name":"up-grade","url":"https://pokeapi.co/api/v2/item/229/"},{"name":"shell-bell","url":"https://pokeapi.co/api/v2/item/230/"},{"name":"sea-incense","url":"https://pokeapi.co/api/v2/item/231/"},{"name":"lax-incense","url":"https://pokeapi.co/api/v2/item/232/"},{"name":"lucky-punch","url":"https://pokeapi.co/api/v2/item/233/"},{"name":"metal-powder","url":"https://pokeapi.co/api/v2/item/234/"},{"name":"thick-club","url":"https://pokeapi.co/api/v2/item/235/"},{"name":"stick","url":"https://pokeapi.co/api/v2/item/236/"},{"name":"red-scarf","url":"https://pokeapi.co/api/v2/item/237/"},{"name":"blue-scarf","url":"https://pokeapi.co/api/v2/item/238/"},{"name":"pink-scarf","url":"https://pokeapi.co/api/v2/item/239/"},{"name":"green-scarf","url":"https://pokeapi.co/api/v2/item/240/"},{"name":"yellow-scarf","url":"https://pokeapi.co/api/v2/item/241/"},{"name":"wide-lens","url":"https://pokeapi.co/api/v2/item/242/"},{"name":"muscle-band","url":"https://pokeapi.co/api/v2/item/243/"},{"name":"wise-glasses","url":"https://pokeapi.co/api/v2/item/244/"},{"name":"expert-belt","url":"https://pokeapi.co/api/v2/item/245/"},{"name":"light-clay","url":"https://pokeapi.co/api/v2/item/246/"},{"name":"life-orb","url":"https://pokeapi.co/api/v2/item/247/"},{"name":"power-herb","url":"https://pokeapi.co/api/v2/item/248/"},{"name":"toxic-orb","url":"https://pokeapi.co/api/v2/item/249/"},{"name":"flame-orb","url":"https://pokeapi.co/api/v2/item/250/"},{"name":"quick-powder","url":"https://pokeapi.co/api/v2/item/251/"},{"name":"focus-sash","url":"https://pokeapi.co/api/v2/item/252/"},{"name":"zoom-lens","url":"https://pokeapi.co/api/v2/item/253/"},{"name":"metronome","url":"https://pokeapi.co/api/v2/item/254/"},{"name":"iron-ball","url":"https://pokeapi.co/api/v2/item/255/"},{"name":"lagging-tail","url":"https://pokeapi.co/api/v2/item/256/"},{"name":"destiny-knot","url":"https://pokeapi.co/api/v2/item/257/"},{"name":"black-sludge","url":"https://pokeapi.co/api/v2/item/258/"},{"name":"icy-rock","url":"https://pokeapi.co/api/v2/item/259/"},{"name":"smooth-rock","url":"https://pokeapi.co/api/v2/item/260/"},{"name":"heat-rock","url":"https://pokeapi.co/api/v2/item/261/"},{"name":"damp-rock","url":"https://pokeapi.co/api/v2/item/262/"},{"name":"grip-claw","url":"https://pokeapi.co/api/v2/item/263/"},{"name":"choice-scarf","url":"https://pokeapi.co/api/v2/item/264/"},{"name":"sticky-barb","url":"https://pokeapi.co/api/v2/item/265/"},{"name":"power-bracer","url":"https://pokeapi.co/api/v2/item/266/"},{"name":"power-belt","url":"https://pokeapi.co/api/v2/item/267/"},{"name":"power-lens","url":"https://pokeapi.co/api/v2/item/268/"},{"name":"power-band","url":"https://pokeapi.co/api/v2/item/269/"},{"name":"power-anklet","url":"https://pokeapi.co/api/v2/item/270/"},{"name":"power-weight","url":"https://pokeapi.co/api/v2/item/271/"},{"name":"shed-shell","url":"https://pokeapi.co/api/v2/item/272/"},{"name":"big-root","url":"https://pokeapi.co/api/v2/item/273/"},{"name":"choice-specs","url":"https://pokeapi.co/api/v2/item/274/"},{"name":"flame-plate","url":"https://pokeapi.co/api/v2/item/275/"},{"name":"splash-plate","url":"https://pokeapi.co/api/v2/item/276/"},{"name":"zap-plate","url":"https://pokeapi.co/api/v2/item/277/"},{"name":"meadow-plate","url":"https://pokeapi.co/api/v2/item/278/"},{"name":"icicle-plate","url":"https://pokeapi.co/api/v2/item/279/"},{"name":"fist-plate","url":"https://pokeapi.co/api/v2/item/280/"},{"name":"toxic-plate","url":"https://pokeapi.co/api/v2/item/281/"},{"name":"earth-plate","url":"https://pokeapi.co/api/v2/item/282/"},{"name":"sky-plate","url":"https://pokeapi.co/api/v2/item/283/"},{"name":"mind-plate","url":"https://pokeapi.co/api/v2/item/284/"},{"name":"insect-plate","url":"https://pokeapi.co/api/v2/item/285/"},{"name":"stone-plate","url":"https://pokeapi.co/api/v2/item/286/"},{"name":"spooky-plate","url":"https://pokeapi.co/api/v2/item/287/"},{"name":"draco-plate","url":"https://pokeapi.co/api/v2/item/288/"},{"name":"dread-plate","url":"https://pokeapi.co/api/v2/item/289/"},{"name":"iron-plate","url":"https://pokeapi.co/api/v2/item/290/"},{"name":"odd-incense","url":"https://pokeapi.co/api/v2/item/291/"},{"name":"rock-incense","url":"https://pokeapi.co/api/v2/item/292/"},{"name":"full-incense","url":"https://pokeapi.co/api/v2/item/293/"},{"name":"wave-incense","url":"https://pokeapi.co/api/v2/item/294/"},{"name":"rose-incense","url":"https://pokeapi.co/api/v2/item/295/"},{"name":"luck-incense","url":"https://pokeapi.co/api/v2/item/296/"},{"name":"pure-incense","url":"https://pokeapi.co/api/v2/item/297/"},{"name":"protector","url":"https://pokeapi.co/api/v2/item/298/"},{"name":"electirizer","url":"https://pokeapi.co/api/v2/item/299/"},{"name":"magmarizer","url":"https://pokeapi.co/api/v2/item/300/"},{"name":"dubious-disc","url":"https://pokeapi.co/api/v2/item/301/"},{"name":"reaper-cloth","url":"https://pokeapi.co/api/v2/item/302/"},{"name":"razor-claw","url":"https://pokeapi.co/api/v2/item/303/"},{"name":"razor-fang","url":"https://pokeapi.co/api/v2/item/304/"},{"name":"tm01","url":"https://pokeapi.co/api/v2/item/305/"},{"name":"tm02","url":"https://pokeapi.co/api/v2/item/306/"},{"name":"tm03","url":"https://pokeapi.co/api/v2/item/307/"},{"name":"tm04","url":"https://pokeapi.co/api/v2/item/308/"},{"name":"tm05","url":"https://pokeapi.co/api/v2/item/309/"},{"name":"tm06","url":"https://pokeapi.co/api/v2/item/310/"},{"name":"tm07","url":"https://pokeapi.co/api/v2/item/311/"},{"name":"tm08","url":"https://pokeapi.co/api/v2/item/312/"},{"name":"tm09","url":"https://pokeapi.co/api/v2/item/313/"},{"name":"tm10","url":"https://pokeapi.co/api/v2/item/314/"},{"name":"tm11","url":"https://pokeapi.co/api/v2/item/315/"},{"name":"tm12","url":"https://pokeapi.co/api/v2/item/316/"},{"name":"tm13","url":"https://pokeapi.co/api/v2/item/317/"},{"name":"tm14","url":"https://pokeapi.co/api/v2/item/318/"},{"name":"tm15","url":"https://pokeapi.co/api/v2/item/319/"},{"name":"tm16","url":"https://pokeapi.co/api/v2/item/320/"},{"name":"tm17","url":"https://pokeapi.co/api/v2/item/321/"},{"name":"tm18","url":"https://pokeapi.co/api/v2/item/322/"},{"name":"tm19","url":"https://pokeapi.co/api/v2/item/323/"},{"name":"tm20","url":"https://pokeapi.co/api/v2/item/324/"},{"name":"tm21","url":"https://pokeapi.co/api/v2/item/325/"},{"name":"tm22","url":"https://pokeapi.co/api/v2/item/326/"},{"name":"tm23","url":"https://pokeapi.co/api/v2/item/327/"},{"name":"tm24","url":"https://pokeapi.co/api/v2/item/328/"},{"name":"tm25","url":"https://pokeapi.co/api/v2/item/329/"},{"name":"tm26","url":"https://pokeapi.co/api/v2/item/330/"},{"name":"tm27","url":"https://pokeapi.co/api/v2/item/331/"},{"name":"tm28","url":"https://pokeapi.co/api/v2/item/332/"},{"name":"tm29","url":"https://pokeapi.co/api/v2/item/333/"},{"name":"tm30","url":"https://pokeapi.co/api/v2/item/334/"},{"name":"tm31","url":"https://pokeapi.co/api/v2/item/335/"},{"name":"tm32","url":"https://pokeapi.co/api/v2/item/336/"},{"name":"tm33","url":"https://pokeapi.co/api/v2/item/337/"},{"name":"tm34","url":"https://pokeapi.co/api/v2/item/338/"},{"name":"tm35","url":"https://pokeapi.co/api/v2/item/339/"},{"name":"tm36","url":"https://pokeapi.co/api/v2/item/340/"},{"name":"tm37","url":"https://pokeapi.co/api/v2/item/341/"},{"name":"tm38","url":"https://pokeapi.co/api/v2/item/342/"},{"name":"tm39","url":"https://pokeapi.co/api/v2/item/343/"},{"name":"tm40","url":"https://pokeapi.co/api/v2/item/344/"},{"name":"tm41","url":"https://pokeapi.co/api/v2/item/345/"},{"name":"tm42","url":"https://pokeapi.co/api/v2/item/346/"},{"name":"tm43","url":"https://pokeapi.co/api/v2/item/347/"},{"name":"tm44","url":"https://pokeapi.co/api/v2/item/348/"},{"name":"tm45","url":"https://pokeapi.co/api/v2/item/349/"},{"name":"tm46","url":"https://pokeapi.co/api/v2/item/350/"},{"name":"tm47","url":"https://pokeapi.co/api/v2/item/351/"},{"name":"tm48","url":"https://pokeapi.co/api/v2/item/352/"},{"name":"tm49","url":"https://pokeapi.co/api/v2/item/353/"},{"name":"tm50","url":"https://pokeapi.co/api/v2/item/354/"},{"name":"tm51","url":"https://pokeapi.co/api/v2/item/355/"},{"name":"tm52","url":"https://pokeapi.co/api/v2/item/356/"},{"name":"tm53","url":"https://pokeapi.co/api/v2/item/357/"},{"name":"tm54","url":"https://pokeapi.co/api/v2/item/358/"},{"name":"tm55","url":"https://pokeapi.co/api/v2/item/359/"},{"name":"tm56","url":"https://pokeapi.co/api/v2/item/360/"},{"name":"tm57","url":"https://pokeapi.co/api/v2/item/361/"},{"name":"tm58","url":"https://pokeapi.co/api/v2/item/362/"},{"name":"tm59","url":"https://pokeapi.co/api/v2/item/363/"},{"name":"tm60","url":"https://pokeapi.co/api/v2/item/364/"},{"name":"tm61","url":"https://pokeapi.co/api/v2/item/365/"},{"name":"tm62","url":"https://pokeapi.co/api/v2/item/366/"},{"name":"tm63","url":"https://pokeapi.co/api/v2/item/367/"},{"name":"tm64","url":"https://pokeapi.co/api/v2/item/368/"},{"name":"tm65","url":"https://pokeapi.co/api/v2/item/369/"},{"name":"tm66","url":"https://pokeapi.co/api/v2/item/370/"},{"name":"tm67","url":"https://pokeapi.co/api/v2/item/371/"},{"name":"tm68","url":"https://pokeapi.co/api/v2/item/372/"},{"name":"tm69","url":"https://pokeapi.co/api/v2/item/373/"},{"name":"tm70","url":"https://pokeapi.co/api/v2/item/374/"},{"name":"tm71","url":"https://pokeapi.co/api/v2/item/375/"},{"name":"tm72","url":"https://pokeapi.co/api/v2/item/376/"},{"name":"tm73","url":"https://pokeapi.co/api/v2/item/377/"},{"name":"tm74","url":"https://pokeapi.co/api/v2/item/378/"},{"name":"tm75","url":"https://pokeapi.co/api/v2/item/379/"},{"name":"tm76","url":"https://pokeapi.co/api/v2/item/380/"},{"name":"tm77","url":"https://pokeapi.co/api/v2/item/381/"},{"name":"tm78","url":"https://pokeapi.co/api/v2/item/382/"},{"name":"tm79","url":"https://pokeapi.co/api/v2/item/383/"},{"name":"tm80","url":"https://pokeapi.co/api/v2/item/384/"},{"name":"tm81","url":"https://pokeapi.co/api/v2/item/385/"},{"name":"tm82","url":"https://pokeapi.co/api/v2/item/386/"},{"name":"tm83","url":"https://pokeapi.co/api/v2/item/387/"},{"name":"tm84","url":"https://pokeapi.co/api/v2/item/388/"},{"name":"tm85","url":"https://pokeapi.co/api/v2/item/389/"},{"name":"tm86","url":"https://pokeapi.co/api/v2/item/390/"},{"name":"tm87","url":"https://pokeapi.co/api/v2/item/391/"},{"name":"tm88","url":"https://pokeapi.co/api/v2/item/392/"},{"name":"tm89","url":"https://pokeapi.co/api/v2/item/393/"},{"name":"tm90","url":"https://pokeapi.co/api/v2/item/394/"},{"name":"tm91","url":"https://pokeapi.co/api/v2/item/395/"},{"name":"tm92","url":"https://pokeapi.co/api/v2/item/396/"},{"name":"hm01","url":"https://pokeapi.co/api/v2/item/397/"},{"name":"hm02","url":"https://pokeapi.co/api/v2/item/398/"},{"name":"hm03","url":"https://pokeapi.co/api/v2/item/399/"},{"name":"hm04","url":"https://pokeapi.co/api/v2/item/400/"},{"name":"hm05","url":"https://pokeapi.co/api/v2/item/401/"},{"name":"hm06","url":"https://pokeapi.co/api/v2/item/402/"},{"name":"hm07","url":"https://pokeapi.co/api/v2/item/403/"},{"name":"hm08","url":"https://pokeapi.co/api/v2/item/404/"},{"name":"explorer-kit","url":"https://pokeapi.co/api/v2/item/405/"},{"name":"loot-sack","url":"https://pokeapi.co/api/v2/item/406/"},{"name":"rule-book","url":"https://pokeapi.co/api/v2/item/407/"},{"name":"poke-radar","url":"https://pokeapi.co/api/v2/item/408/"},{"name":"point-card","url":"https://pokeapi.co/api/v2/item/409/"},{"name":"journal","url":"https://pokeapi.co/api/v2/item/410/"},{"name":"seal-case","url":"https://pokeapi.co/api/v2/item/411/"},{"name":"fashion-case","url":"https://pokeapi.co/api/v2/item/412/"},{"name":"seal-bag","url":"https://pokeapi.co/api/v2/item/413/"},{"name":"pal-pad","url":"https://pokeapi.co/api/v2/item/414/"},{"name":"works-key","url":"https://pokeapi.co/api/v2/item/415/"},{"name":"old-charm","url":"https://pokeapi.co/api/v2/item/416/"},{"name":"galactic-key","url":"https://pokeapi.co/api/v2/item/417/"},{"name":"red-chain","url":"https://pokeapi.co/api/v2/item/418/"},{"name":"town-map","url":"https://pokeapi.co/api/v2/item/419/"},{"name":"vs-seeker","url":"https://pokeapi.co/api/v2/item/420/"},{"name":"coin-case","url":"https://pokeapi.co/api/v2/item/421/"},{"name":"old-rod","url":"https://pokeapi.co/api/v2/item/422/"},{"name":"good-rod","url":"https://pokeapi.co/api/v2/item/423/"},{"name":"super-rod","url":"https://pokeapi.co/api/v2/item/424/"},{"name":"sprayduck","url":"https://pokeapi.co/api/v2/item/425/"},{"name":"poffin-case","url":"https://pokeapi.co/api/v2/item/426/"},{"name":"bicycle","url":"https://pokeapi.co/api/v2/item/427/"},{"name":"suite-key","url":"https://pokeapi.co/api/v2/item/428/"},{"name":"oaks-letter","url":"https://pokeapi.co/api/v2/item/429/"},{"name":"lunar-wing","url":"https://pokeapi.co/api/v2/item/430/"},{"name":"member-card","url":"https://pokeapi.co/api/v2/item/431/"},{"name":"azure-flute","url":"https://pokeapi.co/api/v2/item/432/"},{"name":"ss-ticket","url":"https://pokeapi.co/api/v2/item/433/"},{"name":"contest-pass","url":"https://pokeapi.co/api/v2/item/434/"},{"name":"magma-stone","url":"https://pokeapi.co/api/v2/item/435/"},{"name":"parcel","url":"https://pokeapi.co/api/v2/item/436/"},{"name":"coupon-1","url":"https://pokeapi.co/api/v2/item/437/"},{"name":"coupon-2","url":"https://pokeapi.co/api/v2/item/438/"},{"name":"coupon-3","url":"https://pokeapi.co/api/v2/item/439/"},{"name":"storage-key","url":"https://pokeapi.co/api/v2/item/440/"},{"name":"secret-potion","url":"https://pokeapi.co/api/v2/item/441/"},{"name":"griseous-orb","url":"https://pokeapi.co/api/v2/item/442/"},{"name":"vs-recorder","url":"https://pokeapi.co/api/v2/item/443/"},{"name":"gracidea","url":"https://pokeapi.co/api/v2/item/444/"},{"name":"secret-key","url":"https://pokeapi.co/api/v2/item/445/"},{"name":"apricorn-box","url":"https://pokeapi.co/api/v2/item/446/"},{"name":"berry-pots","url":"https://pokeapi.co/api/v2/item/447/"},{"name":"squirt-bottle","url":"https://pokeapi.co/api/v2/item/448/"},{"name":"lure-ball","url":"https://pokeapi.co/api/v2/item/449/"},{"name":"level-ball","url":"https://pokeapi.co/api/v2/item/450/"},{"name":"moon-ball","url":"https://pokeapi.co/api/v2/item/451/"},{"name":"heavy-ball","url":"https://pokeapi.co/api/v2/item/452/"},{"name":"fast-ball","url":"https://pokeapi.co/api/v2/item/453/"},{"name":"friend-ball","url":"https://pokeapi.co/api/v2/item/454/"},{"name":"love-ball","url":"https://pokeapi.co/api/v2/item/455/"},{"name":"park-ball","url":"https://pokeapi.co/api/v2/item/456/"},{"name":"sport-ball","url":"https://pokeapi.co/api/v2/item/457/"},{"name":"red-apricorn","url":"https://pokeapi.co/api/v2/item/458/"},{"name":"blue-apricorn","url":"https://pokeapi.co/api/v2/item/459/"},{"name":"yellow-apricorn","url":"https://pokeapi.co/api/v2/item/460/"},{"name":"green-apricorn","url":"https://pokeapi.co/api/v2/item/461/"},{"name":"pink-apricorn","url":"https://pokeapi.co/api/v2/item/462/"},{"name":"white-apricorn","url":"https://pokeapi.co/api/v2/item/463/"},{"name":"black-apricorn","url":"https://pokeapi.co/api/v2/item/464/"},{"name":"dowsing-machine","url":"https://pokeapi.co/api/v2/item/465/"},{"name":"rage-candy-bar","url":"https://pokeapi.co/api/v2/item/466/"},{"name":"red-orb","url":"https://pokeapi.co/api/v2/item/467/"},{"name":"blue-orb","url":"https://pokeapi.co/api/v2/item/468/"},{"name":"jade-orb","url":"https://pokeapi.co/api/v2/item/469/"},{"name":"enigma-stone","url":"https://pokeapi.co/api/v2/item/470/"},{"name":"unown-report","url":"https://pokeapi.co/api/v2/item/471/"},{"name":"blue-card","url":"https://pokeapi.co/api/v2/item/472/"},{"name":"slowpoke-tail","url":"https://pokeapi.co/api/v2/item/473/"},{"name":"clear-bell","url":"https://pokeapi.co/api/v2/item/474/"},{"name":"card-key","url":"https://pokeapi.co/api/v2/item/475/"},{"name":"basement-key","url":"https://pokeapi.co/api/v2/item/476/"},{"name":"red-scale","url":"https://pokeapi.co/api/v2/item/477/"},{"name":"lost-item","url":"https://pokeapi.co/api/v2/item/478/"},{"name":"pass","url":"https://pokeapi.co/api/v2/item/479/"},{"name":"machine-part","url":"https://pokeapi.co/api/v2/item/480/"},{"name":"silver-wing","url":"https://pokeapi.co/api/v2/item/481/"},{"name":"rainbow-wing","url":"https://pokeapi.co/api/v2/item/482/"},{"name":"mystery-egg","url":"https://pokeapi.co/api/v2/item/483/"},{"name":"gb-sounds","url":"https://pokeapi.co/api/v2/item/484/"},{"name":"tidal-bell","url":"https://pokeapi.co/api/v2/item/485/"},{"name":"data-card-01","url":"https://pokeapi.co/api/v2/item/486/"},{"name":"data-card-02","url":"https://pokeapi.co/api/v2/item/487/"},{"name":"data-card-03","url":"https://pokeapi.co/api/v2/item/488/"},{"name":"data-card-04","url":"https://pokeapi.co/api/v2/item/489/"},{"name":"data-card-05","url":"https://pokeapi.co/api/v2/item/490/"},{"name":"data-card-06","url":"https://pokeapi.co/api/v2/item/491/"},{"name":"data-card-07","url":"https://pokeapi.co/api/v2/item/492/"},{"name":"data-card-08","url":"https://pokeapi.co/api/v2/item/493/"},{"name":"data-card-09","url":"https://pokeapi.co/api/v2/item/494/"},{"name":"data-card-10","url":"https://pokeapi.co/api/v2/item/495/"},{"name":"data-card-11","url":"https://pokeapi.co/api/v2/item/496/"},{"name":"data-card-12","url":"https://pokeapi.co/api/v2/item/497/"},{"name":"data-card-13","url":"https://pokeapi.co/api/v2/item/498/"},{"name":"data-card-14","url":"https://pokeapi.co/api/v2/item/499/"},{"name":"data-card-15","url":"https://pokeapi.co/api/v2/item/500/"},{"name":"data-card-16","url":"https://pokeapi.co/api/v2/item/501/"},{"name":"data-card-17","url":"https://pokeapi.co/api/v2/item/502/"},{"name":"data-card-18","url":"https://pokeapi.co/api/v2/item/503/"},{"name":"data-card-19","url":"https://pokeapi.co/api/v2/item/504/"},{"name":"data-card-20","url":"https://pokeapi.co/api/v2/item/505/"},{"name":"data-card-21","url":"https://pokeapi.co/api/v2/item/506/"},{"name":"data-card-22","url":"https://pokeapi.co/api/v2/item/507/"},{"name":"data-card-23","url":"https://pokeapi.co/api/v2/item/508/"},{"name":"data-card-24","url":"https://pokeapi.co/api/v2/item/509/"},{"name":"data-card-25","url":"https://pokeapi.co/api/v2/item/510/"},{"name":"data-card-26","url":"https://pokeapi.co/api/v2/item/511/"},{"name":"data-card-27","url":"https://pokeapi.co/api/v2/item/512/"},{"name":"lock-capsule","url":"https://pokeapi.co/api/v2/item/513/"},{"name":"photo-album","url":"https://pokeapi.co/api/v2/item/514/"},{"name":"orange-mail","url":"https://pokeapi.co/api/v2/item/515/"},{"name":"harbor-mail","url":"https://pokeapi.co/api/v2/item/516/"},{"name":"glitter-mail","url":"https://pokeapi.co/api/v2/item/517/"},{"name":"mech-mail","url":"https://pokeapi.co/api/v2/item/518/"},{"name":"wood-mail","url":"https://pokeapi.co/api/v2/item/519/"},{"name":"wave-mail","url":"https://pokeapi.co/api/v2/item/520/"},{"name":"bead-mail","url":"https://pokeapi.co/api/v2/item/521/"},{"name":"shadow-mail","url":"https://pokeapi.co/api/v2/item/522/"},{"name":"tropic-mail","url":"https://pokeapi.co/api/v2/item/523/"},{"name":"dream-mail","url":"https://pokeapi.co/api/v2/item/524/"},{"name":"fab-mail","url":"https://pokeapi.co/api/v2/item/525/"},{"name":"retro-mail","url":"https://pokeapi.co/api/v2/item/526/"},{"name":"mach-bike","url":"https://pokeapi.co/api/v2/item/527/"},{"name":"acro-bike","url":"https://pokeapi.co/api/v2/item/528/"},{"name":"wailmer-pail","url":"https://pokeapi.co/api/v2/item/529/"},{"name":"devon-goods","url":"https://pokeapi.co/api/v2/item/530/"},{"name":"soot-sack","url":"https://pokeapi.co/api/v2/item/531/"},{"name":"pokeblock-case","url":"https://pokeapi.co/api/v2/item/532/"},{"name":"letter","url":"https://pokeapi.co/api/v2/item/533/"},{"name":"eon-ticket","url":"https://pokeapi.co/api/v2/item/534/"},{"name":"scanner","url":"https://pokeapi.co/api/v2/item/535/"},{"name":"go-goggles","url":"https://pokeapi.co/api/v2/item/536/"},{"name":"meteorite","url":"https://pokeapi.co/api/v2/item/537/"},{"name":"rm-1-key","url":"https://pokeapi.co/api/v2/item/538/"},{"name":"rm-2-key","url":"https://pokeapi.co/api/v2/item/539/"},{"name":"rm-4-key","url":"https://pokeapi.co/api/v2/item/540/"},{"name":"rm-6-key","url":"https://pokeapi.co/api/v2/item/541/"},{"name":"devon-scope","url":"https://pokeapi.co/api/v2/item/542/"},{"name":"oaks-parcel","url":"https://pokeapi.co/api/v2/item/543/"},{"name":"poke-flute","url":"https://pokeapi.co/api/v2/item/544/"},{"name":"bike-voucher","url":"https://pokeapi.co/api/v2/item/545/"},{"name":"gold-teeth","url":"https://pokeapi.co/api/v2/item/546/"},{"name":"lift-key","url":"https://pokeapi.co/api/v2/item/547/"},{"name":"silph-scope","url":"https://pokeapi.co/api/v2/item/548/"},{"name":"fame-checker","url":"https://pokeapi.co/api/v2/item/549/"},{"name":"tm-case","url":"https://pokeapi.co/api/v2/item/550/"},{"name":"berry-pouch","url":"https://pokeapi.co/api/v2/item/551/"},{"name":"teachy-tv","url":"https://pokeapi.co/api/v2/item/552/"},{"name":"tri-pass","url":"https://pokeapi.co/api/v2/item/553/"},{"name":"rainbow-pass","url":"https://pokeapi.co/api/v2/item/554/"},{"name":"tea","url":"https://pokeapi.co/api/v2/item/555/"},{"name":"mysticticket","url":"https://pokeapi.co/api/v2/item/556/"},{"name":"auroraticket","url":"https://pokeapi.co/api/v2/item/557/"},{"name":"powder-jar","url":"https://pokeapi.co/api/v2/item/558/"},{"name":"ruby","url":"https://pokeapi.co/api/v2/item/559/"},{"name":"sapphire","url":"https://pokeapi.co/api/v2/item/560/"},{"name":"magma-emblem","url":"https://pokeapi.co/api/v2/item/561/"},{"name":"old-sea-map","url":"https://pokeapi.co/api/v2/item/562/"},{"name":"douse-drive","url":"https://pokeapi.co/api/v2/item/563/"},{"name":"shock-drive","url":"https://pokeapi.co/api/v2/item/564/"},{"name":"burn-drive","url":"https://pokeapi.co/api/v2/item/565/"},{"name":"chill-drive","url":"https://pokeapi.co/api/v2/item/566/"},{"name":"sweet-heart","url":"https://pokeapi.co/api/v2/item/567/"},{"name":"greet-mail","url":"https://pokeapi.co/api/v2/item/568/"},{"name":"favored-mail","url":"https://pokeapi.co/api/v2/item/569/"},{"name":"rsvp-mail","url":"https://pokeapi.co/api/v2/item/570/"},{"name":"thanks-mail","url":"https://pokeapi.co/api/v2/item/571/"},{"name":"inquiry-mail","url":"https://pokeapi.co/api/v2/item/572/"},{"name":"like-mail","url":"https://pokeapi.co/api/v2/item/573/"},{"name":"reply-mail","url":"https://pokeapi.co/api/v2/item/574/"},{"name":"bridge-mail-s","url":"https://pokeapi.co/api/v2/item/575/"},{"name":"bridge-mail-d","url":"https://pokeapi.co/api/v2/item/576/"},{"name":"bridge-mail-t","url":"https://pokeapi.co/api/v2/item/577/"},{"name":"bridge-mail-v","url":"https://pokeapi.co/api/v2/item/578/"},{"name":"bridge-mail-m","url":"https://pokeapi.co/api/v2/item/579/"},{"name":"prism-scale","url":"https://pokeapi.co/api/v2/item/580/"},{"name":"eviolite","url":"https://pokeapi.co/api/v2/item/581/"},{"name":"float-stone","url":"https://pokeapi.co/api/v2/item/582/"},{"name":"rocky-helmet","url":"https://pokeapi.co/api/v2/item/583/"},{"name":"air-balloon","url":"https://pokeapi.co/api/v2/item/584/"},{"name":"red-card","url":"https://pokeapi.co/api/v2/item/585/"},{"name":"ring-target","url":"https://pokeapi.co/api/v2/item/586/"},{"name":"binding-band","url":"https://pokeapi.co/api/v2/item/587/"},{"name":"absorb-bulb","url":"https://pokeapi.co/api/v2/item/588/"},{"name":"cell-battery","url":"https://pokeapi.co/api/v2/item/589/"},{"name":"eject-button","url":"https://pokeapi.co/api/v2/item/590/"},{"name":"fire-gem","url":"https://pokeapi.co/api/v2/item/591/"},{"name":"water-gem","url":"https://pokeapi.co/api/v2/item/592/"},{"name":"electric-gem","url":"https://pokeapi.co/api/v2/item/593/"},{"name":"grass-gem","url":"https://pokeapi.co/api/v2/item/594/"},{"name":"ice-gem","url":"https://pokeapi.co/api/v2/item/595/"},{"name":"fighting-gem","url":"https://pokeapi.co/api/v2/item/596/"},{"name":"poison-gem","url":"https://pokeapi.co/api/v2/item/597/"},{"name":"ground-gem","url":"https://pokeapi.co/api/v2/item/598/"},{"name":"flying-gem","url":"https://pokeapi.co/api/v2/item/599/"},{"name":"psychic-gem","url":"https://pokeapi.co/api/v2/item/600/"},{"name":"bug-gem","url":"https://pokeapi.co/api/v2/item/601/"},{"name":"rock-gem","url":"https://pokeapi.co/api/v2/item/602/"},{"name":"ghost-gem","url":"https://pokeapi.co/api/v2/item/603/"},{"name":"dark-gem","url":"https://pokeapi.co/api/v2/item/604/"},{"name":"steel-gem","url":"https://pokeapi.co/api/v2/item/605/"},{"name":"health-wing","url":"https://pokeapi.co/api/v2/item/606/"},{"name":"muscle-wing","url":"https://pokeapi.co/api/v2/item/607/"},{"name":"resist-wing","url":"https://pokeapi.co/api/v2/item/608/"},{"name":"genius-wing","url":"https://pokeapi.co/api/v2/item/609/"},{"name":"clever-wing","url":"https://pokeapi.co/api/v2/item/610/"},{"name":"swift-wing","url":"https://pokeapi.co/api/v2/item/611/"},{"name":"pretty-wing","url":"https://pokeapi.co/api/v2/item/612/"},{"name":"cover-fossil","url":"https://pokeapi.co/api/v2/item/613/"},{"name":"plume-fossil","url":"https://pokeapi.co/api/v2/item/614/"},{"name":"liberty-pass","url":"https://pokeapi.co/api/v2/item/615/"},{"name":"pass-orb","url":"https://pokeapi.co/api/v2/item/616/"},{"name":"dream-ball","url":"https://pokeapi.co/api/v2/item/617/"},{"name":"poke-toy","url":"https://pokeapi.co/api/v2/item/618/"},{"name":"prop-case","url":"https://pokeapi.co/api/v2/item/619/"},{"name":"dragon-skull","url":"https://pokeapi.co/api/v2/item/620/"},{"name":"balm-mushroom","url":"https://pokeapi.co/api/v2/item/621/"},{"name":"big-nugget","url":"https://pokeapi.co/api/v2/item/622/"},{"name":"pearl-string","url":"https://pokeapi.co/api/v2/item/623/"},{"name":"comet-shard","url":"https://pokeapi.co/api/v2/item/624/"},{"name":"relic-copper","url":"https://pokeapi.co/api/v2/item/625/"},{"name":"relic-silver","url":"https://pokeapi.co/api/v2/item/626/"},{"name":"relic-gold","url":"https://pokeapi.co/api/v2/item/627/"},{"name":"relic-vase","url":"https://pokeapi.co/api/v2/item/628/"},{"name":"relic-band","url":"https://pokeapi.co/api/v2/item/629/"},{"name":"relic-statue","url":"https://pokeapi.co/api/v2/item/630/"},{"name":"relic-crown","url":"https://pokeapi.co/api/v2/item/631/"},{"name":"casteliacone","url":"https://pokeapi.co/api/v2/item/632/"},{"name":"dire-hit-2","url":"https://pokeapi.co/api/v2/item/633/"},{"name":"x-speed-2","url":"https://pokeapi.co/api/v2/item/634/"},{"name":"x-sp-atk-2","url":"https://pokeapi.co/api/v2/item/635/"},{"name":"x-sp-def-2","url":"https://pokeapi.co/api/v2/item/636/"},{"name":"x-defense-2","url":"https://pokeapi.co/api/v2/item/637/"},{"name":"x-attack-2","url":"https://pokeapi.co/api/v2/item/638/"},{"name":"x-accuracy-2","url":"https://pokeapi.co/api/v2/item/639/"},{"name":"x-speed-3","url":"https://pokeapi.co/api/v2/item/640/"},{"name":"x-sp-atk-3","url":"https://pokeapi.co/api/v2/item/641/"},{"name":"x-sp-def-3","url":"https://pokeapi.co/api/v2/item/642/"},{"name":"x-defense-3","url":"https://pokeapi.co/api/v2/item/643/"},{"name":"x-attack-3","url":"https://pokeapi.co/api/v2/item/644/"},{"name":"x-accuracy-3","url":"https://pokeapi.co/api/v2/item/645/"},{"name":"x-speed-6","url":"https://pokeapi.co/api/v2/item/646/"},{"name":"x-sp-atk-6","url":"https://pokeapi.co/api/v2/item/647/"},{"name":"x-sp-def-6","url":"https://pokeapi.co/api/v2/item/648/"},{"name":"x-defense-6","url":"https://pokeapi.co/api/v2/item/649/"},{"name":"x-attack-6","url":"https://pokeapi.co/api/v2/item/650/"},{"name":"x-accuracy-6","url":"https://pokeapi.co/api/v2/item/651/"},{"name":"ability-urge","url":"https://pokeapi.co/api/v2/item/652/"},{"name":"item-drop","url":"https://pokeapi.co/api/v2/item/653/"},{"name":"item-urge","url":"https://pokeapi.co/api/v2/item/654/"},{"name":"reset-urge","url":"https://pokeapi.co/api/v2/item/655/"},{"name":"dire-hit-3","url":"https://pokeapi.co/api/v2/item/656/"},{"name":"light-stone","url":"https://pokeapi.co/api/v2/item/657/"},{"name":"dark-stone","url":"https://pokeapi.co/api/v2/item/658/"},{"name":"tm93","url":"https://pokeapi.co/api/v2/item/659/"},{"name":"tm94","url":"https://pokeapi.co/api/v2/item/660/"},{"name":"tm95","url":"https://pokeapi.co/api/v2/item/661/"},{"name":"xtransceiver","url":"https://pokeapi.co/api/v2/item/662/"},{"name":"god-stone","url":"https://pokeapi.co/api/v2/item/663/"},{"name":"gram-1","url":"https://pokeapi.co/api/v2/item/664/"},{"name":"gram-2","url":"https://pokeapi.co/api/v2/item/665/"},{"name":"gram-3","url":"https://pokeapi.co/api/v2/item/666/"},{"name":"dragon-gem","url":"https://pokeapi.co/api/v2/item/668/"},{"name":"normal-gem","url":"https://pokeapi.co/api/v2/item/669/"},{"name":"medal-box","url":"https://pokeapi.co/api/v2/item/670/"},{"name":"dna-splicers","url":"https://pokeapi.co/api/v2/item/671/"},{"name":"permit","url":"https://pokeapi.co/api/v2/item/673/"},{"name":"oval-charm","url":"https://pokeapi.co/api/v2/item/674/"},{"name":"shiny-charm","url":"https://pokeapi.co/api/v2/item/675/"},{"name":"plasma-card","url":"https://pokeapi.co/api/v2/item/676/"},{"name":"grubby-hanky","url":"https://pokeapi.co/api/v2/item/677/"},{"name":"colress-machine","url":"https://pokeapi.co/api/v2/item/678/"},{"name":"dropped-item","url":"https://pokeapi.co/api/v2/item/679/"},{"name":"reveal-glass","url":"https://pokeapi.co/api/v2/item/681/"},{"name":"weakness-policy","url":"https://pokeapi.co/api/v2/item/682/"},{"name":"assault-vest","url":"https://pokeapi.co/api/v2/item/683/"},{"name":"pixie-plate","url":"https://pokeapi.co/api/v2/item/684/"},{"name":"ability-capsule","url":"https://pokeapi.co/api/v2/item/685/"},{"name":"whipped-dream","url":"https://pokeapi.co/api/v2/item/686/"},{"name":"sachet","url":"https://pokeapi.co/api/v2/item/687/"},{"name":"luminous-moss","url":"https://pokeapi.co/api/v2/item/688/"},{"name":"snowball","url":"https://pokeapi.co/api/v2/item/689/"},{"name":"safety-goggles","url":"https://pokeapi.co/api/v2/item/690/"},{"name":"rich-mulch","url":"https://pokeapi.co/api/v2/item/691/"},{"name":"surprise-mulch","url":"https://pokeapi.co/api/v2/item/692/"},{"name":"boost-mulch","url":"https://pokeapi.co/api/v2/item/693/"},{"name":"amaze-mulch","url":"https://pokeapi.co/api/v2/item/694/"},{"name":"gengarite","url":"https://pokeapi.co/api/v2/item/695/"},{"name":"gardevoirite","url":"https://pokeapi.co/api/v2/item/696/"},{"name":"ampharosite","url":"https://pokeapi.co/api/v2/item/697/"},{"name":"venusaurite","url":"https://pokeapi.co/api/v2/item/698/"},{"name":"charizardite-x","url":"https://pokeapi.co/api/v2/item/699/"},{"name":"blastoisinite","url":"https://pokeapi.co/api/v2/item/700/"},{"name":"mewtwonite-x","url":"https://pokeapi.co/api/v2/item/701/"},{"name":"mewtwonite-y","url":"https://pokeapi.co/api/v2/item/702/"},{"name":"blazikenite","url":"https://pokeapi.co/api/v2/item/703/"},{"name":"medichamite","url":"https://pokeapi.co/api/v2/item/704/"},{"name":"houndoominite","url":"https://pokeapi.co/api/v2/item/705/"},{"name":"aggronite","url":"https://pokeapi.co/api/v2/item/706/"},{"name":"banettite","url":"https://pokeapi.co/api/v2/item/707/"},{"name":"tyranitarite","url":"https://pokeapi.co/api/v2/item/708/"},{"name":"scizorite","url":"https://pokeapi.co/api/v2/item/709/"},{"name":"pinsirite","url":"https://pokeapi.co/api/v2/item/710/"},{"name":"aerodactylite","url":"https://pokeapi.co/api/v2/item/711/"},{"name":"lucarionite","url":"https://pokeapi.co/api/v2/item/712/"},{"name":"abomasite","url":"https://pokeapi.co/api/v2/item/713/"},{"name":"kangaskhanite","url":"https://pokeapi.co/api/v2/item/714/"},{"name":"gyaradosite","url":"https://pokeapi.co/api/v2/item/715/"},{"name":"absolite","url":"https://pokeapi.co/api/v2/item/716/"},{"name":"charizardite-y","url":"https://pokeapi.co/api/v2/item/717/"},{"name":"alakazite","url":"https://pokeapi.co/api/v2/item/718/"},{"name":"heracronite","url":"https://pokeapi.co/api/v2/item/719/"},{"name":"mawilite","url":"https://pokeapi.co/api/v2/item/720/"},{"name":"manectite","url":"https://pokeapi.co/api/v2/item/721/"},{"name":"garchompite","url":"https://pokeapi.co/api/v2/item/722/"},{"name":"roseli-berry","url":"https://pokeapi.co/api/v2/item/723/"},{"name":"kee-berry","url":"https://pokeapi.co/api/v2/item/724/"},{"name":"maranga-berry","url":"https://pokeapi.co/api/v2/item/725/"},{"name":"discount-coupon","url":"https://pokeapi.co/api/v2/item/726/"},{"name":"strange-souvenir","url":"https://pokeapi.co/api/v2/item/727/"},{"name":"lumiose-galette","url":"https://pokeapi.co/api/v2/item/728/"},{"name":"jaw-fossil","url":"https://pokeapi.co/api/v2/item/729/"},{"name":"sail-fossil","url":"https://pokeapi.co/api/v2/item/730/"},{"name":"fairy-gem","url":"https://pokeapi.co/api/v2/item/731/"},{"name":"adventure-rules","url":"https://pokeapi.co/api/v2/item/732/"},{"name":"elevator-key","url":"https://pokeapi.co/api/v2/item/733/"},{"name":"holo-caster","url":"https://pokeapi.co/api/v2/item/734/"},{"name":"honor-of-kalos","url":"https://pokeapi.co/api/v2/item/735/"},{"name":"intriguing-stone","url":"https://pokeapi.co/api/v2/item/736/"},{"name":"lens-case","url":"https://pokeapi.co/api/v2/item/737/"},{"name":"looker-ticket","url":"https://pokeapi.co/api/v2/item/738/"},{"name":"mega-ring","url":"https://pokeapi.co/api/v2/item/739/"},{"name":"power-plant-pass","url":"https://pokeapi.co/api/v2/item/740/"},{"name":"profs-letter","url":"https://pokeapi.co/api/v2/item/741/"},{"name":"roller-skates","url":"https://pokeapi.co/api/v2/item/742/"},{"name":"sprinklotad","url":"https://pokeapi.co/api/v2/item/743/"},{"name":"tmv-pass","url":"https://pokeapi.co/api/v2/item/744/"},{"name":"tm96","url":"https://pokeapi.co/api/v2/item/745/"},{"name":"tm97","url":"https://pokeapi.co/api/v2/item/746/"},{"name":"tm98","url":"https://pokeapi.co/api/v2/item/747/"},{"name":"tm99","url":"https://pokeapi.co/api/v2/item/748/"},{"name":"tm100","url":"https://pokeapi.co/api/v2/item/749/"},{"name":"latiasite","url":"https://pokeapi.co/api/v2/item/760/"},{"name":"latiosite","url":"https://pokeapi.co/api/v2/item/761/"},{"name":"common-stone","url":"https://pokeapi.co/api/v2/item/762/"},{"name":"makeup-bag","url":"https://pokeapi.co/api/v2/item/763/"},{"name":"travel-trunk","url":"https://pokeapi.co/api/v2/item/764/"},{"name":"shalour-sable","url":"https://pokeapi.co/api/v2/item/765/"},{"name":"mega-charm","url":"https://pokeapi.co/api/v2/item/768/"},{"name":"mega-glove","url":"https://pokeapi.co/api/v2/item/769/"},{"name":"devon-parts","url":"https://pokeapi.co/api/v2/item/770/"},{"name":"pokeblock-kit","url":"https://pokeapi.co/api/v2/item/772/"},{"name":"key-to-room-1","url":"https://pokeapi.co/api/v2/item/773/"},{"name":"key-to-room-2","url":"https://pokeapi.co/api/v2/item/774/"},{"name":"key-to-room-4","url":"https://pokeapi.co/api/v2/item/775/"},{"name":"key-to-room-6","url":"https://pokeapi.co/api/v2/item/776/"},{"name":"devon-scuba-gear","url":"https://pokeapi.co/api/v2/item/779/"},{"name":"contest-costume--jacket","url":"https://pokeapi.co/api/v2/item/780/"},{"name":"magma-suit","url":"https://pokeapi.co/api/v2/item/782/"},{"name":"aqua-suit","url":"https://pokeapi.co/api/v2/item/783/"},{"name":"pair-of-tickets","url":"https://pokeapi.co/api/v2/item/784/"},{"name":"mega-bracelet","url":"https://pokeapi.co/api/v2/item/785/"},{"name":"mega-pendant","url":"https://pokeapi.co/api/v2/item/786/"},{"name":"mega-glasses","url":"https://pokeapi.co/api/v2/item/787/"},{"name":"mega-anchor","url":"https://pokeapi.co/api/v2/item/788/"},{"name":"mega-stickpin","url":"https://pokeapi.co/api/v2/item/789/"},{"name":"mega-tiara","url":"https://pokeapi.co/api/v2/item/790/"},{"name":"mega-anklet","url":"https://pokeapi.co/api/v2/item/791/"},{"name":"swampertite","url":"https://pokeapi.co/api/v2/item/793/"},{"name":"sceptilite","url":"https://pokeapi.co/api/v2/item/794/"},{"name":"sablenite","url":"https://pokeapi.co/api/v2/item/795/"},{"name":"altarianite","url":"https://pokeapi.co/api/v2/item/796/"},{"name":"galladite","url":"https://pokeapi.co/api/v2/item/797/"},{"name":"audinite","url":"https://pokeapi.co/api/v2/item/798/"},{"name":"metagrossite","url":"https://pokeapi.co/api/v2/item/799/"},{"name":"sharpedonite","url":"https://pokeapi.co/api/v2/item/800/"},{"name":"slowbronite","url":"https://pokeapi.co/api/v2/item/801/"},{"name":"steelixite","url":"https://pokeapi.co/api/v2/item/802/"},{"name":"pidgeotite","url":"https://pokeapi.co/api/v2/item/803/"},{"name":"glalitite","url":"https://pokeapi.co/api/v2/item/804/"},{"name":"diancite","url":"https://pokeapi.co/api/v2/item/805/"},{"name":"prison-bottle","url":"https://pokeapi.co/api/v2/item/806/"},{"name":"mega-cuff","url":"https://pokeapi.co/api/v2/item/807/"},{"name":"cameruptite","url":"https://pokeapi.co/api/v2/item/808/"},{"name":"lopunnite","url":"https://pokeapi.co/api/v2/item/809/"},{"name":"salamencite","url":"https://pokeapi.co/api/v2/item/810/"},{"name":"beedrillite","url":"https://pokeapi.co/api/v2/item/811/"},{"name":"key-stone","url":"https://pokeapi.co/api/v2/item/814/"},{"name":"meteorite-shard","url":"https://pokeapi.co/api/v2/item/815/"},{"name":"eon-flute","url":"https://pokeapi.co/api/v2/item/816/"},{"name":"normalium-z--held","url":"https://pokeapi.co/api/v2/item/817/"},{"name":"firium-z--held","url":"https://pokeapi.co/api/v2/item/818/"},{"name":"waterium-z--held","url":"https://pokeapi.co/api/v2/item/819/"},{"name":"electrium-z--held","url":"https://pokeapi.co/api/v2/item/820/"},{"name":"grassium-z--held","url":"https://pokeapi.co/api/v2/item/821/"},{"name":"icium-z--held","url":"https://pokeapi.co/api/v2/item/822/"},{"name":"fightinium-z--held","url":"https://pokeapi.co/api/v2/item/823/"},{"name":"poisonium-z--held","url":"https://pokeapi.co/api/v2/item/824/"},{"name":"groundium-z--held","url":"https://pokeapi.co/api/v2/item/825/"},{"name":"flyinium-z--held","url":"https://pokeapi.co/api/v2/item/826/"},{"name":"psychium-z--held","url":"https://pokeapi.co/api/v2/item/827/"},{"name":"buginium-z--held","url":"https://pokeapi.co/api/v2/item/828/"},{"name":"rockium-z--held","url":"https://pokeapi.co/api/v2/item/829/"},{"name":"ghostium-z--held","url":"https://pokeapi.co/api/v2/item/830/"},{"name":"dragonium-z--held","url":"https://pokeapi.co/api/v2/item/831/"},{"name":"darkinium-z--held","url":"https://pokeapi.co/api/v2/item/832/"},{"name":"steelium-z--held","url":"https://pokeapi.co/api/v2/item/833/"},{"name":"fairium-z--held","url":"https://pokeapi.co/api/v2/item/834/"},{"name":"pikanium-z--held","url":"https://pokeapi.co/api/v2/item/835/"},{"name":"bottle-cap","url":"https://pokeapi.co/api/v2/item/836/"},{"name":"gold-bottle-cap","url":"https://pokeapi.co/api/v2/item/837/"},{"name":"z-ring","url":"https://pokeapi.co/api/v2/item/838/"},{"name":"decidium-z--held","url":"https://pokeapi.co/api/v2/item/839/"},{"name":"incinium-z--held","url":"https://pokeapi.co/api/v2/item/840/"},{"name":"primarium-z--held","url":"https://pokeapi.co/api/v2/item/841/"},{"name":"tapunium-z--held","url":"https://pokeapi.co/api/v2/item/842/"},{"name":"marshadium-z--held","url":"https://pokeapi.co/api/v2/item/843/"},{"name":"aloraichium-z--held","url":"https://pokeapi.co/api/v2/item/844/"},{"name":"snorlium-z--held","url":"https://pokeapi.co/api/v2/item/845/"},{"name":"eevium-z--held","url":"https://pokeapi.co/api/v2/item/846/"},{"name":"mewnium-z--held","url":"https://pokeapi.co/api/v2/item/847/"},{"name":"pikashunium-z--held","url":"https://pokeapi.co/api/v2/item/877/"},{"name":"forage-bag","url":"https://pokeapi.co/api/v2/item/878/"},{"name":"fishing-rod","url":"https://pokeapi.co/api/v2/item/879/"},{"name":"professors-mask","url":"https://pokeapi.co/api/v2/item/880/"},{"name":"festival-ticket","url":"https://pokeapi.co/api/v2/item/881/"},{"name":"sparkling-stone","url":"https://pokeapi.co/api/v2/item/882/"},{"name":"adrenaline-orb","url":"https://pokeapi.co/api/v2/item/883/"},{"name":"zygarde-cube","url":"https://pokeapi.co/api/v2/item/884/"},{"name":"ice-stone","url":"https://pokeapi.co/api/v2/item/885/"},{"name":"ride-pager","url":"https://pokeapi.co/api/v2/item/886/"},{"name":"beast-ball","url":"https://pokeapi.co/api/v2/item/887/"},{"name":"big-malasada","url":"https://pokeapi.co/api/v2/item/888/"},{"name":"red-nectar","url":"https://pokeapi.co/api/v2/item/889/"},{"name":"yellow-nectar","url":"https://pokeapi.co/api/v2/item/890/"},{"name":"pink-nectar","url":"https://pokeapi.co/api/v2/item/891/"},{"name":"purple-nectar","url":"https://pokeapi.co/api/v2/item/892/"},{"name":"sun-flute","url":"https://pokeapi.co/api/v2/item/893/"},{"name":"moon-flute","url":"https://pokeapi.co/api/v2/item/894/"},{"name":"enigmatic-card","url":"https://pokeapi.co/api/v2/item/895/"},{"name":"terrain-extender","url":"https://pokeapi.co/api/v2/item/896/"},{"name":"protective-pads","url":"https://pokeapi.co/api/v2/item/897/"},{"name":"electric-seed","url":"https://pokeapi.co/api/v2/item/898/"},{"name":"psychic-seed","url":"https://pokeapi.co/api/v2/item/899/"},{"name":"misty-seed","url":"https://pokeapi.co/api/v2/item/900/"},{"name":"grassy-seed","url":"https://pokeapi.co/api/v2/item/901/"},{"name":"fighting-memory","url":"https://pokeapi.co/api/v2/item/902/"},{"name":"flying-memory","url":"https://pokeapi.co/api/v2/item/903/"},{"name":"poison-memory","url":"https://pokeapi.co/api/v2/item/904/"},{"name":"ground-memory","url":"https://pokeapi.co/api/v2/item/905/"},{"name":"rock-memory","url":"https://pokeapi.co/api/v2/item/906/"},{"name":"bug-memory","url":"https://pokeapi.co/api/v2/item/907/"},{"name":"ghost-memory","url":"https://pokeapi.co/api/v2/item/908/"},{"name":"steel-memory","url":"https://pokeapi.co/api/v2/item/909/"},{"name":"fire-memory","url":"https://pokeapi.co/api/v2/item/910/"},{"name":"water-memory","url":"https://pokeapi.co/api/v2/item/911/"},{"name":"grass-memory","url":"https://pokeapi.co/api/v2/item/912/"},{"name":"electric-memory","url":"https://pokeapi.co/api/v2/item/913/"},{"name":"psychic-memory","url":"https://pokeapi.co/api/v2/item/914/"},{"name":"ice-memory","url":"https://pokeapi.co/api/v2/item/915/"},{"name":"dragon-memory","url":"https://pokeapi.co/api/v2/item/916/"},{"name":"dark-memory","url":"https://pokeapi.co/api/v2/item/917/"},{"name":"fairy-memory","url":"https://pokeapi.co/api/v2/item/918/"},{"name":"bike--green","url":"https://pokeapi.co/api/v2/item/919/"},{"name":"storage-key--galactic-warehouse","url":"https://pokeapi.co/api/v2/item/920/"},{"name":"basement-key--goldenrod","url":"https://pokeapi.co/api/v2/item/921/"},{"name":"xtranceiver--red","url":"https://pokeapi.co/api/v2/item/922/"},{"name":"xtranceiver--yellow","url":"https://pokeapi.co/api/v2/item/923/"},{"name":"dna-splicers--merge","url":"https://pokeapi.co/api/v2/item/924/"},{"name":"dna-splicers--split","url":"https://pokeapi.co/api/v2/item/925/"},{"name":"dropped-item--red","url":"https://pokeapi.co/api/v2/item/926/"},{"name":"dropped-item--yellow","url":"https://pokeapi.co/api/v2/item/927/"},{"name":"holo-caster--green","url":"https://pokeapi.co/api/v2/item/928/"},{"name":"bike--yellow","url":"https://pokeapi.co/api/v2/item/929/"},{"name":"holo-caster--red","url":"https://pokeapi.co/api/v2/item/930/"},{"name":"basement-key--new-mauville","url":"https://pokeapi.co/api/v2/item/931/"},{"name":"storage-key--sea-mauville","url":"https://pokeapi.co/api/v2/item/932/"},{"name":"ss-ticket--hoenn","url":"https://pokeapi.co/api/v2/item/933/"},{"name":"contest-costume--dress","url":"https://pokeapi.co/api/v2/item/934/"},{"name":"meteorite--2","url":"https://pokeapi.co/api/v2/item/935/"},{"name":"meteorite--3","url":"https://pokeapi.co/api/v2/item/936/"},{"name":"meteorite--4","url":"https://pokeapi.co/api/v2/item/937/"},{"name":"normalium-z--bag","url":"https://pokeapi.co/api/v2/item/938/"},{"name":"firium-z--bag","url":"https://pokeapi.co/api/v2/item/939/"},{"name":"waterium-z--bag","url":"https://pokeapi.co/api/v2/item/940/"},{"name":"electrium-z--bag","url":"https://pokeapi.co/api/v2/item/941/"},{"name":"grassium-z--bag","url":"https://pokeapi.co/api/v2/item/942/"},{"name":"icium-z--bag","url":"https://pokeapi.co/api/v2/item/943/"},{"name":"fightinium-z--bag","url":"https://pokeapi.co/api/v2/item/944/"},{"name":"poisonium-z--bag","url":"https://pokeapi.co/api/v2/item/945/"},{"name":"groundium-z--bag","url":"https://pokeapi.co/api/v2/item/946/"},{"name":"flyinium-z--bag","url":"https://pokeapi.co/api/v2/item/947/"},{"name":"psychium-z--bag","url":"https://pokeapi.co/api/v2/item/948/"},{"name":"buginium-z--bag","url":"https://pokeapi.co/api/v2/item/949/"},{"name":"rockium-z--bag","url":"https://pokeapi.co/api/v2/item/950/"},{"name":"ghostium-z--bag","url":"https://pokeapi.co/api/v2/item/951/"},{"name":"dragonium-z--bag","url":"https://pokeapi.co/api/v2/item/952/"},{"name":"darkinium-z--bag","url":"https://pokeapi.co/api/v2/item/953/"},{"name":"steelium-z--bag","url":"https://pokeapi.co/api/v2/item/954/"},{"name":"fairium-z--bag","url":"https://pokeapi.co/api/v2/item/955/"},{"name":"pikanium-z--bag","url":"https://pokeapi.co/api/v2/item/956/"},{"name":"decidium-z--bag","url":"https://pokeapi.co/api/v2/item/957/"},{"name":"incinium-z--bag","url":"https://pokeapi.co/api/v2/item/958/"},{"name":"primarium-z--bag","url":"https://pokeapi.co/api/v2/item/959/"},{"name":"tapunium-z--bag","url":"https://pokeapi.co/api/v2/item/960/"},{"name":"marshadium-z--bag","url":"https://pokeapi.co/api/v2/item/961/"},{"name":"aloraichium-z--bag","url":"https://pokeapi.co/api/v2/item/962/"},{"name":"snorlium-z--bag","url":"https://pokeapi.co/api/v2/item/963/"},{"name":"eevium-z--bag","url":"https://pokeapi.co/api/v2/item/964/"},{"name":"mewnium-z--bag","url":"https://pokeapi.co/api/v2/item/965/"},{"name":"pikashunium-z--bag","url":"https://pokeapi.co/api/v2/item/966/"},{"name":"solganium-z--held","url":"https://pokeapi.co/api/v2/item/967/"},{"name":"lunalium-z--held","url":"https://pokeapi.co/api/v2/item/968/"},{"name":"ultranecrozium-z--held","url":"https://pokeapi.co/api/v2/item/969/"},{"name":"mimikium-z--held","url":"https://pokeapi.co/api/v2/item/970/"},{"name":"lycanium-z--held","url":"https://pokeapi.co/api/v2/item/971/"},{"name":"kommonium-z--held","url":"https://pokeapi.co/api/v2/item/972/"},{"name":"solganium-z--bag","url":"https://pokeapi.co/api/v2/item/973/"},{"name":"lunalium-z--bag","url":"https://pokeapi.co/api/v2/item/974/"},{"name":"ultranecrozium-z--bag","url":"https://pokeapi.co/api/v2/item/975/"},{"name":"mimikium-z--bag","url":"https://pokeapi.co/api/v2/item/976/"},{"name":"lycanium-z--bag","url":"https://pokeapi.co/api/v2/item/977/"},{"name":"kommonium-z--bag","url":"https://pokeapi.co/api/v2/item/978/"},{"name":"z-power-ring","url":"https://pokeapi.co/api/v2/item/979/"},{"name":"pink-petal","url":"https://pokeapi.co/api/v2/item/980/"},{"name":"orange-petal","url":"https://pokeapi.co/api/v2/item/981/"},{"name":"blue-petal","url":"https://pokeapi.co/api/v2/item/982/"},{"name":"red-petal","url":"https://pokeapi.co/api/v2/item/983/"},{"name":"green-petal","url":"https://pokeapi.co/api/v2/item/984/"},{"name":"yellow-petal","url":"https://pokeapi.co/api/v2/item/985/"},{"name":"purple-petal","url":"https://pokeapi.co/api/v2/item/986/"},{"name":"rainbow-flower","url":"https://pokeapi.co/api/v2/item/987/"},{"name":"surge-badge","url":"https://pokeapi.co/api/v2/item/988/"},{"name":"n-solarizer--merge","url":"https://pokeapi.co/api/v2/item/989/"},{"name":"n-lunarizer--merge","url":"https://pokeapi.co/api/v2/item/990/"},{"name":"n-solarizer--split","url":"https://pokeapi.co/api/v2/item/991/"},{"name":"n-lunarizer--split","url":"https://pokeapi.co/api/v2/item/992/"},{"name":"ilimas-normalium-z","url":"https://pokeapi.co/api/v2/item/993/"},{"name":"left-poke-ball","url":"https://pokeapi.co/api/v2/item/994/"},{"name":"roto-hatch","url":"https://pokeapi.co/api/v2/item/995/"},{"name":"roto-bargain","url":"https://pokeapi.co/api/v2/item/996/"},{"name":"roto-prize-money","url":"https://pokeapi.co/api/v2/item/997/"},{"name":"roto-exp-points","url":"https://pokeapi.co/api/v2/item/998/"},{"name":"roto-friendship","url":"https://pokeapi.co/api/v2/item/999/"},{"name":"roto-encounter","url":"https://pokeapi.co/api/v2/item/1000/"},{"name":"roto-stealth","url":"https://pokeapi.co/api/v2/item/1001/"},{"name":"roto-hp-restore","url":"https://pokeapi.co/api/v2/item/1002/"},{"name":"roto-pp-restore","url":"https://pokeapi.co/api/v2/item/1003/"},{"name":"roto-boost","url":"https://pokeapi.co/api/v2/item/1004/"},{"name":"roto-catch","url":"https://pokeapi.co/api/v2/item/1005/"}]}"#;

// https://pokeapi.co/api/v2/item-attribute/?offset=0&limit=9999
static FULL_ITEM_ATTRIBUTE_LIST_JSON: &str = r#"{"count":8,"next":null,"previous":null,"results":[{"name":"countable","url":"https://pokeapi.co/api/v2/item-attribute/1/"},{"name":"consumable","url":"https://pokeapi.co/api/v2/item-attribute/2/"},{"name":"usable-overworld","url":"https://pokeapi.co/api/v2/item-attribute/3/"},{"name":"usable-in-battle","url":"https://pokeapi.co/api/v2/item-attribute/4/"},{"name":"holdable","url":"https://pokeapi.co/api/v2/item-attribute/5/"},{"name":"holdable-passive","url":"https://pokeapi.co/api/v2/item-attribute/6/"},{"name":"holdable-active","url":"https://pokeapi.co/api/v2/item-attribute/7/"},{"name":"underground","url":"https://pokeapi.co/api/v2/item-attribute/8/"}]}"#;

// https://pokeapi.co/api/v2/item-category/?offset=0&limit=9999
static FULL_ITEM_CATEGORY_LIST_JSON: &str = r#"{"count":45,"next":null,"previous":null,"results":[{"name":"stat-boosts","url":"https://pokeapi.co/api/v2/item-category/1/"},{"name":"effort-drop","url":"https://pokeapi.co/api/v2/item-category/2/"},{"name":"medicine","url":"https://pokeapi.co/api/v2/item-category/3/"},{"name":"other","url":"https://pokeapi.co/api/v2/item-category/4/"},{"name":"in-a-pinch","url":"https://pokeapi.co/api/v2/item-category/5/"},{"name":"picky-healing","url":"https://pokeapi.co/api/v2/item-category/6/"},{"name":"type-protection","url":"https://pokeapi.co/api/v2/item-category/7/"},{"name":"baking-only","url":"https://pokeapi.co/api/v2/item-category/8/"},{"name":"collectibles","url":"https://pokeapi.co/api/v2/item-category/9/"},{"name":"evolution","url":"https://pokeapi.co/api/v2/item-category/10/"},{"name":"spelunking","url":"https://pokeapi.co/api/v2/item-category/11/"},{"name":"held-items","url":"https://pokeapi.co/api/v2/item-category/12/"},{"name":"choice","url":"https://pokeapi.co/api/v2/item-category/13/"},{"name":"effort-training","url":"https://pokeapi.co/api/v2/item-category/14/"},{"name":"bad-held-items","url":"https://pokeapi.co/api/v2/item-category/15/"},{"name":"training","url":"https://pokeapi.co/api/v2/item-category/16/"},{"name":"plates","url":"https://pokeapi.co/api/v2/item-category/17/"},{"name":"species-specific","url":"https://pokeapi.co/api/v2/item-category/18/"},{"name":"type-enhancement","url":"https://pokeapi.co/api/v2/item-category/19/"},{"name":"event-items","url":"https://pokeapi.co/api/v2/item-category/20/"},{"name":"gameplay","url":"https://pokeapi.co/api/v2/item-category/21/"},{"name":"plot-advancement","url":"https://pokeapi.co/api/v2/item-category/22/"},{"name":"unused","url":"https://pokeapi.co/api/v2/item-category/23/"},{"name":"loot","url":"https://pokeapi.co/api/v2/item-category/24/"},{"name":"all-mail","url":"https://pokeapi.co/api/v2/item-category/25/"},{"name":"vitamins","url":"https://pokeapi.co/api/v2/item-category/26/"},{"name":"healing","url":"https://pokeapi.co/api/v2/item-category/27/"},{"name":"pp-recovery","url":"https://pokeapi.co/api/v2/item-category/28/"},{"name":"revival","url":"https://pokeapi.co/api/v2/item-category/29/"},{"name":"status-cures","url":"https://pokeapi.co/api/v2/item-category/30/"},{"name":"mulch","url":"https://pokeapi.co/api/v2/item-category/32/"},{"name":"special-balls","url":"https://pokeapi.co/api/v2/item-category/33/"},{"name":"standard-balls","url":"https://pokeapi.co/api/v2/item-category/34/"},{"name":"dex-completion","url":"https://pokeapi.co/api/v2/item-category/35/"},{"name":"scarves","url":"https://pokeapi.co/api/v2/item-category/36/"},{"name":"all-machines","url":"https://pokeapi.co/api/v2/item-category/37/"},{"name":"flutes","url":"https://pokeapi.co/api/v2/item-category/38/"},{"name":"apricorn-balls","url":"https://pokeapi.co/api/v2/item-category/39/"},{"name":"apricorn-box","url":"https://pokeapi.co/api/v2/item-category/40/"},{"name":"data-cards","url":"https://pokeapi.co/api/v2/item-category/41/"},{"name":"jewels","url":"https://pokeapi.co/api/v2/item-category/42/"},{"name":"miracle-shooter","url":"https://pokeapi.co/api/v2/item-category/43/"},{"name":"mega-stones","url":"https://pokeapi.co/api/v2/item-category/44/"},{"name":"memories","url":"https://pokeapi.co/api/v2/item-category/45/"},{"name":"z-crystals","url":"https://pokeapi.co/api/v2/item-category/46/"}]}"#;

// https://pokeapi.co/api/v2/item-fling-effect/?offset=0&limit=9999
static FULL_ITEM_FLING_EFFECT_LIST_JSON: &str = r#"{"count":7,"next":null,"previous":null,"results":[{"name":"badly-poison","url":"https://pokeapi.co/api/v2/item-fling-effect/1/"},{"name":"burn","url":"https://pokeapi.co/api/v2/item-fling-effect/2/"},{"name":"berry-effect","url":"https://pokeapi.co/api/v2/item-fling-effect/3/"},{"name":"herb-effect","url":"https://pokeapi.co/api/v2/item-fling-effect/4/"},{"name":"paralyze","url":"https://pokeapi.co/api/v2/item-fling-effect/5/"},{"name":"poison","url":"https://pokeapi.co/api/v2/item-fling-effect/6/"},{"name":"flinch","url":"https://pokeapi.co/api/v2/item-fling-effect/7/"}]}"#;

// https://pokeapi.co/api/v2/item-pocket/?offset=0&limit=9999
static FULL_ITEM_POCKET_LIST_JSON: &str = r#"{"count":8,"next":null,"previous":null,"results":[{"name":"misc","url":"https://pokeapi.co/api/v2/item-pocket/1/"},{"name":"medicine","url":"https://pokeapi.co/api/v2/item-pocket/2/"},{"name":"pokeballs","url":"https://pokeapi.co/api/v2/item-pocket/3/"},{"name":"machines","url":"https://pokeapi.co/api/v2/item-pocket/4/"},{"name":"berries","url":"https://pokeapi.co/api/v2/item-pocket/5/"},{"name":"mail","url":"https://pokeapi.co/api/v2/item-pocket/6/"},{"name":"battle","url":"https://pokeapi.co/api/v2/item-pocket/7/"},{"name":"key","url":"https://pokeapi.co/api/v2/item-pocket/8/"}]}"#;

// https://pokeapi.co/api/v2/language/?offset=0&limit=9999
static FULL_LANGUAGE_LIST_JSON: &str = r#"{"count":12,"next":null,"previous":null,"results":[{"name":"ja-Hrkt","url":"https://pokeapi.co/api/v2/language/1/"},{"name":"roomaji","url":"https://pokeapi.co/api/v2/language/2/"},{"name":"ko","url":"https://pokeapi.co/api/v2/language/3/"},{"name":"zh-Hant","url":"https://pokeapi.co/api/v2/language/4/"},{"name":"fr","url":"https://pokeapi.co/api/v2/language/5/"},{"name":"de","url":"https://pokeapi.co/api/v2/language/6/"},{"name":"es","url":"https://pokeapi.co/api/v2/language/7/"},{"name":"it","url":"https://pokeapi.co/api/v2/language/8/"},{"name":"en","url":"https://pokeapi.co/api/v2/language/9/"},{"name":"cs","url":"https://pokeapi.co/api/v2/language/10/"},{"name":"ja","url":"https://pokeapi.co/api/v2/language/11/"},{"name":"zh-Hans","url":"https://pokeapi.co/api/v2/language/12/"}]}"#;

// https://pokeapi.co/api/v2/location/?offset=0&limit=9999
static FULL_LOCATION_LIST_JSON: &str = r#"{"count":781,"next":null,"previous":null,"results":[{"name":"canalave-city","url":"https://pokeapi.co/api/v2/location/1/"},{"name":"eterna-city","url":"https://pokeapi.co/api/v2/location/2/"},{"name":"pastoria-city","url":"https://pokeapi.co/api/v2/location/3/"},{"name":"sunyshore-city","url":"https://pokeapi.co/api/v2/location/4/"},{"name":"sinnoh-pokemon-league","url":"https://pokeapi.co/api/v2/location/5/"},{"name":"oreburgh-mine","url":"https://pokeapi.co/api/v2/location/6/"},{"name":"valley-windworks","url":"https://pokeapi.co/api/v2/location/7/"},{"name":"eterna-forest","url":"https://pokeapi.co/api/v2/location/8/"},{"name":"fuego-ironworks","url":"https://pokeapi.co/api/v2/location/9/"},{"name":"mt-coronet","url":"https://pokeapi.co/api/v2/location/10/"},{"name":"great-marsh","url":"https://pokeapi.co/api/v2/location/11/"},{"name":"solaceon-ruins","url":"https://pokeapi.co/api/v2/location/12/"},{"name":"sinnoh-victory-road","url":"https://pokeapi.co/api/v2/location/13/"},{"name":"ravaged-path","url":"https://pokeapi.co/api/v2/location/14/"},{"name":"oreburgh-gate","url":"https://pokeapi.co/api/v2/location/15/"},{"name":"stark-mountain","url":"https://pokeapi.co/api/v2/location/16/"},{"name":"spring-path","url":"https://pokeapi.co/api/v2/location/17/"},{"name":"turnback-cave","url":"https://pokeapi.co/api/v2/location/18/"},{"name":"snowpoint-temple","url":"https://pokeapi.co/api/v2/location/19/"},{"name":"wayward-cave","url":"https://pokeapi.co/api/v2/location/20/"},{"name":"ruin-maniac-cave","url":"https://pokeapi.co/api/v2/location/22/"},{"name":"trophy-garden","url":"https://pokeapi.co/api/v2/location/23/"},{"name":"iron-island","url":"https://pokeapi.co/api/v2/location/24/"},{"name":"old-chateau","url":"https://pokeapi.co/api/v2/location/25/"},{"name":"lake-verity","url":"https://pokeapi.co/api/v2/location/26/"},{"name":"lake-valor","url":"https://pokeapi.co/api/v2/location/27/"},{"name":"lake-acuity","url":"https://pokeapi.co/api/v2/location/28/"},{"name":"valor-lakefront","url":"https://pokeapi.co/api/v2/location/29/"},{"name":"acuity-lakefront","url":"https://pokeapi.co/api/v2/location/30/"},{"name":"sinnoh-route-201","url":"https://pokeapi.co/api/v2/location/31/"},{"name":"sinnoh-route-202","url":"https://pokeapi.co/api/v2/location/32/"},{"name":"sinnoh-route-203","url":"https://pokeapi.co/api/v2/location/33/"},{"name":"sinnoh-route-204","url":"https://pokeapi.co/api/v2/location/34/"},{"name":"sinnoh-route-205","url":"https://pokeapi.co/api/v2/location/35/"},{"name":"sinnoh-route-206","url":"https://pokeapi.co/api/v2/location/36/"},{"name":"sinnoh-route-207","url":"https://pokeapi.co/api/v2/location/37/"},{"name":"sinnoh-route-208","url":"https://pokeapi.co/api/v2/location/38/"},{"name":"sinnoh-route-209","url":"https://pokeapi.co/api/v2/location/39/"},{"name":"lost-tower","url":"https://pokeapi.co/api/v2/location/40/"},{"name":"sinnoh-route-210","url":"https://pokeapi.co/api/v2/location/41/"},{"name":"sinnoh-route-211","url":"https://pokeapi.co/api/v2/location/42/"},{"name":"sinnoh-route-212","url":"https://pokeapi.co/api/v2/location/43/"},{"name":"sinnoh-route-213","url":"https://pokeapi.co/api/v2/location/44/"},{"name":"sinnoh-route-214","url":"https://pokeapi.co/api/v2/location/45/"},{"name":"sinnoh-route-215","url":"https://pokeapi.co/api/v2/location/46/"},{"name":"sinnoh-route-216","url":"https://pokeapi.co/api/v2/location/47/"},{"name":"sinnoh-route-217","url":"https://pokeapi.co/api/v2/location/48/"},{"name":"sinnoh-route-218","url":"https://pokeapi.co/api/v2/location/49/"},{"name":"sinnoh-route-219","url":"https://pokeapi.co/api/v2/location/50/"},{"name":"sinnoh-route-221","url":"https://pokeapi.co/api/v2/location/51/"},{"name":"sinnoh-route-222","url":"https://pokeapi.co/api/v2/location/52/"},{"name":"sinnoh-route-224","url":"https://pokeapi.co/api/v2/location/53/"},{"name":"sinnoh-route-225","url":"https://pokeapi.co/api/v2/location/54/"},{"name":"sinnoh-route-227","url":"https://pokeapi.co/api/v2/location/55/"},{"name":"sinnoh-route-228","url":"https://pokeapi.co/api/v2/location/56/"},{"name":"sinnoh-route-229","url":"https://pokeapi.co/api/v2/location/57/"},{"name":"twinleaf-town","url":"https://pokeapi.co/api/v2/location/58/"},{"name":"celestic-town","url":"https://pokeapi.co/api/v2/location/59/"},{"name":"resort-area","url":"https://pokeapi.co/api/v2/location/60/"},{"name":"sinnoh-sea-route-220","url":"https://pokeapi.co/api/v2/location/61/"},{"name":"sinnoh-sea-route-223","url":"https://pokeapi.co/api/v2/location/62/"},{"name":"sinnoh-sea-route-226","url":"https://pokeapi.co/api/v2/location/63/"},{"name":"sinnoh-sea-route-230","url":"https://pokeapi.co/api/v2/location/64/"},{"name":"blackthorn-city","url":"https://pokeapi.co/api/v2/location/65/"},{"name":"burned-tower","url":"https://pokeapi.co/api/v2/location/66/"},{"name":"celadon-city","url":"https://pokeapi.co/api/v2/location/67/"},{"name":"cerulean-city","url":"https://pokeapi.co/api/v2/location/68/"},{"name":"cherrygrove-city","url":"https://pokeapi.co/api/v2/location/69/"},{"name":"cianwood-city","url":"https://pokeapi.co/api/v2/location/70/"},{"name":"cinnabar-island","url":"https://pokeapi.co/api/v2/location/71/"},{"name":"dark-cave","url":"https://pokeapi.co/api/v2/location/72/"},{"name":"digletts-cave","url":"https://pokeapi.co/api/v2/location/73/"},{"name":"dragons-den","url":"https://pokeapi.co/api/v2/location/74/"},{"name":"ecruteak-city","url":"https://pokeapi.co/api/v2/location/75/"},{"name":"fuchsia-city","url":"https://pokeapi.co/api/v2/location/76/"},{"name":"ice-path","url":"https://pokeapi.co/api/v2/location/77/"},{"name":"ilex-forest","url":"https://pokeapi.co/api/v2/location/78/"},{"name":"lake-of-rage","url":"https://pokeapi.co/api/v2/location/79/"},{"name":"mt-moon","url":"https://pokeapi.co/api/v2/location/80/"},{"name":"mt-mortar","url":"https://pokeapi.co/api/v2/location/81/"},{"name":"mt-silver","url":"https://pokeapi.co/api/v2/location/82/"},{"name":"national-park","url":"https://pokeapi.co/api/v2/location/83/"},{"name":"new-bark-town","url":"https://pokeapi.co/api/v2/location/84/"},{"name":"olivine-city","url":"https://pokeapi.co/api/v2/location/85/"},{"name":"pallet-town","url":"https://pokeapi.co/api/v2/location/86/"},{"name":"rock-tunnel","url":"https://pokeapi.co/api/v2/location/87/"},{"name":"kanto-route-1","url":"https://pokeapi.co/api/v2/location/88/"},{"name":"kanto-route-10","url":"https://pokeapi.co/api/v2/location/89/"},{"name":"kanto-route-11","url":"https://pokeapi.co/api/v2/location/90/"},{"name":"kanto-route-12","url":"https://pokeapi.co/api/v2/location/91/"},{"name":"kanto-route-13","url":"https://pokeapi.co/api/v2/location/92/"},{"name":"kanto-route-14","url":"https://pokeapi.co/api/v2/location/93/"},{"name":"kanto-route-15","url":"https://pokeapi.co/api/v2/location/94/"},{"name":"kanto-route-16","url":"https://pokeapi.co/api/v2/location/95/"},{"name":"kanto-route-17","url":"https://pokeapi.co/api/v2/location/96/"},{"name":"kanto-route-18","url":"https://pokeapi.co/api/v2/location/97/"},{"name":"kanto-sea-route-19","url":"https://pokeapi.co/api/v2/location/98/"},{"name":"kanto-route-2","url":"https://pokeapi.co/api/v2/location/99/"},{"name":"kanto-sea-route-20","url":"https://pokeapi.co/api/v2/location/100/"},{"name":"kanto-sea-route-21","url":"https://pokeapi.co/api/v2/location/101/"},{"name":"kanto-route-22","url":"https://pokeapi.co/api/v2/location/102/"},{"name":"kanto-route-24","url":"https://pokeapi.co/api/v2/location/103/"},{"name":"kanto-route-25","url":"https://pokeapi.co/api/v2/location/104/"},{"name":"kanto-route-26","url":"https://pokeapi.co/api/v2/location/105/"},{"name":"kanto-route-27","url":"https://pokeapi.co/api/v2/location/106/"},{"name":"kanto-route-28","url":"https://pokeapi.co/api/v2/location/107/"},{"name":"johto-route-29","url":"https://pokeapi.co/api/v2/location/108/"},{"name":"kanto-route-3","url":"https://pokeapi.co/api/v2/location/109/"},{"name":"johto-route-30","url":"https://pokeapi.co/api/v2/location/110/"},{"name":"johto-route-31","url":"https://pokeapi.co/api/v2/location/111/"},{"name":"johto-route-32","url":"https://pokeapi.co/api/v2/location/112/"},{"name":"johto-route-33","url":"https://pokeapi.co/api/v2/location/113/"},{"name":"johto-route-34","url":"https://pokeapi.co/api/v2/location/114/"},{"name":"johto-route-35","url":"https://pokeapi.co/api/v2/location/115/"},{"name":"johto-route-36","url":"https://pokeapi.co/api/v2/location/116/"},{"name":"johto-route-37","url":"https://pokeapi.co/api/v2/location/117/"},{"name":"johto-route-38","url":"https://pokeapi.co/api/v2/location/118/"},{"name":"johto-route-39","url":"https://pokeapi.co/api/v2/location/119/"},{"name":"kanto-route-4","url":"https://pokeapi.co/api/v2/location/120/"},{"name":"johto-sea-route-40","url":"https://pokeapi.co/api/v2/location/121/"},{"name":"johto-sea-route-41","url":"https://pokeapi.co/api/v2/location/122/"},{"name":"johto-route-42","url":"https://pokeapi.co/api/v2/location/123/"},{"name":"johto-route-43","url":"https://pokeapi.co/api/v2/location/124/"},{"name":"johto-route-44","url":"https://pokeapi.co/api/v2/location/125/"},{"name":"johto-route-45","url":"https://pokeapi.co/api/v2/location/126/"},{"name":"johto-route-46","url":"https://pokeapi.co/api/v2/location/127/"},{"name":"johto-route-47","url":"https://pokeapi.co/api/v2/location/128/"},{"name":"johto-route-48","url":"https://pokeapi.co/api/v2/location/129/"},{"name":"kanto-route-5","url":"https://pokeapi.co/api/v2/location/130/"},{"name":"kanto-route-6","url":"https://pokeapi.co/api/v2/location/131/"},{"name":"kanto-route-7","url":"https://pokeapi.co/api/v2/location/132/"},{"name":"kanto-route-8","url":"https://pokeapi.co/api/v2/location/133/"},{"name":"kanto-route-9","url":"https://pokeapi.co/api/v2/location/134/"},{"name":"ruins-of-alph","url":"https://pokeapi.co/api/v2/location/135/"},{"name":"seafoam-islands","url":"https://pokeapi.co/api/v2/location/136/"},{"name":"slowpoke-well","url":"https://pokeapi.co/api/v2/location/137/"},{"name":"sprout-tower","url":"https://pokeapi.co/api/v2/location/138/"},{"name":"bell-tower","url":"https://pokeapi.co/api/v2/location/139/"},{"name":"tohjo-falls","url":"https://pokeapi.co/api/v2/location/140/"},{"name":"union-cave","url":"https://pokeapi.co/api/v2/location/141/"},{"name":"cerulean-cave","url":"https://pokeapi.co/api/v2/location/147/"},{"name":"unknown-all-poliwag","url":"https://pokeapi.co/api/v2/location/148/"},{"name":"unknown-all-rattata","url":"https://pokeapi.co/api/v2/location/149/"},{"name":"unknown-all-bugs","url":"https://pokeapi.co/api/v2/location/150/"},{"name":"vermilion-city","url":"https://pokeapi.co/api/v2/location/151/"},{"name":"kanto-victory-road-1","url":"https://pokeapi.co/api/v2/location/152/"},{"name":"violet-city","url":"https://pokeapi.co/api/v2/location/153/"},{"name":"viridian-city","url":"https://pokeapi.co/api/v2/location/154/"},{"name":"viridian-forest","url":"https://pokeapi.co/api/v2/location/155/"},{"name":"whirl-islands","url":"https://pokeapi.co/api/v2/location/156/"},{"name":"kanto-route-23","url":"https://pokeapi.co/api/v2/location/157/"},{"name":"power-plant","url":"https://pokeapi.co/api/v2/location/158/"},{"name":"kanto-victory-road-2","url":"https://pokeapi.co/api/v2/location/159/"},{"name":"pokemon-tower","url":"https://pokeapi.co/api/v2/location/160/"},{"name":"pokemon-mansion","url":"https://pokeapi.co/api/v2/location/161/"},{"name":"kanto-safari-zone","url":"https://pokeapi.co/api/v2/location/162/"},{"name":"sandgem-town","url":"https://pokeapi.co/api/v2/location/163/"},{"name":"floaroma-town","url":"https://pokeapi.co/api/v2/location/164/"},{"name":"solaceon-town","url":"https://pokeapi.co/api/v2/location/165/"},{"name":"jubilife-city","url":"https://pokeapi.co/api/v2/location/167/"},{"name":"oreburgh-city","url":"https://pokeapi.co/api/v2/location/168/"},{"name":"hearthome-city","url":"https://pokeapi.co/api/v2/location/169/"},{"name":"veilstone-city","url":"https://pokeapi.co/api/v2/location/170/"},{"name":"snowpoint-city","url":"https://pokeapi.co/api/v2/location/171/"},{"name":"spear-pillar","url":"https://pokeapi.co/api/v2/location/172/"},{"name":"pal-park","url":"https://pokeapi.co/api/v2/location/173/"},{"name":"amity-square","url":"https://pokeapi.co/api/v2/location/174/"},{"name":"floaroma-meadow","url":"https://pokeapi.co/api/v2/location/175/"},{"name":"fullmoon-island","url":"https://pokeapi.co/api/v2/location/177/"},{"name":"sendoff-spring","url":"https://pokeapi.co/api/v2/location/178/"},{"name":"flower-paradise","url":"https://pokeapi.co/api/v2/location/179/"},{"name":"maniac-tunnel","url":"https://pokeapi.co/api/v2/location/180/"},{"name":"galactic-hq","url":"https://pokeapi.co/api/v2/location/181/"},{"name":"verity-lakefront","url":"https://pokeapi.co/api/v2/location/182/"},{"name":"newmoon-island","url":"https://pokeapi.co/api/v2/location/183/"},{"name":"sinnoh-battle-tower","url":"https://pokeapi.co/api/v2/location/184/"},{"name":"fight-area","url":"https://pokeapi.co/api/v2/location/185/"},{"name":"survival-area","url":"https://pokeapi.co/api/v2/location/186/"},{"name":"seabreak-path","url":"https://pokeapi.co/api/v2/location/187/"},{"name":"sinnoh-hall-of-origin-1","url":"https://pokeapi.co/api/v2/location/188/"},{"name":"sinnoh-hall-of-origin-2","url":"https://pokeapi.co/api/v2/location/189/"},{"name":"verity-cavern","url":"https://pokeapi.co/api/v2/location/190/"},{"name":"valor-cavern","url":"https://pokeapi.co/api/v2/location/191/"},{"name":"acuity-cavern","url":"https://pokeapi.co/api/v2/location/192/"},{"name":"jubilife-tv","url":"https://pokeapi.co/api/v2/location/193/"},{"name":"poketch-co","url":"https://pokeapi.co/api/v2/location/194/"},{"name":"gts","url":"https://pokeapi.co/api/v2/location/195/"},{"name":"trainers-school","url":"https://pokeapi.co/api/v2/location/196/"},{"name":"mining-museum","url":"https://pokeapi.co/api/v2/location/197/"},{"name":"sinnoh-flower-shop","url":"https://pokeapi.co/api/v2/location/198/"},{"name":"sinnoh-cycle-shop","url":"https://pokeapi.co/api/v2/location/199/"},{"name":"contest-hall","url":"https://pokeapi.co/api/v2/location/200/"},{"name":"poffin-house","url":"https://pokeapi.co/api/v2/location/201/"},{"name":"sinnoh-foreign-building","url":"https://pokeapi.co/api/v2/location/202/"},{"name":"pokemon-day-care","url":"https://pokeapi.co/api/v2/location/203/"},{"name":"veilstone-store","url":"https://pokeapi.co/api/v2/location/204/"},{"name":"sinnoh-game-corner","url":"https://pokeapi.co/api/v2/location/205/"},{"name":"canalave-library","url":"https://pokeapi.co/api/v2/location/206/"},{"name":"vista-lighthouse","url":"https://pokeapi.co/api/v2/location/207/"},{"name":"sunyshore-market","url":"https://pokeapi.co/api/v2/location/208/"},{"name":"footstep-house","url":"https://pokeapi.co/api/v2/location/209/"},{"name":"sinnoh-cafe","url":"https://pokeapi.co/api/v2/location/210/"},{"name":"grand-lake","url":"https://pokeapi.co/api/v2/location/211/"},{"name":"sinnoh-restaurant","url":"https://pokeapi.co/api/v2/location/212/"},{"name":"battle-park","url":"https://pokeapi.co/api/v2/location/213/"},{"name":"battle-frontier","url":"https://pokeapi.co/api/v2/location/214/"},{"name":"battle-factory","url":"https://pokeapi.co/api/v2/location/215/"},{"name":"battle-castle","url":"https://pokeapi.co/api/v2/location/216/"},{"name":"battle-arcade","url":"https://pokeapi.co/api/v2/location/217/"},{"name":"battle-hall","url":"https://pokeapi.co/api/v2/location/218/"},{"name":"distortion-world","url":"https://pokeapi.co/api/v2/location/219/"},{"name":"sinnoh-global-terminal","url":"https://pokeapi.co/api/v2/location/220/"},{"name":"sinnoh-villa","url":"https://pokeapi.co/api/v2/location/221/"},{"name":"battleground","url":"https://pokeapi.co/api/v2/location/222/"},{"name":"rotoms-room","url":"https://pokeapi.co/api/v2/location/223/"},{"name":"tg-eterna-bldg","url":"https://pokeapi.co/api/v2/location/224/"},{"name":"iron-ruins","url":"https://pokeapi.co/api/v2/location/225/"},{"name":"iceberg-ruins","url":"https://pokeapi.co/api/v2/location/226/"},{"name":"rock-peak-ruins","url":"https://pokeapi.co/api/v2/location/227/"},{"name":"azalea-town","url":"https://pokeapi.co/api/v2/location/228/"},{"name":"goldenrod-city","url":"https://pokeapi.co/api/v2/location/229/"},{"name":"mahogany-town","url":"https://pokeapi.co/api/v2/location/230/"},{"name":"pewter-city","url":"https://pokeapi.co/api/v2/location/231/"},{"name":"lavender-town","url":"https://pokeapi.co/api/v2/location/232/"},{"name":"indigo-plateau","url":"https://pokeapi.co/api/v2/location/233/"},{"name":"saffron-city","url":"https://pokeapi.co/api/v2/location/234/"},{"name":"johto-lighthouse","url":"https://pokeapi.co/api/v2/location/236/"},{"name":"team-rocket-hq","url":"https://pokeapi.co/api/v2/location/237/"},{"name":"goldenrod-tunnel","url":"https://pokeapi.co/api/v2/location/238/"},{"name":"mt-silver-cave","url":"https://pokeapi.co/api/v2/location/239/"},{"name":"pokeathlon-dome","url":"https://pokeapi.co/api/v2/location/241/"},{"name":"ss-aqua","url":"https://pokeapi.co/api/v2/location/242/"},{"name":"safari-zone-gate","url":"https://pokeapi.co/api/v2/location/243/"},{"name":"cliff-cave","url":"https://pokeapi.co/api/v2/location/244/"},{"name":"frontier-access","url":"https://pokeapi.co/api/v2/location/245/"},{"name":"bellchime-trail","url":"https://pokeapi.co/api/v2/location/246/"},{"name":"sinjoh-ruins","url":"https://pokeapi.co/api/v2/location/247/"},{"name":"embedded-tower","url":"https://pokeapi.co/api/v2/location/248/"},{"name":"pokewalker","url":"https://pokeapi.co/api/v2/location/249/"},{"name":"cliff-edge-gate","url":"https://pokeapi.co/api/v2/location/250/"},{"name":"radio-tower","url":"https://pokeapi.co/api/v2/location/252/"},{"name":"day-care-couple","url":"https://pokeapi.co/api/v2/location/253/"},{"name":"link-trade-arrive","url":"https://pokeapi.co/api/v2/location/254/"},{"name":"link-trade-met","url":"https://pokeapi.co/api/v2/location/255/"},{"name":"kanto","url":"https://pokeapi.co/api/v2/location/256/"},{"name":"johto","url":"https://pokeapi.co/api/v2/location/257/"},{"name":"hoenn","url":"https://pokeapi.co/api/v2/location/258/"},{"name":"sinnoh","url":"https://pokeapi.co/api/v2/location/259/"},{"name":"distant-land","url":"https://pokeapi.co/api/v2/location/260/"},{"name":"traveling-man","url":"https://pokeapi.co/api/v2/location/261/"},{"name":"riley","url":"https://pokeapi.co/api/v2/location/262/"},{"name":"cynthia","url":"https://pokeapi.co/api/v2/location/263/"},{"name":"mystery-zone","url":"https://pokeapi.co/api/v2/location/264/"},{"name":"lovely-place","url":"https://pokeapi.co/api/v2/location/265/"},{"name":"pokemon-ranger","url":"https://pokeapi.co/api/v2/location/266/"},{"name":"faraway-place","url":"https://pokeapi.co/api/v2/location/267/"},{"name":"pokemon-movie","url":"https://pokeapi.co/api/v2/location/268/"},{"name":"pokemon-movie-06","url":"https://pokeapi.co/api/v2/location/269/"},{"name":"pokemon-movie-07","url":"https://pokeapi.co/api/v2/location/270/"},{"name":"pokemon-movie-08","url":"https://pokeapi.co/api/v2/location/271/"},{"name":"pokemon-movie-09","url":"https://pokeapi.co/api/v2/location/272/"},{"name":"pokemon-movie-10","url":"https://pokeapi.co/api/v2/location/273/"},{"name":"pokemon-movie-11","url":"https://pokeapi.co/api/v2/location/274/"},{"name":"pokemon-movie-12","url":"https://pokeapi.co/api/v2/location/275/"},{"name":"pokemon-movie-13","url":"https://pokeapi.co/api/v2/location/276/"},{"name":"pokemon-movie-14","url":"https://pokeapi.co/api/v2/location/277/"},{"name":"pokemon-movie-15","url":"https://pokeapi.co/api/v2/location/278/"},{"name":"pokemon-movie-16","url":"https://pokeapi.co/api/v2/location/279/"},{"name":"pokemon-cartoon","url":"https://pokeapi.co/api/v2/location/280/"},{"name":"space-world","url":"https://pokeapi.co/api/v2/location/281/"},{"name":"space-world-06","url":"https://pokeapi.co/api/v2/location/282/"},{"name":"space-world-07","url":"https://pokeapi.co/api/v2/location/283/"},{"name":"space-world-08","url":"https://pokeapi.co/api/v2/location/284/"},{"name":"space-world-09","url":"https://pokeapi.co/api/v2/location/285/"},{"name":"space-world-10","url":"https://pokeapi.co/api/v2/location/286/"},{"name":"space-world-11","url":"https://pokeapi.co/api/v2/location/287/"},{"name":"space-world-12","url":"https://pokeapi.co/api/v2/location/288/"},{"name":"space-world-13","url":"https://pokeapi.co/api/v2/location/289/"},{"name":"space-world-14","url":"https://pokeapi.co/api/v2/location/290/"},{"name":"space-world-15","url":"https://pokeapi.co/api/v2/location/291/"},{"name":"space-world-16","url":"https://pokeapi.co/api/v2/location/292/"},{"name":"pokemon-festa","url":"https://pokeapi.co/api/v2/location/293/"},{"name":"pokemon-festa-06","url":"https://pokeapi.co/api/v2/location/294/"},{"name":"pokemon-festa-07","url":"https://pokeapi.co/api/v2/location/295/"},{"name":"pokemon-festa-08","url":"https://pokeapi.co/api/v2/location/296/"},{"name":"pokemon-festa-09","url":"https://pokeapi.co/api/v2/location/297/"},{"name":"pokemon-festa-10","url":"https://pokeapi.co/api/v2/location/298/"},{"name":"pokemon-festa-11","url":"https://pokeapi.co/api/v2/location/299/"},{"name":"pokemon-festa-12","url":"https://pokeapi.co/api/v2/location/300/"},{"name":"pokemon-festa-13","url":"https://pokeapi.co/api/v2/location/301/"},{"name":"pokemon-festa-14","url":"https://pokeapi.co/api/v2/location/302/"},{"name":"pokemon-festa-15","url":"https://pokeapi.co/api/v2/location/303/"},{"name":"pokemon-festa-16","url":"https://pokeapi.co/api/v2/location/304/"},{"name":"pokepark","url":"https://pokeapi.co/api/v2/location/305/"},{"name":"pokepark-06","url":"https://pokeapi.co/api/v2/location/306/"},{"name":"pokepark-07","url":"https://pokeapi.co/api/v2/location/307/"},{"name":"pokepark-08","url":"https://pokeapi.co/api/v2/location/308/"},{"name":"pokepark-09","url":"https://pokeapi.co/api/v2/location/309/"},{"name":"pokepark-10","url":"https://pokeapi.co/api/v2/location/310/"},{"name":"pokepark-11","url":"https://pokeapi.co/api/v2/location/311/"},{"name":"pokepark-12","url":"https://pokeapi.co/api/v2/location/312/"},{"name":"pokepark-13","url":"https://pokeapi.co/api/v2/location/313/"},{"name":"pokepark-14","url":"https://pokeapi.co/api/v2/location/314/"},{"name":"pokepark-15","url":"https://pokeapi.co/api/v2/location/315/"},{"name":"pokepark-16","url":"https://pokeapi.co/api/v2/location/316/"},{"name":"pokemon-center","url":"https://pokeapi.co/api/v2/location/317/"},{"name":"pc-tokyo","url":"https://pokeapi.co/api/v2/location/318/"},{"name":"pc-osaka","url":"https://pokeapi.co/api/v2/location/319/"},{"name":"pc-fukuoka","url":"https://pokeapi.co/api/v2/location/320/"},{"name":"pc-nagoya","url":"https://pokeapi.co/api/v2/location/321/"},{"name":"pc-sapporo","url":"https://pokeapi.co/api/v2/location/322/"},{"name":"pc-yokohama","url":"https://pokeapi.co/api/v2/location/323/"},{"name":"nintendo-world","url":"https://pokeapi.co/api/v2/location/324/"},{"name":"pokemon-event","url":"https://pokeapi.co/api/v2/location/325/"},{"name":"pokemon-event-06","url":"https://pokeapi.co/api/v2/location/326/"},{"name":"pokemon-event-07","url":"https://pokeapi.co/api/v2/location/327/"},{"name":"pokemon-event-08","url":"https://pokeapi.co/api/v2/location/328/"},{"name":"pokemon-event-09","url":"https://pokeapi.co/api/v2/location/329/"},{"name":"pokemon-event-10","url":"https://pokeapi.co/api/v2/location/330/"},{"name":"pokemon-event-11","url":"https://pokeapi.co/api/v2/location/331/"},{"name":"pokemon-event-12","url":"https://pokeapi.co/api/v2/location/332/"},{"name":"pokemon-event-13","url":"https://pokeapi.co/api/v2/location/333/"},{"name":"pokemon-event-14","url":"https://pokeapi.co/api/v2/location/334/"},{"name":"pokemon-event-15","url":"https://pokeapi.co/api/v2/location/335/"},{"name":"pokemon-event-16","url":"https://pokeapi.co/api/v2/location/336/"},{"name":"wi-fi-event","url":"https://pokeapi.co/api/v2/location/337/"},{"name":"wi-fi-gift","url":"https://pokeapi.co/api/v2/location/338/"},{"name":"pokemon-fan-club","url":"https://pokeapi.co/api/v2/location/339/"},{"name":"event-site","url":"https://pokeapi.co/api/v2/location/340/"},{"name":"concert-event","url":"https://pokeapi.co/api/v2/location/341/"},{"name":"mr-pokemon","url":"https://pokeapi.co/api/v2/location/342/"},{"name":"primo","url":"https://pokeapi.co/api/v2/location/343/"},{"name":"unova-mystery-zone","url":"https://pokeapi.co/api/v2/location/344/"},{"name":"unova-faraway-place","url":"https://pokeapi.co/api/v2/location/345/"},{"name":"nuvema-town","url":"https://pokeapi.co/api/v2/location/346/"},{"name":"accumula-town","url":"https://pokeapi.co/api/v2/location/347/"},{"name":"striaton-city","url":"https://pokeapi.co/api/v2/location/348/"},{"name":"nacrene-city","url":"https://pokeapi.co/api/v2/location/349/"},{"name":"castelia-city","url":"https://pokeapi.co/api/v2/location/350/"},{"name":"nimbasa-city","url":"https://pokeapi.co/api/v2/location/351/"},{"name":"driftveil-city","url":"https://pokeapi.co/api/v2/location/352/"},{"name":"mistralton-city","url":"https://pokeapi.co/api/v2/location/353/"},{"name":"icirrus-city","url":"https://pokeapi.co/api/v2/location/354/"},{"name":"opelucid-city","url":"https://pokeapi.co/api/v2/location/355/"},{"name":"unova-route-1","url":"https://pokeapi.co/api/v2/location/356/"},{"name":"unova-route-2","url":"https://pokeapi.co/api/v2/location/357/"},{"name":"unova-route-3","url":"https://pokeapi.co/api/v2/location/358/"},{"name":"unova-route-4","url":"https://pokeapi.co/api/v2/location/359/"},{"name":"unova-route-5","url":"https://pokeapi.co/api/v2/location/360/"},{"name":"unova-route-6","url":"https://pokeapi.co/api/v2/location/361/"},{"name":"unova-route-7","url":"https://pokeapi.co/api/v2/location/362/"},{"name":"unova-route-8","url":"https://pokeapi.co/api/v2/location/363/"},{"name":"unova-route-9","url":"https://pokeapi.co/api/v2/location/364/"},{"name":"unova-route-10","url":"https://pokeapi.co/api/v2/location/365/"},{"name":"unova-route-11","url":"https://pokeapi.co/api/v2/location/366/"},{"name":"unova-route-12","url":"https://pokeapi.co/api/v2/location/367/"},{"name":"unova-route-13","url":"https://pokeapi.co/api/v2/location/368/"},{"name":"unova-route-14","url":"https://pokeapi.co/api/v2/location/369/"},{"name":"unova-route-15","url":"https://pokeapi.co/api/v2/location/370/"},{"name":"unova-route-16","url":"https://pokeapi.co/api/v2/location/371/"},{"name":"unova-route-17","url":"https://pokeapi.co/api/v2/location/372/"},{"name":"unova-route-18","url":"https://pokeapi.co/api/v2/location/373/"},{"name":"dreamyard","url":"https://pokeapi.co/api/v2/location/374/"},{"name":"pinwheel-forest","url":"https://pokeapi.co/api/v2/location/375/"},{"name":"desert-resort","url":"https://pokeapi.co/api/v2/location/376/"},{"name":"relic-castle","url":"https://pokeapi.co/api/v2/location/377/"},{"name":"cold-storage","url":"https://pokeapi.co/api/v2/location/378/"},{"name":"chargestone-cave","url":"https://pokeapi.co/api/v2/location/379/"},{"name":"twist-mountain","url":"https://pokeapi.co/api/v2/location/380/"},{"name":"dragonspiral-tower","url":"https://pokeapi.co/api/v2/location/381/"},{"name":"unova-victory-road","url":"https://pokeapi.co/api/v2/location/382/"},{"name":"lacunosa-town","url":"https://pokeapi.co/api/v2/location/383/"},{"name":"undella-town","url":"https://pokeapi.co/api/v2/location/384/"},{"name":"anville-town","url":"https://pokeapi.co/api/v2/location/385/"},{"name":"unova-pokemon-league","url":"https://pokeapi.co/api/v2/location/386/"},{"name":"ns-castle","url":"https://pokeapi.co/api/v2/location/387/"},{"name":"royal-unova","url":"https://pokeapi.co/api/v2/location/388/"},{"name":"gear-station","url":"https://pokeapi.co/api/v2/location/389/"},{"name":"battle-subway","url":"https://pokeapi.co/api/v2/location/390/"},{"name":"musical-theater","url":"https://pokeapi.co/api/v2/location/391/"},{"name":"black-city","url":"https://pokeapi.co/api/v2/location/392/"},{"name":"white-forest","url":"https://pokeapi.co/api/v2/location/393/"},{"name":"unity-tower","url":"https://pokeapi.co/api/v2/location/394/"},{"name":"wellspring-cave","url":"https://pokeapi.co/api/v2/location/395/"},{"name":"mistralton-cave","url":"https://pokeapi.co/api/v2/location/396/"},{"name":"rumination-field","url":"https://pokeapi.co/api/v2/location/397/"},{"name":"celestial-tower","url":"https://pokeapi.co/api/v2/location/398/"},{"name":"moor-of-icirrus","url":"https://pokeapi.co/api/v2/location/399/"},{"name":"unova-shopping-mall","url":"https://pokeapi.co/api/v2/location/400/"},{"name":"challengers-cave","url":"https://pokeapi.co/api/v2/location/401/"},{"name":"poke-transfer-lab","url":"https://pokeapi.co/api/v2/location/402/"},{"name":"giant-chasm","url":"https://pokeapi.co/api/v2/location/403/"},{"name":"liberty-garden","url":"https://pokeapi.co/api/v2/location/404/"},{"name":"p2-laboratory","url":"https://pokeapi.co/api/v2/location/405/"},{"name":"skyarrow-bridge","url":"https://pokeapi.co/api/v2/location/406/"},{"name":"driftveil-drawbridge","url":"https://pokeapi.co/api/v2/location/407/"},{"name":"tubeline-bridge","url":"https://pokeapi.co/api/v2/location/408/"},{"name":"village-bridge","url":"https://pokeapi.co/api/v2/location/409/"},{"name":"marvelous-bridge","url":"https://pokeapi.co/api/v2/location/410/"},{"name":"entralink","url":"https://pokeapi.co/api/v2/location/411/"},{"name":"abundant-shrine","url":"https://pokeapi.co/api/v2/location/412/"},{"name":"undella-bay","url":"https://pokeapi.co/api/v2/location/413/"},{"name":"lostlorn-forest","url":"https://pokeapi.co/api/v2/location/414/"},{"name":"trial-chamber","url":"https://pokeapi.co/api/v2/location/415/"},{"name":"guidance-chamber","url":"https://pokeapi.co/api/v2/location/416/"},{"name":"entree-forest","url":"https://pokeapi.co/api/v2/location/417/"},{"name":"accumula-gate","url":"https://pokeapi.co/api/v2/location/418/"},{"name":"undella-gate","url":"https://pokeapi.co/api/v2/location/419/"},{"name":"nacrene-gate","url":"https://pokeapi.co/api/v2/location/420/"},{"name":"castelia-gate","url":"https://pokeapi.co/api/v2/location/421/"},{"name":"nimbasa-gate","url":"https://pokeapi.co/api/v2/location/422/"},{"name":"opelucid-gate","url":"https://pokeapi.co/api/v2/location/423/"},{"name":"black-gate","url":"https://pokeapi.co/api/v2/location/424/"},{"name":"white-gate","url":"https://pokeapi.co/api/v2/location/425/"},{"name":"bridge-gate","url":"https://pokeapi.co/api/v2/location/426/"},{"name":"route-gate","url":"https://pokeapi.co/api/v2/location/427/"},{"name":"abyssal-ruins","url":"https://pokeapi.co/api/v2/location/428/"},{"name":"petalburg-city","url":"https://pokeapi.co/api/v2/location/429/"},{"name":"slateport-city","url":"https://pokeapi.co/api/v2/location/430/"},{"name":"lilycove-city","url":"https://pokeapi.co/api/v2/location/431/"},{"name":"mossdeep-city","url":"https://pokeapi.co/api/v2/location/432/"},{"name":"sootopolis-city","url":"https://pokeapi.co/api/v2/location/433/"},{"name":"ever-grande-city","url":"https://pokeapi.co/api/v2/location/434/"},{"name":"meteor-falls","url":"https://pokeapi.co/api/v2/location/435/"},{"name":"rusturf-tunnel","url":"https://pokeapi.co/api/v2/location/436/"},{"name":"granite-cave","url":"https://pokeapi.co/api/v2/location/437/"},{"name":"petalburg-woods","url":"https://pokeapi.co/api/v2/location/438/"},{"name":"jagged-pass","url":"https://pokeapi.co/api/v2/location/439/"},{"name":"fiery-path","url":"https://pokeapi.co/api/v2/location/440/"},{"name":"mt-pyre","url":"https://pokeapi.co/api/v2/location/441/"},{"name":"seafloor-cavern","url":"https://pokeapi.co/api/v2/location/442/"},{"name":"cave-of-origin","url":"https://pokeapi.co/api/v2/location/443/"},{"name":"hoenn-victory-road","url":"https://pokeapi.co/api/v2/location/444/"},{"name":"shoal-cave","url":"https://pokeapi.co/api/v2/location/445/"},{"name":"new-mauville","url":"https://pokeapi.co/api/v2/location/446/"},{"name":"abandoned-ship","url":"https://pokeapi.co/api/v2/location/447/"},{"name":"sky-pillar","url":"https://pokeapi.co/api/v2/location/448/"},{"name":"hoenn-route-101","url":"https://pokeapi.co/api/v2/location/449/"},{"name":"hoenn-route-102","url":"https://pokeapi.co/api/v2/location/450/"},{"name":"hoenn-route-103","url":"https://pokeapi.co/api/v2/location/451/"},{"name":"hoenn-route-104","url":"https://pokeapi.co/api/v2/location/452/"},{"name":"hoenn-route-105","url":"https://pokeapi.co/api/v2/location/453/"},{"name":"hoenn-route-106","url":"https://pokeapi.co/api/v2/location/454/"},{"name":"hoenn-route-107","url":"https://pokeapi.co/api/v2/location/455/"},{"name":"hoenn-route-108","url":"https://pokeapi.co/api/v2/location/456/"},{"name":"hoenn-route-109","url":"https://pokeapi.co/api/v2/location/457/"},{"name":"hoenn-route-110","url":"https://pokeapi.co/api/v2/location/458/"},{"name":"hoenn-route-111","url":"https://pokeapi.co/api/v2/location/459/"},{"name":"hoenn-route-112","url":"https://pokeapi.co/api/v2/location/460/"},{"name":"hoenn-route-113","url":"https://pokeapi.co/api/v2/location/461/"},{"name":"hoenn-route-114","url":"https://pokeapi.co/api/v2/location/462/"},{"name":"hoenn-route-115","url":"https://pokeapi.co/api/v2/location/463/"},{"name":"hoenn-route-116","url":"https://pokeapi.co/api/v2/location/464/"},{"name":"hoenn-route-117","url":"https://pokeapi.co/api/v2/location/465/"},{"name":"hoenn-route-118","url":"https://pokeapi.co/api/v2/location/466/"},{"name":"hoenn-route-119","url":"https://pokeapi.co/api/v2/location/467/"},{"name":"hoenn-route-120","url":"https://pokeapi.co/api/v2/location/468/"},{"name":"hoenn-route-121","url":"https://pokeapi.co/api/v2/location/469/"},{"name":"hoenn-route-122","url":"https://pokeapi.co/api/v2/location/470/"},{"name":"hoenn-route-123","url":"https://pokeapi.co/api/v2/location/471/"},{"name":"hoenn-route-124","url":"https://pokeapi.co/api/v2/location/472/"},{"name":"hoenn-route-125","url":"https://pokeapi.co/api/v2/location/473/"},{"name":"hoenn-route-126","url":"https://pokeapi.co/api/v2/location/474/"},{"name":"hoenn-route-127","url":"https://pokeapi.co/api/v2/location/475/"},{"name":"hoenn-route-128","url":"https://pokeapi.co/api/v2/location/476/"},{"name":"hoenn-route-129","url":"https://pokeapi.co/api/v2/location/477/"},{"name":"hoenn-route-130","url":"https://pokeapi.co/api/v2/location/478/"},{"name":"hoenn-route-131","url":"https://pokeapi.co/api/v2/location/479/"},{"name":"hoenn-route-132","url":"https://pokeapi.co/api/v2/location/480/"},{"name":"hoenn-route-133","url":"https://pokeapi.co/api/v2/location/481/"},{"name":"hoenn-route-134","url":"https://pokeapi.co/api/v2/location/482/"},{"name":"hoenn-safari-zone","url":"https://pokeapi.co/api/v2/location/483/"},{"name":"dewford-town","url":"https://pokeapi.co/api/v2/location/484/"},{"name":"pacifidlog-town","url":"https://pokeapi.co/api/v2/location/485/"},{"name":"magma-hideout","url":"https://pokeapi.co/api/v2/location/486/"},{"name":"mirage-tower","url":"https://pokeapi.co/api/v2/location/487/"},{"name":"desert-underpass","url":"https://pokeapi.co/api/v2/location/488/"},{"name":"artisan-cave","url":"https://pokeapi.co/api/v2/location/489/"},{"name":"hoenn-altering-cave","url":"https://pokeapi.co/api/v2/location/490/"},{"name":"monean-chamber","url":"https://pokeapi.co/api/v2/location/491/"},{"name":"liptoo-chamber","url":"https://pokeapi.co/api/v2/location/492/"},{"name":"weepth-chamber","url":"https://pokeapi.co/api/v2/location/493/"},{"name":"dilford-chamber","url":"https://pokeapi.co/api/v2/location/494/"},{"name":"scufib-chamber","url":"https://pokeapi.co/api/v2/location/495/"},{"name":"rixy-chamber","url":"https://pokeapi.co/api/v2/location/496/"},{"name":"viapos-chamber","url":"https://pokeapi.co/api/v2/location/497/"},{"name":"ss-anne","url":"https://pokeapi.co/api/v2/location/498/"},{"name":"mt-ember","url":"https://pokeapi.co/api/v2/location/500/"},{"name":"berry-forest","url":"https://pokeapi.co/api/v2/location/501/"},{"name":"icefall-cave","url":"https://pokeapi.co/api/v2/location/502/"},{"name":"pattern-bush","url":"https://pokeapi.co/api/v2/location/503/"},{"name":"lost-cave","url":"https://pokeapi.co/api/v2/location/504/"},{"name":"kindle-road","url":"https://pokeapi.co/api/v2/location/505/"},{"name":"treasure-beach","url":"https://pokeapi.co/api/v2/location/506/"},{"name":"cape-brink","url":"https://pokeapi.co/api/v2/location/507/"},{"name":"bond-bridge","url":"https://pokeapi.co/api/v2/location/508/"},{"name":"three-isle-port","url":"https://pokeapi.co/api/v2/location/509/"},{"name":"resort-gorgeous","url":"https://pokeapi.co/api/v2/location/510/"},{"name":"water-labyrinth","url":"https://pokeapi.co/api/v2/location/511/"},{"name":"five-isle-meadow","url":"https://pokeapi.co/api/v2/location/512/"},{"name":"memorial-pillar","url":"https://pokeapi.co/api/v2/location/513/"},{"name":"outcast-island","url":"https://pokeapi.co/api/v2/location/514/"},{"name":"green-path","url":"https://pokeapi.co/api/v2/location/515/"},{"name":"water-path","url":"https://pokeapi.co/api/v2/location/516/"},{"name":"ruin-valley","url":"https://pokeapi.co/api/v2/location/517/"},{"name":"trainer-tower","url":"https://pokeapi.co/api/v2/location/518/"},{"name":"canyon-entrance","url":"https://pokeapi.co/api/v2/location/519/"},{"name":"sevault-canyon","url":"https://pokeapi.co/api/v2/location/520/"},{"name":"tanoby-ruins","url":"https://pokeapi.co/api/v2/location/521/"},{"name":"one-island","url":"https://pokeapi.co/api/v2/location/526/"},{"name":"four-island","url":"https://pokeapi.co/api/v2/location/527/"},{"name":"five-island","url":"https://pokeapi.co/api/v2/location/528/"},{"name":"kanto-altering-cave","url":"https://pokeapi.co/api/v2/location/529/"},{"name":"aspertia-city","url":"https://pokeapi.co/api/v2/location/531/"},{"name":"virbank-city","url":"https://pokeapi.co/api/v2/location/532/"},{"name":"humilau-city","url":"https://pokeapi.co/api/v2/location/533/"},{"name":"pokestar-studios","url":"https://pokeapi.co/api/v2/location/534/"},{"name":"join-avenue","url":"https://pokeapi.co/api/v2/location/535/"},{"name":"floccesy-town","url":"https://pokeapi.co/api/v2/location/536/"},{"name":"lentimas-town","url":"https://pokeapi.co/api/v2/location/537/"},{"name":"unova-route-19","url":"https://pokeapi.co/api/v2/location/538/"},{"name":"unova-route-20","url":"https://pokeapi.co/api/v2/location/539/"},{"name":"unova-route-21","url":"https://pokeapi.co/api/v2/location/540/"},{"name":"unova-route-22","url":"https://pokeapi.co/api/v2/location/541/"},{"name":"unova-route-23","url":"https://pokeapi.co/api/v2/location/542/"},{"name":"castelia-sewers","url":"https://pokeapi.co/api/v2/location/543/"},{"name":"floccesy-ranch","url":"https://pokeapi.co/api/v2/location/544/"},{"name":"virbank-complex","url":"https://pokeapi.co/api/v2/location/545/"},{"name":"reversal-mountain","url":"https://pokeapi.co/api/v2/location/546/"},{"name":"strange-house","url":"https://pokeapi.co/api/v2/location/547/"},{"name":"unova-victory-road-2","url":"https://pokeapi.co/api/v2/location/548/"},{"name":"plasma-frigate","url":"https://pokeapi.co/api/v2/location/549/"},{"name":"relic-passage","url":"https://pokeapi.co/api/v2/location/550/"},{"name":"clay-tunnel","url":"https://pokeapi.co/api/v2/location/551/"},{"name":"white-treehollow","url":"https://pokeapi.co/api/v2/location/552/"},{"name":"black-tower","url":"https://pokeapi.co/api/v2/location/553/"},{"name":"seaside-cave","url":"https://pokeapi.co/api/v2/location/554/"},{"name":"cave-of-being","url":"https://pokeapi.co/api/v2/location/555/"},{"name":"hidden-grotto","url":"https://pokeapi.co/api/v2/location/556/"},{"name":"marine-tube","url":"https://pokeapi.co/api/v2/location/557/"},{"name":"virbank-gate","url":"https://pokeapi.co/api/v2/location/558/"},{"name":"aspertia-gate","url":"https://pokeapi.co/api/v2/location/559/"},{"name":"nature-sanctuary","url":"https://pokeapi.co/api/v2/location/560/"},{"name":"medal-secretariat","url":"https://pokeapi.co/api/v2/location/561/"},{"name":"underground-ruins","url":"https://pokeapi.co/api/v2/location/562/"},{"name":"rocky-mountain-room","url":"https://pokeapi.co/api/v2/location/563/"},{"name":"glacier-room","url":"https://pokeapi.co/api/v2/location/564/"},{"name":"iron-room","url":"https://pokeapi.co/api/v2/location/565/"},{"name":"pledge-grove","url":"https://pokeapi.co/api/v2/location/566/"},{"name":"littleroot-town","url":"https://pokeapi.co/api/v2/location/567/"},{"name":"oldale-town","url":"https://pokeapi.co/api/v2/location/568/"},{"name":"lavaridge-town","url":"https://pokeapi.co/api/v2/location/569/"},{"name":"fallarbor-town","url":"https://pokeapi.co/api/v2/location/570/"},{"name":"verdanturf-town","url":"https://pokeapi.co/api/v2/location/571/"},{"name":"mauville-city","url":"https://pokeapi.co/api/v2/location/572/"},{"name":"rustboro-city","url":"https://pokeapi.co/api/v2/location/573/"},{"name":"fortree-city","url":"https://pokeapi.co/api/v2/location/574/"},{"name":"underwater","url":"https://pokeapi.co/api/v2/location/575/"},{"name":"mt-chimney","url":"https://pokeapi.co/api/v2/location/576/"},{"name":"mirage-island","url":"https://pokeapi.co/api/v2/location/577/"},{"name":"southern-island","url":"https://pokeapi.co/api/v2/location/578/"},{"name":"sealed-chamber","url":"https://pokeapi.co/api/v2/location/579/"},{"name":"scorched-slab","url":"https://pokeapi.co/api/v2/location/580/"},{"name":"island-cave","url":"https://pokeapi.co/api/v2/location/581/"},{"name":"desert-ruins","url":"https://pokeapi.co/api/v2/location/582/"},{"name":"ancient-tomb","url":"https://pokeapi.co/api/v2/location/583/"},{"name":"inside-of-truck","url":"https://pokeapi.co/api/v2/location/584/"},{"name":"secret-base","url":"https://pokeapi.co/api/v2/location/585/"},{"name":"hoenn-battle-tower","url":"https://pokeapi.co/api/v2/location/586/"},{"name":"vaniville-town","url":"https://pokeapi.co/api/v2/location/587/"},{"name":"kalos-route-1","url":"https://pokeapi.co/api/v2/location/588/"},{"name":"vaniville-pathway","url":"https://pokeapi.co/api/v2/location/589/"},{"name":"aquacorde-town","url":"https://pokeapi.co/api/v2/location/590/"},{"name":"kalos-route-2","url":"https://pokeapi.co/api/v2/location/591/"},{"name":"avance-trail","url":"https://pokeapi.co/api/v2/location/592/"},{"name":"santalune-forest","url":"https://pokeapi.co/api/v2/location/593/"},{"name":"kalos-route-3","url":"https://pokeapi.co/api/v2/location/594/"},{"name":"ouvert-way","url":"https://pokeapi.co/api/v2/location/595/"},{"name":"santalune-city","url":"https://pokeapi.co/api/v2/location/596/"},{"name":"kalos-route-4","url":"https://pokeapi.co/api/v2/location/597/"},{"name":"parterre-way","url":"https://pokeapi.co/api/v2/location/598/"},{"name":"lumiose-city","url":"https://pokeapi.co/api/v2/location/599/"},{"name":"prism-tower","url":"https://pokeapi.co/api/v2/location/600/"},{"name":"lysandre-labs","url":"https://pokeapi.co/api/v2/location/601/"},{"name":"kalos-route-5","url":"https://pokeapi.co/api/v2/location/602/"},{"name":"versant-road","url":"https://pokeapi.co/api/v2/location/603/"},{"name":"camphrier-town","url":"https://pokeapi.co/api/v2/location/604/"},{"name":"shabboneau-castle","url":"https://pokeapi.co/api/v2/location/605/"},{"name":"kalos-route-6","url":"https://pokeapi.co/api/v2/location/606/"},{"name":"palais-lane","url":"https://pokeapi.co/api/v2/location/607/"},{"name":"parfum-palace","url":"https://pokeapi.co/api/v2/location/608/"},{"name":"kalos-route-7","url":"https://pokeapi.co/api/v2/location/609/"},{"name":"rivière-walk","url":"https://pokeapi.co/api/v2/location/610/"},{"name":"cyllage-city","url":"https://pokeapi.co/api/v2/location/611/"},{"name":"kalos-route-8","url":"https://pokeapi.co/api/v2/location/612/"},{"name":"muraille-coast","url":"https://pokeapi.co/api/v2/location/613/"},{"name":"ambrette-town","url":"https://pokeapi.co/api/v2/location/614/"},{"name":"kalos-route-9","url":"https://pokeapi.co/api/v2/location/615/"},{"name":"spikes-passage","url":"https://pokeapi.co/api/v2/location/616/"},{"name":"battle-chateau","url":"https://pokeapi.co/api/v2/location/617/"},{"name":"kalos-route-10","url":"https://pokeapi.co/api/v2/location/618/"},{"name":"menhir-trail","url":"https://pokeapi.co/api/v2/location/619/"},{"name":"geosenge-town","url":"https://pokeapi.co/api/v2/location/620/"},{"name":"kalos-route-11","url":"https://pokeapi.co/api/v2/location/621/"},{"name":"miroir-way","url":"https://pokeapi.co/api/v2/location/622/"},{"name":"reflection-cave","url":"https://pokeapi.co/api/v2/location/623/"},{"name":"shalour-city","url":"https://pokeapi.co/api/v2/location/624/"},{"name":"tower-of-mastery","url":"https://pokeapi.co/api/v2/location/625/"},{"name":"kalos-route-12","url":"https://pokeapi.co/api/v2/location/626/"},{"name":"fourrage-road","url":"https://pokeapi.co/api/v2/location/627/"},{"name":"coumarine-city","url":"https://pokeapi.co/api/v2/location/628/"},{"name":"kalos-route-13","url":"https://pokeapi.co/api/v2/location/629/"},{"name":"lumiose-badlands","url":"https://pokeapi.co/api/v2/location/630/"},{"name":"kalos-route-14","url":"https://pokeapi.co/api/v2/location/631/"},{"name":"laverre-nature-trail","url":"https://pokeapi.co/api/v2/location/632/"},{"name":"laverre-city","url":"https://pokeapi.co/api/v2/location/633/"},{"name":"poke-ball-factory","url":"https://pokeapi.co/api/v2/location/634/"},{"name":"kalos-route-15","url":"https://pokeapi.co/api/v2/location/635/"},{"name":"brun-way","url":"https://pokeapi.co/api/v2/location/636/"},{"name":"dendemille-town","url":"https://pokeapi.co/api/v2/location/637/"},{"name":"kalos-route-16","url":"https://pokeapi.co/api/v2/location/638/"},{"name":"melancolie-path","url":"https://pokeapi.co/api/v2/location/639/"},{"name":"frost-cavern","url":"https://pokeapi.co/api/v2/location/640/"},{"name":"kalos-route-17","url":"https://pokeapi.co/api/v2/location/641/"},{"name":"mamoswine-road","url":"https://pokeapi.co/api/v2/location/642/"},{"name":"anistar-city","url":"https://pokeapi.co/api/v2/location/643/"},{"name":"kalos-route-18","url":"https://pokeapi.co/api/v2/location/644/"},{"name":"vallee-etroite-way","url":"https://pokeapi.co/api/v2/location/645/"},{"name":"couriway-town","url":"https://pokeapi.co/api/v2/location/646/"},{"name":"kalos-route-19","url":"https://pokeapi.co/api/v2/location/647/"},{"name":"grande-vallee-way","url":"https://pokeapi.co/api/v2/location/648/"},{"name":"snowbelle-city","url":"https://pokeapi.co/api/v2/location/649/"},{"name":"kalos-route-20","url":"https://pokeapi.co/api/v2/location/650/"},{"name":"winding-woods","url":"https://pokeapi.co/api/v2/location/651/"},{"name":"pokemon-village","url":"https://pokeapi.co/api/v2/location/652/"},{"name":"kalos-route-21","url":"https://pokeapi.co/api/v2/location/653/"},{"name":"dernière-way","url":"https://pokeapi.co/api/v2/location/654/"},{"name":"kalos-route-22","url":"https://pokeapi.co/api/v2/location/655/"},{"name":"detourner-way","url":"https://pokeapi.co/api/v2/location/656/"},{"name":"kalos-victory-road","url":"https://pokeapi.co/api/v2/location/657/"},{"name":"kalos-pokemon-league","url":"https://pokeapi.co/api/v2/location/658/"},{"name":"kiloude-city","url":"https://pokeapi.co/api/v2/location/659/"},{"name":"battle-maison","url":"https://pokeapi.co/api/v2/location/660/"},{"name":"azure-bay","url":"https://pokeapi.co/api/v2/location/661/"},{"name":"dendemille-gate","url":"https://pokeapi.co/api/v2/location/662/"},{"name":"couriway-gate","url":"https://pokeapi.co/api/v2/location/663/"},{"name":"ambrette-gate","url":"https://pokeapi.co/api/v2/location/664/"},{"name":"lumiose-gate","url":"https://pokeapi.co/api/v2/location/665/"},{"name":"shalour-gate","url":"https://pokeapi.co/api/v2/location/666/"},{"name":"coumarine-gate","url":"https://pokeapi.co/api/v2/location/667/"},{"name":"laverre-gate","url":"https://pokeapi.co/api/v2/location/668/"},{"name":"anistar-gate","url":"https://pokeapi.co/api/v2/location/669/"},{"name":"snowbelle-gate","url":"https://pokeapi.co/api/v2/location/670/"},{"name":"glittering-cave","url":"https://pokeapi.co/api/v2/location/671/"},{"name":"connecting-cave","url":"https://pokeapi.co/api/v2/location/672/"},{"name":"zubat-roost","url":"https://pokeapi.co/api/v2/location/673/"},{"name":"kalos-power-plant","url":"https://pokeapi.co/api/v2/location/674/"},{"name":"team-flare-secret-hq","url":"https://pokeapi.co/api/v2/location/675/"},{"name":"terminus-cave","url":"https://pokeapi.co/api/v2/location/676/"},{"name":"lost-hotel","url":"https://pokeapi.co/api/v2/location/677/"},{"name":"chamber-of-emptiness","url":"https://pokeapi.co/api/v2/location/678/"},{"name":"sea-spirits-den","url":"https://pokeapi.co/api/v2/location/679/"},{"name":"friend-safari","url":"https://pokeapi.co/api/v2/location/680/"},{"name":"blazing-chamber","url":"https://pokeapi.co/api/v2/location/681/"},{"name":"flood-chamber","url":"https://pokeapi.co/api/v2/location/682/"},{"name":"ironworks-chamber","url":"https://pokeapi.co/api/v2/location/683/"},{"name":"dragonmark-chamber","url":"https://pokeapi.co/api/v2/location/684/"},{"name":"radiant-chamber","url":"https://pokeapi.co/api/v2/location/685/"},{"name":"pokemon-league-gate","url":"https://pokeapi.co/api/v2/location/686/"},{"name":"lumiose-station","url":"https://pokeapi.co/api/v2/location/687/"},{"name":"kiloude-station","url":"https://pokeapi.co/api/v2/location/688/"},{"name":"ambrette-aquarium","url":"https://pokeapi.co/api/v2/location/689/"},{"name":"unknown-dungeon","url":"https://pokeapi.co/api/v2/location/690/"},{"name":"hoenn-pokemon-league","url":"https://pokeapi.co/api/v2/location/691/"},{"name":"team-aqua-hideout","url":"https://pokeapi.co/api/v2/location/692/"},{"name":"sea-mauville","url":"https://pokeapi.co/api/v2/location/693/"},{"name":"team-magma-hideout","url":"https://pokeapi.co/api/v2/location/694/"},{"name":"battle-resort","url":"https://pokeapi.co/api/v2/location/695/"},{"name":"ss-tidal","url":"https://pokeapi.co/api/v2/location/696/"},{"name":"mirage-forest","url":"https://pokeapi.co/api/v2/location/697/"},{"name":"mirage-cave","url":"https://pokeapi.co/api/v2/location/698/"},{"name":"mirage-mountain","url":"https://pokeapi.co/api/v2/location/699/"},{"name":"trackless-forest","url":"https://pokeapi.co/api/v2/location/700/"},{"name":"pathless-plain","url":"https://pokeapi.co/api/v2/location/701/"},{"name":"nameless-cavern","url":"https://pokeapi.co/api/v2/location/702/"},{"name":"fabled-cave","url":"https://pokeapi.co/api/v2/location/703/"},{"name":"gnarled-den","url":"https://pokeapi.co/api/v2/location/704/"},{"name":"crescent-isle","url":"https://pokeapi.co/api/v2/location/705/"},{"name":"secret-islet","url":"https://pokeapi.co/api/v2/location/706/"},{"name":"soaring-in-the-sky","url":"https://pokeapi.co/api/v2/location/707/"},{"name":"secret-shore","url":"https://pokeapi.co/api/v2/location/708/"},{"name":"secret-meadow","url":"https://pokeapi.co/api/v2/location/709/"},{"name":"alola-route-1--hauoli-outskirts","url":"https://pokeapi.co/api/v2/location/710/"},{"name":"alola-route-1","url":"https://pokeapi.co/api/v2/location/711/"},{"name":"alola-route-3","url":"https://pokeapi.co/api/v2/location/712/"},{"name":"alola-route-2","url":"https://pokeapi.co/api/v2/location/713/"},{"name":"kalae-bay","url":"https://pokeapi.co/api/v2/location/714/"},{"name":"melemele-sea","url":"https://pokeapi.co/api/v2/location/715/"},{"name":"hauoli-city--beachfront","url":"https://pokeapi.co/api/v2/location/716/"},{"name":"hauoli-city--shopping-district","url":"https://pokeapi.co/api/v2/location/717/"},{"name":"hauoli-city--marina","url":"https://pokeapi.co/api/v2/location/718/"},{"name":"iki-town","url":"https://pokeapi.co/api/v2/location/719/"},{"name":"mahalo-trail","url":"https://pokeapi.co/api/v2/location/720/"},{"name":"mahalo-trail--plank-bridge","url":"https://pokeapi.co/api/v2/location/721/"},{"name":"ruins-of-conflict","url":"https://pokeapi.co/api/v2/location/722/"},{"name":"ten-carat-hill","url":"https://pokeapi.co/api/v2/location/723/"},{"name":"ten-carat-hill--farthest-hollow","url":"https://pokeapi.co/api/v2/location/724/"},{"name":"hauoli-cemetery","url":"https://pokeapi.co/api/v2/location/725/"},{"name":"melemele-meadow","url":"https://pokeapi.co/api/v2/location/726/"},{"name":"seaward-cave","url":"https://pokeapi.co/api/v2/location/727/"},{"name":"berry-fields","url":"https://pokeapi.co/api/v2/location/728/"},{"name":"verdant-cavern--trial-site","url":"https://pokeapi.co/api/v2/location/729/"},{"name":"verdant-cavern--totems-den","url":"https://pokeapi.co/api/v2/location/730/"},{"name":"alola-route-4","url":"https://pokeapi.co/api/v2/location/731/"},{"name":"alola-route-5","url":"https://pokeapi.co/api/v2/location/732/"},{"name":"alola-route-6","url":"https://pokeapi.co/api/v2/location/733/"},{"name":"alola-route-7","url":"https://pokeapi.co/api/v2/location/734/"},{"name":"alola-route-8","url":"https://pokeapi.co/api/v2/location/735/"},{"name":"alola-route-9","url":"https://pokeapi.co/api/v2/location/736/"},{"name":"hano-grand-resort","url":"https://pokeapi.co/api/v2/location/737/"},{"name":"hano-beach","url":"https://pokeapi.co/api/v2/location/738/"},{"name":"akala-meadow","url":"https://pokeapi.co/api/v2/location/739/"},{"name":"paniola-town","url":"https://pokeapi.co/api/v2/location/740/"},{"name":"heahea-city","url":"https://pokeapi.co/api/v2/location/741/"},{"name":"konikoni-city","url":"https://pokeapi.co/api/v2/location/742/"},{"name":"royal-avenue","url":"https://pokeapi.co/api/v2/location/743/"},{"name":"memorial-hill","url":"https://pokeapi.co/api/v2/location/744/"},{"name":"paniola-ranch","url":"https://pokeapi.co/api/v2/location/745/"},{"name":"wela-volcano-park","url":"https://pokeapi.co/api/v2/location/746/"},{"name":"wela-volcano-park--totems-den","url":"https://pokeapi.co/api/v2/location/747/"},{"name":"brooklet-hill","url":"https://pokeapi.co/api/v2/location/748/"},{"name":"brooklet-hill--totems-den","url":"https://pokeapi.co/api/v2/location/749/"},{"name":"lush-jungle","url":"https://pokeapi.co/api/v2/location/750/"},{"name":"ruins-of-life","url":"https://pokeapi.co/api/v2/location/751/"},{"name":"akala-outskirts","url":"https://pokeapi.co/api/v2/location/752/"},{"name":"digletts-tunnel","url":"https://pokeapi.co/api/v2/location/753/"},{"name":"battle-royal-dome","url":"https://pokeapi.co/api/v2/location/754/"},{"name":"alola-route-10","url":"https://pokeapi.co/api/v2/location/755/"},{"name":"alola-route-11","url":"https://pokeapi.co/api/v2/location/756/"},{"name":"secluded-shore","url":"https://pokeapi.co/api/v2/location/757/"},{"name":"alola-route-13","url":"https://pokeapi.co/api/v2/location/758/"},{"name":"tapu-village","url":"https://pokeapi.co/api/v2/location/759/"},{"name":"alola-route-15","url":"https://pokeapi.co/api/v2/location/760/"},{"name":"alola-route-16","url":"https://pokeapi.co/api/v2/location/761/"},{"name":"alola-route-17","url":"https://pokeapi.co/api/v2/location/762/"},{"name":"alola-route-12","url":"https://pokeapi.co/api/v2/location/763/"},{"name":"haina-desert","url":"https://pokeapi.co/api/v2/location/764/"},{"name":"alola-route-14","url":"https://pokeapi.co/api/v2/location/765/"},{"name":"ulaula-meadow","url":"https://pokeapi.co/api/v2/location/766/"},{"name":"po-town","url":"https://pokeapi.co/api/v2/location/767/"},{"name":"malie-city","url":"https://pokeapi.co/api/v2/location/768/"},{"name":"malie-garden","url":"https://pokeapi.co/api/v2/location/769/"},{"name":"mount-hokulani","url":"https://pokeapi.co/api/v2/location/770/"},{"name":"blush-mountain","url":"https://pokeapi.co/api/v2/location/771/"},{"name":"ruins-of-abundance","url":"https://pokeapi.co/api/v2/location/772/"},{"name":"lake-of-the-sunne","url":"https://pokeapi.co/api/v2/location/773/"},{"name":"lake-of-the-moone","url":"https://pokeapi.co/api/v2/location/774/"},{"name":"mount-lanakila","url":"https://pokeapi.co/api/v2/location/775/"},{"name":"shady-house","url":"https://pokeapi.co/api/v2/location/776/"},{"name":"thrifty-megamart--abandoned-site","url":"https://pokeapi.co/api/v2/location/777/"},{"name":"hokulani-observatory","url":"https://pokeapi.co/api/v2/location/778/"},{"name":"alola-pokemon-league","url":"https://pokeapi.co/api/v2/location/779/"},{"name":"poni-meadow","url":"https://pokeapi.co/api/v2/location/780/"},{"name":"poni-wilds","url":"https://pokeapi.co/api/v2/location/781/"},{"name":"ancient-poni-path","url":"https://pokeapi.co/api/v2/location/782/"},{"name":"poni-breaker-coast","url":"https://pokeapi.co/api/v2/location/783/"},{"name":"poni-grove","url":"https://pokeapi.co/api/v2/location/784/"},{"name":"poni-plains","url":"https://pokeapi.co/api/v2/location/785/"},{"name":"poni-coast","url":"https://pokeapi.co/api/v2/location/786/"},{"name":"poni-gauntlet","url":"https://pokeapi.co/api/v2/location/787/"},{"name":"seafolk-village","url":"https://pokeapi.co/api/v2/location/788/"},{"name":"vast-poni-canyon","url":"https://pokeapi.co/api/v2/location/789/"},{"name":"altar-of-the-sunne","url":"https://pokeapi.co/api/v2/location/790/"},{"name":"altar-of-the-moone","url":"https://pokeapi.co/api/v2/location/791/"},{"name":"ruins-of-hope","url":"https://pokeapi.co/api/v2/location/792/"},{"name":"resolution-cave","url":"https://pokeapi.co/api/v2/location/793/"},{"name":"exeggutor-island","url":"https://pokeapi.co/api/v2/location/794/"},{"name":"battle-tree","url":"https://pokeapi.co/api/v2/location/795/"},{"name":"aether-paradise","url":"https://pokeapi.co/api/v2/location/796/"},{"name":"ultra-space","url":"https://pokeapi.co/api/v2/location/797/"},{"name":"malie-city--outer-cape","url":"https://pokeapi.co/api/v2/location/798/"}]}"#;

// https://pokeapi.co/api/v2/location-area/?offset=0&limit=9999
static FULL_LOCATION_AREA_LIST_JSON: &str = r#"{"count":651,"next":null,"previous":null,"results":[{"name":"canalave-city-area","url":"https://pokeapi.co/api/v2/location-area/1/"},{"name":"eterna-city-area","url":"https://pokeapi.co/api/v2/location-area/2/"},{"name":"pastoria-city-area","url":"https://pokeapi.co/api/v2/location-area/3/"},{"name":"sunyshore-city-area","url":"https://pokeapi.co/api/v2/location-area/4/"},{"name":"sinnoh-pokemon-league-area","url":"https://pokeapi.co/api/v2/location-area/5/"},{"name":"oreburgh-mine-1f","url":"https://pokeapi.co/api/v2/location-area/6/"},{"name":"oreburgh-mine-b1f","url":"https://pokeapi.co/api/v2/location-area/7/"},{"name":"valley-windworks-area","url":"https://pokeapi.co/api/v2/location-area/8/"},{"name":"eterna-forest-area","url":"https://pokeapi.co/api/v2/location-area/9/"},{"name":"fuego-ironworks-area","url":"https://pokeapi.co/api/v2/location-area/10/"},{"name":"mt-coronet-route-207","url":"https://pokeapi.co/api/v2/location-area/11/"},{"name":"mt-coronet-2f","url":"https://pokeapi.co/api/v2/location-area/12/"},{"name":"mt-coronet-3f","url":"https://pokeapi.co/api/v2/location-area/13/"},{"name":"mt-coronet-snowfall","url":"https://pokeapi.co/api/v2/location-area/14/"},{"name":"mt-coronet-blizzard","url":"https://pokeapi.co/api/v2/location-area/15/"},{"name":"mt-coronet-4f","url":"https://pokeapi.co/api/v2/location-area/16/"},{"name":"mt-coronet-5f","url":"https://pokeapi.co/api/v2/location-area/17/"},{"name":"mt-coronet-6f","url":"https://pokeapi.co/api/v2/location-area/18/"},{"name":"mt-coronet-7f","url":"https://pokeapi.co/api/v2/location-area/19/"},{"name":"mt-coronet-cave","url":"https://pokeapi.co/api/v2/location-area/20/"},{"name":"mt-coronet-route-216","url":"https://pokeapi.co/api/v2/location-area/21/"},{"name":"mt-coronet-route-211","url":"https://pokeapi.co/api/v2/location-area/22/"},{"name":"mt-coronet-b1f","url":"https://pokeapi.co/api/v2/location-area/23/"},{"name":"great-marsh-area-1","url":"https://pokeapi.co/api/v2/location-area/24/"},{"name":"great-marsh-area-2","url":"https://pokeapi.co/api/v2/location-area/25/"},{"name":"great-marsh-area-3","url":"https://pokeapi.co/api/v2/location-area/26/"},{"name":"great-marsh-area-4","url":"https://pokeapi.co/api/v2/location-area/27/"},{"name":"great-marsh-area-5","url":"https://pokeapi.co/api/v2/location-area/28/"},{"name":"great-marsh-area-6","url":"https://pokeapi.co/api/v2/location-area/29/"},{"name":"solaceon-ruins-2f","url":"https://pokeapi.co/api/v2/location-area/30/"},{"name":"solaceon-ruins-1f","url":"https://pokeapi.co/api/v2/location-area/31/"},{"name":"solaceon-ruins-b1f-a","url":"https://pokeapi.co/api/v2/location-area/32/"},{"name":"solaceon-ruins-b1f-b","url":"https://pokeapi.co/api/v2/location-area/33/"},{"name":"solaceon-ruins-b1f-c","url":"https://pokeapi.co/api/v2/location-area/34/"},{"name":"solaceon-ruins-b2f-a","url":"https://pokeapi.co/api/v2/location-area/35/"},{"name":"solaceon-ruins-b2f-b","url":"https://pokeapi.co/api/v2/location-area/36/"},{"name":"solaceon-ruins-b2f-c","url":"https://pokeapi.co/api/v2/location-area/37/"},{"name":"solaceon-ruins-b3f-a","url":"https://pokeapi.co/api/v2/location-area/38/"},{"name":"solaceon-ruins-b3f-b","url":"https://pokeapi.co/api/v2/location-area/39/"},{"name":"solaceon-ruins-b3f-c","url":"https://pokeapi.co/api/v2/location-area/40/"},{"name":"solaceon-ruins-b3f-d","url":"https://pokeapi.co/api/v2/location-area/41/"},{"name":"solaceon-ruins-b3f-e","url":"https://pokeapi.co/api/v2/location-area/42/"},{"name":"solaceon-ruins-b4f-a","url":"https://pokeapi.co/api/v2/location-area/43/"},{"name":"solaceon-ruins-b4f-b","url":"https://pokeapi.co/api/v2/location-area/44/"},{"name":"solaceon-ruins-b4f-c","url":"https://pokeapi.co/api/v2/location-area/45/"},{"name":"solaceon-ruins-b4f-d","url":"https://pokeapi.co/api/v2/location-area/46/"},{"name":"solaceon-ruins-b5f","url":"https://pokeapi.co/api/v2/location-area/47/"},{"name":"sinnoh-victory-road-1f","url":"https://pokeapi.co/api/v2/location-area/48/"},{"name":"sinnoh-victory-road-2f","url":"https://pokeapi.co/api/v2/location-area/49/"},{"name":"sinnoh-victory-road-b1f","url":"https://pokeapi.co/api/v2/location-area/50/"},{"name":"sinnoh-victory-road-inside-b1f","url":"https://pokeapi.co/api/v2/location-area/51/"},{"name":"sinnoh-victory-road-inside","url":"https://pokeapi.co/api/v2/location-area/52/"},{"name":"sinnoh-victory-road-inside-exit","url":"https://pokeapi.co/api/v2/location-area/53/"},{"name":"ravaged-path-area","url":"https://pokeapi.co/api/v2/location-area/54/"},{"name":"oreburgh-gate-1f","url":"https://pokeapi.co/api/v2/location-area/55/"},{"name":"oreburgh-gate-b1f","url":"https://pokeapi.co/api/v2/location-area/56/"},{"name":"stark-mountain-area","url":"https://pokeapi.co/api/v2/location-area/57/"},{"name":"stark-mountain-entrance","url":"https://pokeapi.co/api/v2/location-area/58/"},{"name":"stark-mountain-inside","url":"https://pokeapi.co/api/v2/location-area/59/"},{"name":"sendoff-spring-area","url":"https://pokeapi.co/api/v2/location-area/60/"},{"name":"turnback-cave-pillar-1","url":"https://pokeapi.co/api/v2/location-area/61/"},{"name":"turnback-cave-pillar-2","url":"https://pokeapi.co/api/v2/location-area/62/"},{"name":"turnback-cave-pillar-3","url":"https://pokeapi.co/api/v2/location-area/63/"},{"name":"turnback-cave-before-pillar-1","url":"https://pokeapi.co/api/v2/location-area/64/"},{"name":"turnback-cave-between-pillars-1-and-2","url":"https://pokeapi.co/api/v2/location-area/70/"},{"name":"turnback-cave-between-pillars-2-and-3","url":"https://pokeapi.co/api/v2/location-area/76/"},{"name":"turnback-cave-after-pillar-3","url":"https://pokeapi.co/api/v2/location-area/82/"},{"name":"snowpoint-temple-1f","url":"https://pokeapi.co/api/v2/location-area/107/"},{"name":"snowpoint-temple-b1f","url":"https://pokeapi.co/api/v2/location-area/108/"},{"name":"snowpoint-temple-b2f","url":"https://pokeapi.co/api/v2/location-area/109/"},{"name":"snowpoint-temple-b3f","url":"https://pokeapi.co/api/v2/location-area/110/"},{"name":"snowpoint-temple-b4f","url":"https://pokeapi.co/api/v2/location-area/111/"},{"name":"snowpoint-temple-b5f","url":"https://pokeapi.co/api/v2/location-area/112/"},{"name":"wayward-cave-1f","url":"https://pokeapi.co/api/v2/location-area/113/"},{"name":"wayward-cave-b1f","url":"https://pokeapi.co/api/v2/location-area/114/"},{"name":"ruin-maniac-cave-0-9-different-unown-caught","url":"https://pokeapi.co/api/v2/location-area/115/"},{"name":"ruin-maniac-cave-10-25-different-unown-caught","url":"https://pokeapi.co/api/v2/location-area/116/"},{"name":"maniac-tunnel-26-plus-different-unown-caught","url":"https://pokeapi.co/api/v2/location-area/117/"},{"name":"trophy-garden-area","url":"https://pokeapi.co/api/v2/location-area/118/"},{"name":"iron-island-area","url":"https://pokeapi.co/api/v2/location-area/119/"},{"name":"iron-island-1f","url":"https://pokeapi.co/api/v2/location-area/120/"},{"name":"iron-island-b1f-left","url":"https://pokeapi.co/api/v2/location-area/121/"},{"name":"iron-island-b1f-right","url":"https://pokeapi.co/api/v2/location-area/122/"},{"name":"iron-island-b2f-right","url":"https://pokeapi.co/api/v2/location-area/123/"},{"name":"iron-island-b2f-left","url":"https://pokeapi.co/api/v2/location-area/124/"},{"name":"iron-island-b3f","url":"https://pokeapi.co/api/v2/location-area/125/"},{"name":"old-chateau-entrance","url":"https://pokeapi.co/api/v2/location-area/126/"},{"name":"old-chateau-dining-room","url":"https://pokeapi.co/api/v2/location-area/127/"},{"name":"old-chateau-2f-private-room","url":"https://pokeapi.co/api/v2/location-area/128/"},{"name":"old-chateau-2f","url":"https://pokeapi.co/api/v2/location-area/129/"},{"name":"old-chateau-2f-leftmost-room","url":"https://pokeapi.co/api/v2/location-area/130/"},{"name":"old-chateau-2f-left-room","url":"https://pokeapi.co/api/v2/location-area/131/"},{"name":"old-chateau-2f-middle-room","url":"https://pokeapi.co/api/v2/location-area/132/"},{"name":"old-chateau-2f-right-room","url":"https://pokeapi.co/api/v2/location-area/133/"},{"name":"old-chateau-2f-rightmost-room","url":"https://pokeapi.co/api/v2/location-area/134/"},{"name":"lake-verity-before-galactic-intervention","url":"https://pokeapi.co/api/v2/location-area/135/"},{"name":"lake-verity-after-galactic-intervention","url":"https://pokeapi.co/api/v2/location-area/136/"},{"name":"lake-valor-area","url":"https://pokeapi.co/api/v2/location-area/137/"},{"name":"lake-acuity-area","url":"https://pokeapi.co/api/v2/location-area/138/"},{"name":"valor-lakefront-area","url":"https://pokeapi.co/api/v2/location-area/139/"},{"name":"acuity-lakefront-area","url":"https://pokeapi.co/api/v2/location-area/140/"},{"name":"sinnoh-route-201-area","url":"https://pokeapi.co/api/v2/location-area/141/"},{"name":"sinnoh-route-202-area","url":"https://pokeapi.co/api/v2/location-area/142/"},{"name":"sinnoh-route-203-area","url":"https://pokeapi.co/api/v2/location-area/143/"},{"name":"sinnoh-route-204-south-towards-jubilife-city","url":"https://pokeapi.co/api/v2/location-area/144/"},{"name":"sinnoh-route-204-north-towards-floaroma-town","url":"https://pokeapi.co/api/v2/location-area/145/"},{"name":"sinnoh-route-205-south-towards-floaroma-town","url":"https://pokeapi.co/api/v2/location-area/146/"},{"name":"sinnoh-route-205-east-towards-eterna-city","url":"https://pokeapi.co/api/v2/location-area/147/"},{"name":"sinnoh-route-206-area","url":"https://pokeapi.co/api/v2/location-area/148/"},{"name":"sinnoh-route-207-area","url":"https://pokeapi.co/api/v2/location-area/149/"},{"name":"sinnoh-route-208-area","url":"https://pokeapi.co/api/v2/location-area/150/"},{"name":"sinnoh-route-209-area","url":"https://pokeapi.co/api/v2/location-area/151/"},{"name":"lost-tower-1f","url":"https://pokeapi.co/api/v2/location-area/152/"},{"name":"lost-tower-2f","url":"https://pokeapi.co/api/v2/location-area/153/"},{"name":"lost-tower-3f","url":"https://pokeapi.co/api/v2/location-area/154/"},{"name":"lost-tower-4f","url":"https://pokeapi.co/api/v2/location-area/155/"},{"name":"lost-tower-5f","url":"https://pokeapi.co/api/v2/location-area/156/"},{"name":"sinnoh-route-210-south-towards-solaceon-town","url":"https://pokeapi.co/api/v2/location-area/157/"},{"name":"sinnoh-route-210-west-towards-celestic-town","url":"https://pokeapi.co/api/v2/location-area/158/"},{"name":"sinnoh-route-211-west-towards-eterna-city","url":"https://pokeapi.co/api/v2/location-area/159/"},{"name":"sinnoh-route-211-east-towards-celestic-town","url":"https://pokeapi.co/api/v2/location-area/160/"},{"name":"sinnoh-route-212-north-towards-hearthome-city","url":"https://pokeapi.co/api/v2/location-area/161/"},{"name":"sinnoh-route-212-east-towards-pastoria-city","url":"https://pokeapi.co/api/v2/location-area/162/"},{"name":"sinnoh-route-213-area","url":"https://pokeapi.co/api/v2/location-area/163/"},{"name":"sinnoh-route-214-area","url":"https://pokeapi.co/api/v2/location-area/164/"},{"name":"sinnoh-route-215-area","url":"https://pokeapi.co/api/v2/location-area/165/"},{"name":"sinnoh-route-216-area","url":"https://pokeapi.co/api/v2/location-area/166/"},{"name":"sinnoh-route-217-area","url":"https://pokeapi.co/api/v2/location-area/167/"},{"name":"sinnoh-route-218-area","url":"https://pokeapi.co/api/v2/location-area/168/"},{"name":"sinnoh-route-219-area","url":"https://pokeapi.co/api/v2/location-area/169/"},{"name":"sinnoh-route-221-area","url":"https://pokeapi.co/api/v2/location-area/170/"},{"name":"sinnoh-route-222-area","url":"https://pokeapi.co/api/v2/location-area/171/"},{"name":"sinnoh-route-224-area","url":"https://pokeapi.co/api/v2/location-area/172/"},{"name":"sinnoh-route-225-area","url":"https://pokeapi.co/api/v2/location-area/173/"},{"name":"sinnoh-route-227-area","url":"https://pokeapi.co/api/v2/location-area/174/"},{"name":"sinnoh-route-228-area","url":"https://pokeapi.co/api/v2/location-area/175/"},{"name":"sinnoh-route-229-area","url":"https://pokeapi.co/api/v2/location-area/176/"},{"name":"twinleaf-town-area","url":"https://pokeapi.co/api/v2/location-area/177/"},{"name":"celestic-town-area","url":"https://pokeapi.co/api/v2/location-area/178/"},{"name":"resort-area-area","url":"https://pokeapi.co/api/v2/location-area/179/"},{"name":"sinnoh-sea-route-220-area","url":"https://pokeapi.co/api/v2/location-area/180/"},{"name":"sinnoh-sea-route-223-area","url":"https://pokeapi.co/api/v2/location-area/181/"},{"name":"sinnoh-sea-route-226-area","url":"https://pokeapi.co/api/v2/location-area/182/"},{"name":"sinnoh-sea-route-230-area","url":"https://pokeapi.co/api/v2/location-area/183/"},{"name":"new-bark-town-area","url":"https://pokeapi.co/api/v2/location-area/184/"},{"name":"johto-route-29-area","url":"https://pokeapi.co/api/v2/location-area/185/"},{"name":"cherrygrove-city-area","url":"https://pokeapi.co/api/v2/location-area/186/"},{"name":"johto-route-30-area","url":"https://pokeapi.co/api/v2/location-area/187/"},{"name":"johto-route-31-area","url":"https://pokeapi.co/api/v2/location-area/188/"},{"name":"violet-city-area","url":"https://pokeapi.co/api/v2/location-area/189/"},{"name":"sprout-tower-2f","url":"https://pokeapi.co/api/v2/location-area/190/"},{"name":"sprout-tower-3f","url":"https://pokeapi.co/api/v2/location-area/191/"},{"name":"johto-route-32-area","url":"https://pokeapi.co/api/v2/location-area/192/"},{"name":"ruins-of-alph-outside","url":"https://pokeapi.co/api/v2/location-area/193/"},{"name":"ruins-of-alph-interior-a","url":"https://pokeapi.co/api/v2/location-area/194/"},{"name":"ruins-of-alph-interior-b","url":"https://pokeapi.co/api/v2/location-area/195/"},{"name":"ruins-of-alph-interior-c","url":"https://pokeapi.co/api/v2/location-area/196/"},{"name":"ruins-of-alph-interior-d","url":"https://pokeapi.co/api/v2/location-area/197/"},{"name":"union-cave-1f","url":"https://pokeapi.co/api/v2/location-area/198/"},{"name":"union-cave-b1f","url":"https://pokeapi.co/api/v2/location-area/199/"},{"name":"union-cave-b2f","url":"https://pokeapi.co/api/v2/location-area/200/"},{"name":"johto-route-33-area","url":"https://pokeapi.co/api/v2/location-area/201/"},{"name":"slowpoke-well-1f","url":"https://pokeapi.co/api/v2/location-area/202/"},{"name":"slowpoke-well-b1f","url":"https://pokeapi.co/api/v2/location-area/203/"},{"name":"ilex-forest-area","url":"https://pokeapi.co/api/v2/location-area/204/"},{"name":"johto-route-34-area","url":"https://pokeapi.co/api/v2/location-area/205/"},{"name":"johto-route-35-area","url":"https://pokeapi.co/api/v2/location-area/206/"},{"name":"national-park-area","url":"https://pokeapi.co/api/v2/location-area/207/"},{"name":"unknown-all-bugs-area","url":"https://pokeapi.co/api/v2/location-area/208/"},{"name":"johto-route-36-area","url":"https://pokeapi.co/api/v2/location-area/209/"},{"name":"johto-route-37-area","url":"https://pokeapi.co/api/v2/location-area/210/"},{"name":"ecruteak-city-area","url":"https://pokeapi.co/api/v2/location-area/211/"},{"name":"burned-tower-1f","url":"https://pokeapi.co/api/v2/location-area/212/"},{"name":"burned-tower-b1f","url":"https://pokeapi.co/api/v2/location-area/213/"},{"name":"bell-tower-2f","url":"https://pokeapi.co/api/v2/location-area/214/"},{"name":"bell-tower-3f","url":"https://pokeapi.co/api/v2/location-area/215/"},{"name":"bell-tower-4f","url":"https://pokeapi.co/api/v2/location-area/216/"},{"name":"bell-tower-5f","url":"https://pokeapi.co/api/v2/location-area/217/"},{"name":"bell-tower-6f","url":"https://pokeapi.co/api/v2/location-area/218/"},{"name":"bell-tower-7f","url":"https://pokeapi.co/api/v2/location-area/219/"},{"name":"bell-tower-8f","url":"https://pokeapi.co/api/v2/location-area/220/"},{"name":"bell-tower-9f","url":"https://pokeapi.co/api/v2/location-area/221/"},{"name":"johto-route-38-area","url":"https://pokeapi.co/api/v2/location-area/222/"},{"name":"johto-route-39-area","url":"https://pokeapi.co/api/v2/location-area/223/"},{"name":"olivine-city-area","url":"https://pokeapi.co/api/v2/location-area/224/"},{"name":"johto-sea-route-40-area","url":"https://pokeapi.co/api/v2/location-area/225/"},{"name":"johto-sea-route-41-area","url":"https://pokeapi.co/api/v2/location-area/226/"},{"name":"whirl-islands-1f","url":"https://pokeapi.co/api/v2/location-area/227/"},{"name":"whirl-islands-b1f","url":"https://pokeapi.co/api/v2/location-area/228/"},{"name":"whirl-islands-empty-floor-x","url":"https://pokeapi.co/api/v2/location-area/229/"},{"name":"whirl-islands-b2f","url":"https://pokeapi.co/api/v2/location-area/230/"},{"name":"whirl-islands-empty-floor-y","url":"https://pokeapi.co/api/v2/location-area/231/"},{"name":"whirl-islands-b3f","url":"https://pokeapi.co/api/v2/location-area/232/"},{"name":"cianwood-city-area","url":"https://pokeapi.co/api/v2/location-area/235/"},{"name":"johto-route-42-area","url":"https://pokeapi.co/api/v2/location-area/236/"},{"name":"mt-mortar-1f","url":"https://pokeapi.co/api/v2/location-area/237/"},{"name":"mt-mortar-lower-cave","url":"https://pokeapi.co/api/v2/location-area/238/"},{"name":"mt-mortar-upper-cave","url":"https://pokeapi.co/api/v2/location-area/239/"},{"name":"mt-mortar-b1f","url":"https://pokeapi.co/api/v2/location-area/240/"},{"name":"johto-route-43-area","url":"https://pokeapi.co/api/v2/location-area/241/"},{"name":"lake-of-rage-area","url":"https://pokeapi.co/api/v2/location-area/242/"},{"name":"johto-route-44-area","url":"https://pokeapi.co/api/v2/location-area/243/"},{"name":"ice-path-1f","url":"https://pokeapi.co/api/v2/location-area/244/"},{"name":"ice-path-b1f","url":"https://pokeapi.co/api/v2/location-area/245/"},{"name":"ice-path-b2f","url":"https://pokeapi.co/api/v2/location-area/246/"},{"name":"ice-path-b3f","url":"https://pokeapi.co/api/v2/location-area/247/"},{"name":"blackthorn-city-area","url":"https://pokeapi.co/api/v2/location-area/249/"},{"name":"dragons-den-area","url":"https://pokeapi.co/api/v2/location-area/250/"},{"name":"johto-route-45-area","url":"https://pokeapi.co/api/v2/location-area/251/"},{"name":"johto-route-46-area","url":"https://pokeapi.co/api/v2/location-area/252/"},{"name":"dark-cave-violet-city-entrance","url":"https://pokeapi.co/api/v2/location-area/253/"},{"name":"dark-cave-blackthorn-city-entrance","url":"https://pokeapi.co/api/v2/location-area/254/"},{"name":"johto-route-47-area","url":"https://pokeapi.co/api/v2/location-area/255/"},{"name":"mt-moon-mt-moon-square","url":"https://pokeapi.co/api/v2/location-area/256/"},{"name":"unknown-all-poliwag-area","url":"https://pokeapi.co/api/v2/location-area/257/"},{"name":"seafoam-islands-1f","url":"https://pokeapi.co/api/v2/location-area/258/"},{"name":"seafoam-islands-b1f","url":"https://pokeapi.co/api/v2/location-area/259/"},{"name":"seafoam-islands-b2f","url":"https://pokeapi.co/api/v2/location-area/260/"},{"name":"seafoam-islands-b3f","url":"https://pokeapi.co/api/v2/location-area/261/"},{"name":"seafoam-islands-b4f","url":"https://pokeapi.co/api/v2/location-area/262/"},{"name":"mt-silver-2f","url":"https://pokeapi.co/api/v2/location-area/263/"},{"name":"mt-silver-1f-top","url":"https://pokeapi.co/api/v2/location-area/264/"},{"name":"mt-silver-4f","url":"https://pokeapi.co/api/v2/location-area/265/"},{"name":"johto-route-47-cave-gate","url":"https://pokeapi.co/api/v2/location-area/266/"},{"name":"johto-route-47-inside-cave","url":"https://pokeapi.co/api/v2/location-area/267/"},{"name":"bell-tower-10f","url":"https://pokeapi.co/api/v2/location-area/268/"},{"name":"mt-silver-outside","url":"https://pokeapi.co/api/v2/location-area/269/"},{"name":"mt-silver-1f","url":"https://pokeapi.co/api/v2/location-area/270/"},{"name":"mt-silver-mountainside","url":"https://pokeapi.co/api/v2/location-area/271/"},{"name":"mt-silver-3f","url":"https://pokeapi.co/api/v2/location-area/272/"},{"name":"mt-silver-top","url":"https://pokeapi.co/api/v2/location-area/273/"},{"name":"unknown-all-rattata-area","url":"https://pokeapi.co/api/v2/location-area/275/"},{"name":"kanto-route-12-area","url":"https://pokeapi.co/api/v2/location-area/276/"},{"name":"kanto-sea-route-19-area","url":"https://pokeapi.co/api/v2/location-area/277/"},{"name":"kanto-sea-route-20-area","url":"https://pokeapi.co/api/v2/location-area/278/"},{"name":"cinnabar-island-area","url":"https://pokeapi.co/api/v2/location-area/279/"},{"name":"viridian-city-area","url":"https://pokeapi.co/api/v2/location-area/280/"},{"name":"cerulean-city-area","url":"https://pokeapi.co/api/v2/location-area/281/"},{"name":"vermilion-city-area","url":"https://pokeapi.co/api/v2/location-area/282/"},{"name":"celadon-city-area","url":"https://pokeapi.co/api/v2/location-area/283/"},{"name":"fuchsia-city-area","url":"https://pokeapi.co/api/v2/location-area/284/"},{"name":"pallet-town-area","url":"https://pokeapi.co/api/v2/location-area/285/"},{"name":"johto-route-48-area","url":"https://pokeapi.co/api/v2/location-area/286/"},{"name":"kanto-route-26-area","url":"https://pokeapi.co/api/v2/location-area/287/"},{"name":"kanto-route-27-area","url":"https://pokeapi.co/api/v2/location-area/288/"},{"name":"kanto-route-28-area","url":"https://pokeapi.co/api/v2/location-area/289/"},{"name":"mt-moon-1f","url":"https://pokeapi.co/api/v2/location-area/290/"},{"name":"mt-moon-2f","url":"https://pokeapi.co/api/v2/location-area/291/"},{"name":"rock-tunnel-1f","url":"https://pokeapi.co/api/v2/location-area/292/"},{"name":"rock-tunnel-b1f","url":"https://pokeapi.co/api/v2/location-area/293/"},{"name":"kanto-victory-road-1-1f","url":"https://pokeapi.co/api/v2/location-area/294/"},{"name":"kanto-route-1-area","url":"https://pokeapi.co/api/v2/location-area/295/"},{"name":"kanto-route-2-south-towards-viridian-city","url":"https://pokeapi.co/api/v2/location-area/296/"},{"name":"kanto-route-3-area","url":"https://pokeapi.co/api/v2/location-area/297/"},{"name":"kanto-route-4-area","url":"https://pokeapi.co/api/v2/location-area/298/"},{"name":"kanto-route-5-area","url":"https://pokeapi.co/api/v2/location-area/299/"},{"name":"kanto-route-6-area","url":"https://pokeapi.co/api/v2/location-area/300/"},{"name":"kanto-route-7-area","url":"https://pokeapi.co/api/v2/location-area/301/"},{"name":"kanto-route-8-area","url":"https://pokeapi.co/api/v2/location-area/302/"},{"name":"kanto-route-9-area","url":"https://pokeapi.co/api/v2/location-area/303/"},{"name":"kanto-route-10-area","url":"https://pokeapi.co/api/v2/location-area/304/"},{"name":"kanto-route-11-area","url":"https://pokeapi.co/api/v2/location-area/305/"},{"name":"kanto-route-13-area","url":"https://pokeapi.co/api/v2/location-area/306/"},{"name":"kanto-route-14-area","url":"https://pokeapi.co/api/v2/location-area/307/"},{"name":"kanto-route-15-area","url":"https://pokeapi.co/api/v2/location-area/308/"},{"name":"kanto-route-16-area","url":"https://pokeapi.co/api/v2/location-area/309/"},{"name":"kanto-route-17-area","url":"https://pokeapi.co/api/v2/location-area/310/"},{"name":"kanto-route-18-area","url":"https://pokeapi.co/api/v2/location-area/311/"},{"name":"kanto-sea-route-21-area","url":"https://pokeapi.co/api/v2/location-area/312/"},{"name":"kanto-route-22-area","url":"https://pokeapi.co/api/v2/location-area/313/"},{"name":"kanto-route-24-area","url":"https://pokeapi.co/api/v2/location-area/314/"},{"name":"kanto-route-25-area","url":"https://pokeapi.co/api/v2/location-area/315/"},{"name":"tohjo-falls-area","url":"https://pokeapi.co/api/v2/location-area/316/"},{"name":"digletts-cave-area","url":"https://pokeapi.co/api/v2/location-area/317/"},{"name":"kanto-victory-road-1-2f","url":"https://pokeapi.co/api/v2/location-area/318/"},{"name":"kanto-victory-road-1-3f","url":"https://pokeapi.co/api/v2/location-area/319/"},{"name":"kanto-route-2-north-towards-pewter-city","url":"https://pokeapi.co/api/v2/location-area/320/"},{"name":"viridian-forest-area","url":"https://pokeapi.co/api/v2/location-area/321/"},{"name":"cerulean-cave-1f","url":"https://pokeapi.co/api/v2/location-area/323/"},{"name":"cerulean-cave-2f","url":"https://pokeapi.co/api/v2/location-area/324/"},{"name":"cerulean-cave-b1f","url":"https://pokeapi.co/api/v2/location-area/325/"},{"name":"mt-moon-b1f","url":"https://pokeapi.co/api/v2/location-area/326/"},{"name":"mt-moon-b2f","url":"https://pokeapi.co/api/v2/location-area/327/"},{"name":"rock-tunnel-b2f","url":"https://pokeapi.co/api/v2/location-area/328/"},{"name":"kanto-route-23-area","url":"https://pokeapi.co/api/v2/location-area/329/"},{"name":"power-plant-area","url":"https://pokeapi.co/api/v2/location-area/330/"},{"name":"kanto-victory-road-2-1f","url":"https://pokeapi.co/api/v2/location-area/331/"},{"name":"kanto-victory-road-2-2f","url":"https://pokeapi.co/api/v2/location-area/332/"},{"name":"kanto-victory-road-2-3f","url":"https://pokeapi.co/api/v2/location-area/333/"},{"name":"pokemon-tower-1f","url":"https://pokeapi.co/api/v2/location-area/334/"},{"name":"pokemon-tower-2f","url":"https://pokeapi.co/api/v2/location-area/335/"},{"name":"pokemon-tower-3f","url":"https://pokeapi.co/api/v2/location-area/336/"},{"name":"pokemon-tower-4f","url":"https://pokeapi.co/api/v2/location-area/337/"},{"name":"pokemon-tower-5f","url":"https://pokeapi.co/api/v2/location-area/338/"},{"name":"pokemon-tower-6f","url":"https://pokeapi.co/api/v2/location-area/339/"},{"name":"pokemon-tower-7f","url":"https://pokeapi.co/api/v2/location-area/340/"},{"name":"pokemon-mansion-1f","url":"https://pokeapi.co/api/v2/location-area/341/"},{"name":"pokemon-mansion-2f","url":"https://pokeapi.co/api/v2/location-area/342/"},{"name":"pokemon-mansion-3f","url":"https://pokeapi.co/api/v2/location-area/343/"},{"name":"pokemon-mansion-b1f","url":"https://pokeapi.co/api/v2/location-area/344/"},{"name":"kanto-safari-zone-middle","url":"https://pokeapi.co/api/v2/location-area/345/"},{"name":"kanto-safari-zone-area-1-east","url":"https://pokeapi.co/api/v2/location-area/346/"},{"name":"kanto-safari-zone-area-2-north","url":"https://pokeapi.co/api/v2/location-area/347/"},{"name":"kanto-safari-zone-area-3-west","url":"https://pokeapi.co/api/v2/location-area/348/"},{"name":"vermilion-city-ss-anne-dock","url":"https://pokeapi.co/api/v2/location-area/349/"},{"name":"petalburg-city-area","url":"https://pokeapi.co/api/v2/location-area/350/"},{"name":"slateport-city-area","url":"https://pokeapi.co/api/v2/location-area/351/"},{"name":"lilycove-city-area","url":"https://pokeapi.co/api/v2/location-area/352/"},{"name":"mossdeep-city-area","url":"https://pokeapi.co/api/v2/location-area/353/"},{"name":"sootopolis-city-area","url":"https://pokeapi.co/api/v2/location-area/354/"},{"name":"ever-grande-city-area","url":"https://pokeapi.co/api/v2/location-area/355/"},{"name":"meteor-falls-area","url":"https://pokeapi.co/api/v2/location-area/356/"},{"name":"meteor-falls-back","url":"https://pokeapi.co/api/v2/location-area/357/"},{"name":"meteor-falls-b1f","url":"https://pokeapi.co/api/v2/location-area/358/"},{"name":"meteor-falls-backsmall-room","url":"https://pokeapi.co/api/v2/location-area/359/"},{"name":"rusturf-tunnel-area","url":"https://pokeapi.co/api/v2/location-area/360/"},{"name":"granite-cave-1f","url":"https://pokeapi.co/api/v2/location-area/361/"},{"name":"granite-cave-b1f","url":"https://pokeapi.co/api/v2/location-area/362/"},{"name":"granite-cave-b2f","url":"https://pokeapi.co/api/v2/location-area/363/"},{"name":"granite-cave-1fsmall-room","url":"https://pokeapi.co/api/v2/location-area/364/"},{"name":"petalburg-woods-area","url":"https://pokeapi.co/api/v2/location-area/365/"},{"name":"jagged-pass-area","url":"https://pokeapi.co/api/v2/location-area/366/"},{"name":"fiery-path-area","url":"https://pokeapi.co/api/v2/location-area/367/"},{"name":"mt-pyre-1f","url":"https://pokeapi.co/api/v2/location-area/368/"},{"name":"mt-pyre-2f","url":"https://pokeapi.co/api/v2/location-area/369/"},{"name":"mt-pyre-3f","url":"https://pokeapi.co/api/v2/location-area/370/"},{"name":"mt-pyre-4f","url":"https://pokeapi.co/api/v2/location-area/371/"},{"name":"mt-pyre-5f","url":"https://pokeapi.co/api/v2/location-area/372/"},{"name":"mt-pyre-6f","url":"https://pokeapi.co/api/v2/location-area/373/"},{"name":"mt-pyre-outside","url":"https://pokeapi.co/api/v2/location-area/374/"},{"name":"mt-pyre-summit","url":"https://pokeapi.co/api/v2/location-area/375/"},{"name":"seafloor-cavern-area","url":"https://pokeapi.co/api/v2/location-area/376/"},{"name":"cave-of-origin-entrance","url":"https://pokeapi.co/api/v2/location-area/377/"},{"name":"cave-of-origin-1f","url":"https://pokeapi.co/api/v2/location-area/378/"},{"name":"cave-of-origin-b1f","url":"https://pokeapi.co/api/v2/location-area/379/"},{"name":"cave-of-origin-b2f","url":"https://pokeapi.co/api/v2/location-area/380/"},{"name":"cave-of-origin-b3f","url":"https://pokeapi.co/api/v2/location-area/381/"},{"name":"hoenn-victory-road-1f","url":"https://pokeapi.co/api/v2/location-area/382/"},{"name":"hoenn-victory-road-b1f","url":"https://pokeapi.co/api/v2/location-area/383/"},{"name":"hoenn-victory-road-b2f","url":"https://pokeapi.co/api/v2/location-area/384/"},{"name":"shoal-cave-area","url":"https://pokeapi.co/api/v2/location-area/385/"},{"name":"shoal-cave-b1f","url":"https://pokeapi.co/api/v2/location-area/386/"},{"name":"new-mauville-entrance","url":"https://pokeapi.co/api/v2/location-area/387/"},{"name":"new-mauville-area","url":"https://pokeapi.co/api/v2/location-area/388/"},{"name":"abandoned-ship-area","url":"https://pokeapi.co/api/v2/location-area/389/"},{"name":"sky-pillar-1f","url":"https://pokeapi.co/api/v2/location-area/390/"},{"name":"sky-pillar-3f","url":"https://pokeapi.co/api/v2/location-area/391/"},{"name":"sky-pillar-5f","url":"https://pokeapi.co/api/v2/location-area/392/"},{"name":"hoenn-route-101-area","url":"https://pokeapi.co/api/v2/location-area/393/"},{"name":"hoenn-route-102-area","url":"https://pokeapi.co/api/v2/location-area/394/"},{"name":"hoenn-route-103-area","url":"https://pokeapi.co/api/v2/location-area/395/"},{"name":"hoenn-route-104-area","url":"https://pokeapi.co/api/v2/location-area/396/"},{"name":"hoenn-route-105-area","url":"https://pokeapi.co/api/v2/location-area/397/"},{"name":"hoenn-route-106-area","url":"https://pokeapi.co/api/v2/location-area/398/"},{"name":"hoenn-route-107-area","url":"https://pokeapi.co/api/v2/location-area/399/"},{"name":"hoenn-route-108-area","url":"https://pokeapi.co/api/v2/location-area/400/"},{"name":"hoenn-route-109-area","url":"https://pokeapi.co/api/v2/location-area/401/"},{"name":"hoenn-route-110-area","url":"https://pokeapi.co/api/v2/location-area/402/"},{"name":"hoenn-route-111-area","url":"https://pokeapi.co/api/v2/location-area/403/"},{"name":"hoenn-route-112-area","url":"https://pokeapi.co/api/v2/location-area/404/"},{"name":"hoenn-route-113-area","url":"https://pokeapi.co/api/v2/location-area/405/"},{"name":"hoenn-route-114-area","url":"https://pokeapi.co/api/v2/location-area/406/"},{"name":"hoenn-route-115-area","url":"https://pokeapi.co/api/v2/location-area/407/"},{"name":"hoenn-route-116-area","url":"https://pokeapi.co/api/v2/location-area/408/"},{"name":"hoenn-route-117-area","url":"https://pokeapi.co/api/v2/location-area/409/"},{"name":"hoenn-route-118-area","url":"https://pokeapi.co/api/v2/location-area/410/"},{"name":"hoenn-route-119-area","url":"https://pokeapi.co/api/v2/location-area/411/"},{"name":"hoenn-route-120-area","url":"https://pokeapi.co/api/v2/location-area/412/"},{"name":"hoenn-route-121-area","url":"https://pokeapi.co/api/v2/location-area/413/"},{"name":"hoenn-route-122-area","url":"https://pokeapi.co/api/v2/location-area/414/"},{"name":"hoenn-route-123-area","url":"https://pokeapi.co/api/v2/location-area/415/"},{"name":"hoenn-route-124-area","url":"https://pokeapi.co/api/v2/location-area/416/"},{"name":"hoenn-route-124-underwater","url":"https://pokeapi.co/api/v2/location-area/417/"},{"name":"hoenn-route-125-area","url":"https://pokeapi.co/api/v2/location-area/418/"},{"name":"hoenn-route-126-area","url":"https://pokeapi.co/api/v2/location-area/419/"},{"name":"hoenn-route-126-underwater","url":"https://pokeapi.co/api/v2/location-area/420/"},{"name":"hoenn-route-127-area","url":"https://pokeapi.co/api/v2/location-area/421/"},{"name":"hoenn-route-128-area","url":"https://pokeapi.co/api/v2/location-area/422/"},{"name":"hoenn-route-129-area","url":"https://pokeapi.co/api/v2/location-area/423/"},{"name":"hoenn-route-130-area","url":"https://pokeapi.co/api/v2/location-area/424/"},{"name":"hoenn-route-131-area","url":"https://pokeapi.co/api/v2/location-area/425/"},{"name":"hoenn-route-132-area","url":"https://pokeapi.co/api/v2/location-area/426/"},{"name":"hoenn-route-133-area","url":"https://pokeapi.co/api/v2/location-area/427/"},{"name":"hoenn-route-134-area","url":"https://pokeapi.co/api/v2/location-area/428/"},{"name":"hoenn-safari-zone-nwmach-bike-area","url":"https://pokeapi.co/api/v2/location-area/429/"},{"name":"hoenn-safari-zone-neacro-bike-area","url":"https://pokeapi.co/api/v2/location-area/430/"},{"name":"hoenn-safari-zone-sw","url":"https://pokeapi.co/api/v2/location-area/431/"},{"name":"hoenn-safari-zone-se","url":"https://pokeapi.co/api/v2/location-area/432/"},{"name":"dewford-town-area","url":"https://pokeapi.co/api/v2/location-area/433/"},{"name":"pacifidlog-town-area","url":"https://pokeapi.co/api/v2/location-area/434/"},{"name":"hoenn-safari-zone-expansion-south","url":"https://pokeapi.co/api/v2/location-area/435/"},{"name":"hoenn-safari-zone-expansion-north","url":"https://pokeapi.co/api/v2/location-area/436/"},{"name":"magma-hideout-area","url":"https://pokeapi.co/api/v2/location-area/437/"},{"name":"mirage-tower-area","url":"https://pokeapi.co/api/v2/location-area/438/"},{"name":"desert-underpass-area","url":"https://pokeapi.co/api/v2/location-area/439/"},{"name":"artisan-cave-area","url":"https://pokeapi.co/api/v2/location-area/440/"},{"name":"hoenn-altering-cave-a","url":"https://pokeapi.co/api/v2/location-area/441/"},{"name":"hoenn-altering-cave-b","url":"https://pokeapi.co/api/v2/location-area/442/"},{"name":"hoenn-altering-cave-c","url":"https://pokeapi.co/api/v2/location-area/443/"},{"name":"hoenn-altering-cave-d","url":"https://pokeapi.co/api/v2/location-area/444/"},{"name":"hoenn-altering-cave-e","url":"https://pokeapi.co/api/v2/location-area/445/"},{"name":"hoenn-altering-cave-f","url":"https://pokeapi.co/api/v2/location-area/446/"},{"name":"hoenn-altering-cave-g","url":"https://pokeapi.co/api/v2/location-area/447/"},{"name":"hoenn-altering-cave-h","url":"https://pokeapi.co/api/v2/location-area/448/"},{"name":"hoenn-altering-cave-i","url":"https://pokeapi.co/api/v2/location-area/449/"},{"name":"monean-chamber-area","url":"https://pokeapi.co/api/v2/location-area/450/"},{"name":"liptoo-chamber-area","url":"https://pokeapi.co/api/v2/location-area/451/"},{"name":"weepth-chamber-area","url":"https://pokeapi.co/api/v2/location-area/452/"},{"name":"dilford-chamber-area","url":"https://pokeapi.co/api/v2/location-area/453/"},{"name":"scufib-chamber-area","url":"https://pokeapi.co/api/v2/location-area/454/"},{"name":"rixy-chamber-area","url":"https://pokeapi.co/api/v2/location-area/455/"},{"name":"viapos-chamber-area","url":"https://pokeapi.co/api/v2/location-area/456/"},{"name":"ss-anne-area","url":"https://pokeapi.co/api/v2/location-area/461/"},{"name":"mt-ember-area","url":"https://pokeapi.co/api/v2/location-area/488/"},{"name":"mt-ember-cave","url":"https://pokeapi.co/api/v2/location-area/489/"},{"name":"mt-ember-inside","url":"https://pokeapi.co/api/v2/location-area/490/"},{"name":"mt-ember-1f-cave-behind-team-rocket","url":"https://pokeapi.co/api/v2/location-area/491/"},{"name":"mt-ember-b1f","url":"https://pokeapi.co/api/v2/location-area/492/"},{"name":"mt-ember-b2f","url":"https://pokeapi.co/api/v2/location-area/493/"},{"name":"mt-ember-b3f","url":"https://pokeapi.co/api/v2/location-area/494/"},{"name":"berry-forest-area","url":"https://pokeapi.co/api/v2/location-area/495/"},{"name":"icefall-cave-entrance","url":"https://pokeapi.co/api/v2/location-area/496/"},{"name":"icefall-cave-1f","url":"https://pokeapi.co/api/v2/location-area/497/"},{"name":"icefall-cave-b1f","url":"https://pokeapi.co/api/v2/location-area/498/"},{"name":"icefall-cave-waterfall","url":"https://pokeapi.co/api/v2/location-area/499/"},{"name":"pattern-bush-area","url":"https://pokeapi.co/api/v2/location-area/500/"},{"name":"lost-cave-room-1","url":"https://pokeapi.co/api/v2/location-area/501/"},{"name":"lost-cave-room-2","url":"https://pokeapi.co/api/v2/location-area/502/"},{"name":"lost-cave-room-3","url":"https://pokeapi.co/api/v2/location-area/503/"},{"name":"lost-cave-room-4","url":"https://pokeapi.co/api/v2/location-area/504/"},{"name":"lost-cave-room-5","url":"https://pokeapi.co/api/v2/location-area/505/"},{"name":"lost-cave-room-6","url":"https://pokeapi.co/api/v2/location-area/506/"},{"name":"lost-cave-room-7","url":"https://pokeapi.co/api/v2/location-area/507/"},{"name":"lost-cave-room-8","url":"https://pokeapi.co/api/v2/location-area/508/"},{"name":"lost-cave-room-9","url":"https://pokeapi.co/api/v2/location-area/509/"},{"name":"lost-cave-room-10","url":"https://pokeapi.co/api/v2/location-area/510/"},{"name":"lost-cave-item-rooms","url":"https://pokeapi.co/api/v2/location-area/511/"},{"name":"kindle-road-area","url":"https://pokeapi.co/api/v2/location-area/512/"},{"name":"treasure-beach-area","url":"https://pokeapi.co/api/v2/location-area/513/"},{"name":"cape-brink-area","url":"https://pokeapi.co/api/v2/location-area/514/"},{"name":"bond-bridge-area","url":"https://pokeapi.co/api/v2/location-area/515/"},{"name":"three-isle-port-area","url":"https://pokeapi.co/api/v2/location-area/516/"},{"name":"resort-gorgeous-area","url":"https://pokeapi.co/api/v2/location-area/517/"},{"name":"water-labyrinth-area","url":"https://pokeapi.co/api/v2/location-area/518/"},{"name":"five-isle-meadow-area","url":"https://pokeapi.co/api/v2/location-area/519/"},{"name":"memorial-pillar-area","url":"https://pokeapi.co/api/v2/location-area/520/"},{"name":"outcast-island-area","url":"https://pokeapi.co/api/v2/location-area/521/"},{"name":"green-path-area","url":"https://pokeapi.co/api/v2/location-area/522/"},{"name":"water-path-area","url":"https://pokeapi.co/api/v2/location-area/523/"},{"name":"ruin-valley-area","url":"https://pokeapi.co/api/v2/location-area/524/"},{"name":"trainer-tower-area","url":"https://pokeapi.co/api/v2/location-area/525/"},{"name":"canyon-entrance-area","url":"https://pokeapi.co/api/v2/location-area/526/"},{"name":"sevault-canyon-area","url":"https://pokeapi.co/api/v2/location-area/527/"},{"name":"tanoby-ruins-area","url":"https://pokeapi.co/api/v2/location-area/528/"},{"name":"one-island-area","url":"https://pokeapi.co/api/v2/location-area/561/"},{"name":"four-island-area","url":"https://pokeapi.co/api/v2/location-area/562/"},{"name":"five-island-area","url":"https://pokeapi.co/api/v2/location-area/563/"},{"name":"kanto-altering-cave-a","url":"https://pokeapi.co/api/v2/location-area/564/"},{"name":"kanto-altering-cave-b","url":"https://pokeapi.co/api/v2/location-area/565/"},{"name":"kanto-altering-cave-c","url":"https://pokeapi.co/api/v2/location-area/566/"},{"name":"kanto-altering-cave-d","url":"https://pokeapi.co/api/v2/location-area/567/"},{"name":"kanto-altering-cave-e","url":"https://pokeapi.co/api/v2/location-area/568/"},{"name":"kanto-altering-cave-f","url":"https://pokeapi.co/api/v2/location-area/569/"},{"name":"kanto-altering-cave-g","url":"https://pokeapi.co/api/v2/location-area/570/"},{"name":"kanto-altering-cave-h","url":"https://pokeapi.co/api/v2/location-area/571/"},{"name":"kanto-altering-cave-i","url":"https://pokeapi.co/api/v2/location-area/572/"},{"name":"striaton-city-area","url":"https://pokeapi.co/api/v2/location-area/576/"},{"name":"driftveil-city-area","url":"https://pokeapi.co/api/v2/location-area/577/"},{"name":"icirrus-city-area","url":"https://pokeapi.co/api/v2/location-area/578/"},{"name":"dreamyard-area","url":"https://pokeapi.co/api/v2/location-area/579/"},{"name":"dreamyard-b1f","url":"https://pokeapi.co/api/v2/location-area/580/"},{"name":"pinwheel-forest-outside","url":"https://pokeapi.co/api/v2/location-area/581/"},{"name":"pinwheel-forest-inside","url":"https://pokeapi.co/api/v2/location-area/582/"},{"name":"desert-resort-entrance","url":"https://pokeapi.co/api/v2/location-area/583/"},{"name":"desert-resort-area","url":"https://pokeapi.co/api/v2/location-area/584/"},{"name":"relic-castle-a","url":"https://pokeapi.co/api/v2/location-area/585/"},{"name":"relic-castle-b","url":"https://pokeapi.co/api/v2/location-area/586/"},{"name":"relic-castle-c","url":"https://pokeapi.co/api/v2/location-area/587/"},{"name":"relic-castle-d","url":"https://pokeapi.co/api/v2/location-area/588/"},{"name":"cold-storage-area","url":"https://pokeapi.co/api/v2/location-area/589/"},{"name":"chargestone-cave-1f","url":"https://pokeapi.co/api/v2/location-area/590/"},{"name":"chargestone-cave-b1f","url":"https://pokeapi.co/api/v2/location-area/591/"},{"name":"chargestone-cave-b2f","url":"https://pokeapi.co/api/v2/location-area/592/"},{"name":"twist-mountain-area","url":"https://pokeapi.co/api/v2/location-area/593/"},{"name":"dragonspiral-tower-entrance","url":"https://pokeapi.co/api/v2/location-area/594/"},{"name":"dragonspiral-tower-outside","url":"https://pokeapi.co/api/v2/location-area/595/"},{"name":"dragonspiral-tower-1f","url":"https://pokeapi.co/api/v2/location-area/596/"},{"name":"dragonspiral-tower-2f","url":"https://pokeapi.co/api/v2/location-area/597/"},{"name":"unova-victory-road-outside","url":"https://pokeapi.co/api/v2/location-area/598/"},{"name":"unova-victory-road-unknown-area-53","url":"https://pokeapi.co/api/v2/location-area/599/"},{"name":"unova-victory-road-unknown-area-54","url":"https://pokeapi.co/api/v2/location-area/600/"},{"name":"unova-victory-road-unknown-area-55","url":"https://pokeapi.co/api/v2/location-area/601/"},{"name":"unova-victory-road-unknown-area-56","url":"https://pokeapi.co/api/v2/location-area/602/"},{"name":"unova-victory-road-unknown-area-57","url":"https://pokeapi.co/api/v2/location-area/603/"},{"name":"unova-victory-road-unknown-area-58","url":"https://pokeapi.co/api/v2/location-area/604/"},{"name":"unova-victory-road-unknown-area-59","url":"https://pokeapi.co/api/v2/location-area/605/"},{"name":"unova-victory-road-unknown-area-60","url":"https://pokeapi.co/api/v2/location-area/606/"},{"name":"unova-victory-road-unknown-area-61","url":"https://pokeapi.co/api/v2/location-area/607/"},{"name":"unova-victory-road-unknown-area-62","url":"https://pokeapi.co/api/v2/location-area/608/"},{"name":"unova-victory-road-unknown-area-63","url":"https://pokeapi.co/api/v2/location-area/609/"},{"name":"unova-victory-road-unknown-area-64","url":"https://pokeapi.co/api/v2/location-area/610/"},{"name":"unova-victory-road-unknown-area-65","url":"https://pokeapi.co/api/v2/location-area/611/"},{"name":"unova-victory-road-unknown-area-66","url":"https://pokeapi.co/api/v2/location-area/612/"},{"name":"trial-chamber-area","url":"https://pokeapi.co/api/v2/location-area/613/"},{"name":"giant-chasm-outside","url":"https://pokeapi.co/api/v2/location-area/614/"},{"name":"giant-chasm-area","url":"https://pokeapi.co/api/v2/location-area/615/"},{"name":"giant-chasm-forest","url":"https://pokeapi.co/api/v2/location-area/616/"},{"name":"giant-chasm-forest-cave","url":"https://pokeapi.co/api/v2/location-area/617/"},{"name":"p2-laboratory-area","url":"https://pokeapi.co/api/v2/location-area/618/"},{"name":"undella-bay-area","url":"https://pokeapi.co/api/v2/location-area/619/"},{"name":"driftveil-drawbridge-area","url":"https://pokeapi.co/api/v2/location-area/620/"},{"name":"village-bridge-area","url":"https://pokeapi.co/api/v2/location-area/621/"},{"name":"marvelous-bridge-area","url":"https://pokeapi.co/api/v2/location-area/622/"},{"name":"unova-route-1-area","url":"https://pokeapi.co/api/v2/location-area/623/"},{"name":"unova-route-2-area","url":"https://pokeapi.co/api/v2/location-area/624/"},{"name":"unova-route-3-area","url":"https://pokeapi.co/api/v2/location-area/625/"},{"name":"wellspring-cave-area","url":"https://pokeapi.co/api/v2/location-area/626/"},{"name":"unova-route-4-area","url":"https://pokeapi.co/api/v2/location-area/627/"},{"name":"unova-route-5-area","url":"https://pokeapi.co/api/v2/location-area/628/"},{"name":"unova-route-6-area","url":"https://pokeapi.co/api/v2/location-area/629/"},{"name":"mistralton-cave-area","url":"https://pokeapi.co/api/v2/location-area/630/"},{"name":"guidance-chamber-area","url":"https://pokeapi.co/api/v2/location-area/631/"},{"name":"unova-route-7-area","url":"https://pokeapi.co/api/v2/location-area/632/"},{"name":"celestial-tower-2f","url":"https://pokeapi.co/api/v2/location-area/633/"},{"name":"celestial-tower-3f","url":"https://pokeapi.co/api/v2/location-area/634/"},{"name":"celestial-tower-4f","url":"https://pokeapi.co/api/v2/location-area/635/"},{"name":"celestial-tower-5f","url":"https://pokeapi.co/api/v2/location-area/636/"},{"name":"unova-route-8-area","url":"https://pokeapi.co/api/v2/location-area/637/"},{"name":"moor-of-icirrus-area","url":"https://pokeapi.co/api/v2/location-area/638/"},{"name":"unova-route-9-area","url":"https://pokeapi.co/api/v2/location-area/639/"},{"name":"challengers-cave-1f","url":"https://pokeapi.co/api/v2/location-area/640/"},{"name":"challengers-cave-b1f","url":"https://pokeapi.co/api/v2/location-area/641/"},{"name":"challengers-cave-b2f","url":"https://pokeapi.co/api/v2/location-area/642/"},{"name":"unova-route-10-area","url":"https://pokeapi.co/api/v2/location-area/643/"},{"name":"unova-route-10-victory-road-gate","url":"https://pokeapi.co/api/v2/location-area/644/"},{"name":"unova-route-11-area","url":"https://pokeapi.co/api/v2/location-area/645/"},{"name":"unova-route-12-area","url":"https://pokeapi.co/api/v2/location-area/646/"},{"name":"unova-route-13-area","url":"https://pokeapi.co/api/v2/location-area/647/"},{"name":"unova-route-14-area","url":"https://pokeapi.co/api/v2/location-area/648/"},{"name":"abundant-shrine-area","url":"https://pokeapi.co/api/v2/location-area/649/"},{"name":"unova-route-15-area","url":"https://pokeapi.co/api/v2/location-area/650/"},{"name":"unova-route-16-area","url":"https://pokeapi.co/api/v2/location-area/651/"},{"name":"lostlorn-forest-area","url":"https://pokeapi.co/api/v2/location-area/652/"},{"name":"unova-route-18-area","url":"https://pokeapi.co/api/v2/location-area/653/"},{"name":"undella-town-area","url":"https://pokeapi.co/api/v2/location-area/654/"},{"name":"unova-route-17-area","url":"https://pokeapi.co/api/v2/location-area/655/"},{"name":"castelia-city-area","url":"https://pokeapi.co/api/v2/location-area/656/"},{"name":"aspertia-city-area","url":"https://pokeapi.co/api/v2/location-area/657/"},{"name":"virbank-city-area","url":"https://pokeapi.co/api/v2/location-area/658/"},{"name":"humilau-city-area","url":"https://pokeapi.co/api/v2/location-area/659/"},{"name":"unova-victory-road-7f","url":"https://pokeapi.co/api/v2/location-area/660/"},{"name":"unova-victory-road-2-unknown-area-71","url":"https://pokeapi.co/api/v2/location-area/661/"},{"name":"unova-victory-road-2-unknown-area-72","url":"https://pokeapi.co/api/v2/location-area/662/"},{"name":"unova-victory-road-2-unknown-area-73","url":"https://pokeapi.co/api/v2/location-area/663/"},{"name":"unova-victory-road-2-unknown-area-74","url":"https://pokeapi.co/api/v2/location-area/664/"},{"name":"unova-victory-road-2-unknown-area-75","url":"https://pokeapi.co/api/v2/location-area/665/"},{"name":"unova-victory-road-2-unknown-area-76","url":"https://pokeapi.co/api/v2/location-area/666/"},{"name":"unova-victory-road-2-unknown-area-77","url":"https://pokeapi.co/api/v2/location-area/667/"},{"name":"unova-victory-road-2-unknown-area-78","url":"https://pokeapi.co/api/v2/location-area/668/"},{"name":"unova-victory-road-2-unknown-area-79","url":"https://pokeapi.co/api/v2/location-area/669/"},{"name":"unova-victory-road-2-unknown-area-80","url":"https://pokeapi.co/api/v2/location-area/670/"},{"name":"castelia-sewers-area","url":"https://pokeapi.co/api/v2/location-area/671/"},{"name":"castelia-sewers-unknown-area-38","url":"https://pokeapi.co/api/v2/location-area/672/"},{"name":"floccesy-ranch-outer","url":"https://pokeapi.co/api/v2/location-area/673/"},{"name":"floccesy-ranch-inner","url":"https://pokeapi.co/api/v2/location-area/674/"},{"name":"virbank-complex-outer","url":"https://pokeapi.co/api/v2/location-area/675/"},{"name":"virbank-complex-inner","url":"https://pokeapi.co/api/v2/location-area/676/"},{"name":"reversal-mountain-unknown-area-48","url":"https://pokeapi.co/api/v2/location-area/677/"},{"name":"reversal-mountain-unknown-area-49","url":"https://pokeapi.co/api/v2/location-area/678/"},{"name":"reversal-mountain-unknown-area-50","url":"https://pokeapi.co/api/v2/location-area/679/"},{"name":"reversal-mountain-unknown-area-51","url":"https://pokeapi.co/api/v2/location-area/680/"},{"name":"reversal-mountain-unknown-area-52","url":"https://pokeapi.co/api/v2/location-area/681/"},{"name":"reversal-mountain-unknown-area-53","url":"https://pokeapi.co/api/v2/location-area/682/"},{"name":"reversal-mountain-unknown-area-54","url":"https://pokeapi.co/api/v2/location-area/683/"},{"name":"reversal-mountain-unknown-area-55","url":"https://pokeapi.co/api/v2/location-area/684/"},{"name":"reversal-mountain-unknown-area-56","url":"https://pokeapi.co/api/v2/location-area/685/"},{"name":"reversal-mountain-unknown-area-57","url":"https://pokeapi.co/api/v2/location-area/686/"},{"name":"reversal-mountain-unknown-area-58","url":"https://pokeapi.co/api/v2/location-area/687/"},{"name":"reversal-mountain-unknown-area-59","url":"https://pokeapi.co/api/v2/location-area/688/"},{"name":"reversal-mountain-unknown-area-60","url":"https://pokeapi.co/api/v2/location-area/689/"},{"name":"strange-house-1f","url":"https://pokeapi.co/api/v2/location-area/690/"},{"name":"strange-house-b1f","url":"https://pokeapi.co/api/v2/location-area/691/"},{"name":"relic-passage-castelia-sewers-entrance","url":"https://pokeapi.co/api/v2/location-area/692/"},{"name":"relic-passage-relic-castle-entrance","url":"https://pokeapi.co/api/v2/location-area/693/"},{"name":"relic-passage-pwt-entrance","url":"https://pokeapi.co/api/v2/location-area/694/"},{"name":"clay-tunnel-area","url":"https://pokeapi.co/api/v2/location-area/695/"},{"name":"underground-ruins-area","url":"https://pokeapi.co/api/v2/location-area/696/"},{"name":"rocky-mountain-room-area","url":"https://pokeapi.co/api/v2/location-area/697/"},{"name":"glacier-room-area","url":"https://pokeapi.co/api/v2/location-area/698/"},{"name":"iron-room-area","url":"https://pokeapi.co/api/v2/location-area/699/"},{"name":"seaside-cave-1f","url":"https://pokeapi.co/api/v2/location-area/700/"},{"name":"seaside-cave-b1f","url":"https://pokeapi.co/api/v2/location-area/701/"},{"name":"nature-sanctuary-area","url":"https://pokeapi.co/api/v2/location-area/702/"},{"name":"unova-route-19-area","url":"https://pokeapi.co/api/v2/location-area/703/"},{"name":"unova-route-20-area","url":"https://pokeapi.co/api/v2/location-area/704/"},{"name":"unova-route-22-area","url":"https://pokeapi.co/api/v2/location-area/705/"},{"name":"unova-route-23-area","url":"https://pokeapi.co/api/v2/location-area/706/"},{"name":"unova-route-21-area","url":"https://pokeapi.co/api/v2/location-area/707/"},{"name":"couriway-town-area","url":"https://pokeapi.co/api/v2/location-area/708/"},{"name":"ambrette-town-area","url":"https://pokeapi.co/api/v2/location-area/709/"},{"name":"cyllage-city-area","url":"https://pokeapi.co/api/v2/location-area/710/"},{"name":"shalour-city-area","url":"https://pokeapi.co/api/v2/location-area/711/"},{"name":"laverre-city-area","url":"https://pokeapi.co/api/v2/location-area/712/"},{"name":"kalos-route-2-area","url":"https://pokeapi.co/api/v2/location-area/713/"},{"name":"kalos-route-3-area","url":"https://pokeapi.co/api/v2/location-area/714/"},{"name":"kalos-route-4-area","url":"https://pokeapi.co/api/v2/location-area/715/"},{"name":"kalos-route-5-area","url":"https://pokeapi.co/api/v2/location-area/716/"},{"name":"kalos-route-6-area","url":"https://pokeapi.co/api/v2/location-area/717/"},{"name":"kalos-route-7-area","url":"https://pokeapi.co/api/v2/location-area/718/"},{"name":"kalos-route-8-area","url":"https://pokeapi.co/api/v2/location-area/719/"},{"name":"kalos-route-9-area","url":"https://pokeapi.co/api/v2/location-area/720/"},{"name":"kalos-route-10-area","url":"https://pokeapi.co/api/v2/location-area/721/"},{"name":"kalos-route-11-area","url":"https://pokeapi.co/api/v2/location-area/722/"},{"name":"kalos-route-12-area","url":"https://pokeapi.co/api/v2/location-area/723/"},{"name":"kalos-route-13-area","url":"https://pokeapi.co/api/v2/location-area/724/"},{"name":"kalos-route-14-area","url":"https://pokeapi.co/api/v2/location-area/725/"},{"name":"kalos-route-15-area","url":"https://pokeapi.co/api/v2/location-area/726/"},{"name":"kalos-route-16-area","url":"https://pokeapi.co/api/v2/location-area/727/"},{"name":"kalos-route-17-area","url":"https://pokeapi.co/api/v2/location-area/728/"},{"name":"kalos-route-18-area","url":"https://pokeapi.co/api/v2/location-area/729/"},{"name":"kalos-route-19-area","url":"https://pokeapi.co/api/v2/location-area/730/"},{"name":"kalos-route-20-area","url":"https://pokeapi.co/api/v2/location-area/731/"},{"name":"kalos-route-21-area","url":"https://pokeapi.co/api/v2/location-area/732/"},{"name":"kalos-route-22-area","url":"https://pokeapi.co/api/v2/location-area/733/"},{"name":"santalune-forest-area","url":"https://pokeapi.co/api/v2/location-area/734/"},{"name":"parfum-palace-area","url":"https://pokeapi.co/api/v2/location-area/735/"},{"name":"glittering-cave-unknown-area-303","url":"https://pokeapi.co/api/v2/location-area/736/"},{"name":"glittering-cave-unknown-area-304","url":"https://pokeapi.co/api/v2/location-area/737/"},{"name":"reflection-cave-unknown-area-305","url":"https://pokeapi.co/api/v2/location-area/738/"},{"name":"reflection-cave-unknown-area-306","url":"https://pokeapi.co/api/v2/location-area/739/"},{"name":"reflection-cave-unknown-area-307","url":"https://pokeapi.co/api/v2/location-area/740/"},{"name":"reflection-cave-unknown-area-308","url":"https://pokeapi.co/api/v2/location-area/741/"},{"name":"frost-cavern-unknown-area-313","url":"https://pokeapi.co/api/v2/location-area/742/"},{"name":"frost-cavern-unknown-area-314","url":"https://pokeapi.co/api/v2/location-area/743/"},{"name":"frost-cavern-unknown-area-315","url":"https://pokeapi.co/api/v2/location-area/744/"},{"name":"frost-cavern-unknown-area-316","url":"https://pokeapi.co/api/v2/location-area/745/"},{"name":"frost-cavern-unknown-area-317","url":"https://pokeapi.co/api/v2/location-area/746/"},{"name":"pokemon-village-area","url":"https://pokeapi.co/api/v2/location-area/747/"},{"name":"kalos-victory-road-unknown-area-322","url":"https://pokeapi.co/api/v2/location-area/748/"},{"name":"kalos-victory-road-unknown-area-324","url":"https://pokeapi.co/api/v2/location-area/749/"},{"name":"kalos-victory-road-unknown-area-326","url":"https://pokeapi.co/api/v2/location-area/750/"},{"name":"kalos-victory-road-unknown-area-327","url":"https://pokeapi.co/api/v2/location-area/751/"},{"name":"kalos-victory-road-unknown-area-328","url":"https://pokeapi.co/api/v2/location-area/752/"},{"name":"connecting-cave-area","url":"https://pokeapi.co/api/v2/location-area/753/"},{"name":"terminus-cave-unknown-area-343","url":"https://pokeapi.co/api/v2/location-area/754/"},{"name":"terminus-cave-unknown-area-344","url":"https://pokeapi.co/api/v2/location-area/755/"},{"name":"terminus-cave-unknown-area-345","url":"https://pokeapi.co/api/v2/location-area/756/"},{"name":"terminus-cave-unknown-area-347","url":"https://pokeapi.co/api/v2/location-area/757/"},{"name":"terminus-cave-unknown-area-348","url":"https://pokeapi.co/api/v2/location-area/758/"},{"name":"lost-hotel-area","url":"https://pokeapi.co/api/v2/location-area/759/"},{"name":"azure-bay-area","url":"https://pokeapi.co/api/v2/location-area/760/"}]}"#;

// https://pokeapi.co/api/v2/machine/?offset=0&limit=9999
static FULL_MACHINE_LIST_JSON: &str = r#"{"count":1442,"next":null,"previous":null,"results":[{"url":"https://pokeapi.co/api/v2/machine/1/"},{"url":"https://pokeapi.co/api/v2/machine/2/"},{"url":"https://pokeapi.co/api/v2/machine/3/"},{"url":"https://pokeapi.co/api/v2/machine/4/"},{"url":"https://pokeapi.co/api/v2/machine/5/"},{"url":"https://pokeapi.co/api/v2/machine/6/"},{"url":"https://pokeapi.co/api/v2/machine/7/"},{"url":"https://pokeapi.co/api/v2/machine/8/"},{"url":"https://pokeapi.co/api/v2/machine/9/"},{"url":"https://pokeapi.co/api/v2/machine/10/"},{"url":"https://pokeapi.co/api/v2/machine/11/"},{"url":"https://pokeapi.co/api/v2/machine/12/"},{"url":"https://pokeapi.co/api/v2/machine/13/"},{"url":"https://pokeapi.co/api/v2/machine/14/"},{"url":"https://pokeapi.co/api/v2/machine/15/"},{"url":"https://pokeapi.co/api/v2/machine/16/"},{"url":"https://pokeapi.co/api/v2/machine/17/"},{"url":"https://pokeapi.co/api/v2/machine/18/"},{"url":"https://pokeapi.co/api/v2/machine/19/"},{"url":"https://pokeapi.co/api/v2/machine/20/"},{"url":"https://pokeapi.co/api/v2/machine/21/"},{"url":"https://pokeapi.co/api/v2/machine/22/"},{"url":"https://pokeapi.co/api/v2/machine/23/"},{"url":"https://pokeapi.co/api/v2/machine/24/"},{"url":"https://pokeapi.co/api/v2/machine/25/"},{"url":"https://pokeapi.co/api/v2/machine/26/"},{"url":"https://pokeapi.co/api/v2/machine/27/"},{"url":"https://pokeapi.co/api/v2/machine/28/"},{"url":"https://pokeapi.co/api/v2/machine/29/"},{"url":"https://pokeapi.co/api/v2/machine/30/"},{"url":"https://pokeapi.co/api/v2/machine/31/"},{"url":"https://pokeapi.co/api/v2/machine/32/"},{"url":"https://pokeapi.co/api/v2/machine/33/"},{"url":"https://pokeapi.co/api/v2/machine/34/"},{"url":"https://pokeapi.co/api/v2/machine/35/"},{"url":"https://pokeapi.co/api/v2/machine/36/"},{"url":"https://pokeapi.co/api/v2/machine/37/"},{"url":"https://pokeapi.co/api/v2/machine/38/"},{"url":"https://pokeapi.co/api/v2/machine/39/"},{"url":"https://pokeapi.co/api/v2/machine/40/"},{"url":"https://pokeapi.co/api/v2/machine/41/"},{"url":"https://pokeapi.co/api/v2/machine/42/"},{"url":"https://pokeapi.co/api/v2/machine/43/"},{"url":"https://pokeapi.co/api/v2/machine/44/"},{"url":"https://pokeapi.co/api/v2/machine/45/"},{"url":"https://pokeapi.co/api/v2/machine/46/"},{"url":"https://pokeapi.co/api/v2/machine/47/"},{"url":"https://pokeapi.co/api/v2/machine/48/"},{"url":"https://pokeapi.co/api/v2/machine/49/"},{"url":"https://pokeapi.co/api/v2/machine/50/"},{"url":"https://pokeapi.co/api/v2/machine/51/"},{"url":"https://pokeapi.co/api/v2/machine/52/"},{"url":"https://pokeapi.co/api/v2/machine/53/"},{"url":"https://pokeapi.co/api/v2/machine/54/"},{"url":"https://pokeapi.co/api/v2/machine/55/"},{"url":"https://pokeapi.co/api/v2/machine/56/"},{"url":"https://pokeapi.co/api/v2/machine/57/"},{"url":"https://pokeapi.co/api/v2/machine/58/"},{"url":"https://pokeapi.co/api/v2/machine/59/"},{"url":"https://pokeapi.co/api/v2/machine/60/"},{"url":"https://pokeapi.co/api/v2/machine/61/"},{"url":"https://pokeapi.co/api/v2/machine/62/"},{"url":"https://pokeapi.co/api/v2/machine/63/"},{"url":"https://pokeapi.co/api/v2/machine/64/"},{"url":"https://pokeapi.co/api/v2/machine/65/"},{"url":"https://pokeapi.co/api/v2/machine/66/"},{"url":"https://pokeapi.co/api/v2/machine/67/"},{"url":"https://pokeapi.co/api/v2/machine/68/"},{"url":"https://pokeapi.co/api/v2/machine/69/"},{"url":"https://pokeapi.co/api/v2/machine/70/"},{"url":"https://pokeapi.co/api/v2/machine/71/"},{"url":"https://pokeapi.co/api/v2/machine/72/"},{"url":"https://pokeapi.co/api/v2/machine/73/"},{"url":"https://pokeapi.co/api/v2/machine/74/"},{"url":"https://pokeapi.co/api/v2/machine/75/"},{"url":"https://pokeapi.co/api/v2/machine/76/"},{"url":"https://pokeapi.co/api/v2/machine/77/"},{"url":"https://pokeapi.co/api/v2/machine/78/"},{"url":"https://pokeapi.co/api/v2/machine/79/"},{"url":"https://pokeapi.co/api/v2/machine/80/"},{"url":"https://pokeapi.co/api/v2/machine/81/"},{"url":"https://pokeapi.co/api/v2/machine/82/"},{"url":"https://pokeapi.co/api/v2/machine/83/"},{"url":"https://pokeapi.co/api/v2/machine/84/"},{"url":"https://pokeapi.co/api/v2/machine/85/"},{"url":"https://pokeapi.co/api/v2/machine/86/"},{"url":"https://pokeapi.co/api/v2/machine/87/"},{"url":"https://pokeapi.co/api/v2/machine/88/"},{"url":"https://pokeapi.co/api/v2/machine/89/"},{"url":"https://pokeapi.co/api/v2/machine/90/"},{"url":"https://pokeapi.co/api/v2/machine/91/"},{"url":"https://pokeapi.co/api/v2/machine/92/"},{"url":"https://pokeapi.co/api/v2/machine/93/"},{"url":"https://pokeapi.co/api/v2/machine/94/"},{"url":"https://pokeapi.co/api/v2/machine/95/"},{"url":"https://pokeapi.co/api/v2/machine/96/"},{"url":"https://pokeapi.co/api/v2/machine/97/"},{"url":"https://pokeapi.co/api/v2/machine/98/"},{"url":"https://pokeapi.co/api/v2/machine/99/"},{"url":"https://pokeapi.co/api/v2/machine/100/"},{"url":"https://pokeapi.co/api/v2/machine/101/"},{"url":"https://pokeapi.co/api/v2/machine/102/"},{"url":"https://pokeapi.co/api/v2/machine/103/"},{"url":"https://pokeapi.co/api/v2/machine/104/"},{"url":"https://pokeapi.co/api/v2/machine/105/"},{"url":"https://pokeapi.co/api/v2/machine/106/"},{"url":"https://pokeapi.co/api/v2/machine/107/"},{"url":"https://pokeapi.co/api/v2/machine/108/"},{"url":"https://pokeapi.co/api/v2/machine/109/"},{"url":"https://pokeapi.co/api/v2/machine/110/"},{"url":"https://pokeapi.co/api/v2/machine/111/"},{"url":"https://pokeapi.co/api/v2/machine/112/"},{"url":"https://pokeapi.co/api/v2/machine/113/"},{"url":"https://pokeapi.co/api/v2/machine/114/"},{"url":"https://pokeapi.co/api/v2/machine/115/"},{"url":"https://pokeapi.co/api/v2/machine/116/"},{"url":"https://pokeapi.co/api/v2/machine/117/"},{"url":"https://pokeapi.co/api/v2/machine/118/"},{"url":"https://pokeapi.co/api/v2/machine/119/"},{"url":"https://pokeapi.co/api/v2/machine/120/"},{"url":"https://pokeapi.co/api/v2/machine/121/"},{"url":"https://pokeapi.co/api/v2/machine/122/"},{"url":"https://pokeapi.co/api/v2/machine/123/"},{"url":"https://pokeapi.co/api/v2/machine/124/"},{"url":"https://pokeapi.co/api/v2/machine/125/"},{"url":"https://pokeapi.co/api/v2/machine/126/"},{"url":"https://pokeapi.co/api/v2/machine/127/"},{"url":"https://pokeapi.co/api/v2/machine/128/"},{"url":"https://pokeapi.co/api/v2/machine/129/"},{"url":"https://pokeapi.co/api/v2/machine/130/"},{"url":"https://pokeapi.co/api/v2/machine/131/"},{"url":"https://pokeapi.co/api/v2/machine/132/"},{"url":"https://pokeapi.co/api/v2/machine/133/"},{"url":"https://pokeapi.co/api/v2/machine/134/"},{"url":"https://pokeapi.co/api/v2/machine/135/"},{"url":"https://pokeapi.co/api/v2/machine/136/"},{"url":"https://pokeapi.co/api/v2/machine/137/"},{"url":"https://pokeapi.co/api/v2/machine/138/"},{"url":"https://pokeapi.co/api/v2/machine/139/"},{"url":"https://pokeapi.co/api/v2/machine/140/"},{"url":"https://pokeapi.co/api/v2/machine/141/"},{"url":"https://pokeapi.co/api/v2/machine/142/"},{"url":"https://pokeapi.co/api/v2/machine/143/"},{"url":"https://pokeapi.co/api/v2/machine/144/"},{"url":"https://pokeapi.co/api/v2/machine/145/"},{"url":"https://pokeapi.co/api/v2/machine/146/"},{"url":"https://pokeapi.co/api/v2/machine/147/"},{"url":"https://pokeapi.co/api/v2/machine/148/"},{"url":"https://pokeapi.co/api/v2/machine/149/"},{"url":"https://pokeapi.co/api/v2/machine/150/"},{"url":"https://pokeapi.co/api/v2/machine/151/"},{"url":"https://pokeapi.co/api/v2/machine/152/"},{"url":"https://pokeapi.co/api/v2/machine/153/"},{"url":"https://pokeapi.co/api/v2/machine/154/"},{"url":"https://pokeapi.co/api/v2/machine/155/"},{"url":"https://pokeapi.co/api/v2/machine/156/"},{"url":"https://pokeapi.co/api/v2/machine/157/"},{"url":"https://pokeapi.co/api/v2/machine/158/"},{"url":"https://pokeapi.co/api/v2/machine/159/"},{"url":"https://pokeapi.co/api/v2/machine/160/"},{"url":"https://pokeapi.co/api/v2/machine/161/"},{"url":"https://pokeapi.co/api/v2/machine/162/"},{"url":"https://pokeapi.co/api/v2/machine/163/"},{"url":"https://pokeapi.co/api/v2/machine/164/"},{"url":"https://pokeapi.co/api/v2/machine/165/"},{"url":"https://pokeapi.co/api/v2/machine/166/"},{"url":"https://pokeapi.co/api/v2/machine/167/"},{"url":"https://pokeapi.co/api/v2/machine/168/"},{"url":"https://pokeapi.co/api/v2/machine/169/"},{"url":"https://pokeapi.co/api/v2/machine/170/"},{"url":"https://pokeapi.co/api/v2/machine/171/"},{"url":"https://pokeapi.co/api/v2/machine/172/"},{"url":"https://pokeapi.co/api/v2/machine/173/"},{"url":"https://pokeapi.co/api/v2/machine/174/"},{"url":"https://pokeapi.co/api/v2/machine/175/"},{"url":"https://pokeapi.co/api/v2/machine/176/"},{"url":"https://pokeapi.co/api/v2/machine/177/"},{"url":"https://pokeapi.co/api/v2/machine/178/"},{"url":"https://pokeapi.co/api/v2/machine/179/"},{"url":"https://pokeapi.co/api/v2/machine/180/"},{"url":"https://pokeapi.co/api/v2/machine/181/"},{"url":"https://pokeapi.co/api/v2/machine/182/"},{"url":"https://pokeapi.co/api/v2/machine/183/"},{"url":"https://pokeapi.co/api/v2/machine/184/"},{"url":"https://pokeapi.co/api/v2/machine/185/"},{"url":"https://pokeapi.co/api/v2/machine/186/"},{"url":"https://pokeapi.co/api/v2/machine/187/"},{"url":"https://pokeapi.co/api/v2/machine/188/"},{"url":"https://pokeapi.co/api/v2/machine/189/"},{"url":"https://pokeapi.co/api/v2/machine/190/"},{"url":"https://pokeapi.co/api/v2/machine/191/"},{"url":"https://pokeapi.co/api/v2/machine/192/"},{"url":"https://pokeapi.co/api/v2/machine/193/"},{"url":"https://pokeapi.co/api/v2/machine/194/"},{"url":"https://pokeapi.co/api/v2/machine/195/"},{"url":"https://pokeapi.co/api/v2/machine/196/"},{"url":"https://pokeapi.co/api/v2/machine/197/"},{"url":"https://pokeapi.co/api/v2/machine/198/"},{"url":"https://pokeapi.co/api/v2/machine/199/"},{"url":"https://pokeapi.co/api/v2/machine/200/"},{"url":"https://pokeapi.co/api/v2/machine/201/"},{"url":"https://pokeapi.co/api/v2/machine/202/"},{"url":"https://pokeapi.co/api/v2/machine/203/"},{"url":"https://pokeapi.co/api/v2/machine/204/"},{"url":"https://pokeapi.co/api/v2/machine/205/"},{"url":"https://pokeapi.co/api/v2/machine/206/"},{"url":"https://pokeapi.co/api/v2/machine/207/"},{"url":"https://pokeapi.co/api/v2/machine/208/"},{"url":"https://pokeapi.co/api/v2/machine/209/"},{"url":"https://pokeapi.co/api/v2/machine/210/"},{"url":"https://pokeapi.co/api/v2/machine/211/"},{"url":"https://pokeapi.co/api/v2/machine/212/"},{"url":"https://pokeapi.co/api/v2/machine/213/"},{"url":"https://pokeapi.co/api/v2/machine/214/"},{"url":"https://pokeapi.co/api/v2/machine/215/"},{"url":"https://pokeapi.co/api/v2/machine/216/"},{"url":"https://pokeapi.co/api/v2/machine/217/"},{"url":"https://pokeapi.co/api/v2/machine/218/"},{"url":"https://pokeapi.co/api/v2/machine/219/"},{"url":"https://pokeapi.co/api/v2/machine/220/"},{"url":"https://pokeapi.co/api/v2/machine/221/"},{"url":"https://pokeapi.co/api/v2/machine/222/"},{"url":"https://pokeapi.co/api/v2/machine/223/"},{"url":"https://pokeapi.co/api/v2/machine/224/"},{"url":"https://pokeapi.co/api/v2/machine/225/"},{"url":"https://pokeapi.co/api/v2/machine/226/"},{"url":"https://pokeapi.co/api/v2/machine/227/"},{"url":"https://pokeapi.co/api/v2/machine/228/"},{"url":"https://pokeapi.co/api/v2/machine/229/"},{"url":"https://pokeapi.co/api/v2/machine/230/"},{"url":"https://pokeapi.co/api/v2/machine/231/"},{"url":"https://pokeapi.co/api/v2/machine/232/"},{"url":"https://pokeapi.co/api/v2/machine/233/"},{"url":"https://pokeapi.co/api/v2/machine/234/"},{"url":"https://pokeapi.co/api/v2/machine/235/"},{"url":"https://pokeapi.co/api/v2/machine/236/"},{"url":"https://pokeapi.co/api/v2/machine/237/"},{"url":"https://pokeapi.co/api/v2/machine/238/"},{"url":"https://pokeapi.co/api/v2/machine/239/"},{"url":"https://pokeapi.co/api/v2/machine/240/"},{"url":"https://pokeapi.co/api/v2/machine/241/"},{"url":"https://pokeapi.co/api/v2/machine/242/"},{"url":"https://pokeapi.co/api/v2/machine/243/"},{"url":"https://pokeapi.co/api/v2/machine/244/"},{"url":"https://pokeapi.co/api/v2/machine/245/"},{"url":"https://pokeapi.co/api/v2/machine/246/"},{"url":"https://pokeapi.co/api/v2/machine/247/"},{"url":"https://pokeapi.co/api/v2/machine/248/"},{"url":"https://pokeapi.co/api/v2/machine/249/"},{"url":"https://pokeapi.co/api/v2/machine/250/"},{"url":"https://pokeapi.co/api/v2/machine/251/"},{"url":"https://pokeapi.co/api/v2/machine/252/"},{"url":"https://pokeapi.co/api/v2/machine/253/"},{"url":"https://pokeapi.co/api/v2/machine/254/"},{"url":"https://pokeapi.co/api/v2/machine/255/"},{"url":"https://pokeapi.co/api/v2/machine/256/"},{"url":"https://pokeapi.co/api/v2/machine/257/"},{"url":"https://pokeapi.co/api/v2/machine/258/"},{"url":"https://pokeapi.co/api/v2/machine/259/"},{"url":"https://pokeapi.co/api/v2/machine/260/"},{"url":"https://pokeapi.co/api/v2/machine/261/"},{"url":"https://pokeapi.co/api/v2/machine/262/"},{"url":"https://pokeapi.co/api/v2/machine/263/"},{"url":"https://pokeapi.co/api/v2/machine/264/"},{"url":"https://pokeapi.co/api/v2/machine/265/"},{"url":"https://pokeapi.co/api/v2/machine/266/"},{"url":"https://pokeapi.co/api/v2/machine/267/"},{"url":"https://pokeapi.co/api/v2/machine/268/"},{"url":"https://pokeapi.co/api/v2/machine/269/"},{"url":"https://pokeapi.co/api/v2/machine/270/"},{"url":"https://pokeapi.co/api/v2/machine/271/"},{"url":"https://pokeapi.co/api/v2/machine/272/"},{"url":"https://pokeapi.co/api/v2/machine/273/"},{"url":"https://pokeapi.co/api/v2/machine/274/"},{"url":"https://pokeapi.co/api/v2/machine/275/"},{"url":"https://pokeapi.co/api/v2/machine/276/"},{"url":"https://pokeapi.co/api/v2/machine/277/"},{"url":"https://pokeapi.co/api/v2/machine/278/"},{"url":"https://pokeapi.co/api/v2/machine/279/"},{"url":"https://pokeapi.co/api/v2/machine/280/"},{"url":"https://pokeapi.co/api/v2/machine/281/"},{"url":"https://pokeapi.co/api/v2/machine/282/"},{"url":"https://pokeapi.co/api/v2/machine/283/"},{"url":"https://pokeapi.co/api/v2/machine/284/"},{"url":"https://pokeapi.co/api/v2/machine/285/"},{"url":"https://pokeapi.co/api/v2/machine/286/"},{"url":"https://pokeapi.co/api/v2/machine/287/"},{"url":"https://pokeapi.co/api/v2/machine/288/"},{"url":"https://pokeapi.co/api/v2/machine/289/"},{"url":"https://pokeapi.co/api/v2/machine/290/"},{"url":"https://pokeapi.co/api/v2/machine/291/"},{"url":"https://pokeapi.co/api/v2/machine/292/"},{"url":"https://pokeapi.co/api/v2/machine/293/"},{"url":"https://pokeapi.co/api/v2/machine/294/"},{"url":"https://pokeapi.co/api/v2/machine/295/"},{"url":"https://pokeapi.co/api/v2/machine/296/"},{"url":"https://pokeapi.co/api/v2/machine/297/"},{"url":"https://pokeapi.co/api/v2/machine/298/"},{"url":"https://pokeapi.co/api/v2/machine/299/"},{"url":"https://pokeapi.co/api/v2/machine/300/"},{"url":"https://pokeapi.co/api/v2/machine/301/"},{"url":"https://pokeapi.co/api/v2/machine/302/"},{"url":"https://pokeapi.co/api/v2/machine/303/"},{"url":"https://pokeapi.co/api/v2/machine/304/"},{"url":"https://pokeapi.co/api/v2/machine/305/"},{"url":"https://pokeapi.co/api/v2/machine/306/"},{"url":"https://pokeapi.co/api/v2/machine/307/"},{"url":"https://pokeapi.co/api/v2/machine/308/"},{"url":"https://pokeapi.co/api/v2/machine/309/"},{"url":"https://pokeapi.co/api/v2/machine/310/"},{"url":"https://pokeapi.co/api/v2/machine/311/"},{"url":"https://pokeapi.co/api/v2/machine/312/"},{"url":"https://pokeapi.co/api/v2/machine/313/"},{"url":"https://pokeapi.co/api/v2/machine/314/"},{"url":"https://pokeapi.co/api/v2/machine/315/"},{"url":"https://pokeapi.co/api/v2/machine/316/"},{"url":"https://pokeapi.co/api/v2/machine/317/"},{"url":"https://pokeapi.co/api/v2/machine/318/"},{"url":"https://pokeapi.co/api/v2/machine/319/"},{"url":"https://pokeapi.co/api/v2/machine/320/"},{"url":"https://pokeapi.co/api/v2/machine/321/"},{"url":"https://pokeapi.co/api/v2/machine/322/"},{"url":"https://pokeapi.co/api/v2/machine/323/"},{"url":"https://pokeapi.co/api/v2/machine/324/"},{"url":"https://pokeapi.co/api/v2/machine/325/"},{"url":"https://pokeapi.co/api/v2/machine/326/"},{"url":"https://pokeapi.co/api/v2/machine/327/"},{"url":"https://pokeapi.co/api/v2/machine/328/"},{"url":"https://pokeapi.co/api/v2/machine/329/"},{"url":"https://pokeapi.co/api/v2/machine/330/"},{"url":"https://pokeapi.co/api/v2/machine/331/"},{"url":"https://pokeapi.co/api/v2/machine/332/"},{"url":"https://pokeapi.co/api/v2/machine/333/"},{"url":"https://pokeapi.co/api/v2/machine/334/"},{"url":"https://pokeapi.co/api/v2/machine/335/"},{"url":"https://pokeapi.co/api/v2/machine/336/"},{"url":"https://pokeapi.co/api/v2/machine/337/"},{"url":"https://pokeapi.co/api/v2/machine/338/"},{"url":"https://pokeapi.co/api/v2/machine/339/"},{"url":"https://pokeapi.co/api/v2/machine/340/"},{"url":"https://pokeapi.co/api/v2/machine/341/"},{"url":"https://pokeapi.co/api/v2/machine/342/"},{"url":"https://pokeapi.co/api/v2/machine/343/"},{"url":"https://pokeapi.co/api/v2/machine/344/"},{"url":"https://pokeapi.co/api/v2/machine/345/"},{"url":"https://pokeapi.co/api/v2/machine/346/"},{"url":"https://pokeapi.co/api/v2/machine/347/"},{"url":"https://pokeapi.co/api/v2/machine/348/"},{"url":"https://pokeapi.co/api/v2/machine/349/"},{"url":"https://pokeapi.co/api/v2/machine/350/"},{"url":"https://pokeapi.co/api/v2/machine/351/"},{"url":"https://pokeapi.co/api/v2/machine/352/"},{"url":"https://pokeapi.co/api/v2/machine/353/"},{"url":"https://pokeapi.co/api/v2/machine/354/"},{"url":"https://pokeapi.co/api/v2/machine/355/"},{"url":"https://pokeapi.co/api/v2/machine/356/"},{"url":"https://pokeapi.co/api/v2/machine/357/"},{"url":"https://pokeapi.co/api/v2/machine/358/"},{"url":"https://pokeapi.co/api/v2/machine/359/"},{"url":"https://pokeapi.co/api/v2/machine/360/"},{"url":"https://pokeapi.co/api/v2/machine/361/"},{"url":"https://pokeapi.co/api/v2/machine/362/"},{"url":"https://pokeapi.co/api/v2/machine/363/"},{"url":"https://pokeapi.co/api/v2/machine/364/"},{"url":"https://pokeapi.co/api/v2/machine/365/"},{"url":"https://pokeapi.co/api/v2/machine/366/"},{"url":"https://pokeapi.co/api/v2/machine/367/"},{"url":"https://pokeapi.co/api/v2/machine/368/"},{"url":"https://pokeapi.co/api/v2/machine/369/"},{"url":"https://pokeapi.co/api/v2/machine/370/"},{"url":"https://pokeapi.co/api/v2/machine/371/"},{"url":"https://pokeapi.co/api/v2/machine/372/"},{"url":"https://pokeapi.co/api/v2/machine/373/"},{"url":"https://pokeapi.co/api/v2/machine/374/"},{"url":"https://pokeapi.co/api/v2/machine/375/"},{"url":"https://pokeapi.co/api/v2/machine/376/"},{"url":"https://pokeapi.co/api/v2/machine/377/"},{"url":"https://pokeapi.co/api/v2/machine/378/"},{"url":"https://pokeapi.co/api/v2/machine/379/"},{"url":"https://pokeapi.co/api/v2/machine/380/"},{"url":"https://pokeapi.co/api/v2/machine/381/"},{"url":"https://pokeapi.co/api/v2/machine/382/"},{"url":"https://pokeapi.co/api/v2/machine/383/"},{"url":"https://pokeapi.co/api/v2/machine/384/"},{"url":"https://pokeapi.co/api/v2/machine/385/"},{"url":"https://pokeapi.co/api/v2/machine/386/"},{"url":"https://pokeapi.co/api/v2/machine/387/"},{"url":"https://pokeapi.co/api/v2/machine/388/"},{"url":"https://pokeapi.co/api/v2/machine/389/"},{"url":"https://pokeapi.co/api/v2/machine/390/"},{"url":"https://pokeapi.co/api/v2/machine/391/"},{"url":"https://pokeapi.co/api/v2/machine/392/"},{"url":"https://pokeapi.co/api/v2/machine/393/"},{"url":"https://pokeapi.co/api/v2/machine/394/"},{"url":"https://pokeapi.co/api/v2/machine/395/"},{"url":"https://pokeapi.co/api/v2/machine/396/"},{"url":"https://pokeapi.co/api/v2/machine/397/"},{"url":"https://pokeapi.co/api/v2/machine/398/"},{"url":"https://pokeapi.co/api/v2/machine/399/"},{"url":"https://pokeapi.co/api/v2/machine/400/"},{"url":"https://pokeapi.co/api/v2/machine/401/"},{"url":"https://pokeapi.co/api/v2/machine/402/"},{"url":"https://pokeapi.co/api/v2/machine/403/"},{"url":"https://pokeapi.co/api/v2/machine/404/"},{"url":"https://pokeapi.co/api/v2/machine/405/"},{"url":"https://pokeapi.co/api/v2/machine/406/"},{"url":"https://pokeapi.co/api/v2/machine/407/"},{"url":"https://pokeapi.co/api/v2/machine/408/"},{"url":"https://pokeapi.co/api/v2/machine/409/"},{"url":"https://pokeapi.co/api/v2/machine/410/"},{"url":"https://pokeapi.co/api/v2/machine/411/"},{"url":"https://pokeapi.co/api/v2/machine/412/"},{"url":"https://pokeapi.co/api/v2/machine/413/"},{"url":"https://pokeapi.co/api/v2/machine/414/"},{"url":"https://pokeapi.co/api/v2/machine/415/"},{"url":"https://pokeapi.co/api/v2/machine/416/"},{"url":"https://pokeapi.co/api/v2/machine/417/"},{"url":"https://pokeapi.co/api/v2/machine/418/"},{"url":"https://pokeapi.co/api/v2/machine/419/"},{"url":"https://pokeapi.co/api/v2/machine/420/"},{"url":"https://pokeapi.co/api/v2/machine/421/"},{"url":"https://pokeapi.co/api/v2/machine/422/"},{"url":"https://pokeapi.co/api/v2/machine/423/"},{"url":"https://pokeapi.co/api/v2/machine/424/"},{"url":"https://pokeapi.co/api/v2/machine/425/"},{"url":"https://pokeapi.co/api/v2/machine/426/"},{"url":"https://pokeapi.co/api/v2/machine/427/"},{"url":"https://pokeapi.co/api/v2/machine/428/"},{"url":"https://pokeapi.co/api/v2/machine/429/"},{"url":"https://pokeapi.co/api/v2/machine/430/"},{"url":"https://pokeapi.co/api/v2/machine/431/"},{"url":"https://pokeapi.co/api/v2/machine/432/"},{"url":"https://pokeapi.co/api/v2/machine/433/"},{"url":"https://pokeapi.co/api/v2/machine/434/"},{"url":"https://pokeapi.co/api/v2/machine/435/"},{"url":"https://pokeapi.co/api/v2/machine/436/"},{"url":"https://pokeapi.co/api/v2/machine/437/"},{"url":"https://pokeapi.co/api/v2/machine/438/"},{"url":"https://pokeapi.co/api/v2/machine/439/"},{"url":"https://pokeapi.co/api/v2/machine/440/"},{"url":"https://pokeapi.co/api/v2/machine/441/"},{"url":"https://pokeapi.co/api/v2/machine/442/"},{"url":"https://pokeapi.co/api/v2/machine/443/"},{"url":"https://pokeapi.co/api/v2/machine/444/"},{"url":"https://pokeapi.co/api/v2/machine/445/"},{"url":"https://pokeapi.co/api/v2/machine/446/"},{"url":"https://pokeapi.co/api/v2/machine/447/"},{"url":"https://pokeapi.co/api/v2/machine/448/"},{"url":"https://pokeapi.co/api/v2/machine/449/"},{"url":"https://pokeapi.co/api/v2/machine/450/"},{"url":"https://pokeapi.co/api/v2/machine/451/"},{"url":"https://pokeapi.co/api/v2/machine/452/"},{"url":"https://pokeapi.co/api/v2/machine/453/"},{"url":"https://pokeapi.co/api/v2/machine/454/"},{"url":"https://pokeapi.co/api/v2/machine/455/"},{"url":"https://pokeapi.co/api/v2/machine/456/"},{"url":"https://pokeapi.co/api/v2/machine/457/"},{"url":"https://pokeapi.co/api/v2/machine/458/"},{"url":"https://pokeapi.co/api/v2/machine/459/"},{"url":"https://pokeapi.co/api/v2/machine/460/"},{"url":"https://pokeapi.co/api/v2/machine/461/"},{"url":"https://pokeapi.co/api/v2/machine/462/"},{"url":"https://pokeapi.co/api/v2/machine/463/"},{"url":"https://pokeapi.co/api/v2/machine/464/"},{"url":"https://pokeapi.co/api/v2/machine/465/"},{"url":"https://pokeapi.co/api/v2/machine/466/"},{"url":"https://pokeapi.co/api/v2/machine/467/"},{"url":"https://pokeapi.co/api/v2/machine/468/"},{"url":"https://pokeapi.co/api/v2/machine/469/"},{"url":"https://pokeapi.co/api/v2/machine/470/"},{"url":"https://pokeapi.co/api/v2/machine/471/"},{"url":"https://pokeapi.co/api/v2/machine/472/"},{"url":"https://pokeapi.co/api/v2/machine/473/"},{"url":"https://pokeapi.co/api/v2/machine/474/"},{"url":"https://pokeapi.co/api/v2/machine/475/"},{"url":"https://pokeapi.co/api/v2/machine/476/"},{"url":"https://pokeapi.co/api/v2/machine/477/"},{"url":"https://pokeapi.co/api/v2/machine/478/"},{"url":"https://pokeapi.co/api/v2/machine/479/"},{"url":"https://pokeapi.co/api/v2/machine/480/"},{"url":"https://pokeapi.co/api/v2/machine/481/"},{"url":"https://pokeapi.co/api/v2/machine/482/"},{"url":"https://pokeapi.co/api/v2/machine/483/"},{"url":"https://pokeapi.co/api/v2/machine/484/"},{"url":"https://pokeapi.co/api/v2/machine/485/"},{"url":"https://pokeapi.co/api/v2/machine/486/"},{"url":"https://pokeapi.co/api/v2/machine/487/"},{"url":"https://pokeapi.co/api/v2/machine/488/"},{"url":"https://pokeapi.co/api/v2/machine/489/"},{"url":"https://pokeapi.co/api/v2/machine/490/"},{"url":"https://pokeapi.co/api/v2/machine/491/"},{"url":"https://pokeapi.co/api/v2/machine/492/"},{"url":"https://pokeapi.co/api/v2/machine/493/"},{"url":"https://pokeapi.co/api/v2/machine/494/"},{"url":"https://pokeapi.co/api/v2/machine/495/"},{"url":"https://pokeapi.co/api/v2/machine/496/"},{"url":"https://pokeapi.co/api/v2/machine/497/"},{"url":"https://pokeapi.co/api/v2/machine/498/"},{"url":"https://pokeapi.co/api/v2/machine/499/"},{"url":"https://pokeapi.co/api/v2/machine/500/"},{"url":"https://pokeapi.co/api/v2/machine/501/"},{"url":"https://pokeapi.co/api/v2/machine/502/"},{"url":"https://pokeapi.co/api/v2/machine/503/"},{"url":"https://pokeapi.co/api/v2/machine/504/"},{"url":"https://pokeapi.co/api/v2/machine/505/"},{"url":"https://pokeapi.co/api/v2/machine/506/"},{"url":"https://pokeapi.co/api/v2/machine/507/"},{"url":"https://pokeapi.co/api/v2/machine/508/"},{"url":"https://pokeapi.co/api/v2/machine/509/"},{"url":"https://pokeapi.co/api/v2/machine/510/"},{"url":"https://pokeapi.co/api/v2/machine/511/"},{"url":"https://pokeapi.co/api/v2/machine/512/"},{"url":"https://pokeapi.co/api/v2/machine/513/"},{"url":"https://pokeapi.co/api/v2/machine/514/"},{"url":"https://pokeapi.co/api/v2/machine/515/"},{"url":"https://pokeapi.co/api/v2/machine/516/"},{"url":"https://pokeapi.co/api/v2/machine/517/"},{"url":"https://pokeapi.co/api/v2/machine/518/"},{"url":"https://pokeapi.co/api/v2/machine/519/"},{"url":"https://pokeapi.co/api/v2/machine/520/"},{"url":"https://pokeapi.co/api/v2/machine/521/"},{"url":"https://pokeapi.co/api/v2/machine/522/"},{"url":"https://pokeapi.co/api/v2/machine/523/"},{"url":"https://pokeapi.co/api/v2/machine/524/"},{"url":"https://pokeapi.co/api/v2/machine/525/"},{"url":"https://pokeapi.co/api/v2/machine/526/"},{"url":"https://pokeapi.co/api/v2/machine/527/"},{"url":"https://pokeapi.co/api/v2/machine/528/"},{"url":"https://pokeapi.co/api/v2/machine/529/"},{"url":"https://pokeapi.co/api/v2/machine/530/"},{"url":"https://pokeapi.co/api/v2/machine/531/"},{"url":"https://pokeapi.co/api/v2/machine/532/"},{"url":"https://pokeapi.co/api/v2/machine/533/"},{"url":"https://pokeapi.co/api/v2/machine/534/"},{"url":"https://pokeapi.co/api/v2/machine/535/"},{"url":"https://pokeapi.co/api/v2/machine/536/"},{"url":"https://pokeapi.co/api/v2/machine/537/"},{"url":"https://pokeapi.co/api/v2/machine/538/"},{"url":"https://pokeapi.co/api/v2/machine/539/"},{"url":"https://pokeapi.co/api/v2/machine/540/"},{"url":"https://pokeapi.co/api/v2/machine/541/"},{"url":"https://pokeapi.co/api/v2/machine/542/"},{"url":"https://pokeapi.co/api/v2/machine/543/"},{"url":"https://pokeapi.co/api/v2/machine/544/"},{"url":"https://pokeapi.co/api/v2/machine/545/"},{"url":"https://pokeapi.co/api/v2/machine/546/"},{"url":"https://pokeapi.co/api/v2/machine/547/"},{"url":"https://pokeapi.co/api/v2/machine/548/"},{"url":"https://pokeapi.co/api/v2/machine/549/"},{"url":"https://pokeapi.co/api/v2/machine/550/"},{"url":"https://pokeapi.co/api/v2/machine/551/"},{"url":"https://pokeapi.co/api/v2/machine/552/"},{"url":"https://pokeapi.co/api/v2/machine/553/"},{"url":"https://pokeapi.co/api/v2/machine/554/"},{"url":"https://pokeapi.co/api/v2/machine/555/"},{"url":"https://pokeapi.co/api/v2/machine/556/"},{"url":"https://pokeapi.co/api/v2/machine/557/"},{"url":"https://pokeapi.co/api/v2/machine/558/"},{"url":"https://pokeapi.co/api/v2/machine/559/"},{"url":"https://pokeapi.co/api/v2/machine/560/"},{"url":"https://pokeapi.co/api/v2/machine/561/"},{"url":"https://pokeapi.co/api/v2/machine/562/"},{"url":"https://pokeapi.co/api/v2/machine/563/"},{"url":"https://pokeapi.co/api/v2/machine/564/"},{"url":"https://pokeapi.co/api/v2/machine/565/"},{"url":"https://pokeapi.co/api/v2/machine/566/"},{"url":"https://pokeapi.co/api/v2/machine/567/"},{"url":"https://pokeapi.co/api/v2/machine/568/"},{"url":"https://pokeapi.co/api/v2/machine/569/"},{"url":"https://pokeapi.co/api/v2/machine/570/"},{"url":"https://pokeapi.co/api/v2/machine/571/"},{"url":"https://pokeapi.co/api/v2/machine/572/"},{"url":"https://pokeapi.co/api/v2/machine/573/"},{"url":"https://pokeapi.co/api/v2/machine/574/"},{"url":"https://pokeapi.co/api/v2/machine/575/"},{"url":"https://pokeapi.co/api/v2/machine/576/"},{"url":"https://pokeapi.co/api/v2/machine/577/"},{"url":"https://pokeapi.co/api/v2/machine/578/"},{"url":"https://pokeapi.co/api/v2/machine/579/"},{"url":"https://pokeapi.co/api/v2/machine/580/"},{"url":"https://pokeapi.co/api/v2/machine/581/"},{"url":"https://pokeapi.co/api/v2/machine/582/"},{"url":"https://pokeapi.co/api/v2/machine/583/"},{"url":"https://pokeapi.co/api/v2/machine/584/"},{"url":"https://pokeapi.co/api/v2/machine/585/"},{"url":"https://pokeapi.co/api/v2/machine/586/"},{"url":"https://pokeapi.co/api/v2/machine/587/"},{"url":"https://pokeapi.co/api/v2/machine/588/"},{"url":"https://pokeapi.co/api/v2/machine/589/"},{"url":"https://pokeapi.co/api/v2/machine/590/"},{"url":"https://pokeapi.co/api/v2/machine/591/"},{"url":"https://pokeapi.co/api/v2/machine/592/"},{"url":"https://pokeapi.co/api/v2/machine/593/"},{"url":"https://pokeapi.co/api/v2/machine/594/"},{"url":"https://pokeapi.co/api/v2/machine/595/"},{"url":"https://pokeapi.co/api/v2/machine/596/"},{"url":"https://pokeapi.co/api/v2/machine/597/"},{"url":"https://pokeapi.co/api/v2/machine/598/"},{"url":"https://pokeapi.co/api/v2/machine/599/"},{"url":"https://pokeapi.co/api/v2/machine/600/"},{"url":"https://pokeapi.co/api/v2/machine/601/"},{"url":"https://pokeapi.co/api/v2/machine/602/"},{"url":"https://pokeapi.co/api/v2/machine/603/"},{"url":"https://pokeapi.co/api/v2/machine/604/"},{"url":"https://pokeapi.co/api/v2/machine/605/"},{"url":"https://pokeapi.co/api/v2/machine/606/"},{"url":"https://pokeapi.co/api/v2/machine/607/"},{"url":"https://pokeapi.co/api/v2/machine/608/"},{"url":"https://pokeapi.co/api/v2/machine/609/"},{"url":"https://pokeapi.co/api/v2/machine/610/"},{"url":"https://pokeapi.co/api/v2/machine/611/"},{"url":"https://pokeapi.co/api/v2/machine/612/"},{"url":"https://pokeapi.co/api/v2/machine/613/"},{"url":"https://pokeapi.co/api/v2/machine/614/"},{"url":"https://pokeapi.co/api/v2/machine/615/"},{"url":"https://pokeapi.co/api/v2/machine/616/"},{"url":"https://pokeapi.co/api/v2/machine/617/"},{"url":"https://pokeapi.co/api/v2/machine/618/"},{"url":"https://pokeapi.co/api/v2/machine/619/"},{"url":"https://pokeapi.co/api/v2/machine/620/"},{"url":"https://pokeapi.co/api/v2/machine/621/"},{"url":"https://pokeapi.co/api/v2/machine/622/"},{"url":"https://pokeapi.co/api/v2/machine/623/"},{"url":"https://pokeapi.co/api/v2/machine/624/"},{"url":"https://pokeapi.co/api/v2/machine/625/"},{"url":"https://pokeapi.co/api/v2/machine/626/"},{"url":"https://pokeapi.co/api/v2/machine/627/"},{"url":"https://pokeapi.co/api/v2/machine/628/"},{"url":"https://pokeapi.co/api/v2/machine/629/"},{"url":"https://pokeapi.co/api/v2/machine/630/"},{"url":"https://pokeapi.co/api/v2/machine/631/"},{"url":"https://pokeapi.co/api/v2/machine/632/"},{"url":"https://pokeapi.co/api/v2/machine/633/"},{"url":"https://pokeapi.co/api/v2/machine/634/"},{"url":"https://pokeapi.co/api/v2/machine/635/"},{"url":"https://pokeapi.co/api/v2/machine/636/"},{"url":"https://pokeapi.co/api/v2/machine/637/"},{"url":"https://pokeapi.co/api/v2/machine/638/"},{"url":"https://pokeapi.co/api/v2/machine/639/"},{"url":"https://pokeapi.co/api/v2/machine/640/"},{"url":"https://pokeapi.co/api/v2/machine/641/"},{"url":"https://pokeapi.co/api/v2/machine/642/"},{"url":"https://pokeapi.co/api/v2/machine/643/"},{"url":"https://pokeapi.co/api/v2/machine/644/"},{"url":"https://pokeapi.co/api/v2/machine/645/"},{"url":"https://pokeapi.co/api/v2/machine/646/"},{"url":"https://pokeapi.co/api/v2/machine/647/"},{"url":"https://pokeapi.co/api/v2/machine/648/"},{"url":"https://pokeapi.co/api/v2/machine/649/"},{"url":"https://pokeapi.co/api/v2/machine/650/"},{"url":"https://pokeapi.co/api/v2/machine/651/"},{"url":"https://pokeapi.co/api/v2/machine/652/"},{"url":"https://pokeapi.co/api/v2/machine/653/"},{"url":"https://pokeapi.co/api/v2/machine/654/"},{"url":"https://pokeapi.co/api/v2/machine/655/"},{"url":"https://pokeapi.co/api/v2/machine/656/"},{"url":"https://pokeapi.co/api/v2/machine/657/"},{"url":"https://pokeapi.co/api/v2/machine/658/"},{"url":"https://pokeapi.co/api/v2/machine/659/"},{"url":"https://pokeapi.co/api/v2/machine/660/"},{"url":"https://pokeapi.co/api/v2/machine/661/"},{"url":"https://pokeapi.co/api/v2/machine/662/"},{"url":"https://pokeapi.co/api/v2/machine/663/"},{"url":"https://pokeapi.co/api/v2/machine/664/"},{"url":"https://pokeapi.co/api/v2/machine/665/"},{"url":"https://pokeapi.co/api/v2/machine/666/"},{"url":"https://pokeapi.co/api/v2/machine/667/"},{"url":"https://pokeapi.co/api/v2/machine/668/"},{"url":"https://pokeapi.co/api/v2/machine/669/"},{"url":"https://pokeapi.co/api/v2/machine/670/"},{"url":"https://pokeapi.co/api/v2/machine/671/"},{"url":"https://pokeapi.co/api/v2/machine/672/"},{"url":"https://pokeapi.co/api/v2/machine/673/"},{"url":"https://pokeapi.co/api/v2/machine/674/"},{"url":"https://pokeapi.co/api/v2/machine/675/"},{"url":"https://pokeapi.co/api/v2/machine/676/"},{"url":"https://pokeapi.co/api/v2/machine/677/"},{"url":"https://pokeapi.co/api/v2/machine/678/"},{"url":"https://pokeapi.co/api/v2/machine/679/"},{"url":"https://pokeapi.co/api/v2/machine/680/"},{"url":"https://pokeapi.co/api/v2/machine/681/"},{"url":"https://pokeapi.co/api/v2/machine/682/"},{"url":"https://pokeapi.co/api/v2/machine/683/"},{"url":"https://pokeapi.co/api/v2/machine/684/"},{"url":"https://pokeapi.co/api/v2/machine/685/"},{"url":"https://pokeapi.co/api/v2/machine/686/"},{"url":"https://pokeapi.co/api/v2/machine/687/"},{"url":"https://pokeapi.co/api/v2/machine/688/"},{"url":"https://pokeapi.co/api/v2/machine/689/"},{"url":"https://pokeapi.co/api/v2/machine/690/"},{"url":"https://pokeapi.co/api/v2/machine/691/"},{"url":"https://pokeapi.co/api/v2/machine/692/"},{"url":"https://pokeapi.co/api/v2/machine/693/"},{"url":"https://pokeapi.co/api/v2/machine/694/"},{"url":"https://pokeapi.co/api/v2/machine/695/"},{"url":"https://pokeapi.co/api/v2/machine/696/"},{"url":"https://pokeapi.co/api/v2/machine/697/"},{"url":"https://pokeapi.co/api/v2/machine/698/"},{"url":"https://pokeapi.co/api/v2/machine/699/"},{"url":"https://pokeapi.co/api/v2/machine/700/"},{"url":"https://pokeapi.co/api/v2/machine/701/"},{"url":"https://pokeapi.co/api/v2/machine/702/"},{"url":"https://pokeapi.co/api/v2/machine/703/"},{"url":"https://pokeapi.co/api/v2/machine/704/"},{"url":"https://pokeapi.co/api/v2/machine/705/"},{"url":"https://pokeapi.co/api/v2/machine/706/"},{"url":"https://pokeapi.co/api/v2/machine/707/"},{"url":"https://pokeapi.co/api/v2/machine/708/"},{"url":"https://pokeapi.co/api/v2/machine/709/"},{"url":"https://pokeapi.co/api/v2/machine/710/"},{"url":"https://pokeapi.co/api/v2/machine/711/"},{"url":"https://pokeapi.co/api/v2/machine/712/"},{"url":"https://pokeapi.co/api/v2/machine/713/"},{"url":"https://pokeapi.co/api/v2/machine/714/"},{"url":"https://pokeapi.co/api/v2/machine/715/"},{"url":"https://pokeapi.co/api/v2/machine/716/"},{"url":"https://pokeapi.co/api/v2/machine/717/"},{"url":"https://pokeapi.co/api/v2/machine/718/"},{"url":"https://pokeapi.co/api/v2/machine/719/"},{"url":"https://pokeapi.co/api/v2/machine/720/"},{"url":"https://pokeapi.co/api/v2/machine/721/"},{"url":"https://pokeapi.co/api/v2/machine/722/"},{"url":"https://pokeapi.co/api/v2/machine/723/"},{"url":"https://pokeapi.co/api/v2/machine/724/"},{"url":"https://pokeapi.co/api/v2/machine/725/"},{"url":"https://pokeapi.co/api/v2/machine/726/"},{"url":"https://pokeapi.co/api/v2/machine/727/"},{"url":"https://pokeapi.co/api/v2/machine/728/"},{"url":"https://pokeapi.co/api/v2/machine/729/"},{"url":"https://pokeapi.co/api/v2/machine/730/"},{"url":"https://pokeapi.co/api/v2/machine/731/"},{"url":"https://pokeapi.co/api/v2/machine/732/"},{"url":"https://pokeapi.co/api/v2/machine/733/"},{"url":"https://pokeapi.co/api/v2/machine/734/"},{"url":"https://pokeapi.co/api/v2/machine/735/"},{"url":"https://pokeapi.co/api/v2/machine/736/"},{"url":"https://pokeapi.co/api/v2/machine/737/"},{"url":"https://pokeapi.co/api/v2/machine/738/"},{"url":"https://pokeapi.co/api/v2/machine/739/"},{"url":"https://pokeapi.co/api/v2/machine/740/"},{"url":"https://pokeapi.co/api/v2/machine/741/"},{"url":"https://pokeapi.co/api/v2/machine/742/"},{"url":"https://pokeapi.co/api/v2/machine/743/"},{"url":"https://pokeapi.co/api/v2/machine/744/"},{"url":"https://pokeapi.co/api/v2/machine/745/"},{"url":"https://pokeapi.co/api/v2/machine/746/"},{"url":"https://pokeapi.co/api/v2/machine/747/"},{"url":"https://pokeapi.co/api/v2/machine/748/"},{"url":"https://pokeapi.co/api/v2/machine/749/"},{"url":"https://pokeapi.co/api/v2/machine/750/"},{"url":"https://pokeapi.co/api/v2/machine/751/"},{"url":"https://pokeapi.co/api/v2/machine/752/"},{"url":"https://pokeapi.co/api/v2/machine/753/"},{"url":"https://pokeapi.co/api/v2/machine/754/"},{"url":"https://pokeapi.co/api/v2/machine/755/"},{"url":"https://pokeapi.co/api/v2/machine/756/"},{"url":"https://pokeapi.co/api/v2/machine/757/"},{"url":"https://pokeapi.co/api/v2/machine/758/"},{"url":"https://pokeapi.co/api/v2/machine/759/"},{"url":"https://pokeapi.co/api/v2/machine/760/"},{"url":"https://pokeapi.co/api/v2/machine/761/"},{"url":"https://pokeapi.co/api/v2/machine/762/"},{"url":"https://pokeapi.co/api/v2/machine/763/"},{"url":"https://pokeapi.co/api/v2/machine/764/"},{"url":"https://pokeapi.co/api/v2/machine/765/"},{"url":"https://pokeapi.co/api/v2/machine/766/"},{"url":"https://pokeapi.co/api/v2/machine/767/"},{"url":"https://pokeapi.co/api/v2/machine/768/"},{"url":"https://pokeapi.co/api/v2/machine/769/"},{"url":"https://pokeapi.co/api/v2/machine/770/"},{"url":"https://pokeapi.co/api/v2/machine/771/"},{"url":"https://pokeapi.co/api/v2/machine/772/"},{"url":"https://pokeapi.co/api/v2/machine/773/"},{"url":"https://pokeapi.co/api/v2/machine/774/"},{"url":"https://pokeapi.co/api/v2/machine/775/"},{"url":"https://pokeapi.co/api/v2/machine/776/"},{"url":"https://pokeapi.co/api/v2/machine/777/"},{"url":"https://pokeapi.co/api/v2/machine/778/"},{"url":"https://pokeapi.co/api/v2/machine/779/"},{"url":"https://pokeapi.co/api/v2/machine/780/"},{"url":"https://pokeapi.co/api/v2/machine/781/"},{"url":"https://pokeapi.co/api/v2/machine/782/"},{"url":"https://pokeapi.co/api/v2/machine/783/"},{"url":"https://pokeapi.co/api/v2/machine/784/"},{"url":"https://pokeapi.co/api/v2/machine/785/"},{"url":"https://pokeapi.co/api/v2/machine/786/"},{"url":"https://pokeapi.co/api/v2/machine/787/"},{"url":"https://pokeapi.co/api/v2/machine/788/"},{"url":"https://pokeapi.co/api/v2/machine/789/"},{"url":"https://pokeapi.co/api/v2/machine/790/"},{"url":"https://pokeapi.co/api/v2/machine/791/"},{"url":"https://pokeapi.co/api/v2/machine/792/"},{"url":"https://pokeapi.co/api/v2/machine/793/"},{"url":"https://pokeapi.co/api/v2/machine/794/"},{"url":"https://pokeapi.co/api/v2/machine/795/"},{"url":"https://pokeapi.co/api/v2/machine/796/"},{"url":"https://pokeapi.co/api/v2/machine/797/"},{"url":"https://pokeapi.co/api/v2/machine/798/"},{"url":"https://pokeapi.co/api/v2/machine/799/"},{"url":"https://pokeapi.co/api/v2/machine/800/"},{"url":"https://pokeapi.co/api/v2/machine/801/"},{"url":"https://pokeapi.co/api/v2/machine/802/"},{"url":"https://pokeapi.co/api/v2/machine/803/"},{"url":"https://pokeapi.co/api/v2/machine/804/"},{"url":"https://pokeapi.co/api/v2/machine/805/"},{"url":"https://pokeapi.co/api/v2/machine/806/"},{"url":"https://pokeapi.co/api/v2/machine/807/"},{"url":"https://pokeapi.co/api/v2/machine/808/"},{"url":"https://pokeapi.co/api/v2/machine/809/"},{"url":"https://pokeapi.co/api/v2/machine/810/"},{"url":"https://pokeapi.co/api/v2/machine/811/"},{"url":"https://pokeapi.co/api/v2/machine/812/"},{"url":"https://pokeapi.co/api/v2/machine/813/"},{"url":"https://pokeapi.co/api/v2/machine/814/"},{"url":"https://pokeapi.co/api/v2/machine/815/"},{"url":"https://pokeapi.co/api/v2/machine/816/"},{"url":"https://pokeapi.co/api/v2/machine/817/"},{"url":"https://pokeapi.co/api/v2/machine/818/"},{"url":"https://pokeapi.co/api/v2/machine/819/"},{"url":"https://pokeapi.co/api/v2/machine/820/"},{"url":"https://pokeapi.co/api/v2/machine/821/"},{"url":"https://pokeapi.co/api/v2/machine/822/"},{"url":"https://pokeapi.co/api/v2/machine/823/"},{"url":"https://pokeapi.co/api/v2/machine/824/"},{"url":"https://pokeapi.co/api/v2/machine/825/"},{"url":"https://pokeapi.co/api/v2/machine/826/"},{"url":"https://pokeapi.co/api/v2/machine/827/"},{"url":"https://pokeapi.co/api/v2/machine/828/"},{"url":"https://pokeapi.co/api/v2/machine/829/"},{"url":"https://pokeapi.co/api/v2/machine/830/"},{"url":"https://pokeapi.co/api/v2/machine/831/"},{"url":"https://pokeapi.co/api/v2/machine/832/"},{"url":"https://pokeapi.co/api/v2/machine/833/"},{"url":"https://pokeapi.co/api/v2/machine/834/"},{"url":"https://pokeapi.co/api/v2/machine/835/"},{"url":"https://pokeapi.co/api/v2/machine/836/"},{"url":"https://pokeapi.co/api/v2/machine/837/"},{"url":"https://pokeapi.co/api/v2/machine/838/"},{"url":"https://pokeapi.co/api/v2/machine/839/"},{"url":"https://pokeapi.co/api/v2/machine/840/"},{"url":"https://pokeapi.co/api/v2/machine/841/"},{"url":"https://pokeapi.co/api/v2/machine/842/"},{"url":"https://pokeapi.co/api/v2/machine/843/"},{"url":"https://pokeapi.co/api/v2/machine/844/"},{"url":"https://pokeapi.co/api/v2/machine/845/"},{"url":"https://pokeapi.co/api/v2/machine/846/"},{"url":"https://pokeapi.co/api/v2/machine/847/"},{"url":"https://pokeapi.co/api/v2/machine/848/"},{"url":"https://pokeapi.co/api/v2/machine/849/"},{"url":"https://pokeapi.co/api/v2/machine/850/"},{"url":"https://pokeapi.co/api/v2/machine/851/"},{"url":"https://pokeapi.co/api/v2/machine/852/"},{"url":"https://pokeapi.co/api/v2/machine/853/"},{"url":"https://pokeapi.co/api/v2/machine/854/"},{"url":"https://pokeapi.co/api/v2/machine/855/"},{"url":"https://pokeapi.co/api/v2/machine/856/"},{"url":"https://pokeapi.co/api/v2/machine/857/"},{"url":"https://pokeapi.co/api/v2/machine/858/"},{"url":"https://pokeapi.co/api/v2/machine/859/"},{"url":"https://pokeapi.co/api/v2/machine/860/"},{"url":"https://pokeapi.co/api/v2/machine/861/"},{"url":"https://pokeapi.co/api/v2/machine/862/"},{"url":"https://pokeapi.co/api/v2/machine/863/"},{"url":"https://pokeapi.co/api/v2/machine/864/"},{"url":"https://pokeapi.co/api/v2/machine/865/"},{"url":"https://pokeapi.co/api/v2/machine/866/"},{"url":"https://pokeapi.co/api/v2/machine/867/"},{"url":"https://pokeapi.co/api/v2/machine/868/"},{"url":"https://pokeapi.co/api/v2/machine/869/"},{"url":"https://pokeapi.co/api/v2/machine/870/"},{"url":"https://pokeapi.co/api/v2/machine/871/"},{"url":"https://pokeapi.co/api/v2/machine/872/"},{"url":"https://pokeapi.co/api/v2/machine/873/"},{"url":"https://pokeapi.co/api/v2/machine/874/"},{"url":"https://pokeapi.co/api/v2/machine/875/"},{"url":"https://pokeapi.co/api/v2/machine/876/"},{"url":"https://pokeapi.co/api/v2/machine/877/"},{"url":"https://pokeapi.co/api/v2/machine/878/"},{"url":"https://pokeapi.co/api/v2/machine/879/"},{"url":"https://pokeapi.co/api/v2/machine/880/"},{"url":"https://pokeapi.co/api/v2/machine/881/"},{"url":"https://pokeapi.co/api/v2/machine/882/"},{"url":"https://pokeapi.co/api/v2/machine/883/"},{"url":"https://pokeapi.co/api/v2/machine/884/"},{"url":"https://pokeapi.co/api/v2/machine/885/"},{"url":"https://pokeapi.co/api/v2/machine/886/"},{"url":"https://pokeapi.co/api/v2/machine/887/"},{"url":"https://pokeapi.co/api/v2/machine/888/"},{"url":"https://pokeapi.co/api/v2/machine/889/"},{"url":"https://pokeapi.co/api/v2/machine/890/"},{"url":"https://pokeapi.co/api/v2/machine/891/"},{"url":"https://pokeapi.co/api/v2/machine/892/"},{"url":"https://pokeapi.co/api/v2/machine/893/"},{"url":"https://pokeapi.co/api/v2/machine/894/"},{"url":"https://pokeapi.co/api/v2/machine/895/"},{"url":"https://pokeapi.co/api/v2/machine/896/"},{"url":"https://pokeapi.co/api/v2/machine/897/"},{"url":"https://pokeapi.co/api/v2/machine/898/"},{"url":"https://pokeapi.co/api/v2/machine/899/"},{"url":"https://pokeapi.co/api/v2/machine/900/"},{"url":"https://pokeapi.co/api/v2/machine/901/"},{"url":"https://pokeapi.co/api/v2/machine/902/"},{"url":"https://pokeapi.co/api/v2/machine/903/"},{"url":"https://pokeapi.co/api/v2/machine/904/"},{"url":"https://pokeapi.co/api/v2/machine/905/"},{"url":"https://pokeapi.co/api/v2/machine/906/"},{"url":"https://pokeapi.co/api/v2/machine/907/"},{"url":"https://pokeapi.co/api/v2/machine/908/"},{"url":"https://pokeapi.co/api/v2/machine/909/"},{"url":"https://pokeapi.co/api/v2/machine/910/"},{"url":"https://pokeapi.co/api/v2/machine/911/"},{"url":"https://pokeapi.co/api/v2/machine/912/"},{"url":"https://pokeapi.co/api/v2/machine/913/"},{"url":"https://pokeapi.co/api/v2/machine/914/"},{"url":"https://pokeapi.co/api/v2/machine/915/"},{"url":"https://pokeapi.co/api/v2/machine/916/"},{"url":"https://pokeapi.co/api/v2/machine/917/"},{"url":"https://pokeapi.co/api/v2/machine/918/"},{"url":"https://pokeapi.co/api/v2/machine/919/"},{"url":"https://pokeapi.co/api/v2/machine/920/"},{"url":"https://pokeapi.co/api/v2/machine/921/"},{"url":"https://pokeapi.co/api/v2/machine/922/"},{"url":"https://pokeapi.co/api/v2/machine/923/"},{"url":"https://pokeapi.co/api/v2/machine/924/"},{"url":"https://pokeapi.co/api/v2/machine/925/"},{"url":"https://pokeapi.co/api/v2/machine/926/"},{"url":"https://pokeapi.co/api/v2/machine/927/"},{"url":"https://pokeapi.co/api/v2/machine/928/"},{"url":"https://pokeapi.co/api/v2/machine/929/"},{"url":"https://pokeapi.co/api/v2/machine/930/"},{"url":"https://pokeapi.co/api/v2/machine/931/"},{"url":"https://pokeapi.co/api/v2/machine/932/"},{"url":"https://pokeapi.co/api/v2/machine/933/"},{"url":"https://pokeapi.co/api/v2/machine/934/"},{"url":"https://pokeapi.co/api/v2/machine/935/"},{"url":"https://pokeapi.co/api/v2/machine/936/"},{"url":"https://pokeapi.co/api/v2/machine/937/"},{"url":"https://pokeapi.co/api/v2/machine/938/"},{"url":"https://pokeapi.co/api/v2/machine/939/"},{"url":"https://pokeapi.co/api/v2/machine/940/"},{"url":"https://pokeapi.co/api/v2/machine/941/"},{"url":"https://pokeapi.co/api/v2/machine/942/"},{"url":"https://pokeapi.co/api/v2/machine/943/"},{"url":"https://pokeapi.co/api/v2/machine/944/"},{"url":"https://pokeapi.co/api/v2/machine/945/"},{"url":"https://pokeapi.co/api/v2/machine/946/"},{"url":"https://pokeapi.co/api/v2/machine/947/"},{"url":"https://pokeapi.co/api/v2/machine/948/"},{"url":"https://pokeapi.co/api/v2/machine/949/"},{"url":"https://pokeapi.co/api/v2/machine/950/"},{"url":"https://pokeapi.co/api/v2/machine/951/"},{"url":"https://pokeapi.co/api/v2/machine/952/"},{"url":"https://pokeapi.co/api/v2/machine/953/"},{"url":"https://pokeapi.co/api/v2/machine/954/"},{"url":"https://pokeapi.co/api/v2/machine/955/"},{"url":"https://pokeapi.co/api/v2/machine/956/"},{"url":"https://pokeapi.co/api/v2/machine/957/"},{"url":"https://pokeapi.co/api/v2/machine/958/"},{"url":"https://pokeapi.co/api/v2/machine/959/"},{"url":"https://pokeapi.co/api/v2/machine/960/"},{"url":"https://pokeapi.co/api/v2/machine/961/"},{"url":"https://pokeapi.co/api/v2/machine/962/"},{"url":"https://pokeapi.co/api/v2/machine/963/"},{"url":"https://pokeapi.co/api/v2/machine/964/"},{"url":"https://pokeapi.co/api/v2/machine/965/"},{"url":"https://pokeapi.co/api/v2/machine/966/"},{"url":"https://pokeapi.co/api/v2/machine/967/"},{"url":"https://pokeapi.co/api/v2/machine/968/"},{"url":"https://pokeapi.co/api/v2/machine/969/"},{"url":"https://pokeapi.co/api/v2/machine/970/"},{"url":"https://pokeapi.co/api/v2/machine/971/"},{"url":"https://pokeapi.co/api/v2/machine/972/"},{"url":"https://pokeapi.co/api/v2/machine/973/"},{"url":"https://pokeapi.co/api/v2/machine/974/"},{"url":"https://pokeapi.co/api/v2/machine/975/"},{"url":"https://pokeapi.co/api/v2/machine/976/"},{"url":"https://pokeapi.co/api/v2/machine/977/"},{"url":"https://pokeapi.co/api/v2/machine/978/"},{"url":"https://pokeapi.co/api/v2/machine/979/"},{"url":"https://pokeapi.co/api/v2/machine/980/"},{"url":"https://pokeapi.co/api/v2/machine/981/"},{"url":"https://pokeapi.co/api/v2/machine/982/"},{"url":"https://pokeapi.co/api/v2/machine/983/"},{"url":"https://pokeapi.co/api/v2/machine/984/"},{"url":"https://pokeapi.co/api/v2/machine/985/"},{"url":"https://pokeapi.co/api/v2/machine/986/"},{"url":"https://pokeapi.co/api/v2/machine/987/"},{"url":"https://pokeapi.co/api/v2/machine/988/"},{"url":"https://pokeapi.co/api/v2/machine/989/"},{"url":"https://pokeapi.co/api/v2/machine/990/"},{"url":"https://pokeapi.co/api/v2/machine/991/"},{"url":"https://pokeapi.co/api/v2/machine/992/"},{"url":"https://pokeapi.co/api/v2/machine/993/"},{"url":"https://pokeapi.co/api/v2/machine/994/"},{"url":"https://pokeapi.co/api/v2/machine/995/"},{"url":"https://pokeapi.co/api/v2/machine/996/"},{"url":"https://pokeapi.co/api/v2/machine/997/"},{"url":"https://pokeapi.co/api/v2/machine/998/"},{"url":"https://pokeapi.co/api/v2/machine/999/"},{"url":"https://pokeapi.co/api/v2/machine/1000/"},{"url":"https://pokeapi.co/api/v2/machine/1001/"},{"url":"https://pokeapi.co/api/v2/machine/1002/"},{"url":"https://pokeapi.co/api/v2/machine/1003/"},{"url":"https://pokeapi.co/api/v2/machine/1004/"},{"url":"https://pokeapi.co/api/v2/machine/1005/"},{"url":"https://pokeapi.co/api/v2/machine/1006/"},{"url":"https://pokeapi.co/api/v2/machine/1007/"},{"url":"https://pokeapi.co/api/v2/machine/1008/"},{"url":"https://pokeapi.co/api/v2/machine/1009/"},{"url":"https://pokeapi.co/api/v2/machine/1010/"},{"url":"https://pokeapi.co/api/v2/machine/1011/"},{"url":"https://pokeapi.co/api/v2/machine/1012/"},{"url":"https://pokeapi.co/api/v2/machine/1013/"},{"url":"https://pokeapi.co/api/v2/machine/1014/"},{"url":"https://pokeapi.co/api/v2/machine/1015/"},{"url":"https://pokeapi.co/api/v2/machine/1016/"},{"url":"https://pokeapi.co/api/v2/machine/1017/"},{"url":"https://pokeapi.co/api/v2/machine/1018/"},{"url":"https://pokeapi.co/api/v2/machine/1019/"},{"url":"https://pokeapi.co/api/v2/machine/1020/"},{"url":"https://pokeapi.co/api/v2/machine/1021/"},{"url":"https://pokeapi.co/api/v2/machine/1022/"},{"url":"https://pokeapi.co/api/v2/machine/1023/"},{"url":"https://pokeapi.co/api/v2/machine/1024/"},{"url":"https://pokeapi.co/api/v2/machine/1025/"},{"url":"https://pokeapi.co/api/v2/machine/1026/"},{"url":"https://pokeapi.co/api/v2/machine/1027/"},{"url":"https://pokeapi.co/api/v2/machine/1028/"},{"url":"https://pokeapi.co/api/v2/machine/1029/"},{"url":"https://pokeapi.co/api/v2/machine/1030/"},{"url":"https://pokeapi.co/api/v2/machine/1031/"},{"url":"https://pokeapi.co/api/v2/machine/1032/"},{"url":"https://pokeapi.co/api/v2/machine/1033/"},{"url":"https://pokeapi.co/api/v2/machine/1034/"},{"url":"https://pokeapi.co/api/v2/machine/1035/"},{"url":"https://pokeapi.co/api/v2/machine/1036/"},{"url":"https://pokeapi.co/api/v2/machine/1037/"},{"url":"https://pokeapi.co/api/v2/machine/1038/"},{"url":"https://pokeapi.co/api/v2/machine/1039/"},{"url":"https://pokeapi.co/api/v2/machine/1040/"},{"url":"https://pokeapi.co/api/v2/machine/1041/"},{"url":"https://pokeapi.co/api/v2/machine/1042/"},{"url":"https://pokeapi.co/api/v2/machine/1043/"},{"url":"https://pokeapi.co/api/v2/machine/1044/"},{"url":"https://pokeapi.co/api/v2/machine/1045/"},{"url":"https://pokeapi.co/api/v2/machine/1046/"},{"url":"https://pokeapi.co/api/v2/machine/1047/"},{"url":"https://pokeapi.co/api/v2/machine/1048/"},{"url":"https://pokeapi.co/api/v2/machine/1049/"},{"url":"https://pokeapi.co/api/v2/machine/1050/"},{"url":"https://pokeapi.co/api/v2/machine/1051/"},{"url":"https://pokeapi.co/api/v2/machine/1052/"},{"url":"https://pokeapi.co/api/v2/machine/1053/"},{"url":"https://pokeapi.co/api/v2/machine/1054/"},{"url":"https://pokeapi.co/api/v2/machine/1055/"},{"url":"https://pokeapi.co/api/v2/machine/1056/"},{"url":"https://pokeapi.co/api/v2/machine/1057/"},{"url":"https://pokeapi.co/api/v2/machine/1058/"},{"url":"https://pokeapi.co/api/v2/machine/1059/"},{"url":"https://pokeapi.co/api/v2/machine/1060/"},{"url":"https://pokeapi.co/api/v2/machine/1061/"},{"url":"https://pokeapi.co/api/v2/machine/1062/"},{"url":"https://pokeapi.co/api/v2/machine/1063/"},{"url":"https://pokeapi.co/api/v2/machine/1064/"},{"url":"https://pokeapi.co/api/v2/machine/1065/"},{"url":"https://pokeapi.co/api/v2/machine/1066/"},{"url":"https://pokeapi.co/api/v2/machine/1067/"},{"url":"https://pokeapi.co/api/v2/machine/1068/"},{"url":"https://pokeapi.co/api/v2/machine/1069/"},{"url":"https://pokeapi.co/api/v2/machine/1070/"},{"url":"https://pokeapi.co/api/v2/machine/1071/"},{"url":"https://pokeapi.co/api/v2/machine/1072/"},{"url":"https://pokeapi.co/api/v2/machine/1073/"},{"url":"https://pokeapi.co/api/v2/machine/1074/"},{"url":"https://pokeapi.co/api/v2/machine/1075/"},{"url":"https://pokeapi.co/api/v2/machine/1076/"},{"url":"https://pokeapi.co/api/v2/machine/1077/"},{"url":"https://pokeapi.co/api/v2/machine/1078/"},{"url":"https://pokeapi.co/api/v2/machine/1079/"},{"url":"https://pokeapi.co/api/v2/machine/1080/"},{"url":"https://pokeapi.co/api/v2/machine/1081/"},{"url":"https://pokeapi.co/api/v2/machine/1082/"},{"url":"https://pokeapi.co/api/v2/machine/1083/"},{"url":"https://pokeapi.co/api/v2/machine/1084/"},{"url":"https://pokeapi.co/api/v2/machine/1085/"},{"url":"https://pokeapi.co/api/v2/machine/1086/"},{"url":"https://pokeapi.co/api/v2/machine/1087/"},{"url":"https://pokeapi.co/api/v2/machine/1088/"},{"url":"https://pokeapi.co/api/v2/machine/1089/"},{"url":"https://pokeapi.co/api/v2/machine/1090/"},{"url":"https://pokeapi.co/api/v2/machine/1091/"},{"url":"https://pokeapi.co/api/v2/machine/1092/"},{"url":"https://pokeapi.co/api/v2/machine/1093/"},{"url":"https://pokeapi.co/api/v2/machine/1094/"},{"url":"https://pokeapi.co/api/v2/machine/1095/"},{"url":"https://pokeapi.co/api/v2/machine/1096/"},{"url":"https://pokeapi.co/api/v2/machine/1097/"},{"url":"https://pokeapi.co/api/v2/machine/1098/"},{"url":"https://pokeapi.co/api/v2/machine/1099/"},{"url":"https://pokeapi.co/api/v2/machine/1100/"},{"url":"https://pokeapi.co/api/v2/machine/1101/"},{"url":"https://pokeapi.co/api/v2/machine/1102/"},{"url":"https://pokeapi.co/api/v2/machine/1103/"},{"url":"https://pokeapi.co/api/v2/machine/1104/"},{"url":"https://pokeapi.co/api/v2/machine/1105/"},{"url":"https://pokeapi.co/api/v2/machine/1106/"},{"url":"https://pokeapi.co/api/v2/machine/1107/"},{"url":"https://pokeapi.co/api/v2/machine/1108/"},{"url":"https://pokeapi.co/api/v2/machine/1109/"},{"url":"https://pokeapi.co/api/v2/machine/1110/"},{"url":"https://pokeapi.co/api/v2/machine/1111/"},{"url":"https://pokeapi.co/api/v2/machine/1112/"},{"url":"https://pokeapi.co/api/v2/machine/1113/"},{"url":"https://pokeapi.co/api/v2/machine/1114/"},{"url":"https://pokeapi.co/api/v2/machine/1115/"},{"url":"https://pokeapi.co/api/v2/machine/1116/"},{"url":"https://pokeapi.co/api/v2/machine/1117/"},{"url":"https://pokeapi.co/api/v2/machine/1118/"},{"url":"https://pokeapi.co/api/v2/machine/1119/"},{"url":"https://pokeapi.co/api/v2/machine/1120/"},{"url":"https://pokeapi.co/api/v2/machine/1121/"},{"url":"https://pokeapi.co/api/v2/machine/1122/"},{"url":"https://pokeapi.co/api/v2/machine/1123/"},{"url":"https://pokeapi.co/api/v2/machine/1124/"},{"url":"https://pokeapi.co/api/v2/machine/1125/"},{"url":"https://pokeapi.co/api/v2/machine/1126/"},{"url":"https://pokeapi.co/api/v2/machine/1127/"},{"url":"https://pokeapi.co/api/v2/machine/1128/"},{"url":"https://pokeapi.co/api/v2/machine/1129/"},{"url":"https://pokeapi.co/api/v2/machine/1130/"},{"url":"https://pokeapi.co/api/v2/machine/1131/"},{"url":"https://pokeapi.co/api/v2/machine/1132/"},{"url":"https://pokeapi.co/api/v2/machine/1133/"},{"url":"https://pokeapi.co/api/v2/machine/1134/"},{"url":"https://pokeapi.co/api/v2/machine/1135/"},{"url":"https://pokeapi.co/api/v2/machine/1136/"},{"url":"https://pokeapi.co/api/v2/machine/1137/"},{"url":"https://pokeapi.co/api/v2/machine/1138/"},{"url":"https://pokeapi.co/api/v2/machine/1139/"},{"url":"https://pokeapi.co/api/v2/machine/1140/"},{"url":"https://pokeapi.co/api/v2/machine/1141/"},{"url":"https://pokeapi.co/api/v2/machine/1142/"},{"url":"https://pokeapi.co/api/v2/machine/1143/"},{"url":"https://pokeapi.co/api/v2/machine/1144/"},{"url":"https://pokeapi.co/api/v2/machine/1145/"},{"url":"https://pokeapi.co/api/v2/machine/1146/"},{"url":"https://pokeapi.co/api/v2/machine/1147/"},{"url":"https://pokeapi.co/api/v2/machine/1148/"},{"url":"https://pokeapi.co/api/v2/machine/1149/"},{"url":"https://pokeapi.co/api/v2/machine/1150/"},{"url":"https://pokeapi.co/api/v2/machine/1151/"},{"url":"https://pokeapi.co/api/v2/machine/1152/"},{"url":"https://pokeapi.co/api/v2/machine/1153/"},{"url":"https://pokeapi.co/api/v2/machine/1154/"},{"url":"https://pokeapi.co/api/v2/machine/1155/"},{"url":"https://pokeapi.co/api/v2/machine/1156/"},{"url":"https://pokeapi.co/api/v2/machine/1157/"},{"url":"https://pokeapi.co/api/v2/machine/1158/"},{"url":"https://pokeapi.co/api/v2/machine/1159/"},{"url":"https://pokeapi.co/api/v2/machine/1160/"},{"url":"https://pokeapi.co/api/v2/machine/1161/"},{"url":"https://pokeapi.co/api/v2/machine/1162/"},{"url":"https://pokeapi.co/api/v2/machine/1163/"},{"url":"https://pokeapi.co/api/v2/machine/1164/"},{"url":"https://pokeapi.co/api/v2/machine/1165/"},{"url":"https://pokeapi.co/api/v2/machine/1166/"},{"url":"https://pokeapi.co/api/v2/machine/1167/"},{"url":"https://pokeapi.co/api/v2/machine/1168/"},{"url":"https://pokeapi.co/api/v2/machine/1169/"},{"url":"https://pokeapi.co/api/v2/machine/1170/"},{"url":"https://pokeapi.co/api/v2/machine/1171/"},{"url":"https://pokeapi.co/api/v2/machine/1172/"},{"url":"https://pokeapi.co/api/v2/machine/1173/"},{"url":"https://pokeapi.co/api/v2/machine/1174/"},{"url":"https://pokeapi.co/api/v2/machine/1175/"},{"url":"https://pokeapi.co/api/v2/machine/1176/"},{"url":"https://pokeapi.co/api/v2/machine/1177/"},{"url":"https://pokeapi.co/api/v2/machine/1178/"},{"url":"https://pokeapi.co/api/v2/machine/1179/"},{"url":"https://pokeapi.co/api/v2/machine/1180/"},{"url":"https://pokeapi.co/api/v2/machine/1181/"},{"url":"https://pokeapi.co/api/v2/machine/1182/"},{"url":"https://pokeapi.co/api/v2/machine/1183/"},{"url":"https://pokeapi.co/api/v2/machine/1184/"},{"url":"https://pokeapi.co/api/v2/machine/1185/"},{"url":"https://pokeapi.co/api/v2/machine/1186/"},{"url":"https://pokeapi.co/api/v2/machine/1187/"},{"url":"https://pokeapi.co/api/v2/machine/1188/"},{"url":"https://pokeapi.co/api/v2/machine/1189/"},{"url":"https://pokeapi.co/api/v2/machine/1190/"},{"url":"https://pokeapi.co/api/v2/machine/1191/"},{"url":"https://pokeapi.co/api/v2/machine/1192/"},{"url":"https://pokeapi.co/api/v2/machine/1193/"},{"url":"https://pokeapi.co/api/v2/machine/1194/"},{"url":"https://pokeapi.co/api/v2/machine/1195/"},{"url":"https://pokeapi.co/api/v2/machine/1196/"},{"url":"https://pokeapi.co/api/v2/machine/1197/"},{"url":"https://pokeapi.co/api/v2/machine/1198/"},{"url":"https://pokeapi.co/api/v2/machine/1199/"},{"url":"https://pokeapi.co/api/v2/machine/1200/"},{"url":"https://pokeapi.co/api/v2/machine/1201/"},{"url":"https://pokeapi.co/api/v2/machine/1202/"},{"url":"https://pokeapi.co/api/v2/machine/1203/"},{"url":"https://pokeapi.co/api/v2/machine/1204/"},{"url":"https://pokeapi.co/api/v2/machine/1205/"},{"url":"https://pokeapi.co/api/v2/machine/1206/"},{"url":"https://pokeapi.co/api/v2/machine/1207/"},{"url":"https://pokeapi.co/api/v2/machine/1208/"},{"url":"https://pokeapi.co/api/v2/machine/1209/"},{"url":"https://pokeapi.co/api/v2/machine/1210/"},{"url":"https://pokeapi.co/api/v2/machine/1211/"},{"url":"https://pokeapi.co/api/v2/machine/1212/"},{"url":"https://pokeapi.co/api/v2/machine/1213/"},{"url":"https://pokeapi.co/api/v2/machine/1214/"},{"url":"https://pokeapi.co/api/v2/machine/1215/"},{"url":"https://pokeapi.co/api/v2/machine/1216/"},{"url":"https://pokeapi.co/api/v2/machine/1217/"},{"url":"https://pokeapi.co/api/v2/machine/1218/"},{"url":"https://pokeapi.co/api/v2/machine/1219/"},{"url":"https://pokeapi.co/api/v2/machine/1220/"},{"url":"https://pokeapi.co/api/v2/machine/1221/"},{"url":"https://pokeapi.co/api/v2/machine/1222/"},{"url":"https://pokeapi.co/api/v2/machine/1223/"},{"url":"https://pokeapi.co/api/v2/machine/1224/"},{"url":"https://pokeapi.co/api/v2/machine/1225/"},{"url":"https://pokeapi.co/api/v2/machine/1226/"},{"url":"https://pokeapi.co/api/v2/machine/1227/"},{"url":"https://pokeapi.co/api/v2/machine/1228/"},{"url":"https://pokeapi.co/api/v2/machine/1229/"},{"url":"https://pokeapi.co/api/v2/machine/1230/"},{"url":"https://pokeapi.co/api/v2/machine/1231/"},{"url":"https://pokeapi.co/api/v2/machine/1232/"},{"url":"https://pokeapi.co/api/v2/machine/1233/"},{"url":"https://pokeapi.co/api/v2/machine/1234/"},{"url":"https://pokeapi.co/api/v2/machine/1235/"},{"url":"https://pokeapi.co/api/v2/machine/1236/"},{"url":"https://pokeapi.co/api/v2/machine/1237/"},{"url":"https://pokeapi.co/api/v2/machine/1238/"},{"url":"https://pokeapi.co/api/v2/machine/1239/"},{"url":"https://pokeapi.co/api/v2/machine/1240/"},{"url":"https://pokeapi.co/api/v2/machine/1241/"},{"url":"https://pokeapi.co/api/v2/machine/1242/"},{"url":"https://pokeapi.co/api/v2/machine/1243/"},{"url":"https://pokeapi.co/api/v2/machine/1244/"},{"url":"https://pokeapi.co/api/v2/machine/1245/"},{"url":"https://pokeapi.co/api/v2/machine/1246/"},{"url":"https://pokeapi.co/api/v2/machine/1247/"},{"url":"https://pokeapi.co/api/v2/machine/1248/"},{"url":"https://pokeapi.co/api/v2/machine/1249/"},{"url":"https://pokeapi.co/api/v2/machine/1250/"},{"url":"https://pokeapi.co/api/v2/machine/1251/"},{"url":"https://pokeapi.co/api/v2/machine/1252/"},{"url":"https://pokeapi.co/api/v2/machine/1253/"},{"url":"https://pokeapi.co/api/v2/machine/1254/"},{"url":"https://pokeapi.co/api/v2/machine/1255/"},{"url":"https://pokeapi.co/api/v2/machine/1256/"},{"url":"https://pokeapi.co/api/v2/machine/1257/"},{"url":"https://pokeapi.co/api/v2/machine/1258/"},{"url":"https://pokeapi.co/api/v2/machine/1259/"},{"url":"https://pokeapi.co/api/v2/machine/1260/"},{"url":"https://pokeapi.co/api/v2/machine/1261/"},{"url":"https://pokeapi.co/api/v2/machine/1262/"},{"url":"https://pokeapi.co/api/v2/machine/1263/"},{"url":"https://pokeapi.co/api/v2/machine/1264/"},{"url":"https://pokeapi.co/api/v2/machine/1265/"},{"url":"https://pokeapi.co/api/v2/machine/1266/"},{"url":"https://pokeapi.co/api/v2/machine/1267/"},{"url":"https://pokeapi.co/api/v2/machine/1268/"},{"url":"https://pokeapi.co/api/v2/machine/1269/"},{"url":"https://pokeapi.co/api/v2/machine/1270/"},{"url":"https://pokeapi.co/api/v2/machine/1271/"},{"url":"https://pokeapi.co/api/v2/machine/1272/"},{"url":"https://pokeapi.co/api/v2/machine/1273/"},{"url":"https://pokeapi.co/api/v2/machine/1274/"},{"url":"https://pokeapi.co/api/v2/machine/1275/"},{"url":"https://pokeapi.co/api/v2/machine/1276/"},{"url":"https://pokeapi.co/api/v2/machine/1277/"},{"url":"https://pokeapi.co/api/v2/machine/1278/"},{"url":"https://pokeapi.co/api/v2/machine/1279/"},{"url":"https://pokeapi.co/api/v2/machine/1280/"},{"url":"https://pokeapi.co/api/v2/machine/1281/"},{"url":"https://pokeapi.co/api/v2/machine/1282/"},{"url":"https://pokeapi.co/api/v2/machine/1283/"},{"url":"https://pokeapi.co/api/v2/machine/1284/"},{"url":"https://pokeapi.co/api/v2/machine/1285/"},{"url":"https://pokeapi.co/api/v2/machine/1286/"},{"url":"https://pokeapi.co/api/v2/machine/1287/"},{"url":"https://pokeapi.co/api/v2/machine/1288/"},{"url":"https://pokeapi.co/api/v2/machine/1289/"},{"url":"https://pokeapi.co/api/v2/machine/1290/"},{"url":"https://pokeapi.co/api/v2/machine/1291/"},{"url":"https://pokeapi.co/api/v2/machine/1292/"},{"url":"https://pokeapi.co/api/v2/machine/1293/"},{"url":"https://pokeapi.co/api/v2/machine/1294/"},{"url":"https://pokeapi.co/api/v2/machine/1295/"},{"url":"https://pokeapi.co/api/v2/machine/1296/"},{"url":"https://pokeapi.co/api/v2/machine/1297/"},{"url":"https://pokeapi.co/api/v2/machine/1298/"},{"url":"https://pokeapi.co/api/v2/machine/1299/"},{"url":"https://pokeapi.co/api/v2/machine/1300/"},{"url":"https://pokeapi.co/api/v2/machine/1301/"},{"url":"https://pokeapi.co/api/v2/machine/1302/"},{"url":"https://pokeapi.co/api/v2/machine/1303/"},{"url":"https://pokeapi.co/api/v2/machine/1304/"},{"url":"https://pokeapi.co/api/v2/machine/1305/"},{"url":"https://pokeapi.co/api/v2/machine/1306/"},{"url":"https://pokeapi.co/api/v2/machine/1307/"},{"url":"https://pokeapi.co/api/v2/machine/1308/"},{"url":"https://pokeapi.co/api/v2/machine/1309/"},{"url":"https://pokeapi.co/api/v2/machine/1310/"},{"url":"https://pokeapi.co/api/v2/machine/1311/"},{"url":"https://pokeapi.co/api/v2/machine/1312/"},{"url":"https://pokeapi.co/api/v2/machine/1313/"},{"url":"https://pokeapi.co/api/v2/machine/1314/"},{"url":"https://pokeapi.co/api/v2/machine/1315/"},{"url":"https://pokeapi.co/api/v2/machine/1316/"},{"url":"https://pokeapi.co/api/v2/machine/1317/"},{"url":"https://pokeapi.co/api/v2/machine/1318/"},{"url":"https://pokeapi.co/api/v2/machine/1319/"},{"url":"https://pokeapi.co/api/v2/machine/1320/"},{"url":"https://pokeapi.co/api/v2/machine/1321/"},{"url":"https://pokeapi.co/api/v2/machine/1322/"},{"url":"https://pokeapi.co/api/v2/machine/1323/"},{"url":"https://pokeapi.co/api/v2/machine/1324/"},{"url":"https://pokeapi.co/api/v2/machine/1325/"},{"url":"https://pokeapi.co/api/v2/machine/1326/"},{"url":"https://pokeapi.co/api/v2/machine/1327/"},{"url":"https://pokeapi.co/api/v2/machine/1328/"},{"url":"https://pokeapi.co/api/v2/machine/1329/"},{"url":"https://pokeapi.co/api/v2/machine/1330/"},{"url":"https://pokeapi.co/api/v2/machine/1331/"},{"url":"https://pokeapi.co/api/v2/machine/1332/"},{"url":"https://pokeapi.co/api/v2/machine/1333/"},{"url":"https://pokeapi.co/api/v2/machine/1334/"},{"url":"https://pokeapi.co/api/v2/machine/1335/"},{"url":"https://pokeapi.co/api/v2/machine/1336/"},{"url":"https://pokeapi.co/api/v2/machine/1337/"},{"url":"https://pokeapi.co/api/v2/machine/1338/"},{"url":"https://pokeapi.co/api/v2/machine/1339/"},{"url":"https://pokeapi.co/api/v2/machine/1340/"},{"url":"https://pokeapi.co/api/v2/machine/1341/"},{"url":"https://pokeapi.co/api/v2/machine/1342/"},{"url":"https://pokeapi.co/api/v2/machine/1343/"},{"url":"https://pokeapi.co/api/v2/machine/1344/"},{"url":"https://pokeapi.co/api/v2/machine/1345/"},{"url":"https://pokeapi.co/api/v2/machine/1346/"},{"url":"https://pokeapi.co/api/v2/machine/1347/"},{"url":"https://pokeapi.co/api/v2/machine/1348/"},{"url":"https://pokeapi.co/api/v2/machine/1349/"},{"url":"https://pokeapi.co/api/v2/machine/1350/"},{"url":"https://pokeapi.co/api/v2/machine/1351/"},{"url":"https://pokeapi.co/api/v2/machine/1352/"},{"url":"https://pokeapi.co/api/v2/machine/1353/"},{"url":"https://pokeapi.co/api/v2/machine/1354/"},{"url":"https://pokeapi.co/api/v2/machine/1355/"},{"url":"https://pokeapi.co/api/v2/machine/1356/"},{"url":"https://pokeapi.co/api/v2/machine/1357/"},{"url":"https://pokeapi.co/api/v2/machine/1358/"},{"url":"https://pokeapi.co/api/v2/machine/1359/"},{"url":"https://pokeapi.co/api/v2/machine/1360/"},{"url":"https://pokeapi.co/api/v2/machine/1361/"},{"url":"https://pokeapi.co/api/v2/machine/1362/"},{"url":"https://pokeapi.co/api/v2/machine/1363/"},{"url":"https://pokeapi.co/api/v2/machine/1364/"},{"url":"https://pokeapi.co/api/v2/machine/1365/"},{"url":"https://pokeapi.co/api/v2/machine/1366/"},{"url":"https://pokeapi.co/api/v2/machine/1367/"},{"url":"https://pokeapi.co/api/v2/machine/1368/"},{"url":"https://pokeapi.co/api/v2/machine/1369/"},{"url":"https://pokeapi.co/api/v2/machine/1370/"},{"url":"https://pokeapi.co/api/v2/machine/1371/"},{"url":"https://pokeapi.co/api/v2/machine/1372/"},{"url":"https://pokeapi.co/api/v2/machine/1373/"},{"url":"https://pokeapi.co/api/v2/machine/1374/"},{"url":"https://pokeapi.co/api/v2/machine/1375/"},{"url":"https://pokeapi.co/api/v2/machine/1376/"},{"url":"https://pokeapi.co/api/v2/machine/1377/"},{"url":"https://pokeapi.co/api/v2/machine/1378/"},{"url":"https://pokeapi.co/api/v2/machine/1379/"},{"url":"https://pokeapi.co/api/v2/machine/1380/"},{"url":"https://pokeapi.co/api/v2/machine/1381/"},{"url":"https://pokeapi.co/api/v2/machine/1382/"},{"url":"https://pokeapi.co/api/v2/machine/1383/"},{"url":"https://pokeapi.co/api/v2/machine/1384/"},{"url":"https://pokeapi.co/api/v2/machine/1385/"},{"url":"https://pokeapi.co/api/v2/machine/1386/"},{"url":"https://pokeapi.co/api/v2/machine/1387/"},{"url":"https://pokeapi.co/api/v2/machine/1388/"},{"url":"https://pokeapi.co/api/v2/machine/1389/"},{"url":"https://pokeapi.co/api/v2/machine/1390/"},{"url":"https://pokeapi.co/api/v2/machine/1391/"},{"url":"https://pokeapi.co/api/v2/machine/1392/"},{"url":"https://pokeapi.co/api/v2/machine/1393/"},{"url":"https://pokeapi.co/api/v2/machine/1394/"},{"url":"https://pokeapi.co/api/v2/machine/1395/"},{"url":"https://pokeapi.co/api/v2/machine/1396/"},{"url":"https://pokeapi.co/api/v2/machine/1397/"},{"url":"https://pokeapi.co/api/v2/machine/1398/"},{"url":"https://pokeapi.co/api/v2/machine/1399/"},{"url":"https://pokeapi.co/api/v2/machine/1400/"},{"url":"https://pokeapi.co/api/v2/machine/1401/"},{"url":"https://pokeapi.co/api/v2/machine/1402/"},{"url":"https://pokeapi.co/api/v2/machine/1403/"},{"url":"https://pokeapi.co/api/v2/machine/1404/"},{"url":"https://pokeapi.co/api/v2/machine/1405/"},{"url":"https://pokeapi.co/api/v2/machine/1406/"},{"url":"https://pokeapi.co/api/v2/machine/1407/"},{"url":"https://pokeapi.co/api/v2/machine/1408/"},{"url":"https://pokeapi.co/api/v2/machine/1409/"},{"url":"https://pokeapi.co/api/v2/machine/1410/"},{"url":"https://pokeapi.co/api/v2/machine/1411/"},{"url":"https://pokeapi.co/api/v2/machine/1412/"},{"url":"https://pokeapi.co/api/v2/machine/1413/"},{"url":"https://pokeapi.co/api/v2/machine/1414/"},{"url":"https://pokeapi.co/api/v2/machine/1415/"},{"url":"https://pokeapi.co/api/v2/machine/1416/"},{"url":"https://pokeapi.co/api/v2/machine/1417/"},{"url":"https://pokeapi.co/api/v2/machine/1418/"},{"url":"https://pokeapi.co/api/v2/machine/1419/"},{"url":"https://pokeapi.co/api/v2/machine/1420/"},{"url":"https://pokeapi.co/api/v2/machine/1421/"},{"url":"https://pokeapi.co/api/v2/machine/1422/"},{"url":"https://pokeapi.co/api/v2/machine/1423/"},{"url":"https://pokeapi.co/api/v2/machine/1424/"},{"url":"https://pokeapi.co/api/v2/machine/1425/"},{"url":"https://pokeapi.co/api/v2/machine/1426/"},{"url":"https://pokeapi.co/api/v2/machine/1427/"},{"url":"https://pokeapi.co/api/v2/machine/1428/"},{"url":"https://pokeapi.co/api/v2/machine/1429/"},{"url":"https://pokeapi.co/api/v2/machine/1430/"},{"url":"https://pokeapi.co/api/v2/machine/1431/"},{"url":"https://pokeapi.co/api/v2/machine/1432/"},{"url":"https://pokeapi.co/api/v2/machine/1433/"},{"url":"https://pokeapi.co/api/v2/machine/1434/"},{"url":"https://pokeapi.co/api/v2/machine/1435/"},{"url":"https://pokeapi.co/api/v2/machine/1436/"},{"url":"https://pokeapi.co/api/v2/machine/1437/"},{"url":"https://pokeapi.co/api/v2/machine/1438/"},{"url":"https://pokeapi.co/api/v2/machine/1439/"},{"url":"https://pokeapi.co/api/v2/machine/1440/"},{"url":"https://pokeapi.co/api/v2/machine/1441/"},{"url":"https://pokeapi.co/api/v2/machine/1442/"}]}"#;

// https://pokeapi.co/api/v2/move/?offset=0&limit=9999
static FULL_MOVE_LIST_JSON: &str = r#"{"count":746,"next":null,"previous":null,"results":[{"name":"pound","url":"https://pokeapi.co/api/v2/move/1/"},{"name":"karate-chop","url":"https://pokeapi.co/api/v2/move/2/"},{"name":"double-slap","url":"https://pokeapi.co/api/v2/move/3/"},{"name":"comet-punch","url":"https://pokeapi.co/api/v2/move/4/"},{"name":"mega-punch","url":"https://pokeapi.co/api/v2/move/5/"},{"name":"pay-day","url":"https://pokeapi.co/api/v2/move/6/"},{"name":"fire-punch","url":"https://pokeapi.co/api/v2/move/7/"},{"name":"ice-punch","url":"https://pokeapi.co/api/v2/move/8/"},{"name":"thunder-punch","url":"https://pokeapi.co/api/v2/move/9/"},{"name":"scratch","url":"https://pokeapi.co/api/v2/move/10/"},{"name":"vice-grip","url":"https://pokeapi.co/api/v2/move/11/"},{"name":"guillotine","url":"https://pokeapi.co/api/v2/move/12/"},{"name":"razor-wind","url":"https://pokeapi.co/api/v2/move/13/"},{"name":"swords-dance","url":"https://pokeapi.co/api/v2/move/14/"},{"name":"cut","url":"https://pokeapi.co/api/v2/move/15/"},{"name":"gust","url":"https://pokeapi.co/api/v2/move/16/"},{"name":"wing-attack","url":"https://pokeapi.co/api/v2/move/17/"},{"name":"whirlwind","url":"https://pokeapi.co/api/v2/move/18/"},{"name":"fly","url":"https://pokeapi.co/api/v2/move/19/"},{"name":"bind","url":"https://pokeapi.co/api/v2/move/20/"},{"name":"slam","url":"https://pokeapi.co/api/v2/move/21/"},{"name":"vine-whip","url":"https://pokeapi.co/api/v2/move/22/"},{"name":"stomp","url":"https://pokeapi.co/api/v2/move/23/"},{"name":"double-kick","url":"https://pokeapi.co/api/v2/move/24/"},{"name":"mega-kick","url":"https://pokeapi.co/api/v2/move/25/"},{"name":"jump-kick","url":"https://pokeapi.co/api/v2/move/26/"},{"name":"rolling-kick","url":"https://pokeapi.co/api/v2/move/27/"},{"name":"sand-attack","url":"https://pokeapi.co/api/v2/move/28/"},{"name":"headbutt","url":"https://pokeapi.co/api/v2/move/29/"},{"name":"horn-attack","url":"https://pokeapi.co/api/v2/move/30/"},{"name":"fury-attack","url":"https://pokeapi.co/api/v2/move/31/"},{"name":"horn-drill","url":"https://pokeapi.co/api/v2/move/32/"},{"name":"tackle","url":"https://pokeapi.co/api/v2/move/33/"},{"name":"body-slam","url":"https://pokeapi.co/api/v2/move/34/"},{"name":"wrap","url":"https://pokeapi.co/api/v2/move/35/"},{"name":"take-down","url":"https://pokeapi.co/api/v2/move/36/"},{"name":"thrash","url":"https://pokeapi.co/api/v2/move/37/"},{"name":"double-edge","url":"https://pokeapi.co/api/v2/move/38/"},{"name":"tail-whip","url":"https://pokeapi.co/api/v2/move/39/"},{"name":"poison-sting","url":"https://pokeapi.co/api/v2/move/40/"},{"name":"twineedle","url":"https://pokeapi.co/api/v2/move/41/"},{"name":"pin-missile","url":"https://pokeapi.co/api/v2/move/42/"},{"name":"leer","url":"https://pokeapi.co/api/v2/move/43/"},{"name":"bite","url":"https://pokeapi.co/api/v2/move/44/"},{"name":"growl","url":"https://pokeapi.co/api/v2/move/45/"},{"name":"roar","url":"https://pokeapi.co/api/v2/move/46/"},{"name":"sing","url":"https://pokeapi.co/api/v2/move/47/"},{"name":"supersonic","url":"https://pokeapi.co/api/v2/move/48/"},{"name":"sonic-boom","url":"https://pokeapi.co/api/v2/move/49/"},{"name":"disable","url":"https://pokeapi.co/api/v2/move/50/"},{"name":"acid","url":"https://pokeapi.co/api/v2/move/51/"},{"name":"ember","url":"https://pokeapi.co/api/v2/move/52/"},{"name":"flamethrower","url":"https://pokeapi.co/api/v2/move/53/"},{"name":"mist","url":"https://pokeapi.co/api/v2/move/54/"},{"name":"water-gun","url":"https://pokeapi.co/api/v2/move/55/"},{"name":"hydro-pump","url":"https://pokeapi.co/api/v2/move/56/"},{"name":"surf","url":"https://pokeapi.co/api/v2/move/57/"},{"name":"ice-beam","url":"https://pokeapi.co/api/v2/move/58/"},{"name":"blizzard","url":"https://pokeapi.co/api/v2/move/59/"},{"name":"psybeam","url":"https://pokeapi.co/api/v2/move/60/"},{"name":"bubble-beam","url":"https://pokeapi.co/api/v2/move/61/"},{"name":"aurora-beam","url":"https://pokeapi.co/api/v2/move/62/"},{"name":"hyper-beam","url":"https://pokeapi.co/api/v2/move/63/"},{"name":"peck","url":"https://pokeapi.co/api/v2/move/64/"},{"name":"drill-peck","url":"https://pokeapi.co/api/v2/move/65/"},{"name":"submission","url":"https://pokeapi.co/api/v2/move/66/"},{"name":"low-kick","url":"https://pokeapi.co/api/v2/move/67/"},{"name":"counter","url":"https://pokeapi.co/api/v2/move/68/"},{"name":"seismic-toss","url":"https://pokeapi.co/api/v2/move/69/"},{"name":"strength","url":"https://pokeapi.co/api/v2/move/70/"},{"name":"absorb","url":"https://pokeapi.co/api/v2/move/71/"},{"name":"mega-drain","url":"https://pokeapi.co/api/v2/move/72/"},{"name":"leech-seed","url":"https://pokeapi.co/api/v2/move/73/"},{"name":"growth","url":"https://pokeapi.co/api/v2/move/74/"},{"name":"razor-leaf","url":"https://pokeapi.co/api/v2/move/75/"},{"name":"solar-beam","url":"https://pokeapi.co/api/v2/move/76/"},{"name":"poison-powder","url":"https://pokeapi.co/api/v2/move/77/"},{"name":"stun-spore","url":"https://pokeapi.co/api/v2/move/78/"},{"name":"sleep-powder","url":"https://pokeapi.co/api/v2/move/79/"},{"name":"petal-dance","url":"https://pokeapi.co/api/v2/move/80/"},{"name":"string-shot","url":"https://pokeapi.co/api/v2/move/81/"},{"name":"dragon-rage","url":"https://pokeapi.co/api/v2/move/82/"},{"name":"fire-spin","url":"https://pokeapi.co/api/v2/move/83/"},{"name":"thunder-shock","url":"https://pokeapi.co/api/v2/move/84/"},{"name":"thunderbolt","url":"https://pokeapi.co/api/v2/move/85/"},{"name":"thunder-wave","url":"https://pokeapi.co/api/v2/move/86/"},{"name":"thunder","url":"https://pokeapi.co/api/v2/move/87/"},{"name":"rock-throw","url":"https://pokeapi.co/api/v2/move/88/"},{"name":"earthquake","url":"https://pokeapi.co/api/v2/move/89/"},{"name":"fissure","url":"https://pokeapi.co/api/v2/move/90/"},{"name":"dig","url":"https://pokeapi.co/api/v2/move/91/"},{"name":"toxic","url":"https://pokeapi.co/api/v2/move/92/"},{"name":"confusion","url":"https://pokeapi.co/api/v2/move/93/"},{"name":"psychic","url":"https://pokeapi.co/api/v2/move/94/"},{"name":"hypnosis","url":"https://pokeapi.co/api/v2/move/95/"},{"name":"meditate","url":"https://pokeapi.co/api/v2/move/96/"},{"name":"agility","url":"https://pokeapi.co/api/v2/move/97/"},{"name":"quick-attack","url":"https://pokeapi.co/api/v2/move/98/"},{"name":"rage","url":"https://pokeapi.co/api/v2/move/99/"},{"name":"teleport","url":"https://pokeapi.co/api/v2/move/100/"},{"name":"night-shade","url":"https://pokeapi.co/api/v2/move/101/"},{"name":"mimic","url":"https://pokeapi.co/api/v2/move/102/"},{"name":"screech","url":"https://pokeapi.co/api/v2/move/103/"},{"name":"double-team","url":"https://pokeapi.co/api/v2/move/104/"},{"name":"recover","url":"https://pokeapi.co/api/v2/move/105/"},{"name":"harden","url":"https://pokeapi.co/api/v2/move/106/"},{"name":"minimize","url":"https://pokeapi.co/api/v2/move/107/"},{"name":"smokescreen","url":"https://pokeapi.co/api/v2/move/108/"},{"name":"confuse-ray","url":"https://pokeapi.co/api/v2/move/109/"},{"name":"withdraw","url":"https://pokeapi.co/api/v2/move/110/"},{"name":"defense-curl","url":"https://pokeapi.co/api/v2/move/111/"},{"name":"barrier","url":"https://pokeapi.co/api/v2/move/112/"},{"name":"light-screen","url":"https://pokeapi.co/api/v2/move/113/"},{"name":"haze","url":"https://pokeapi.co/api/v2/move/114/"},{"name":"reflect","url":"https://pokeapi.co/api/v2/move/115/"},{"name":"focus-energy","url":"https://pokeapi.co/api/v2/move/116/"},{"name":"bide","url":"https://pokeapi.co/api/v2/move/117/"},{"name":"metronome","url":"https://pokeapi.co/api/v2/move/118/"},{"name":"mirror-move","url":"https://pokeapi.co/api/v2/move/119/"},{"name":"self-destruct","url":"https://pokeapi.co/api/v2/move/120/"},{"name":"egg-bomb","url":"https://pokeapi.co/api/v2/move/121/"},{"name":"lick","url":"https://pokeapi.co/api/v2/move/122/"},{"name":"smog","url":"https://pokeapi.co/api/v2/move/123/"},{"name":"sludge","url":"https://pokeapi.co/api/v2/move/124/"},{"name":"bone-club","url":"https://pokeapi.co/api/v2/move/125/"},{"name":"fire-blast","url":"https://pokeapi.co/api/v2/move/126/"},{"name":"waterfall","url":"https://pokeapi.co/api/v2/move/127/"},{"name":"clamp","url":"https://pokeapi.co/api/v2/move/128/"},{"name":"swift","url":"https://pokeapi.co/api/v2/move/129/"},{"name":"skull-bash","url":"https://pokeapi.co/api/v2/move/130/"},{"name":"spike-cannon","url":"https://pokeapi.co/api/v2/move/131/"},{"name":"constrict","url":"https://pokeapi.co/api/v2/move/132/"},{"name":"amnesia","url":"https://pokeapi.co/api/v2/move/133/"},{"name":"kinesis","url":"https://pokeapi.co/api/v2/move/134/"},{"name":"soft-boiled","url":"https://pokeapi.co/api/v2/move/135/"},{"name":"high-jump-kick","url":"https://pokeapi.co/api/v2/move/136/"},{"name":"glare","url":"https://pokeapi.co/api/v2/move/137/"},{"name":"dream-eater","url":"https://pokeapi.co/api/v2/move/138/"},{"name":"poison-gas","url":"https://pokeapi.co/api/v2/move/139/"},{"name":"barrage","url":"https://pokeapi.co/api/v2/move/140/"},{"name":"leech-life","url":"https://pokeapi.co/api/v2/move/141/"},{"name":"lovely-kiss","url":"https://pokeapi.co/api/v2/move/142/"},{"name":"sky-attack","url":"https://pokeapi.co/api/v2/move/143/"},{"name":"transform","url":"https://pokeapi.co/api/v2/move/144/"},{"name":"bubble","url":"https://pokeapi.co/api/v2/move/145/"},{"name":"dizzy-punch","url":"https://pokeapi.co/api/v2/move/146/"},{"name":"spore","url":"https://pokeapi.co/api/v2/move/147/"},{"name":"flash","url":"https://pokeapi.co/api/v2/move/148/"},{"name":"psywave","url":"https://pokeapi.co/api/v2/move/149/"},{"name":"splash","url":"https://pokeapi.co/api/v2/move/150/"},{"name":"acid-armor","url":"https://pokeapi.co/api/v2/move/151/"},{"name":"crabhammer","url":"https://pokeapi.co/api/v2/move/152/"},{"name":"explosion","url":"https://pokeapi.co/api/v2/move/153/"},{"name":"fury-swipes","url":"https://pokeapi.co/api/v2/move/154/"},{"name":"bonemerang","url":"https://pokeapi.co/api/v2/move/155/"},{"name":"rest","url":"https://pokeapi.co/api/v2/move/156/"},{"name":"rock-slide","url":"https://pokeapi.co/api/v2/move/157/"},{"name":"hyper-fang","url":"https://pokeapi.co/api/v2/move/158/"},{"name":"sharpen","url":"https://pokeapi.co/api/v2/move/159/"},{"name":"conversion","url":"https://pokeapi.co/api/v2/move/160/"},{"name":"tri-attack","url":"https://pokeapi.co/api/v2/move/161/"},{"name":"super-fang","url":"https://pokeapi.co/api/v2/move/162/"},{"name":"slash","url":"https://pokeapi.co/api/v2/move/163/"},{"name":"substitute","url":"https://pokeapi.co/api/v2/move/164/"},{"name":"struggle","url":"https://pokeapi.co/api/v2/move/165/"},{"name":"sketch","url":"https://pokeapi.co/api/v2/move/166/"},{"name":"triple-kick","url":"https://pokeapi.co/api/v2/move/167/"},{"name":"thief","url":"https://pokeapi.co/api/v2/move/168/"},{"name":"spider-web","url":"https://pokeapi.co/api/v2/move/169/"},{"name":"mind-reader","url":"https://pokeapi.co/api/v2/move/170/"},{"name":"nightmare","url":"https://pokeapi.co/api/v2/move/171/"},{"name":"flame-wheel","url":"https://pokeapi.co/api/v2/move/172/"},{"name":"snore","url":"https://pokeapi.co/api/v2/move/173/"},{"name":"curse","url":"https://pokeapi.co/api/v2/move/174/"},{"name":"flail","url":"https://pokeapi.co/api/v2/move/175/"},{"name":"conversion-2","url":"https://pokeapi.co/api/v2/move/176/"},{"name":"aeroblast","url":"https://pokeapi.co/api/v2/move/177/"},{"name":"cotton-spore","url":"https://pokeapi.co/api/v2/move/178/"},{"name":"reversal","url":"https://pokeapi.co/api/v2/move/179/"},{"name":"spite","url":"https://pokeapi.co/api/v2/move/180/"},{"name":"powder-snow","url":"https://pokeapi.co/api/v2/move/181/"},{"name":"protect","url":"https://pokeapi.co/api/v2/move/182/"},{"name":"mach-punch","url":"https://pokeapi.co/api/v2/move/183/"},{"name":"scary-face","url":"https://pokeapi.co/api/v2/move/184/"},{"name":"feint-attack","url":"https://pokeapi.co/api/v2/move/185/"},{"name":"sweet-kiss","url":"https://pokeapi.co/api/v2/move/186/"},{"name":"belly-drum","url":"https://pokeapi.co/api/v2/move/187/"},{"name":"sludge-bomb","url":"https://pokeapi.co/api/v2/move/188/"},{"name":"mud-slap","url":"https://pokeapi.co/api/v2/move/189/"},{"name":"octazooka","url":"https://pokeapi.co/api/v2/move/190/"},{"name":"spikes","url":"https://pokeapi.co/api/v2/move/191/"},{"name":"zap-cannon","url":"https://pokeapi.co/api/v2/move/192/"},{"name":"foresight","url":"https://pokeapi.co/api/v2/move/193/"},{"name":"destiny-bond","url":"https://pokeapi.co/api/v2/move/194/"},{"name":"perish-song","url":"https://pokeapi.co/api/v2/move/195/"},{"name":"icy-wind","url":"https://pokeapi.co/api/v2/move/196/"},{"name":"detect","url":"https://pokeapi.co/api/v2/move/197/"},{"name":"bone-rush","url":"https://pokeapi.co/api/v2/move/198/"},{"name":"lock-on","url":"https://pokeapi.co/api/v2/move/199/"},{"name":"outrage","url":"https://pokeapi.co/api/v2/move/200/"},{"name":"sandstorm","url":"https://pokeapi.co/api/v2/move/201/"},{"name":"giga-drain","url":"https://pokeapi.co/api/v2/move/202/"},{"name":"endure","url":"https://pokeapi.co/api/v2/move/203/"},{"name":"charm","url":"https://pokeapi.co/api/v2/move/204/"},{"name":"rollout","url":"https://pokeapi.co/api/v2/move/205/"},{"name":"false-swipe","url":"https://pokeapi.co/api/v2/move/206/"},{"name":"swagger","url":"https://pokeapi.co/api/v2/move/207/"},{"name":"milk-drink","url":"https://pokeapi.co/api/v2/move/208/"},{"name":"spark","url":"https://pokeapi.co/api/v2/move/209/"},{"name":"fury-cutter","url":"https://pokeapi.co/api/v2/move/210/"},{"name":"steel-wing","url":"https://pokeapi.co/api/v2/move/211/"},{"name":"mean-look","url":"https://pokeapi.co/api/v2/move/212/"},{"name":"attract","url":"https://pokeapi.co/api/v2/move/213/"},{"name":"sleep-talk","url":"https://pokeapi.co/api/v2/move/214/"},{"name":"heal-bell","url":"https://pokeapi.co/api/v2/move/215/"},{"name":"return","url":"https://pokeapi.co/api/v2/move/216/"},{"name":"present","url":"https://pokeapi.co/api/v2/move/217/"},{"name":"frustration","url":"https://pokeapi.co/api/v2/move/218/"},{"name":"safeguard","url":"https://pokeapi.co/api/v2/move/219/"},{"name":"pain-split","url":"https://pokeapi.co/api/v2/move/220/"},{"name":"sacred-fire","url":"https://pokeapi.co/api/v2/move/221/"},{"name":"magnitude","url":"https://pokeapi.co/api/v2/move/222/"},{"name":"dynamic-punch","url":"https://pokeapi.co/api/v2/move/223/"},{"name":"megahorn","url":"https://pokeapi.co/api/v2/move/224/"},{"name":"dragon-breath","url":"https://pokeapi.co/api/v2/move/225/"},{"name":"baton-pass","url":"https://pokeapi.co/api/v2/move/226/"},{"name":"encore","url":"https://pokeapi.co/api/v2/move/227/"},{"name":"pursuit","url":"https://pokeapi.co/api/v2/move/228/"},{"name":"rapid-spin","url":"https://pokeapi.co/api/v2/move/229/"},{"name":"sweet-scent","url":"https://pokeapi.co/api/v2/move/230/"},{"name":"iron-tail","url":"https://pokeapi.co/api/v2/move/231/"},{"name":"metal-claw","url":"https://pokeapi.co/api/v2/move/232/"},{"name":"vital-throw","url":"https://pokeapi.co/api/v2/move/233/"},{"name":"morning-sun","url":"https://pokeapi.co/api/v2/move/234/"},{"name":"synthesis","url":"https://pokeapi.co/api/v2/move/235/"},{"name":"moonlight","url":"https://pokeapi.co/api/v2/move/236/"},{"name":"hidden-power","url":"https://pokeapi.co/api/v2/move/237/"},{"name":"cross-chop","url":"https://pokeapi.co/api/v2/move/238/"},{"name":"twister","url":"https://pokeapi.co/api/v2/move/239/"},{"name":"rain-dance","url":"https://pokeapi.co/api/v2/move/240/"},{"name":"sunny-day","url":"https://pokeapi.co/api/v2/move/241/"},{"name":"crunch","url":"https://pokeapi.co/api/v2/move/242/"},{"name":"mirror-coat","url":"https://pokeapi.co/api/v2/move/243/"},{"name":"psych-up","url":"https://pokeapi.co/api/v2/move/244/"},{"name":"extreme-speed","url":"https://pokeapi.co/api/v2/move/245/"},{"name":"ancient-power","url":"https://pokeapi.co/api/v2/move/246/"},{"name":"shadow-ball","url":"https://pokeapi.co/api/v2/move/247/"},{"name":"future-sight","url":"https://pokeapi.co/api/v2/move/248/"},{"name":"rock-smash","url":"https://pokeapi.co/api/v2/move/249/"},{"name":"whirlpool","url":"https://pokeapi.co/api/v2/move/250/"},{"name":"beat-up","url":"https://pokeapi.co/api/v2/move/251/"},{"name":"fake-out","url":"https://pokeapi.co/api/v2/move/252/"},{"name":"uproar","url":"https://pokeapi.co/api/v2/move/253/"},{"name":"stockpile","url":"https://pokeapi.co/api/v2/move/254/"},{"name":"spit-up","url":"https://pokeapi.co/api/v2/move/255/"},{"name":"swallow","url":"https://pokeapi.co/api/v2/move/256/"},{"name":"heat-wave","url":"https://pokeapi.co/api/v2/move/257/"},{"name":"hail","url":"https://pokeapi.co/api/v2/move/258/"},{"name":"torment","url":"https://pokeapi.co/api/v2/move/259/"},{"name":"flatter","url":"https://pokeapi.co/api/v2/move/260/"},{"name":"will-o-wisp","url":"https://pokeapi.co/api/v2/move/261/"},{"name":"memento","url":"https://pokeapi.co/api/v2/move/262/"},{"name":"facade","url":"https://pokeapi.co/api/v2/move/263/"},{"name":"focus-punch","url":"https://pokeapi.co/api/v2/move/264/"},{"name":"smelling-salts","url":"https://pokeapi.co/api/v2/move/265/"},{"name":"follow-me","url":"https://pokeapi.co/api/v2/move/266/"},{"name":"nature-power","url":"https://pokeapi.co/api/v2/move/267/"},{"name":"charge","url":"https://pokeapi.co/api/v2/move/268/"},{"name":"taunt","url":"https://pokeapi.co/api/v2/move/269/"},{"name":"helping-hand","url":"https://pokeapi.co/api/v2/move/270/"},{"name":"trick","url":"https://pokeapi.co/api/v2/move/271/"},{"name":"role-play","url":"https://pokeapi.co/api/v2/move/272/"},{"name":"wish","url":"https://pokeapi.co/api/v2/move/273/"},{"name":"assist","url":"https://pokeapi.co/api/v2/move/274/"},{"name":"ingrain","url":"https://pokeapi.co/api/v2/move/275/"},{"name":"superpower","url":"https://pokeapi.co/api/v2/move/276/"},{"name":"magic-coat","url":"https://pokeapi.co/api/v2/move/277/"},{"name":"recycle","url":"https://pokeapi.co/api/v2/move/278/"},{"name":"revenge","url":"https://pokeapi.co/api/v2/move/279/"},{"name":"brick-break","url":"https://pokeapi.co/api/v2/move/280/"},{"name":"yawn","url":"https://pokeapi.co/api/v2/move/281/"},{"name":"knock-off","url":"https://pokeapi.co/api/v2/move/282/"},{"name":"endeavor","url":"https://pokeapi.co/api/v2/move/283/"},{"name":"eruption","url":"https://pokeapi.co/api/v2/move/284/"},{"name":"skill-swap","url":"https://pokeapi.co/api/v2/move/285/"},{"name":"imprison","url":"https://pokeapi.co/api/v2/move/286/"},{"name":"refresh","url":"https://pokeapi.co/api/v2/move/287/"},{"name":"grudge","url":"https://pokeapi.co/api/v2/move/288/"},{"name":"snatch","url":"https://pokeapi.co/api/v2/move/289/"},{"name":"secret-power","url":"https://pokeapi.co/api/v2/move/290/"},{"name":"dive","url":"https://pokeapi.co/api/v2/move/291/"},{"name":"arm-thrust","url":"https://pokeapi.co/api/v2/move/292/"},{"name":"camouflage","url":"https://pokeapi.co/api/v2/move/293/"},{"name":"tail-glow","url":"https://pokeapi.co/api/v2/move/294/"},{"name":"luster-purge","url":"https://pokeapi.co/api/v2/move/295/"},{"name":"mist-ball","url":"https://pokeapi.co/api/v2/move/296/"},{"name":"feather-dance","url":"https://pokeapi.co/api/v2/move/297/"},{"name":"teeter-dance","url":"https://pokeapi.co/api/v2/move/298/"},{"name":"blaze-kick","url":"https://pokeapi.co/api/v2/move/299/"},{"name":"mud-sport","url":"https://pokeapi.co/api/v2/move/300/"},{"name":"ice-ball","url":"https://pokeapi.co/api/v2/move/301/"},{"name":"needle-arm","url":"https://pokeapi.co/api/v2/move/302/"},{"name":"slack-off","url":"https://pokeapi.co/api/v2/move/303/"},{"name":"hyper-voice","url":"https://pokeapi.co/api/v2/move/304/"},{"name":"poison-fang","url":"https://pokeapi.co/api/v2/move/305/"},{"name":"crush-claw","url":"https://pokeapi.co/api/v2/move/306/"},{"name":"blast-burn","url":"https://pokeapi.co/api/v2/move/307/"},{"name":"hydro-cannon","url":"https://pokeapi.co/api/v2/move/308/"},{"name":"meteor-mash","url":"https://pokeapi.co/api/v2/move/309/"},{"name":"astonish","url":"https://pokeapi.co/api/v2/move/310/"},{"name":"weather-ball","url":"https://pokeapi.co/api/v2/move/311/"},{"name":"aromatherapy","url":"https://pokeapi.co/api/v2/move/312/"},{"name":"fake-tears","url":"https://pokeapi.co/api/v2/move/313/"},{"name":"air-cutter","url":"https://pokeapi.co/api/v2/move/314/"},{"name":"overheat","url":"https://pokeapi.co/api/v2/move/315/"},{"name":"odor-sleuth","url":"https://pokeapi.co/api/v2/move/316/"},{"name":"rock-tomb","url":"https://pokeapi.co/api/v2/move/317/"},{"name":"silver-wind","url":"https://pokeapi.co/api/v2/move/318/"},{"name":"metal-sound","url":"https://pokeapi.co/api/v2/move/319/"},{"name":"grass-whistle","url":"https://pokeapi.co/api/v2/move/320/"},{"name":"tickle","url":"https://pokeapi.co/api/v2/move/321/"},{"name":"cosmic-power","url":"https://pokeapi.co/api/v2/move/322/"},{"name":"water-spout","url":"https://pokeapi.co/api/v2/move/323/"},{"name":"signal-beam","url":"https://pokeapi.co/api/v2/move/324/"},{"name":"shadow-punch","url":"https://pokeapi.co/api/v2/move/325/"},{"name":"extrasensory","url":"https://pokeapi.co/api/v2/move/326/"},{"name":"sky-uppercut","url":"https://pokeapi.co/api/v2/move/327/"},{"name":"sand-tomb","url":"https://pokeapi.co/api/v2/move/328/"},{"name":"sheer-cold","url":"https://pokeapi.co/api/v2/move/329/"},{"name":"muddy-water","url":"https://pokeapi.co/api/v2/move/330/"},{"name":"bullet-seed","url":"https://pokeapi.co/api/v2/move/331/"},{"name":"aerial-ace","url":"https://pokeapi.co/api/v2/move/332/"},{"name":"icicle-spear","url":"https://pokeapi.co/api/v2/move/333/"},{"name":"iron-defense","url":"https://pokeapi.co/api/v2/move/334/"},{"name":"block","url":"https://pokeapi.co/api/v2/move/335/"},{"name":"howl","url":"https://pokeapi.co/api/v2/move/336/"},{"name":"dragon-claw","url":"https://pokeapi.co/api/v2/move/337/"},{"name":"frenzy-plant","url":"https://pokeapi.co/api/v2/move/338/"},{"name":"bulk-up","url":"https://pokeapi.co/api/v2/move/339/"},{"name":"bounce","url":"https://pokeapi.co/api/v2/move/340/"},{"name":"mud-shot","url":"https://pokeapi.co/api/v2/move/341/"},{"name":"poison-tail","url":"https://pokeapi.co/api/v2/move/342/"},{"name":"covet","url":"https://pokeapi.co/api/v2/move/343/"},{"name":"volt-tackle","url":"https://pokeapi.co/api/v2/move/344/"},{"name":"magical-leaf","url":"https://pokeapi.co/api/v2/move/345/"},{"name":"water-sport","url":"https://pokeapi.co/api/v2/move/346/"},{"name":"calm-mind","url":"https://pokeapi.co/api/v2/move/347/"},{"name":"leaf-blade","url":"https://pokeapi.co/api/v2/move/348/"},{"name":"dragon-dance","url":"https://pokeapi.co/api/v2/move/349/"},{"name":"rock-blast","url":"https://pokeapi.co/api/v2/move/350/"},{"name":"shock-wave","url":"https://pokeapi.co/api/v2/move/351/"},{"name":"water-pulse","url":"https://pokeapi.co/api/v2/move/352/"},{"name":"doom-desire","url":"https://pokeapi.co/api/v2/move/353/"},{"name":"psycho-boost","url":"https://pokeapi.co/api/v2/move/354/"},{"name":"roost","url":"https://pokeapi.co/api/v2/move/355/"},{"name":"gravity","url":"https://pokeapi.co/api/v2/move/356/"},{"name":"miracle-eye","url":"https://pokeapi.co/api/v2/move/357/"},{"name":"wake-up-slap","url":"https://pokeapi.co/api/v2/move/358/"},{"name":"hammer-arm","url":"https://pokeapi.co/api/v2/move/359/"},{"name":"gyro-ball","url":"https://pokeapi.co/api/v2/move/360/"},{"name":"healing-wish","url":"https://pokeapi.co/api/v2/move/361/"},{"name":"brine","url":"https://pokeapi.co/api/v2/move/362/"},{"name":"natural-gift","url":"https://pokeapi.co/api/v2/move/363/"},{"name":"feint","url":"https://pokeapi.co/api/v2/move/364/"},{"name":"pluck","url":"https://pokeapi.co/api/v2/move/365/"},{"name":"tailwind","url":"https://pokeapi.co/api/v2/move/366/"},{"name":"acupressure","url":"https://pokeapi.co/api/v2/move/367/"},{"name":"metal-burst","url":"https://pokeapi.co/api/v2/move/368/"},{"name":"u-turn","url":"https://pokeapi.co/api/v2/move/369/"},{"name":"close-combat","url":"https://pokeapi.co/api/v2/move/370/"},{"name":"payback","url":"https://pokeapi.co/api/v2/move/371/"},{"name":"assurance","url":"https://pokeapi.co/api/v2/move/372/"},{"name":"embargo","url":"https://pokeapi.co/api/v2/move/373/"},{"name":"fling","url":"https://pokeapi.co/api/v2/move/374/"},{"name":"psycho-shift","url":"https://pokeapi.co/api/v2/move/375/"},{"name":"trump-card","url":"https://pokeapi.co/api/v2/move/376/"},{"name":"heal-block","url":"https://pokeapi.co/api/v2/move/377/"},{"name":"wring-out","url":"https://pokeapi.co/api/v2/move/378/"},{"name":"power-trick","url":"https://pokeapi.co/api/v2/move/379/"},{"name":"gastro-acid","url":"https://pokeapi.co/api/v2/move/380/"},{"name":"lucky-chant","url":"https://pokeapi.co/api/v2/move/381/"},{"name":"me-first","url":"https://pokeapi.co/api/v2/move/382/"},{"name":"copycat","url":"https://pokeapi.co/api/v2/move/383/"},{"name":"power-swap","url":"https://pokeapi.co/api/v2/move/384/"},{"name":"guard-swap","url":"https://pokeapi.co/api/v2/move/385/"},{"name":"punishment","url":"https://pokeapi.co/api/v2/move/386/"},{"name":"last-resort","url":"https://pokeapi.co/api/v2/move/387/"},{"name":"worry-seed","url":"https://pokeapi.co/api/v2/move/388/"},{"name":"sucker-punch","url":"https://pokeapi.co/api/v2/move/389/"},{"name":"toxic-spikes","url":"https://pokeapi.co/api/v2/move/390/"},{"name":"heart-swap","url":"https://pokeapi.co/api/v2/move/391/"},{"name":"aqua-ring","url":"https://pokeapi.co/api/v2/move/392/"},{"name":"magnet-rise","url":"https://pokeapi.co/api/v2/move/393/"},{"name":"flare-blitz","url":"https://pokeapi.co/api/v2/move/394/"},{"name":"force-palm","url":"https://pokeapi.co/api/v2/move/395/"},{"name":"aura-sphere","url":"https://pokeapi.co/api/v2/move/396/"},{"name":"rock-polish","url":"https://pokeapi.co/api/v2/move/397/"},{"name":"poison-jab","url":"https://pokeapi.co/api/v2/move/398/"},{"name":"dark-pulse","url":"https://pokeapi.co/api/v2/move/399/"},{"name":"night-slash","url":"https://pokeapi.co/api/v2/move/400/"},{"name":"aqua-tail","url":"https://pokeapi.co/api/v2/move/401/"},{"name":"seed-bomb","url":"https://pokeapi.co/api/v2/move/402/"},{"name":"air-slash","url":"https://pokeapi.co/api/v2/move/403/"},{"name":"x-scissor","url":"https://pokeapi.co/api/v2/move/404/"},{"name":"bug-buzz","url":"https://pokeapi.co/api/v2/move/405/"},{"name":"dragon-pulse","url":"https://pokeapi.co/api/v2/move/406/"},{"name":"dragon-rush","url":"https://pokeapi.co/api/v2/move/407/"},{"name":"power-gem","url":"https://pokeapi.co/api/v2/move/408/"},{"name":"drain-punch","url":"https://pokeapi.co/api/v2/move/409/"},{"name":"vacuum-wave","url":"https://pokeapi.co/api/v2/move/410/"},{"name":"focus-blast","url":"https://pokeapi.co/api/v2/move/411/"},{"name":"energy-ball","url":"https://pokeapi.co/api/v2/move/412/"},{"name":"brave-bird","url":"https://pokeapi.co/api/v2/move/413/"},{"name":"earth-power","url":"https://pokeapi.co/api/v2/move/414/"},{"name":"switcheroo","url":"https://pokeapi.co/api/v2/move/415/"},{"name":"giga-impact","url":"https://pokeapi.co/api/v2/move/416/"},{"name":"nasty-plot","url":"https://pokeapi.co/api/v2/move/417/"},{"name":"bullet-punch","url":"https://pokeapi.co/api/v2/move/418/"},{"name":"avalanche","url":"https://pokeapi.co/api/v2/move/419/"},{"name":"ice-shard","url":"https://pokeapi.co/api/v2/move/420/"},{"name":"shadow-claw","url":"https://pokeapi.co/api/v2/move/421/"},{"name":"thunder-fang","url":"https://pokeapi.co/api/v2/move/422/"},{"name":"ice-fang","url":"https://pokeapi.co/api/v2/move/423/"},{"name":"fire-fang","url":"https://pokeapi.co/api/v2/move/424/"},{"name":"shadow-sneak","url":"https://pokeapi.co/api/v2/move/425/"},{"name":"mud-bomb","url":"https://pokeapi.co/api/v2/move/426/"},{"name":"psycho-cut","url":"https://pokeapi.co/api/v2/move/427/"},{"name":"zen-headbutt","url":"https://pokeapi.co/api/v2/move/428/"},{"name":"mirror-shot","url":"https://pokeapi.co/api/v2/move/429/"},{"name":"flash-cannon","url":"https://pokeapi.co/api/v2/move/430/"},{"name":"rock-climb","url":"https://pokeapi.co/api/v2/move/431/"},{"name":"defog","url":"https://pokeapi.co/api/v2/move/432/"},{"name":"trick-room","url":"https://pokeapi.co/api/v2/move/433/"},{"name":"draco-meteor","url":"https://pokeapi.co/api/v2/move/434/"},{"name":"discharge","url":"https://pokeapi.co/api/v2/move/435/"},{"name":"lava-plume","url":"https://pokeapi.co/api/v2/move/436/"},{"name":"leaf-storm","url":"https://pokeapi.co/api/v2/move/437/"},{"name":"power-whip","url":"https://pokeapi.co/api/v2/move/438/"},{"name":"rock-wrecker","url":"https://pokeapi.co/api/v2/move/439/"},{"name":"cross-poison","url":"https://pokeapi.co/api/v2/move/440/"},{"name":"gunk-shot","url":"https://pokeapi.co/api/v2/move/441/"},{"name":"iron-head","url":"https://pokeapi.co/api/v2/move/442/"},{"name":"magnet-bomb","url":"https://pokeapi.co/api/v2/move/443/"},{"name":"stone-edge","url":"https://pokeapi.co/api/v2/move/444/"},{"name":"captivate","url":"https://pokeapi.co/api/v2/move/445/"},{"name":"stealth-rock","url":"https://pokeapi.co/api/v2/move/446/"},{"name":"grass-knot","url":"https://pokeapi.co/api/v2/move/447/"},{"name":"chatter","url":"https://pokeapi.co/api/v2/move/448/"},{"name":"judgment","url":"https://pokeapi.co/api/v2/move/449/"},{"name":"bug-bite","url":"https://pokeapi.co/api/v2/move/450/"},{"name":"charge-beam","url":"https://pokeapi.co/api/v2/move/451/"},{"name":"wood-hammer","url":"https://pokeapi.co/api/v2/move/452/"},{"name":"aqua-jet","url":"https://pokeapi.co/api/v2/move/453/"},{"name":"attack-order","url":"https://pokeapi.co/api/v2/move/454/"},{"name":"defend-order","url":"https://pokeapi.co/api/v2/move/455/"},{"name":"heal-order","url":"https://pokeapi.co/api/v2/move/456/"},{"name":"head-smash","url":"https://pokeapi.co/api/v2/move/457/"},{"name":"double-hit","url":"https://pokeapi.co/api/v2/move/458/"},{"name":"roar-of-time","url":"https://pokeapi.co/api/v2/move/459/"},{"name":"spacial-rend","url":"https://pokeapi.co/api/v2/move/460/"},{"name":"lunar-dance","url":"https://pokeapi.co/api/v2/move/461/"},{"name":"crush-grip","url":"https://pokeapi.co/api/v2/move/462/"},{"name":"magma-storm","url":"https://pokeapi.co/api/v2/move/463/"},{"name":"dark-void","url":"https://pokeapi.co/api/v2/move/464/"},{"name":"seed-flare","url":"https://pokeapi.co/api/v2/move/465/"},{"name":"ominous-wind","url":"https://pokeapi.co/api/v2/move/466/"},{"name":"shadow-force","url":"https://pokeapi.co/api/v2/move/467/"},{"name":"hone-claws","url":"https://pokeapi.co/api/v2/move/468/"},{"name":"wide-guard","url":"https://pokeapi.co/api/v2/move/469/"},{"name":"guard-split","url":"https://pokeapi.co/api/v2/move/470/"},{"name":"power-split","url":"https://pokeapi.co/api/v2/move/471/"},{"name":"wonder-room","url":"https://pokeapi.co/api/v2/move/472/"},{"name":"psyshock","url":"https://pokeapi.co/api/v2/move/473/"},{"name":"venoshock","url":"https://pokeapi.co/api/v2/move/474/"},{"name":"autotomize","url":"https://pokeapi.co/api/v2/move/475/"},{"name":"rage-powder","url":"https://pokeapi.co/api/v2/move/476/"},{"name":"telekinesis","url":"https://pokeapi.co/api/v2/move/477/"},{"name":"magic-room","url":"https://pokeapi.co/api/v2/move/478/"},{"name":"smack-down","url":"https://pokeapi.co/api/v2/move/479/"},{"name":"storm-throw","url":"https://pokeapi.co/api/v2/move/480/"},{"name":"flame-burst","url":"https://pokeapi.co/api/v2/move/481/"},{"name":"sludge-wave","url":"https://pokeapi.co/api/v2/move/482/"},{"name":"quiver-dance","url":"https://pokeapi.co/api/v2/move/483/"},{"name":"heavy-slam","url":"https://pokeapi.co/api/v2/move/484/"},{"name":"synchronoise","url":"https://pokeapi.co/api/v2/move/485/"},{"name":"electro-ball","url":"https://pokeapi.co/api/v2/move/486/"},{"name":"soak","url":"https://pokeapi.co/api/v2/move/487/"},{"name":"flame-charge","url":"https://pokeapi.co/api/v2/move/488/"},{"name":"coil","url":"https://pokeapi.co/api/v2/move/489/"},{"name":"low-sweep","url":"https://pokeapi.co/api/v2/move/490/"},{"name":"acid-spray","url":"https://pokeapi.co/api/v2/move/491/"},{"name":"foul-play","url":"https://pokeapi.co/api/v2/move/492/"},{"name":"simple-beam","url":"https://pokeapi.co/api/v2/move/493/"},{"name":"entrainment","url":"https://pokeapi.co/api/v2/move/494/"},{"name":"after-you","url":"https://pokeapi.co/api/v2/move/495/"},{"name":"round","url":"https://pokeapi.co/api/v2/move/496/"},{"name":"echoed-voice","url":"https://pokeapi.co/api/v2/move/497/"},{"name":"chip-away","url":"https://pokeapi.co/api/v2/move/498/"},{"name":"clear-smog","url":"https://pokeapi.co/api/v2/move/499/"},{"name":"stored-power","url":"https://pokeapi.co/api/v2/move/500/"},{"name":"quick-guard","url":"https://pokeapi.co/api/v2/move/501/"},{"name":"ally-switch","url":"https://pokeapi.co/api/v2/move/502/"},{"name":"scald","url":"https://pokeapi.co/api/v2/move/503/"},{"name":"shell-smash","url":"https://pokeapi.co/api/v2/move/504/"},{"name":"heal-pulse","url":"https://pokeapi.co/api/v2/move/505/"},{"name":"hex","url":"https://pokeapi.co/api/v2/move/506/"},{"name":"sky-drop","url":"https://pokeapi.co/api/v2/move/507/"},{"name":"shift-gear","url":"https://pokeapi.co/api/v2/move/508/"},{"name":"circle-throw","url":"https://pokeapi.co/api/v2/move/509/"},{"name":"incinerate","url":"https://pokeapi.co/api/v2/move/510/"},{"name":"quash","url":"https://pokeapi.co/api/v2/move/511/"},{"name":"acrobatics","url":"https://pokeapi.co/api/v2/move/512/"},{"name":"reflect-type","url":"https://pokeapi.co/api/v2/move/513/"},{"name":"retaliate","url":"https://pokeapi.co/api/v2/move/514/"},{"name":"final-gambit","url":"https://pokeapi.co/api/v2/move/515/"},{"name":"bestow","url":"https://pokeapi.co/api/v2/move/516/"},{"name":"inferno","url":"https://pokeapi.co/api/v2/move/517/"},{"name":"water-pledge","url":"https://pokeapi.co/api/v2/move/518/"},{"name":"fire-pledge","url":"https://pokeapi.co/api/v2/move/519/"},{"name":"grass-pledge","url":"https://pokeapi.co/api/v2/move/520/"},{"name":"volt-switch","url":"https://pokeapi.co/api/v2/move/521/"},{"name":"struggle-bug","url":"https://pokeapi.co/api/v2/move/522/"},{"name":"bulldoze","url":"https://pokeapi.co/api/v2/move/523/"},{"name":"frost-breath","url":"https://pokeapi.co/api/v2/move/524/"},{"name":"dragon-tail","url":"https://pokeapi.co/api/v2/move/525/"},{"name":"work-up","url":"https://pokeapi.co/api/v2/move/526/"},{"name":"electroweb","url":"https://pokeapi.co/api/v2/move/527/"},{"name":"wild-charge","url":"https://pokeapi.co/api/v2/move/528/"},{"name":"drill-run","url":"https://pokeapi.co/api/v2/move/529/"},{"name":"dual-chop","url":"https://pokeapi.co/api/v2/move/530/"},{"name":"heart-stamp","url":"https://pokeapi.co/api/v2/move/531/"},{"name":"horn-leech","url":"https://pokeapi.co/api/v2/move/532/"},{"name":"sacred-sword","url":"https://pokeapi.co/api/v2/move/533/"},{"name":"razor-shell","url":"https://pokeapi.co/api/v2/move/534/"},{"name":"heat-crash","url":"https://pokeapi.co/api/v2/move/535/"},{"name":"leaf-tornado","url":"https://pokeapi.co/api/v2/move/536/"},{"name":"steamroller","url":"https://pokeapi.co/api/v2/move/537/"},{"name":"cotton-guard","url":"https://pokeapi.co/api/v2/move/538/"},{"name":"night-daze","url":"https://pokeapi.co/api/v2/move/539/"},{"name":"psystrike","url":"https://pokeapi.co/api/v2/move/540/"},{"name":"tail-slap","url":"https://pokeapi.co/api/v2/move/541/"},{"name":"hurricane","url":"https://pokeapi.co/api/v2/move/542/"},{"name":"head-charge","url":"https://pokeapi.co/api/v2/move/543/"},{"name":"gear-grind","url":"https://pokeapi.co/api/v2/move/544/"},{"name":"searing-shot","url":"https://pokeapi.co/api/v2/move/545/"},{"name":"techno-blast","url":"https://pokeapi.co/api/v2/move/546/"},{"name":"relic-song","url":"https://pokeapi.co/api/v2/move/547/"},{"name":"secret-sword","url":"https://pokeapi.co/api/v2/move/548/"},{"name":"glaciate","url":"https://pokeapi.co/api/v2/move/549/"},{"name":"bolt-strike","url":"https://pokeapi.co/api/v2/move/550/"},{"name":"blue-flare","url":"https://pokeapi.co/api/v2/move/551/"},{"name":"fiery-dance","url":"https://pokeapi.co/api/v2/move/552/"},{"name":"freeze-shock","url":"https://pokeapi.co/api/v2/move/553/"},{"name":"ice-burn","url":"https://pokeapi.co/api/v2/move/554/"},{"name":"snarl","url":"https://pokeapi.co/api/v2/move/555/"},{"name":"icicle-crash","url":"https://pokeapi.co/api/v2/move/556/"},{"name":"v-create","url":"https://pokeapi.co/api/v2/move/557/"},{"name":"fusion-flare","url":"https://pokeapi.co/api/v2/move/558/"},{"name":"fusion-bolt","url":"https://pokeapi.co/api/v2/move/559/"},{"name":"flying-press","url":"https://pokeapi.co/api/v2/move/560/"},{"name":"mat-block","url":"https://pokeapi.co/api/v2/move/561/"},{"name":"belch","url":"https://pokeapi.co/api/v2/move/562/"},{"name":"rototiller","url":"https://pokeapi.co/api/v2/move/563/"},{"name":"sticky-web","url":"https://pokeapi.co/api/v2/move/564/"},{"name":"fell-stinger","url":"https://pokeapi.co/api/v2/move/565/"},{"name":"phantom-force","url":"https://pokeapi.co/api/v2/move/566/"},{"name":"trick-or-treat","url":"https://pokeapi.co/api/v2/move/567/"},{"name":"noble-roar","url":"https://pokeapi.co/api/v2/move/568/"},{"name":"ion-deluge","url":"https://pokeapi.co/api/v2/move/569/"},{"name":"parabolic-charge","url":"https://pokeapi.co/api/v2/move/570/"},{"name":"forests-curse","url":"https://pokeapi.co/api/v2/move/571/"},{"name":"petal-blizzard","url":"https://pokeapi.co/api/v2/move/572/"},{"name":"freeze-dry","url":"https://pokeapi.co/api/v2/move/573/"},{"name":"disarming-voice","url":"https://pokeapi.co/api/v2/move/574/"},{"name":"parting-shot","url":"https://pokeapi.co/api/v2/move/575/"},{"name":"topsy-turvy","url":"https://pokeapi.co/api/v2/move/576/"},{"name":"draining-kiss","url":"https://pokeapi.co/api/v2/move/577/"},{"name":"crafty-shield","url":"https://pokeapi.co/api/v2/move/578/"},{"name":"flower-shield","url":"https://pokeapi.co/api/v2/move/579/"},{"name":"grassy-terrain","url":"https://pokeapi.co/api/v2/move/580/"},{"name":"misty-terrain","url":"https://pokeapi.co/api/v2/move/581/"},{"name":"electrify","url":"https://pokeapi.co/api/v2/move/582/"},{"name":"play-rough","url":"https://pokeapi.co/api/v2/move/583/"},{"name":"fairy-wind","url":"https://pokeapi.co/api/v2/move/584/"},{"name":"moonblast","url":"https://pokeapi.co/api/v2/move/585/"},{"name":"boomburst","url":"https://pokeapi.co/api/v2/move/586/"},{"name":"fairy-lock","url":"https://pokeapi.co/api/v2/move/587/"},{"name":"kings-shield","url":"https://pokeapi.co/api/v2/move/588/"},{"name":"play-nice","url":"https://pokeapi.co/api/v2/move/589/"},{"name":"confide","url":"https://pokeapi.co/api/v2/move/590/"},{"name":"diamond-storm","url":"https://pokeapi.co/api/v2/move/591/"},{"name":"steam-eruption","url":"https://pokeapi.co/api/v2/move/592/"},{"name":"hyperspace-hole","url":"https://pokeapi.co/api/v2/move/593/"},{"name":"water-shuriken","url":"https://pokeapi.co/api/v2/move/594/"},{"name":"mystical-fire","url":"https://pokeapi.co/api/v2/move/595/"},{"name":"spiky-shield","url":"https://pokeapi.co/api/v2/move/596/"},{"name":"aromatic-mist","url":"https://pokeapi.co/api/v2/move/597/"},{"name":"eerie-impulse","url":"https://pokeapi.co/api/v2/move/598/"},{"name":"venom-drench","url":"https://pokeapi.co/api/v2/move/599/"},{"name":"powder","url":"https://pokeapi.co/api/v2/move/600/"},{"name":"geomancy","url":"https://pokeapi.co/api/v2/move/601/"},{"name":"magnetic-flux","url":"https://pokeapi.co/api/v2/move/602/"},{"name":"happy-hour","url":"https://pokeapi.co/api/v2/move/603/"},{"name":"electric-terrain","url":"https://pokeapi.co/api/v2/move/604/"},{"name":"dazzling-gleam","url":"https://pokeapi.co/api/v2/move/605/"},{"name":"celebrate","url":"https://pokeapi.co/api/v2/move/606/"},{"name":"hold-hands","url":"https://pokeapi.co/api/v2/move/607/"},{"name":"baby-doll-eyes","url":"https://pokeapi.co/api/v2/move/608/"},{"name":"nuzzle","url":"https://pokeapi.co/api/v2/move/609/"},{"name":"hold-back","url":"https://pokeapi.co/api/v2/move/610/"},{"name":"infestation","url":"https://pokeapi.co/api/v2/move/611/"},{"name":"power-up-punch","url":"https://pokeapi.co/api/v2/move/612/"},{"name":"oblivion-wing","url":"https://pokeapi.co/api/v2/move/613/"},{"name":"thousand-arrows","url":"https://pokeapi.co/api/v2/move/614/"},{"name":"thousand-waves","url":"https://pokeapi.co/api/v2/move/615/"},{"name":"lands-wrath","url":"https://pokeapi.co/api/v2/move/616/"},{"name":"light-of-ruin","url":"https://pokeapi.co/api/v2/move/617/"},{"name":"origin-pulse","url":"https://pokeapi.co/api/v2/move/618/"},{"name":"precipice-blades","url":"https://pokeapi.co/api/v2/move/619/"},{"name":"dragon-ascent","url":"https://pokeapi.co/api/v2/move/620/"},{"name":"hyperspace-fury","url":"https://pokeapi.co/api/v2/move/621/"},{"name":"breakneck-blitz--physical","url":"https://pokeapi.co/api/v2/move/622/"},{"name":"breakneck-blitz--special","url":"https://pokeapi.co/api/v2/move/623/"},{"name":"all-out-pummeling--physical","url":"https://pokeapi.co/api/v2/move/624/"},{"name":"all-out-pummeling--special","url":"https://pokeapi.co/api/v2/move/625/"},{"name":"supersonic-skystrike--physical","url":"https://pokeapi.co/api/v2/move/626/"},{"name":"supersonic-skystrike--special","url":"https://pokeapi.co/api/v2/move/627/"},{"name":"acid-downpour--physical","url":"https://pokeapi.co/api/v2/move/628/"},{"name":"acid-downpour--special","url":"https://pokeapi.co/api/v2/move/629/"},{"name":"tectonic-rage--physical","url":"https://pokeapi.co/api/v2/move/630/"},{"name":"tectonic-rage--special","url":"https://pokeapi.co/api/v2/move/631/"},{"name":"continental-crush--physical","url":"https://pokeapi.co/api/v2/move/632/"},{"name":"continental-crush--special","url":"https://pokeapi.co/api/v2/move/633/"},{"name":"savage-spin-out--physical","url":"https://pokeapi.co/api/v2/move/634/"},{"name":"savage-spin-out--special","url":"https://pokeapi.co/api/v2/move/635/"},{"name":"never-ending-nightmare--physical","url":"https://pokeapi.co/api/v2/move/636/"},{"name":"never-ending-nightmare--special","url":"https://pokeapi.co/api/v2/move/637/"},{"name":"corkscrew-crash--physical","url":"https://pokeapi.co/api/v2/move/638/"},{"name":"corkscrew-crash--special","url":"https://pokeapi.co/api/v2/move/639/"},{"name":"inferno-overdrive--physical","url":"https://pokeapi.co/api/v2/move/640/"},{"name":"inferno-overdrive--special","url":"https://pokeapi.co/api/v2/move/641/"},{"name":"hydro-vortex--physical","url":"https://pokeapi.co/api/v2/move/642/"},{"name":"hydro-vortex--special","url":"https://pokeapi.co/api/v2/move/643/"},{"name":"bloom-doom--physical","url":"https://pokeapi.co/api/v2/move/644/"},{"name":"bloom-doom--special","url":"https://pokeapi.co/api/v2/move/645/"},{"name":"gigavolt-havoc--physical","url":"https://pokeapi.co/api/v2/move/646/"},{"name":"gigavolt-havoc--special","url":"https://pokeapi.co/api/v2/move/647/"},{"name":"shattered-psyche--physical","url":"https://pokeapi.co/api/v2/move/648/"},{"name":"shattered-psyche--special","url":"https://pokeapi.co/api/v2/move/649/"},{"name":"subzero-slammer--physical","url":"https://pokeapi.co/api/v2/move/650/"},{"name":"subzero-slammer--special","url":"https://pokeapi.co/api/v2/move/651/"},{"name":"devastating-drake--physical","url":"https://pokeapi.co/api/v2/move/652/"},{"name":"devastating-drake--special","url":"https://pokeapi.co/api/v2/move/653/"},{"name":"black-hole-eclipse--physical","url":"https://pokeapi.co/api/v2/move/654/"},{"name":"black-hole-eclipse--special","url":"https://pokeapi.co/api/v2/move/655/"},{"name":"twinkle-tackle--physical","url":"https://pokeapi.co/api/v2/move/656/"},{"name":"twinkle-tackle--special","url":"https://pokeapi.co/api/v2/move/657/"},{"name":"catastropika","url":"https://pokeapi.co/api/v2/move/658/"},{"name":"shore-up","url":"https://pokeapi.co/api/v2/move/659/"},{"name":"first-impression","url":"https://pokeapi.co/api/v2/move/660/"},{"name":"baneful-bunker","url":"https://pokeapi.co/api/v2/move/661/"},{"name":"spirit-shackle","url":"https://pokeapi.co/api/v2/move/662/"},{"name":"darkest-lariat","url":"https://pokeapi.co/api/v2/move/663/"},{"name":"sparkling-aria","url":"https://pokeapi.co/api/v2/move/664/"},{"name":"ice-hammer","url":"https://pokeapi.co/api/v2/move/665/"},{"name":"floral-healing","url":"https://pokeapi.co/api/v2/move/666/"},{"name":"high-horsepower","url":"https://pokeapi.co/api/v2/move/667/"},{"name":"strength-sap","url":"https://pokeapi.co/api/v2/move/668/"},{"name":"solar-blade","url":"https://pokeapi.co/api/v2/move/669/"},{"name":"leafage","url":"https://pokeapi.co/api/v2/move/670/"},{"name":"spotlight","url":"https://pokeapi.co/api/v2/move/671/"},{"name":"toxic-thread","url":"https://pokeapi.co/api/v2/move/672/"},{"name":"laser-focus","url":"https://pokeapi.co/api/v2/move/673/"},{"name":"gear-up","url":"https://pokeapi.co/api/v2/move/674/"},{"name":"throat-chop","url":"https://pokeapi.co/api/v2/move/675/"},{"name":"pollen-puff","url":"https://pokeapi.co/api/v2/move/676/"},{"name":"anchor-shot","url":"https://pokeapi.co/api/v2/move/677/"},{"name":"psychic-terrain","url":"https://pokeapi.co/api/v2/move/678/"},{"name":"lunge","url":"https://pokeapi.co/api/v2/move/679/"},{"name":"fire-lash","url":"https://pokeapi.co/api/v2/move/680/"},{"name":"power-trip","url":"https://pokeapi.co/api/v2/move/681/"},{"name":"burn-up","url":"https://pokeapi.co/api/v2/move/682/"},{"name":"speed-swap","url":"https://pokeapi.co/api/v2/move/683/"},{"name":"smart-strike","url":"https://pokeapi.co/api/v2/move/684/"},{"name":"purify","url":"https://pokeapi.co/api/v2/move/685/"},{"name":"revelation-dance","url":"https://pokeapi.co/api/v2/move/686/"},{"name":"core-enforcer","url":"https://pokeapi.co/api/v2/move/687/"},{"name":"trop-kick","url":"https://pokeapi.co/api/v2/move/688/"},{"name":"instruct","url":"https://pokeapi.co/api/v2/move/689/"},{"name":"beak-blast","url":"https://pokeapi.co/api/v2/move/690/"},{"name":"clanging-scales","url":"https://pokeapi.co/api/v2/move/691/"},{"name":"dragon-hammer","url":"https://pokeapi.co/api/v2/move/692/"},{"name":"brutal-swing","url":"https://pokeapi.co/api/v2/move/693/"},{"name":"aurora-veil","url":"https://pokeapi.co/api/v2/move/694/"},{"name":"sinister-arrow-raid","url":"https://pokeapi.co/api/v2/move/695/"},{"name":"malicious-moonsault","url":"https://pokeapi.co/api/v2/move/696/"},{"name":"oceanic-operetta","url":"https://pokeapi.co/api/v2/move/697/"},{"name":"guardian-of-alola","url":"https://pokeapi.co/api/v2/move/698/"},{"name":"soul-stealing-7-star-strike","url":"https://pokeapi.co/api/v2/move/699/"},{"name":"stoked-sparksurfer","url":"https://pokeapi.co/api/v2/move/700/"},{"name":"pulverizing-pancake","url":"https://pokeapi.co/api/v2/move/701/"},{"name":"extreme-evoboost","url":"https://pokeapi.co/api/v2/move/702/"},{"name":"genesis-supernova","url":"https://pokeapi.co/api/v2/move/703/"},{"name":"shell-trap","url":"https://pokeapi.co/api/v2/move/704/"},{"name":"fleur-cannon","url":"https://pokeapi.co/api/v2/move/705/"},{"name":"psychic-fangs","url":"https://pokeapi.co/api/v2/move/706/"},{"name":"stomping-tantrum","url":"https://pokeapi.co/api/v2/move/707/"},{"name":"shadow-bone","url":"https://pokeapi.co/api/v2/move/708/"},{"name":"accelerock","url":"https://pokeapi.co/api/v2/move/709/"},{"name":"liquidation","url":"https://pokeapi.co/api/v2/move/710/"},{"name":"prismatic-laser","url":"https://pokeapi.co/api/v2/move/711/"},{"name":"spectral-thief","url":"https://pokeapi.co/api/v2/move/712/"},{"name":"sunsteel-strike","url":"https://pokeapi.co/api/v2/move/713/"},{"name":"moongeist-beam","url":"https://pokeapi.co/api/v2/move/714/"},{"name":"tearful-look","url":"https://pokeapi.co/api/v2/move/715/"},{"name":"zing-zap","url":"https://pokeapi.co/api/v2/move/716/"},{"name":"natures-madness","url":"https://pokeapi.co/api/v2/move/717/"},{"name":"multi-attack","url":"https://pokeapi.co/api/v2/move/718/"},{"name":"10-000-000-volt-thunderbolt","url":"https://pokeapi.co/api/v2/move/719/"},{"name":"mind-blown","url":"https://pokeapi.co/api/v2/move/720/"},{"name":"plasma-fists","url":"https://pokeapi.co/api/v2/move/721/"},{"name":"photon-geyser","url":"https://pokeapi.co/api/v2/move/722/"},{"name":"light-that-burns-the-sky","url":"https://pokeapi.co/api/v2/move/723/"},{"name":"searing-sunraze-smash","url":"https://pokeapi.co/api/v2/move/724/"},{"name":"menacing-moonraze-maelstrom","url":"https://pokeapi.co/api/v2/move/725/"},{"name":"lets-snuggle-forever","url":"https://pokeapi.co/api/v2/move/726/"},{"name":"splintered-stormshards","url":"https://pokeapi.co/api/v2/move/727/"},{"name":"clangorous-soulblaze","url":"https://pokeapi.co/api/v2/move/728/"},{"name":"shadow-rush","url":"https://pokeapi.co/api/v2/move/10001/"},{"name":"shadow-blast","url":"https://pokeapi.co/api/v2/move/10002/"},{"name":"shadow-blitz","url":"https://pokeapi.co/api/v2/move/10003/"},{"name":"shadow-bolt","url":"https://pokeapi.co/api/v2/move/10004/"},{"name":"shadow-break","url":"https://pokeapi.co/api/v2/move/10005/"},{"name":"shadow-chill","url":"https://pokeapi.co/api/v2/move/10006/"},{"name":"shadow-end","url":"https://pokeapi.co/api/v2/move/10007/"},{"name":"shadow-fire","url":"https://pokeapi.co/api/v2/move/10008/"},{"name":"shadow-rave","url":"https://pokeapi.co/api/v2/move/10009/"},{"name":"shadow-storm","url":"https://pokeapi.co/api/v2/move/10010/"},{"name":"shadow-wave","url":"https://pokeapi.co/api/v2/move/10011/"},{"name":"shadow-down","url":"https://pokeapi.co/api/v2/move/10012/"},{"name":"shadow-half","url":"https://pokeapi.co/api/v2/move/10013/"},{"name":"shadow-hold","url":"https://pokeapi.co/api/v2/move/10014/"},{"name":"shadow-mist","url":"https://pokeapi.co/api/v2/move/10015/"},{"name":"shadow-panic","url":"https://pokeapi.co/api/v2/move/10016/"},{"name":"shadow-shed","url":"https://pokeapi.co/api/v2/move/10017/"},{"name":"shadow-sky","url":"https://pokeapi.co/api/v2/move/10018/"}]}"#;

// https://pokeapi.co/api/v2/move-ailment/?offset=0&limit=9999
static FULL_MOVE_AILMENT_LIST_JSON: &str = r#"{"count":21,"next":null,"previous":null,"results":[{"name":"unknown","url":"https://pokeapi.co/api/v2/move-ailment/-1/"},{"name":"none","url":"https://pokeapi.co/api/v2/move-ailment/0/"},{"name":"paralysis","url":"https://pokeapi.co/api/v2/move-ailment/1/"},{"name":"sleep","url":"https://pokeapi.co/api/v2/move-ailment/2/"},{"name":"freeze","url":"https://pokeapi.co/api/v2/move-ailment/3/"},{"name":"burn","url":"https://pokeapi.co/api/v2/move-ailment/4/"},{"name":"poison","url":"https://pokeapi.co/api/v2/move-ailment/5/"},{"name":"confusion","url":"https://pokeapi.co/api/v2/move-ailment/6/"},{"name":"infatuation","url":"https://pokeapi.co/api/v2/move-ailment/7/"},{"name":"trap","url":"https://pokeapi.co/api/v2/move-ailment/8/"},{"name":"nightmare","url":"https://pokeapi.co/api/v2/move-ailment/9/"},{"name":"torment","url":"https://pokeapi.co/api/v2/move-ailment/12/"},{"name":"disable","url":"https://pokeapi.co/api/v2/move-ailment/13/"},{"name":"yawn","url":"https://pokeapi.co/api/v2/move-ailment/14/"},{"name":"heal-block","url":"https://pokeapi.co/api/v2/move-ailment/15/"},{"name":"no-type-immunity","url":"https://pokeapi.co/api/v2/move-ailment/17/"},{"name":"leech-seed","url":"https://pokeapi.co/api/v2/move-ailment/18/"},{"name":"embargo","url":"https://pokeapi.co/api/v2/move-ailment/19/"},{"name":"perish-song","url":"https://pokeapi.co/api/v2/move-ailment/20/"},{"name":"ingrain","url":"https://pokeapi.co/api/v2/move-ailment/21/"},{"name":"silence","url":"https://pokeapi.co/api/v2/move-ailment/24/"}]}"#;

// https://pokeapi.co/api/v2/move-battle-style/?offset=0&limit=9999
static FULL_MOVE_BATTLE_STYLE_LIST_JSON: &str = r#"{"count":3,"next":null,"previous":null,"results":[{"name":"attack","url":"https://pokeapi.co/api/v2/move-battle-style/1/"},{"name":"defense","url":"https://pokeapi.co/api/v2/move-battle-style/2/"},{"name":"support","url":"https://pokeapi.co/api/v2/move-battle-style/3/"}]}"#;

// https://pokeapi.co/api/v2/move-category/?offset=0&limit=9999
static FULL_MOVE_CATEGORY_LIST_JSON: &str = r#"{"count":14,"next":null,"previous":null,"results":[{"name":"damage","url":"https://pokeapi.co/api/v2/move-category/0/"},{"name":"ailment","url":"https://pokeapi.co/api/v2/move-category/1/"},{"name":"net-good-stats","url":"https://pokeapi.co/api/v2/move-category/2/"},{"name":"heal","url":"https://pokeapi.co/api/v2/move-category/3/"},{"name":"damage+ailment","url":"https://pokeapi.co/api/v2/move-category/4/"},{"name":"swagger","url":"https://pokeapi.co/api/v2/move-category/5/"},{"name":"damage+lower","url":"https://pokeapi.co/api/v2/move-category/6/"},{"name":"damage+raise","url":"https://pokeapi.co/api/v2/move-category/7/"},{"name":"damage+heal","url":"https://pokeapi.co/api/v2/move-category/8/"},{"name":"ohko","url":"https://pokeapi.co/api/v2/move-category/9/"},{"name":"whole-field-effect","url":"https://pokeapi.co/api/v2/move-category/10/"},{"name":"field-effect","url":"https://pokeapi.co/api/v2/move-category/11/"},{"name":"force-switch","url":"https://pokeapi.co/api/v2/move-category/12/"},{"name":"unique","url":"https://pokeapi.co/api/v2/move-category/13/"}]}"#;

// https://pokeapi.co/api/v2/move-damage-class/?offset=0&limit=9999
static FULL_MOVE_DAMAGE_CLASS_LIST_JSON: &str = r#"{"count":3,"next":null,"previous":null,"results":[{"name":"status","url":"https://pokeapi.co/api/v2/move-damage-class/1/"},{"name":"physical","url":"https://pokeapi.co/api/v2/move-damage-class/2/"},{"name":"special","url":"https://pokeapi.co/api/v2/move-damage-class/3/"}]}"#;

// https://pokeapi.co/api/v2/move-learn-method/?offset=0&limit=9999
static FULL_MOVE_LEARN_METHOD_LIST_JSON: &str = r#"{"count":10,"next":null,"previous":null,"results":[{"name":"level-up","url":"https://pokeapi.co/api/v2/move-learn-method/1/"},{"name":"egg","url":"https://pokeapi.co/api/v2/move-learn-method/2/"},{"name":"tutor","url":"https://pokeapi.co/api/v2/move-learn-method/3/"},{"name":"machine","url":"https://pokeapi.co/api/v2/move-learn-method/4/"},{"name":"stadium-surfing-pikachu","url":"https://pokeapi.co/api/v2/move-learn-method/5/"},{"name":"light-ball-egg","url":"https://pokeapi.co/api/v2/move-learn-method/6/"},{"name":"colosseum-purification","url":"https://pokeapi.co/api/v2/move-learn-method/7/"},{"name":"xd-shadow","url":"https://pokeapi.co/api/v2/move-learn-method/8/"},{"name":"xd-purification","url":"https://pokeapi.co/api/v2/move-learn-method/9/"},{"name":"form-change","url":"https://pokeapi.co/api/v2/move-learn-method/10/"}]}"#;

// https://pokeapi.co/api/v2/move-target/?offset=0&limit=9999
static FULL_MOVE_TARGET_LIST_JSON: &str = r#"{"count":14,"next":null,"previous":null,"results":[{"name":"specific-move","url":"https://pokeapi.co/api/v2/move-target/1/"},{"name":"selected-pokemon-me-first","url":"https://pokeapi.co/api/v2/move-target/2/"},{"name":"ally","url":"https://pokeapi.co/api/v2/move-target/3/"},{"name":"users-field","url":"https://pokeapi.co/api/v2/move-target/4/"},{"name":"user-or-ally","url":"https://pokeapi.co/api/v2/move-target/5/"},{"name":"opponents-field","url":"https://pokeapi.co/api/v2/move-target/6/"},{"name":"user","url":"https://pokeapi.co/api/v2/move-target/7/"},{"name":"random-opponent","url":"https://pokeapi.co/api/v2/move-target/8/"},{"name":"all-other-pokemon","url":"https://pokeapi.co/api/v2/move-target/9/"},{"name":"selected-pokemon","url":"https://pokeapi.co/api/v2/move-target/10/"},{"name":"all-opponents","url":"https://pokeapi.co/api/v2/move-target/11/"},{"name":"entire-field","url":"https://pokeapi.co/api/v2/move-target/12/"},{"name":"user-and-allies","url":"https://pokeapi.co/api/v2/move-target/13/"},{"name":"all-pokemon","url":"https://pokeapi.co/api/v2/move-target/14/"}]}"#;

// https://pokeapi.co/api/v2/nature/?offset=0&limit=9999
static FULL_NATURE_LIST_JSON: &str = r#"{"count":25,"next":null,"previous":null,"results":[{"name":"hardy","url":"https://pokeapi.co/api/v2/nature/1/"},{"name":"bold","url":"https://pokeapi.co/api/v2/nature/2/"},{"name":"modest","url":"https://pokeapi.co/api/v2/nature/3/"},{"name":"calm","url":"https://pokeapi.co/api/v2/nature/4/"},{"name":"timid","url":"https://pokeapi.co/api/v2/nature/5/"},{"name":"lonely","url":"https://pokeapi.co/api/v2/nature/6/"},{"name":"docile","url":"https://pokeapi.co/api/v2/nature/7/"},{"name":"mild","url":"https://pokeapi.co/api/v2/nature/8/"},{"name":"gentle","url":"https://pokeapi.co/api/v2/nature/9/"},{"name":"hasty","url":"https://pokeapi.co/api/v2/nature/10/"},{"name":"adamant","url":"https://pokeapi.co/api/v2/nature/11/"},{"name":"impish","url":"https://pokeapi.co/api/v2/nature/12/"},{"name":"bashful","url":"https://pokeapi.co/api/v2/nature/13/"},{"name":"careful","url":"https://pokeapi.co/api/v2/nature/14/"},{"name":"rash","url":"https://pokeapi.co/api/v2/nature/15/"},{"name":"jolly","url":"https://pokeapi.co/api/v2/nature/16/"},{"name":"naughty","url":"https://pokeapi.co/api/v2/nature/17/"},{"name":"lax","url":"https://pokeapi.co/api/v2/nature/18/"},{"name":"quirky","url":"https://pokeapi.co/api/v2/nature/19/"},{"name":"naive","url":"https://pokeapi.co/api/v2/nature/20/"},{"name":"brave","url":"https://pokeapi.co/api/v2/nature/21/"},{"name":"relaxed","url":"https://pokeapi.co/api/v2/nature/22/"},{"name":"quiet","url":"https://pokeapi.co/api/v2/nature/23/"},{"name":"sassy","url":"https://pokeapi.co/api/v2/nature/24/"},{"name":"serious","url":"https://pokeapi.co/api/v2/nature/25/"}]}"#;

// https://pokeapi.co/api/v2/pal-park-area/?offset=0&limit=9999
static FULL_PAL_PARK_AREA_LIST_JSON: &str = r#"{"count":5,"next":null,"previous":null,"results":[{"name":"forest","url":"https://pokeapi.co/api/v2/pal-park-area/1/"},{"name":"field","url":"https://pokeapi.co/api/v2/pal-park-area/2/"},{"name":"mountain","url":"https://pokeapi.co/api/v2/pal-park-area/3/"},{"name":"pond","url":"https://pokeapi.co/api/v2/pal-park-area/4/"},{"name":"sea","url":"https://pokeapi.co/api/v2/pal-park-area/5/"}]}"#;

// https://pokeapi.co/api/v2/pokeathlon-stat/?offset=0&limit=9999
static FULL_POKEATHLON_STAT_LIST_JSON: &str = r#"{"count":5,"next":null,"previous":null,"results":[{"name":"speed","url":"https://pokeapi.co/api/v2/pokeathlon-stat/1/"},{"name":"power","url":"https://pokeapi.co/api/v2/pokeathlon-stat/2/"},{"name":"skill","url":"https://pokeapi.co/api/v2/pokeathlon-stat/3/"},{"name":"stamina","url":"https://pokeapi.co/api/v2/pokeathlon-stat/4/"},{"name":"jump","url":"https://pokeapi.co/api/v2/pokeathlon-stat/5/"}]}"#;

// https://pokeapi.co/api/v2/pokedex/?offset=0&limit=9999
static FULL_POKEDEX_LIST_JSON: &str = r#"{"count":14,"next":null,"previous":null,"results":[{"name":"national","url":"https://pokeapi.co/api/v2/pokedex/1/"},{"name":"kanto","url":"https://pokeapi.co/api/v2/pokedex/2/"},{"name":"original-johto","url":"https://pokeapi.co/api/v2/pokedex/3/"},{"name":"hoenn","url":"https://pokeapi.co/api/v2/pokedex/4/"},{"name":"original-sinnoh","url":"https://pokeapi.co/api/v2/pokedex/5/"},{"name":"extended-sinnoh","url":"https://pokeapi.co/api/v2/pokedex/6/"},{"name":"updated-johto","url":"https://pokeapi.co/api/v2/pokedex/7/"},{"name":"original-unova","url":"https://pokeapi.co/api/v2/pokedex/8/"},{"name":"updated-unova","url":"https://pokeapi.co/api/v2/pokedex/9/"},{"name":"conquest-gallery","url":"https://pokeapi.co/api/v2/pokedex/11/"},{"name":"kalos-central","url":"https://pokeapi.co/api/v2/pokedex/12/"},{"name":"kalos-coastal","url":"https://pokeapi.co/api/v2/pokedex/13/"},{"name":"kalos-mountain","url":"https://pokeapi.co/api/v2/pokedex/14/"},{"name":"updated-hoenn","url":"https://pokeapi.co/api/v2/pokedex/15/"}]}"#;

// https://pokeapi.co/api/v2/pokemon/?offset=0&limit=9999
static FULL_POKEMON_LIST_JSON: &str = r#"{"count":964,"next":null,"previous":null,"results":[{"name":"bulbasaur","url":"https://pokeapi.co/api/v2/pokemon/1/"},{"name":"ivysaur","url":"https://pokeapi.co/api/v2/pokemon/2/"},{"name":"venusaur","url":"https://pokeapi.co/api/v2/pokemon/3/"},{"name":"charmander","url":"https://pokeapi.co/api/v2/pokemon/4/"},{"name":"charmeleon","url":"https://pokeapi.co/api/v2/pokemon/5/"},{"name":"charizard","url":"https://pokeapi.co/api/v2/pokemon/6/"},{"name":"squirtle","url":"https://pokeapi.co/api/v2/pokemon/7/"},{"name":"wartortle","url":"https://pokeapi.co/api/v2/pokemon/8/"},{"name":"blastoise","url":"https://pokeapi.co/api/v2/pokemon/9/"},{"name":"caterpie","url":"https://pokeapi.co/api/v2/pokemon/10/"},{"name":"metapod","url":"https://pokeapi.co/api/v2/pokemon/11/"},{"name":"butterfree","url":"https://pokeapi.co/api/v2/pokemon/12/"},{"name":"weedle","url":"https://pokeapi.co/api/v2/pokemon/13/"},{"name":"kakuna","url":"https://pokeapi.co/api/v2/pokemon/14/"},{"name":"beedrill","url":"https://pokeapi.co/api/v2/pokemon/15/"},{"name":"pidgey","url":"https://pokeapi.co/api/v2/pokemon/16/"},{"name":"pidgeotto","url":"https://pokeapi.co/api/v2/pokemon/17/"},{"name":"pidgeot","url":"https://pokeapi.co/api/v2/pokemon/18/"},{"name":"rattata","url":"https://pokeapi.co/api/v2/pokemon/19/"},{"name":"raticate","url":"https://pokeapi.co/api/v2/pokemon/20/"},{"name":"spearow","url":"https://pokeapi.co/api/v2/pokemon/21/"},{"name":"fearow","url":"https://pokeapi.co/api/v2/pokemon/22/"},{"name":"ekans","url":"https://pokeapi.co/api/v2/pokemon/23/"},{"name":"arbok","url":"https://pokeapi.co/api/v2/pokemon/24/"},{"name":"pikachu","url":"https://pokeapi.co/api/v2/pokemon/25/"},{"name":"raichu","url":"https://pokeapi.co/api/v2/pokemon/26/"},{"name":"sandshrew","url":"https://pokeapi.co/api/v2/pokemon/27/"},{"name":"sandslash","url":"https://pokeapi.co/api/v2/pokemon/28/"},{"name":"nidoran-f","url":"https://pokeapi.co/api/v2/pokemon/29/"},{"name":"nidorina","url":"https://pokeapi.co/api/v2/pokemon/30/"},{"name":"nidoqueen","url":"https://pokeapi.co/api/v2/pokemon/31/"},{"name":"nidoran-m","url":"https://pokeapi.co/api/v2/pokemon/32/"},{"name":"nidorino","url":"https://pokeapi.co/api/v2/pokemon/33/"},{"name":"nidoking","url":"https://pokeapi.co/api/v2/pokemon/34/"},{"name":"clefairy","url":"https://pokeapi.co/api/v2/pokemon/35/"},{"name":"clefable","url":"https://pokeapi.co/api/v2/pokemon/36/"},{"name":"vulpix","url":"https://pokeapi.co/api/v2/pokemon/37/"},{"name":"ninetales","url":"https://pokeapi.co/api/v2/pokemon/38/"},{"name":"jigglypuff","url":"https://pokeapi.co/api/v2/pokemon/39/"},{"name":"wigglytuff","url":"https://pokeapi.co/api/v2/pokemon/40/"},{"name":"zubat","url":"https://pokeapi.co/api/v2/pokemon/41/"},{"name":"golbat","url":"https://pokeapi.co/api/v2/pokemon/42/"},{"name":"oddish","url":"https://pokeapi.co/api/v2/pokemon/43/"},{"name":"gloom","url":"https://pokeapi.co/api/v2/pokemon/44/"},{"name":"vileplume","url":"https://pokeapi.co/api/v2/pokemon/45/"},{"name":"paras","url":"https://pokeapi.co/api/v2/pokemon/46/"},{"name":"parasect","url":"https://pokeapi.co/api/v2/pokemon/47/"},{"name":"venonat","url":"https://pokeapi.co/api/v2/pokemon/48/"},{"name":"venomoth","url":"https://pokeapi.co/api/v2/pokemon/49/"},{"name":"diglett","url":"https://pokeapi.co/api/v2/pokemon/50/"},{"name":"dugtrio","url":"https://pokeapi.co/api/v2/pokemon/51/"},{"name":"meowth","url":"https://pokeapi.co/api/v2/pokemon/52/"},{"name":"persian","url":"https://pokeapi.co/api/v2/pokemon/53/"},{"name":"psyduck","url":"https://pokeapi.co/api/v2/pokemon/54/"},{"name":"golduck","url":"https://pokeapi.co/api/v2/pokemon/55/"},{"name":"mankey","url":"https://pokeapi.co/api/v2/pokemon/56/"},{"name":"primeape","url":"https://pokeapi.co/api/v2/pokemon/57/"},{"name":"growlithe","url":"https://pokeapi.co/api/v2/pokemon/58/"},{"name":"arcanine","url":"https://pokeapi.co/api/v2/pokemon/59/"},{"name":"poliwag","url":"https://pokeapi.co/api/v2/pokemon/60/"},{"name":"poliwhirl","url":"https://pokeapi.co/api/v2/pokemon/61/"},{"name":"poliwrath","url":"https://pokeapi.co/api/v2/pokemon/62/"},{"name":"abra","url":"https://pokeapi.co/api/v2/pokemon/63/"},{"name":"kadabra","url":"https://pokeapi.co/api/v2/pokemon/64/"},{"name":"alakazam","url":"https://pokeapi.co/api/v2/pokemon/65/"},{"name":"machop","url":"https://pokeapi.co/api/v2/pokemon/66/"},{"name":"machoke","url":"https://pokeapi.co/api/v2/pokemon/67/"},{"name":"machamp","url":"https://pokeapi.co/api/v2/pokemon/68/"},{"name":"bellsprout","url":"https://pokeapi.co/api/v2/pokemon/69/"},{"name":"weepinbell","url":"https://pokeapi.co/api/v2/pokemon/70/"},{"name":"victreebel","url":"https://pokeapi.co/api/v2/pokemon/71/"},{"name":"tentacool","url":"https://pokeapi.co/api/v2/pokemon/72/"},{"name":"tentacruel","url":"https://pokeapi.co/api/v2/pokemon/73/"},{"name":"geodude","url":"https://pokeapi.co/api/v2/pokemon/74/"},{"name":"graveler","url":"https://pokeapi.co/api/v2/pokemon/75/"},{"name":"golem","url":"https://pokeapi.co/api/v2/pokemon/76/"},{"name":"ponyta","url":"https://pokeapi.co/api/v2/pokemon/77/"},{"name":"rapidash","url":"https://pokeapi.co/api/v2/pokemon/78/"},{"name":"slowpoke","url":"https://pokeapi.co/api/v2/pokemon/79/"},{"name":"slowbro","url":"https://pokeapi.co/api/v2/pokemon/80/"},{"name":"magnemite","url":"https://pokeapi.co/api/v2/pokemon/81/"},{"name":"magneton","url":"https://pokeapi.co/api/v2/pokemon/82/"},{"name":"farfetchd","url":"https://pokeapi.co/api/v2/pokemon/83/"},{"name":"doduo","url":"https://pokeapi.co/api/v2/pokemon/84/"},{"name":"dodrio","url":"https://pokeapi.co/api/v2/pokemon/85/"},{"name":"seel","url":"https://pokeapi.co/api/v2/pokemon/86/"},{"name":"dewgong","url":"https://pokeapi.co/api/v2/pokemon/87/"},{"name":"grimer","url":"https://pokeapi.co/api/v2/pokemon/88/"},{"name":"muk","url":"https://pokeapi.co/api/v2/pokemon/89/"},{"name":"shellder","url":"https://pokeapi.co/api/v2/pokemon/90/"},{"name":"cloyster","url":"https://pokeapi.co/api/v2/pokemon/91/"},{"name":"gastly","url":"https://pokeapi.co/api/v2/pokemon/92/"},{"name":"haunter","url":"https://pokeapi.co/api/v2/pokemon/93/"},{"name":"gengar","url":"https://pokeapi.co/api/v2/pokemon/94/"},{"name":"onix","url":"https://pokeapi.co/api/v2/pokemon/95/"},{"name":"drowzee","url":"https://pokeapi.co/api/v2/pokemon/96/"},{"name":"hypno","url":"https://pokeapi.co/api/v2/pokemon/97/"},{"name":"krabby","url":"https://pokeapi.co/api/v2/pokemon/98/"},{"name":"kingler","url":"https://pokeapi.co/api/v2/pokemon/99/"},{"name":"voltorb","url":"https://pokeapi.co/api/v2/pokemon/100/"},{"name":"electrode","url":"https://pokeapi.co/api/v2/pokemon/101/"},{"name":"exeggcute","url":"https://pokeapi.co/api/v2/pokemon/102/"},{"name":"exeggutor","url":"https://pokeapi.co/api/v2/pokemon/103/"},{"name":"cubone","url":"https://pokeapi.co/api/v2/pokemon/104/"},{"name":"marowak","url":"https://pokeapi.co/api/v2/pokemon/105/"},{"name":"hitmonlee","url":"https://pokeapi.co/api/v2/pokemon/106/"},{"name":"hitmonchan","url":"https://pokeapi.co/api/v2/pokemon/107/"},{"name":"lickitung","url":"https://pokeapi.co/api/v2/pokemon/108/"},{"name":"koffing","url":"https://pokeapi.co/api/v2/pokemon/109/"},{"name":"weezing","url":"https://pokeapi.co/api/v2/pokemon/110/"},{"name":"rhyhorn","url":"https://pokeapi.co/api/v2/pokemon/111/"},{"name":"rhydon","url":"https://pokeapi.co/api/v2/pokemon/112/"},{"name":"chansey","url":"https://pokeapi.co/api/v2/pokemon/113/"},{"name":"tangela","url":"https://pokeapi.co/api/v2/pokemon/114/"},{"name":"kangaskhan","url":"https://pokeapi.co/api/v2/pokemon/115/"},{"name":"horsea","url":"https://pokeapi.co/api/v2/pokemon/116/"},{"name":"seadra","url":"https://pokeapi.co/api/v2/pokemon/117/"},{"name":"goldeen","url":"https://pokeapi.co/api/v2/pokemon/118/"},{"name":"seaking","url":"https://pokeapi.co/api/v2/pokemon/119/"},{"name":"staryu","url":"https://pokeapi.co/api/v2/pokemon/120/"},{"name":"starmie","url":"https://pokeapi.co/api/v2/pokemon/121/"},{"name":"mr-mime","url":"https://pokeapi.co/api/v2/pokemon/122/"},{"name":"scyther","url":"https://pokeapi.co/api/v2/pokemon/123/"},{"name":"jynx","url":"https://pokeapi.co/api/v2/pokemon/124/"},{"name":"electabuzz","url":"https://pokeapi.co/api/v2/pokemon/125/"},{"name":"magmar","url":"https://pokeapi.co/api/v2/pokemon/126/"},{"name":"pinsir","url":"https://pokeapi.co/api/v2/pokemon/127/"},{"name":"tauros","url":"https://pokeapi.co/api/v2/pokemon/128/"},{"name":"magikarp","url":"https://pokeapi.co/api/v2/pokemon/129/"},{"name":"gyarados","url":"https://pokeapi.co/api/v2/pokemon/130/"},{"name":"lapras","url":"https://pokeapi.co/api/v2/pokemon/131/"},{"name":"ditto","url":"https://pokeapi.co/api/v2/pokemon/132/"},{"name":"eevee","url":"https://pokeapi.co/api/v2/pokemon/133/"},{"name":"vaporeon","url":"https://pokeapi.co/api/v2/pokemon/134/"},{"name":"jolteon","url":"https://pokeapi.co/api/v2/pokemon/135/"},{"name":"flareon","url":"https://pokeapi.co/api/v2/pokemon/136/"},{"name":"porygon","url":"https://pokeapi.co/api/v2/pokemon/137/"},{"name":"omanyte","url":"https://pokeapi.co/api/v2/pokemon/138/"},{"name":"omastar","url":"https://pokeapi.co/api/v2/pokemon/139/"},{"name":"kabuto","url":"https://pokeapi.co/api/v2/pokemon/140/"},{"name":"kabutops","url":"https://pokeapi.co/api/v2/pokemon/141/"},{"name":"aerodactyl","url":"https://pokeapi.co/api/v2/pokemon/142/"},{"name":"snorlax","url":"https://pokeapi.co/api/v2/pokemon/143/"},{"name":"articuno","url":"https://pokeapi.co/api/v2/pokemon/144/"},{"name":"zapdos","url":"https://pokeapi.co/api/v2/pokemon/145/"},{"name":"moltres","url":"https://pokeapi.co/api/v2/pokemon/146/"},{"name":"dratini","url":"https://pokeapi.co/api/v2/pokemon/147/"},{"name":"dragonair","url":"https://pokeapi.co/api/v2/pokemon/148/"},{"name":"dragonite","url":"https://pokeapi.co/api/v2/pokemon/149/"},{"name":"mewtwo","url":"https://pokeapi.co/api/v2/pokemon/150/"},{"name":"mew","url":"https://pokeapi.co/api/v2/pokemon/151/"},{"name":"chikorita","url":"https://pokeapi.co/api/v2/pokemon/152/"},{"name":"bayleef","url":"https://pokeapi.co/api/v2/pokemon/153/"},{"name":"meganium","url":"https://pokeapi.co/api/v2/pokemon/154/"},{"name":"cyndaquil","url":"https://pokeapi.co/api/v2/pokemon/155/"},{"name":"quilava","url":"https://pokeapi.co/api/v2/pokemon/156/"},{"name":"typhlosion","url":"https://pokeapi.co/api/v2/pokemon/157/"},{"name":"totodile","url":"https://pokeapi.co/api/v2/pokemon/158/"},{"name":"croconaw","url":"https://pokeapi.co/api/v2/pokemon/159/"},{"name":"feraligatr","url":"https://pokeapi.co/api/v2/pokemon/160/"},{"name":"sentret","url":"https://pokeapi.co/api/v2/pokemon/161/"},{"name":"furret","url":"https://pokeapi.co/api/v2/pokemon/162/"},{"name":"hoothoot","url":"https://pokeapi.co/api/v2/pokemon/163/"},{"name":"noctowl","url":"https://pokeapi.co/api/v2/pokemon/164/"},{"name":"ledyba","url":"https://pokeapi.co/api/v2/pokemon/165/"},{"name":"ledian","url":"https://pokeapi.co/api/v2/pokemon/166/"},{"name":"spinarak","url":"https://pokeapi.co/api/v2/pokemon/167/"},{"name":"ariados","url":"https://pokeapi.co/api/v2/pokemon/168/"},{"name":"crobat","url":"https://pokeapi.co/api/v2/pokemon/169/"},{"name":"chinchou","url":"https://pokeapi.co/api/v2/pokemon/170/"},{"name":"lanturn","url":"https://pokeapi.co/api/v2/pokemon/171/"},{"name":"pichu","url":"https://pokeapi.co/api/v2/pokemon/172/"},{"name":"cleffa","url":"https://pokeapi.co/api/v2/pokemon/173/"},{"name":"igglybuff","url":"https://pokeapi.co/api/v2/pokemon/174/"},{"name":"togepi","url":"https://pokeapi.co/api/v2/pokemon/175/"},{"name":"togetic","url":"https://pokeapi.co/api/v2/pokemon/176/"},{"name":"natu","url":"https://pokeapi.co/api/v2/pokemon/177/"},{"name":"xatu","url":"https://pokeapi.co/api/v2/pokemon/178/"},{"name":"mareep","url":"https://pokeapi.co/api/v2/pokemon/179/"},{"name":"flaaffy","url":"https://pokeapi.co/api/v2/pokemon/180/"},{"name":"ampharos","url":"https://pokeapi.co/api/v2/pokemon/181/"},{"name":"bellossom","url":"https://pokeapi.co/api/v2/pokemon/182/"},{"name":"marill","url":"https://pokeapi.co/api/v2/pokemon/183/"},{"name":"azumarill","url":"https://pokeapi.co/api/v2/pokemon/184/"},{"name":"sudowoodo","url":"https://pokeapi.co/api/v2/pokemon/185/"},{"name":"politoed","url":"https://pokeapi.co/api/v2/pokemon/186/"},{"name":"hoppip","url":"https://pokeapi.co/api/v2/pokemon/187/"},{"name":"skiploom","url":"https://pokeapi.co/api/v2/pokemon/188/"},{"name":"jumpluff","url":"https://pokeapi.co/api/v2/pokemon/189/"},{"name":"aipom","url":"https://pokeapi.co/api/v2/pokemon/190/"},{"name":"sunkern","url":"https://pokeapi.co/api/v2/pokemon/191/"},{"name":"sunflora","url":"https://pokeapi.co/api/v2/pokemon/192/"},{"name":"yanma","url":"https://pokeapi.co/api/v2/pokemon/193/"},{"name":"wooper","url":"https://pokeapi.co/api/v2/pokemon/194/"},{"name":"quagsire","url":"https://pokeapi.co/api/v2/pokemon/195/"},{"name":"espeon","url":"https://pokeapi.co/api/v2/pokemon/196/"},{"name":"umbreon","url":"https://pokeapi.co/api/v2/pokemon/197/"},{"name":"murkrow","url":"https://pokeapi.co/api/v2/pokemon/198/"},{"name":"slowking","url":"https://pokeapi.co/api/v2/pokemon/199/"},{"name":"misdreavus","url":"https://pokeapi.co/api/v2/pokemon/200/"},{"name":"unown","url":"https://pokeapi.co/api/v2/pokemon/201/"},{"name":"wobbuffet","url":"https://pokeapi.co/api/v2/pokemon/202/"},{"name":"girafarig","url":"https://pokeapi.co/api/v2/pokemon/203/"},{"name":"pineco","url":"https://pokeapi.co/api/v2/pokemon/204/"},{"name":"forretress","url":"https://pokeapi.co/api/v2/pokemon/205/"},{"name":"dunsparce","url":"https://pokeapi.co/api/v2/pokemon/206/"},{"name":"gligar","url":"https://pokeapi.co/api/v2/pokemon/207/"},{"name":"steelix","url":"https://pokeapi.co/api/v2/pokemon/208/"},{"name":"snubbull","url":"https://pokeapi.co/api/v2/pokemon/209/"},{"name":"granbull","url":"https://pokeapi.co/api/v2/pokemon/210/"},{"name":"qwilfish","url":"https://pokeapi.co/api/v2/pokemon/211/"},{"name":"scizor","url":"https://pokeapi.co/api/v2/pokemon/212/"},{"name":"shuckle","url":"https://pokeapi.co/api/v2/pokemon/213/"},{"name":"heracross","url":"https://pokeapi.co/api/v2/pokemon/214/"},{"name":"sneasel","url":"https://pokeapi.co/api/v2/pokemon/215/"},{"name":"teddiursa","url":"https://pokeapi.co/api/v2/pokemon/216/"},{"name":"ursaring","url":"https://pokeapi.co/api/v2/pokemon/217/"},{"name":"slugma","url":"https://pokeapi.co/api/v2/pokemon/218/"},{"name":"magcargo","url":"https://pokeapi.co/api/v2/pokemon/219/"},{"name":"swinub","url":"https://pokeapi.co/api/v2/pokemon/220/"},{"name":"piloswine","url":"https://pokeapi.co/api/v2/pokemon/221/"},{"name":"corsola","url":"https://pokeapi.co/api/v2/pokemon/222/"},{"name":"remoraid","url":"https://pokeapi.co/api/v2/pokemon/223/"},{"name":"octillery","url":"https://pokeapi.co/api/v2/pokemon/224/"},{"name":"delibird","url":"https://pokeapi.co/api/v2/pokemon/225/"},{"name":"mantine","url":"https://pokeapi.co/api/v2/pokemon/226/"},{"name":"skarmory","url":"https://pokeapi.co/api/v2/pokemon/227/"},{"name":"houndour","url":"https://pokeapi.co/api/v2/pokemon/228/"},{"name":"houndoom","url":"https://pokeapi.co/api/v2/pokemon/229/"},{"name":"kingdra","url":"https://pokeapi.co/api/v2/pokemon/230/"},{"name":"phanpy","url":"https://pokeapi.co/api/v2/pokemon/231/"},{"name":"donphan","url":"https://pokeapi.co/api/v2/pokemon/232/"},{"name":"porygon2","url":"https://pokeapi.co/api/v2/pokemon/233/"},{"name":"stantler","url":"https://pokeapi.co/api/v2/pokemon/234/"},{"name":"smeargle","url":"https://pokeapi.co/api/v2/pokemon/235/"},{"name":"tyrogue","url":"https://pokeapi.co/api/v2/pokemon/236/"},{"name":"hitmontop","url":"https://pokeapi.co/api/v2/pokemon/237/"},{"name":"smoochum","url":"https://pokeapi.co/api/v2/pokemon/238/"},{"name":"elekid","url":"https://pokeapi.co/api/v2/pokemon/239/"},{"name":"magby","url":"https://pokeapi.co/api/v2/pokemon/240/"},{"name":"miltank","url":"https://pokeapi.co/api/v2/pokemon/241/"},{"name":"blissey","url":"https://pokeapi.co/api/v2/pokemon/242/"},{"name":"raikou","url":"https://pokeapi.co/api/v2/pokemon/243/"},{"name":"entei","url":"https://pokeapi.co/api/v2/pokemon/244/"},{"name":"suicune","url":"https://pokeapi.co/api/v2/pokemon/245/"},{"name":"larvitar","url":"https://pokeapi.co/api/v2/pokemon/246/"},{"name":"pupitar","url":"https://pokeapi.co/api/v2/pokemon/247/"},{"name":"tyranitar","url":"https://pokeapi.co/api/v2/pokemon/248/"},{"name":"lugia","url":"https://pokeapi.co/api/v2/pokemon/249/"},{"name":"ho-oh","url":"https://pokeapi.co/api/v2/pokemon/250/"},{"name":"celebi","url":"https://pokeapi.co/api/v2/pokemon/251/"},{"name":"treecko","url":"https://pokeapi.co/api/v2/pokemon/252/"},{"name":"grovyle","url":"https://pokeapi.co/api/v2/pokemon/253/"},{"name":"sceptile","url":"https://pokeapi.co/api/v2/pokemon/254/"},{"name":"torchic","url":"https://pokeapi.co/api/v2/pokemon/255/"},{"name":"combusken","url":"https://pokeapi.co/api/v2/pokemon/256/"},{"name":"blaziken","url":"https://pokeapi.co/api/v2/pokemon/257/"},{"name":"mudkip","url":"https://pokeapi.co/api/v2/pokemon/258/"},{"name":"marshtomp","url":"https://pokeapi.co/api/v2/pokemon/259/"},{"name":"swampert","url":"https://pokeapi.co/api/v2/pokemon/260/"},{"name":"poochyena","url":"https://pokeapi.co/api/v2/pokemon/261/"},{"name":"mightyena","url":"https://pokeapi.co/api/v2/pokemon/262/"},{"name":"zigzagoon","url":"https://pokeapi.co/api/v2/pokemon/263/"},{"name":"linoone","url":"https://pokeapi.co/api/v2/pokemon/264/"},{"name":"wurmple","url":"https://pokeapi.co/api/v2/pokemon/265/"},{"name":"silcoon","url":"https://pokeapi.co/api/v2/pokemon/266/"},{"name":"beautifly","url":"https://pokeapi.co/api/v2/pokemon/267/"},{"name":"cascoon","url":"https://pokeapi.co/api/v2/pokemon/268/"},{"name":"dustox","url":"https://pokeapi.co/api/v2/pokemon/269/"},{"name":"lotad","url":"https://pokeapi.co/api/v2/pokemon/270/"},{"name":"lombre","url":"https://pokeapi.co/api/v2/pokemon/271/"},{"name":"ludicolo","url":"https://pokeapi.co/api/v2/pokemon/272/"},{"name":"seedot","url":"https://pokeapi.co/api/v2/pokemon/273/"},{"name":"nuzleaf","url":"https://pokeapi.co/api/v2/pokemon/274/"},{"name":"shiftry","url":"https://pokeapi.co/api/v2/pokemon/275/"},{"name":"taillow","url":"https://pokeapi.co/api/v2/pokemon/276/"},{"name":"swellow","url":"https://pokeapi.co/api/v2/pokemon/277/"},{"name":"wingull","url":"https://pokeapi.co/api/v2/pokemon/278/"},{"name":"pelipper","url":"https://pokeapi.co/api/v2/pokemon/279/"},{"name":"ralts","url":"https://pokeapi.co/api/v2/pokemon/280/"},{"name":"kirlia","url":"https://pokeapi.co/api/v2/pokemon/281/"},{"name":"gardevoir","url":"https://pokeapi.co/api/v2/pokemon/282/"},{"name":"surskit","url":"https://pokeapi.co/api/v2/pokemon/283/"},{"name":"masquerain","url":"https://pokeapi.co/api/v2/pokemon/284/"},{"name":"shroomish","url":"https://pokeapi.co/api/v2/pokemon/285/"},{"name":"breloom","url":"https://pokeapi.co/api/v2/pokemon/286/"},{"name":"slakoth","url":"https://pokeapi.co/api/v2/pokemon/287/"},{"name":"vigoroth","url":"https://pokeapi.co/api/v2/pokemon/288/"},{"name":"slaking","url":"https://pokeapi.co/api/v2/pokemon/289/"},{"name":"nincada","url":"https://pokeapi.co/api/v2/pokemon/290/"},{"name":"ninjask","url":"https://pokeapi.co/api/v2/pokemon/291/"},{"name":"shedinja","url":"https://pokeapi.co/api/v2/pokemon/292/"},{"name":"whismur","url":"https://pokeapi.co/api/v2/pokemon/293/"},{"name":"loudred","url":"https://pokeapi.co/api/v2/pokemon/294/"},{"name":"exploud","url":"https://pokeapi.co/api/v2/pokemon/295/"},{"name":"makuhita","url":"https://pokeapi.co/api/v2/pokemon/296/"},{"name":"hariyama","url":"https://pokeapi.co/api/v2/pokemon/297/"},{"name":"azurill","url":"https://pokeapi.co/api/v2/pokemon/298/"},{"name":"nosepass","url":"https://pokeapi.co/api/v2/pokemon/299/"},{"name":"skitty","url":"https://pokeapi.co/api/v2/pokemon/300/"},{"name":"delcatty","url":"https://pokeapi.co/api/v2/pokemon/301/"},{"name":"sableye","url":"https://pokeapi.co/api/v2/pokemon/302/"},{"name":"mawile","url":"https://pokeapi.co/api/v2/pokemon/303/"},{"name":"aron","url":"https://pokeapi.co/api/v2/pokemon/304/"},{"name":"lairon","url":"https://pokeapi.co/api/v2/pokemon/305/"},{"name":"aggron","url":"https://pokeapi.co/api/v2/pokemon/306/"},{"name":"meditite","url":"https://pokeapi.co/api/v2/pokemon/307/"},{"name":"medicham","url":"https://pokeapi.co/api/v2/pokemon/308/"},{"name":"electrike","url":"https://pokeapi.co/api/v2/pokemon/309/"},{"name":"manectric","url":"https://pokeapi.co/api/v2/pokemon/310/"},{"name":"plusle","url":"https://pokeapi.co/api/v2/pokemon/311/"},{"name":"minun","url":"https://pokeapi.co/api/v2/pokemon/312/"},{"name":"volbeat","url":"https://pokeapi.co/api/v2/pokemon/313/"},{"name":"illumise","url":"https://pokeapi.co/api/v2/pokemon/314/"},{"name":"roselia","url":"https://pokeapi.co/api/v2/pokemon/315/"},{"name":"gulpin","url":"https://pokeapi.co/api/v2/pokemon/316/"},{"name":"swalot","url":"https://pokeapi.co/api/v2/pokemon/317/"},{"name":"carvanha","url":"https://pokeapi.co/api/v2/pokemon/318/"},{"name":"sharpedo","url":"https://pokeapi.co/api/v2/pokemon/319/"},{"name":"wailmer","url":"https://pokeapi.co/api/v2/pokemon/320/"},{"name":"wailord","url":"https://pokeapi.co/api/v2/pokemon/321/"},{"name":"numel","url":"https://pokeapi.co/api/v2/pokemon/322/"},{"name":"camerupt","url":"https://pokeapi.co/api/v2/pokemon/323/"},{"name":"torkoal","url":"https://pokeapi.co/api/v2/pokemon/324/"},{"name":"spoink","url":"https://pokeapi.co/api/v2/pokemon/325/"},{"name":"grumpig","url":"https://pokeapi.co/api/v2/pokemon/326/"},{"name":"spinda","url":"https://pokeapi.co/api/v2/pokemon/327/"},{"name":"trapinch","url":"https://pokeapi.co/api/v2/pokemon/328/"},{"name":"vibrava","url":"https://pokeapi.co/api/v2/pokemon/329/"},{"name":"flygon","url":"https://pokeapi.co/api/v2/pokemon/330/"},{"name":"cacnea","url":"https://pokeapi.co/api/v2/pokemon/331/"},{"name":"cacturne","url":"https://pokeapi.co/api/v2/pokemon/332/"},{"name":"swablu","url":"https://pokeapi.co/api/v2/pokemon/333/"},{"name":"altaria","url":"https://pokeapi.co/api/v2/pokemon/334/"},{"name":"zangoose","url":"https://pokeapi.co/api/v2/pokemon/335/"},{"name":"seviper","url":"https://pokeapi.co/api/v2/pokemon/336/"},{"name":"lunatone","url":"https://pokeapi.co/api/v2/pokemon/337/"},{"name":"solrock","url":"https://pokeapi.co/api/v2/pokemon/338/"},{"name":"barboach","url":"https://pokeapi.co/api/v2/pokemon/339/"},{"name":"whiscash","url":"https://pokeapi.co/api/v2/pokemon/340/"},{"name":"corphish","url":"https://pokeapi.co/api/v2/pokemon/341/"},{"name":"crawdaunt","url":"https://pokeapi.co/api/v2/pokemon/342/"},{"name":"baltoy","url":"https://pokeapi.co/api/v2/pokemon/343/"},{"name":"claydol","url":"https://pokeapi.co/api/v2/pokemon/344/"},{"name":"lileep","url":"https://pokeapi.co/api/v2/pokemon/345/"},{"name":"cradily","url":"https://pokeapi.co/api/v2/pokemon/346/"},{"name":"anorith","url":"https://pokeapi.co/api/v2/pokemon/347/"},{"name":"armaldo","url":"https://pokeapi.co/api/v2/pokemon/348/"},{"name":"feebas","url":"https://pokeapi.co/api/v2/pokemon/349/"},{"name":"milotic","url":"https://pokeapi.co/api/v2/pokemon/350/"},{"name":"castform","url":"https://pokeapi.co/api/v2/pokemon/351/"},{"name":"kecleon","url":"https://pokeapi.co/api/v2/pokemon/352/"},{"name":"shuppet","url":"https://pokeapi.co/api/v2/pokemon/353/"},{"name":"banette","url":"https://pokeapi.co/api/v2/pokemon/354/"},{"name":"duskull","url":"https://pokeapi.co/api/v2/pokemon/355/"},{"name":"dusclops","url":"https://pokeapi.co/api/v2/pokemon/356/"},{"name":"tropius","url":"https://pokeapi.co/api/v2/pokemon/357/"},{"name":"chimecho","url":"https://pokeapi.co/api/v2/pokemon/358/"},{"name":"absol","url":"https://pokeapi.co/api/v2/pokemon/359/"},{"name":"wynaut","url":"https://pokeapi.co/api/v2/pokemon/360/"},{"name":"snorunt","url":"https://pokeapi.co/api/v2/pokemon/361/"},{"name":"glalie","url":"https://pokeapi.co/api/v2/pokemon/362/"},{"name":"spheal","url":"https://pokeapi.co/api/v2/pokemon/363/"},{"name":"sealeo","url":"https://pokeapi.co/api/v2/pokemon/364/"},{"name":"walrein","url":"https://pokeapi.co/api/v2/pokemon/365/"},{"name":"clamperl","url":"https://pokeapi.co/api/v2/pokemon/366/"},{"name":"huntail","url":"https://pokeapi.co/api/v2/pokemon/367/"},{"name":"gorebyss","url":"https://pokeapi.co/api/v2/pokemon/368/"},{"name":"relicanth","url":"https://pokeapi.co/api/v2/pokemon/369/"},{"name":"luvdisc","url":"https://pokeapi.co/api/v2/pokemon/370/"},{"name":"bagon","url":"https://pokeapi.co/api/v2/pokemon/371/"},{"name":"shelgon","url":"https://pokeapi.co/api/v2/pokemon/372/"},{"name":"salamence","url":"https://pokeapi.co/api/v2/pokemon/373/"},{"name":"beldum","url":"https://pokeapi.co/api/v2/pokemon/374/"},{"name":"metang","url":"https://pokeapi.co/api/v2/pokemon/375/"},{"name":"metagross","url":"https://pokeapi.co/api/v2/pokemon/376/"},{"name":"regirock","url":"https://pokeapi.co/api/v2/pokemon/377/"},{"name":"regice","url":"https://pokeapi.co/api/v2/pokemon/378/"},{"name":"registeel","url":"https://pokeapi.co/api/v2/pokemon/379/"},{"name":"latias","url":"https://pokeapi.co/api/v2/pokemon/380/"},{"name":"latios","url":"https://pokeapi.co/api/v2/pokemon/381/"},{"name":"kyogre","url":"https://pokeapi.co/api/v2/pokemon/382/"},{"name":"groudon","url":"https://pokeapi.co/api/v2/pokemon/383/"},{"name":"rayquaza","url":"https://pokeapi.co/api/v2/pokemon/384/"},{"name":"jirachi","url":"https://pokeapi.co/api/v2/pokemon/385/"},{"name":"deoxys-normal","url":"https://pokeapi.co/api/v2/pokemon/386/"},{"name":"turtwig","url":"https://pokeapi.co/api/v2/pokemon/387/"},{"name":"grotle","url":"https://pokeapi.co/api/v2/pokemon/388/"},{"name":"torterra","url":"https://pokeapi.co/api/v2/pokemon/389/"},{"name":"chimchar","url":"https://pokeapi.co/api/v2/pokemon/390/"},{"name":"monferno","url":"https://pokeapi.co/api/v2/pokemon/391/"},{"name":"infernape","url":"https://pokeapi.co/api/v2/pokemon/392/"},{"name":"piplup","url":"https://pokeapi.co/api/v2/pokemon/393/"},{"name":"prinplup","url":"https://pokeapi.co/api/v2/pokemon/394/"},{"name":"empoleon","url":"https://pokeapi.co/api/v2/pokemon/395/"},{"name":"starly","url":"https://pokeapi.co/api/v2/pokemon/396/"},{"name":"staravia","url":"https://pokeapi.co/api/v2/pokemon/397/"},{"name":"staraptor","url":"https://pokeapi.co/api/v2/pokemon/398/"},{"name":"bidoof","url":"https://pokeapi.co/api/v2/pokemon/399/"},{"name":"bibarel","url":"https://pokeapi.co/api/v2/pokemon/400/"},{"name":"kricketot","url":"https://pokeapi.co/api/v2/pokemon/401/"},{"name":"kricketune","url":"https://pokeapi.co/api/v2/pokemon/402/"},{"name":"shinx","url":"https://pokeapi.co/api/v2/pokemon/403/"},{"name":"luxio","url":"https://pokeapi.co/api/v2/pokemon/404/"},{"name":"luxray","url":"https://pokeapi.co/api/v2/pokemon/405/"},{"name":"budew","url":"https://pokeapi.co/api/v2/pokemon/406/"},{"name":"roserade","url":"https://pokeapi.co/api/v2/pokemon/407/"},{"name":"cranidos","url":"https://pokeapi.co/api/v2/pokemon/408/"},{"name":"rampardos","url":"https://pokeapi.co/api/v2/pokemon/409/"},{"name":"shieldon","url":"https://pokeapi.co/api/v2/pokemon/410/"},{"name":"bastiodon","url":"https://pokeapi.co/api/v2/pokemon/411/"},{"name":"burmy","url":"https://pokeapi.co/api/v2/pokemon/412/"},{"name":"wormadam-plant","url":"https://pokeapi.co/api/v2/pokemon/413/"},{"name":"mothim","url":"https://pokeapi.co/api/v2/pokemon/414/"},{"name":"combee","url":"https://pokeapi.co/api/v2/pokemon/415/"},{"name":"vespiquen","url":"https://pokeapi.co/api/v2/pokemon/416/"},{"name":"pachirisu","url":"https://pokeapi.co/api/v2/pokemon/417/"},{"name":"buizel","url":"https://pokeapi.co/api/v2/pokemon/418/"},{"name":"floatzel","url":"https://pokeapi.co/api/v2/pokemon/419/"},{"name":"cherubi","url":"https://pokeapi.co/api/v2/pokemon/420/"},{"name":"cherrim","url":"https://pokeapi.co/api/v2/pokemon/421/"},{"name":"shellos","url":"https://pokeapi.co/api/v2/pokemon/422/"},{"name":"gastrodon","url":"https://pokeapi.co/api/v2/pokemon/423/"},{"name":"ambipom","url":"https://pokeapi.co/api/v2/pokemon/424/"},{"name":"drifloon","url":"https://pokeapi.co/api/v2/pokemon/425/"},{"name":"drifblim","url":"https://pokeapi.co/api/v2/pokemon/426/"},{"name":"buneary","url":"https://pokeapi.co/api/v2/pokemon/427/"},{"name":"lopunny","url":"https://pokeapi.co/api/v2/pokemon/428/"},{"name":"mismagius","url":"https://pokeapi.co/api/v2/pokemon/429/"},{"name":"honchkrow","url":"https://pokeapi.co/api/v2/pokemon/430/"},{"name":"glameow","url":"https://pokeapi.co/api/v2/pokemon/431/"},{"name":"purugly","url":"https://pokeapi.co/api/v2/pokemon/432/"},{"name":"chingling","url":"https://pokeapi.co/api/v2/pokemon/433/"},{"name":"stunky","url":"https://pokeapi.co/api/v2/pokemon/434/"},{"name":"skuntank","url":"https://pokeapi.co/api/v2/pokemon/435/"},{"name":"bronzor","url":"https://pokeapi.co/api/v2/pokemon/436/"},{"name":"bronzong","url":"https://pokeapi.co/api/v2/pokemon/437/"},{"name":"bonsly","url":"https://pokeapi.co/api/v2/pokemon/438/"},{"name":"mime-jr","url":"https://pokeapi.co/api/v2/pokemon/439/"},{"name":"happiny","url":"https://pokeapi.co/api/v2/pokemon/440/"},{"name":"chatot","url":"https://pokeapi.co/api/v2/pokemon/441/"},{"name":"spiritomb","url":"https://pokeapi.co/api/v2/pokemon/442/"},{"name":"gible","url":"https://pokeapi.co/api/v2/pokemon/443/"},{"name":"gabite","url":"https://pokeapi.co/api/v2/pokemon/444/"},{"name":"garchomp","url":"https://pokeapi.co/api/v2/pokemon/445/"},{"name":"munchlax","url":"https://pokeapi.co/api/v2/pokemon/446/"},{"name":"riolu","url":"https://pokeapi.co/api/v2/pokemon/447/"},{"name":"lucario","url":"https://pokeapi.co/api/v2/pokemon/448/"},{"name":"hippopotas","url":"https://pokeapi.co/api/v2/pokemon/449/"},{"name":"hippowdon","url":"https://pokeapi.co/api/v2/pokemon/450/"},{"name":"skorupi","url":"https://pokeapi.co/api/v2/pokemon/451/"},{"name":"drapion","url":"https://pokeapi.co/api/v2/pokemon/452/"},{"name":"croagunk","url":"https://pokeapi.co/api/v2/pokemon/453/"},{"name":"toxicroak","url":"https://pokeapi.co/api/v2/pokemon/454/"},{"name":"carnivine","url":"https://pokeapi.co/api/v2/pokemon/455/"},{"name":"finneon","url":"https://pokeapi.co/api/v2/pokemon/456/"},{"name":"lumineon","url":"https://pokeapi.co/api/v2/pokemon/457/"},{"name":"mantyke","url":"https://pokeapi.co/api/v2/pokemon/458/"},{"name":"snover","url":"https://pokeapi.co/api/v2/pokemon/459/"},{"name":"abomasnow","url":"https://pokeapi.co/api/v2/pokemon/460/"},{"name":"weavile","url":"https://pokeapi.co/api/v2/pokemon/461/"},{"name":"magnezone","url":"https://pokeapi.co/api/v2/pokemon/462/"},{"name":"lickilicky","url":"https://pokeapi.co/api/v2/pokemon/463/"},{"name":"rhyperior","url":"https://pokeapi.co/api/v2/pokemon/464/"},{"name":"tangrowth","url":"https://pokeapi.co/api/v2/pokemon/465/"},{"name":"electivire","url":"https://pokeapi.co/api/v2/pokemon/466/"},{"name":"magmortar","url":"https://pokeapi.co/api/v2/pokemon/467/"},{"name":"togekiss","url":"https://pokeapi.co/api/v2/pokemon/468/"},{"name":"yanmega","url":"https://pokeapi.co/api/v2/pokemon/469/"},{"name":"leafeon","url":"https://pokeapi.co/api/v2/pokemon/470/"},{"name":"glaceon","url":"https://pokeapi.co/api/v2/pokemon/471/"},{"name":"gliscor","url":"https://pokeapi.co/api/v2/pokemon/472/"},{"name":"mamoswine","url":"https://pokeapi.co/api/v2/pokemon/473/"},{"name":"porygon-z","url":"https://pokeapi.co/api/v2/pokemon/474/"},{"name":"gallade","url":"https://pokeapi.co/api/v2/pokemon/475/"},{"name":"probopass","url":"https://pokeapi.co/api/v2/pokemon/476/"},{"name":"dusknoir","url":"https://pokeapi.co/api/v2/pokemon/477/"},{"name":"froslass","url":"https://pokeapi.co/api/v2/pokemon/478/"},{"name":"rotom","url":"https://pokeapi.co/api/v2/pokemon/479/"},{"name":"uxie","url":"https://pokeapi.co/api/v2/pokemon/480/"},{"name":"mesprit","url":"https://pokeapi.co/api/v2/pokemon/481/"},{"name":"azelf","url":"https://pokeapi.co/api/v2/pokemon/482/"},{"name":"dialga","url":"https://pokeapi.co/api/v2/pokemon/483/"},{"name":"palkia","url":"https://pokeapi.co/api/v2/pokemon/484/"},{"name":"heatran","url":"https://pokeapi.co/api/v2/pokemon/485/"},{"name":"regigigas","url":"https://pokeapi.co/api/v2/pokemon/486/"},{"name":"giratina-altered","url":"https://pokeapi.co/api/v2/pokemon/487/"},{"name":"cresselia","url":"https://pokeapi.co/api/v2/pokemon/488/"},{"name":"phione","url":"https://pokeapi.co/api/v2/pokemon/489/"},{"name":"manaphy","url":"https://pokeapi.co/api/v2/pokemon/490/"},{"name":"darkrai","url":"https://pokeapi.co/api/v2/pokemon/491/"},{"name":"shaymin-land","url":"https://pokeapi.co/api/v2/pokemon/492/"},{"name":"arceus","url":"https://pokeapi.co/api/v2/pokemon/493/"},{"name":"victini","url":"https://pokeapi.co/api/v2/pokemon/494/"},{"name":"snivy","url":"https://pokeapi.co/api/v2/pokemon/495/"},{"name":"servine","url":"https://pokeapi.co/api/v2/pokemon/496/"},{"name":"serperior","url":"https://pokeapi.co/api/v2/pokemon/497/"},{"name":"tepig","url":"https://pokeapi.co/api/v2/pokemon/498/"},{"name":"pignite","url":"https://pokeapi.co/api/v2/pokemon/499/"},{"name":"emboar","url":"https://pokeapi.co/api/v2/pokemon/500/"},{"name":"oshawott","url":"https://pokeapi.co/api/v2/pokemon/501/"},{"name":"dewott","url":"https://pokeapi.co/api/v2/pokemon/502/"},{"name":"samurott","url":"https://pokeapi.co/api/v2/pokemon/503/"},{"name":"patrat","url":"https://pokeapi.co/api/v2/pokemon/504/"},{"name":"watchog","url":"https://pokeapi.co/api/v2/pokemon/505/"},{"name":"lillipup","url":"https://pokeapi.co/api/v2/pokemon/506/"},{"name":"herdier","url":"https://pokeapi.co/api/v2/pokemon/507/"},{"name":"stoutland","url":"https://pokeapi.co/api/v2/pokemon/508/"},{"name":"purrloin","url":"https://pokeapi.co/api/v2/pokemon/509/"},{"name":"liepard","url":"https://pokeapi.co/api/v2/pokemon/510/"},{"name":"pansage","url":"https://pokeapi.co/api/v2/pokemon/511/"},{"name":"simisage","url":"https://pokeapi.co/api/v2/pokemon/512/"},{"name":"pansear","url":"https://pokeapi.co/api/v2/pokemon/513/"},{"name":"simisear","url":"https://pokeapi.co/api/v2/pokemon/514/"},{"name":"panpour","url":"https://pokeapi.co/api/v2/pokemon/515/"},{"name":"simipour","url":"https://pokeapi.co/api/v2/pokemon/516/"},{"name":"munna","url":"https://pokeapi.co/api/v2/pokemon/517/"},{"name":"musharna","url":"https://pokeapi.co/api/v2/pokemon/518/"},{"name":"pidove","url":"https://pokeapi.co/api/v2/pokemon/519/"},{"name":"tranquill","url":"https://pokeapi.co/api/v2/pokemon/520/"},{"name":"unfezant","url":"https://pokeapi.co/api/v2/pokemon/521/"},{"name":"blitzle","url":"https://pokeapi.co/api/v2/pokemon/522/"},{"name":"zebstrika","url":"https://pokeapi.co/api/v2/pokemon/523/"},{"name":"roggenrola","url":"https://pokeapi.co/api/v2/pokemon/524/"},{"name":"boldore","url":"https://pokeapi.co/api/v2/pokemon/525/"},{"name":"gigalith","url":"https://pokeapi.co/api/v2/pokemon/526/"},{"name":"woobat","url":"https://pokeapi.co/api/v2/pokemon/527/"},{"name":"swoobat","url":"https://pokeapi.co/api/v2/pokemon/528/"},{"name":"drilbur","url":"https://pokeapi.co/api/v2/pokemon/529/"},{"name":"excadrill","url":"https://pokeapi.co/api/v2/pokemon/530/"},{"name":"audino","url":"https://pokeapi.co/api/v2/pokemon/531/"},{"name":"timburr","url":"https://pokeapi.co/api/v2/pokemon/532/"},{"name":"gurdurr","url":"https://pokeapi.co/api/v2/pokemon/533/"},{"name":"conkeldurr","url":"https://pokeapi.co/api/v2/pokemon/534/"},{"name":"tympole","url":"https://pokeapi.co/api/v2/pokemon/535/"},{"name":"palpitoad","url":"https://pokeapi.co/api/v2/pokemon/536/"},{"name":"seismitoad","url":"https://pokeapi.co/api/v2/pokemon/537/"},{"name":"throh","url":"https://pokeapi.co/api/v2/pokemon/538/"},{"name":"sawk","url":"https://pokeapi.co/api/v2/pokemon/539/"},{"name":"sewaddle","url":"https://pokeapi.co/api/v2/pokemon/540/"},{"name":"swadloon","url":"https://pokeapi.co/api/v2/pokemon/541/"},{"name":"leavanny","url":"https://pokeapi.co/api/v2/pokemon/542/"},{"name":"venipede","url":"https://pokeapi.co/api/v2/pokemon/543/"},{"name":"whirlipede","url":"https://pokeapi.co/api/v2/pokemon/544/"},{"name":"scolipede","url":"https://pokeapi.co/api/v2/pokemon/545/"},{"name":"cottonee","url":"https://pokeapi.co/api/v2/pokemon/546/"},{"name":"whimsicott","url":"https://pokeapi.co/api/v2/pokemon/547/"},{"name":"petilil","url":"https://pokeapi.co/api/v2/pokemon/548/"},{"name":"lilligant","url":"https://pokeapi.co/api/v2/pokemon/549/"},{"name":"basculin-red-striped","url":"https://pokeapi.co/api/v2/pokemon/550/"},{"name":"sandile","url":"https://pokeapi.co/api/v2/pokemon/551/"},{"name":"krokorok","url":"https://pokeapi.co/api/v2/pokemon/552/"},{"name":"krookodile","url":"https://pokeapi.co/api/v2/pokemon/553/"},{"name":"darumaka","url":"https://pokeapi.co/api/v2/pokemon/554/"},{"name":"darmanitan-standard","url":"https://pokeapi.co/api/v2/pokemon/555/"},{"name":"maractus","url":"https://pokeapi.co/api/v2/pokemon/556/"},{"name":"dwebble","url":"https://pokeapi.co/api/v2/pokemon/557/"},{"name":"crustle","url":"https://pokeapi.co/api/v2/pokemon/558/"},{"name":"scraggy","url":"https://pokeapi.co/api/v2/pokemon/559/"},{"name":"scrafty","url":"https://pokeapi.co/api/v2/pokemon/560/"},{"name":"sigilyph","url":"https://pokeapi.co/api/v2/pokemon/561/"},{"name":"yamask","url":"https://pokeapi.co/api/v2/pokemon/562/"},{"name":"cofagrigus","url":"https://pokeapi.co/api/v2/pokemon/563/"},{"name":"tirtouga","url":"https://pokeapi.co/api/v2/pokemon/564/"},{"name":"carracosta","url":"https://pokeapi.co/api/v2/pokemon/565/"},{"name":"archen","url":"https://pokeapi.co/api/v2/pokemon/566/"},{"name":"archeops","url":"https://pokeapi.co/api/v2/pokemon/567/"},{"name":"trubbish","url":"https://pokeapi.co/api/v2/pokemon/568/"},{"name":"garbodor","url":"https://pokeapi.co/api/v2/pokemon/569/"},{"name":"zorua","url":"https://pokeapi.co/api/v2/pokemon/570/"},{"name":"zoroark","url":"https://pokeapi.co/api/v2/pokemon/571/"},{"name":"minccino","url":"https://pokeapi.co/api/v2/pokemon/572/"},{"name":"cinccino","url":"https://pokeapi.co/api/v2/pokemon/573/"},{"name":"gothita","url":"https://pokeapi.co/api/v2/pokemon/574/"},{"name":"gothorita","url":"https://pokeapi.co/api/v2/pokemon/575/"},{"name":"gothitelle","url":"https://pokeapi.co/api/v2/pokemon/576/"},{"name":"solosis","url":"https://pokeapi.co/api/v2/pokemon/577/"},{"name":"duosion","url":"https://pokeapi.co/api/v2/pokemon/578/"},{"name":"reuniclus","url":"https://pokeapi.co/api/v2/pokemon/579/"},{"name":"ducklett","url":"https://pokeapi.co/api/v2/pokemon/580/"},{"name":"swanna","url":"https://pokeapi.co/api/v2/pokemon/581/"},{"name":"vanillite","url":"https://pokeapi.co/api/v2/pokemon/582/"},{"name":"vanillish","url":"https://pokeapi.co/api/v2/pokemon/583/"},{"name":"vanilluxe","url":"https://pokeapi.co/api/v2/pokemon/584/"},{"name":"deerling","url":"https://pokeapi.co/api/v2/pokemon/585/"},{"name":"sawsbuck","url":"https://pokeapi.co/api/v2/pokemon/586/"},{"name":"emolga","url":"https://pokeapi.co/api/v2/pokemon/587/"},{"name":"karrablast","url":"https://pokeapi.co/api/v2/pokemon/588/"},{"name":"escavalier","url":"https://pokeapi.co/api/v2/pokemon/589/"},{"name":"foongus","url":"https://pokeapi.co/api/v2/pokemon/590/"},{"name":"amoonguss","url":"https://pokeapi.co/api/v2/pokemon/591/"},{"name":"frillish","url":"https://pokeapi.co/api/v2/pokemon/592/"},{"name":"jellicent","url":"https://pokeapi.co/api/v2/pokemon/593/"},{"name":"alomomola","url":"https://pokeapi.co/api/v2/pokemon/594/"},{"name":"joltik","url":"https://pokeapi.co/api/v2/pokemon/595/"},{"name":"galvantula","url":"https://pokeapi.co/api/v2/pokemon/596/"},{"name":"ferroseed","url":"https://pokeapi.co/api/v2/pokemon/597/"},{"name":"ferrothorn","url":"https://pokeapi.co/api/v2/pokemon/598/"},{"name":"klink","url":"https://pokeapi.co/api/v2/pokemon/599/"},{"name":"klang","url":"https://pokeapi.co/api/v2/pokemon/600/"},{"name":"klinklang","url":"https://pokeapi.co/api/v2/pokemon/601/"},{"name":"tynamo","url":"https://pokeapi.co/api/v2/pokemon/602/"},{"name":"eelektrik","url":"https://pokeapi.co/api/v2/pokemon/603/"},{"name":"eelektross","url":"https://pokeapi.co/api/v2/pokemon/604/"},{"name":"elgyem","url":"https://pokeapi.co/api/v2/pokemon/605/"},{"name":"beheeyem","url":"https://pokeapi.co/api/v2/pokemon/606/"},{"name":"litwick","url":"https://pokeapi.co/api/v2/pokemon/607/"},{"name":"lampent","url":"https://pokeapi.co/api/v2/pokemon/608/"},{"name":"chandelure","url":"https://pokeapi.co/api/v2/pokemon/609/"},{"name":"axew","url":"https://pokeapi.co/api/v2/pokemon/610/"},{"name":"fraxure","url":"https://pokeapi.co/api/v2/pokemon/611/"},{"name":"haxorus","url":"https://pokeapi.co/api/v2/pokemon/612/"},{"name":"cubchoo","url":"https://pokeapi.co/api/v2/pokemon/613/"},{"name":"beartic","url":"https://pokeapi.co/api/v2/pokemon/614/"},{"name":"cryogonal","url":"https://pokeapi.co/api/v2/pokemon/615/"},{"name":"shelmet","url":"https://pokeapi.co/api/v2/pokemon/616/"},{"name":"accelgor","url":"https://pokeapi.co/api/v2/pokemon/617/"},{"name":"stunfisk","url":"https://pokeapi.co/api/v2/pokemon/618/"},{"name":"mienfoo","url":"https://pokeapi.co/api/v2/pokemon/619/"},{"name":"mienshao","url":"https://pokeapi.co/api/v2/pokemon/620/"},{"name":"druddigon","url":"https://pokeapi.co/api/v2/pokemon/621/"},{"name":"golett","url":"https://pokeapi.co/api/v2/pokemon/622/"},{"name":"golurk","url":"https://pokeapi.co/api/v2/pokemon/623/"},{"name":"pawniard","url":"https://pokeapi.co/api/v2/pokemon/624/"},{"name":"bisharp","url":"https://pokeapi.co/api/v2/pokemon/625/"},{"name":"bouffalant","url":"https://pokeapi.co/api/v2/pokemon/626/"},{"name":"rufflet","url":"https://pokeapi.co/api/v2/pokemon/627/"},{"name":"braviary","url":"https://pokeapi.co/api/v2/pokemon/628/"},{"name":"vullaby","url":"https://pokeapi.co/api/v2/pokemon/629/"},{"name":"mandibuzz","url":"https://pokeapi.co/api/v2/pokemon/630/"},{"name":"heatmor","url":"https://pokeapi.co/api/v2/pokemon/631/"},{"name":"durant","url":"https://pokeapi.co/api/v2/pokemon/632/"},{"name":"deino","url":"https://pokeapi.co/api/v2/pokemon/633/"},{"name":"zweilous","url":"https://pokeapi.co/api/v2/pokemon/634/"},{"name":"hydreigon","url":"https://pokeapi.co/api/v2/pokemon/635/"},{"name":"larvesta","url":"https://pokeapi.co/api/v2/pokemon/636/"},{"name":"volcarona","url":"https://pokeapi.co/api/v2/pokemon/637/"},{"name":"cobalion","url":"https://pokeapi.co/api/v2/pokemon/638/"},{"name":"terrakion","url":"https://pokeapi.co/api/v2/pokemon/639/"},{"name":"virizion","url":"https://pokeapi.co/api/v2/pokemon/640/"},{"name":"tornadus-incarnate","url":"https://pokeapi.co/api/v2/pokemon/641/"},{"name":"thundurus-incarnate","url":"https://pokeapi.co/api/v2/pokemon/642/"},{"name":"reshiram","url":"https://pokeapi.co/api/v2/pokemon/643/"},{"name":"zekrom","url":"https://pokeapi.co/api/v2/pokemon/644/"},{"name":"landorus-incarnate","url":"https://pokeapi.co/api/v2/pokemon/645/"},{"name":"kyurem","url":"https://pokeapi.co/api/v2/pokemon/646/"},{"name":"keldeo-ordinary","url":"https://pokeapi.co/api/v2/pokemon/647/"},{"name":"meloetta-aria","url":"https://pokeapi.co/api/v2/pokemon/648/"},{"name":"genesect","url":"https://pokeapi.co/api/v2/pokemon/649/"},{"name":"chespin","url":"https://pokeapi.co/api/v2/pokemon/650/"},{"name":"quilladin","url":"https://pokeapi.co/api/v2/pokemon/651/"},{"name":"chesnaught","url":"https://pokeapi.co/api/v2/pokemon/652/"},{"name":"fennekin","url":"https://pokeapi.co/api/v2/pokemon/653/"},{"name":"braixen","url":"https://pokeapi.co/api/v2/pokemon/654/"},{"name":"delphox","url":"https://pokeapi.co/api/v2/pokemon/655/"},{"name":"froakie","url":"https://pokeapi.co/api/v2/pokemon/656/"},{"name":"frogadier","url":"https://pokeapi.co/api/v2/pokemon/657/"},{"name":"greninja","url":"https://pokeapi.co/api/v2/pokemon/658/"},{"name":"bunnelby","url":"https://pokeapi.co/api/v2/pokemon/659/"},{"name":"diggersby","url":"https://pokeapi.co/api/v2/pokemon/660/"},{"name":"fletchling","url":"https://pokeapi.co/api/v2/pokemon/661/"},{"name":"fletchinder","url":"https://pokeapi.co/api/v2/pokemon/662/"},{"name":"talonflame","url":"https://pokeapi.co/api/v2/pokemon/663/"},{"name":"scatterbug","url":"https://pokeapi.co/api/v2/pokemon/664/"},{"name":"spewpa","url":"https://pokeapi.co/api/v2/pokemon/665/"},{"name":"vivillon","url":"https://pokeapi.co/api/v2/pokemon/666/"},{"name":"litleo","url":"https://pokeapi.co/api/v2/pokemon/667/"},{"name":"pyroar","url":"https://pokeapi.co/api/v2/pokemon/668/"},{"name":"flabebe","url":"https://pokeapi.co/api/v2/pokemon/669/"},{"name":"floette","url":"https://pokeapi.co/api/v2/pokemon/670/"},{"name":"florges","url":"https://pokeapi.co/api/v2/pokemon/671/"},{"name":"skiddo","url":"https://pokeapi.co/api/v2/pokemon/672/"},{"name":"gogoat","url":"https://pokeapi.co/api/v2/pokemon/673/"},{"name":"pancham","url":"https://pokeapi.co/api/v2/pokemon/674/"},{"name":"pangoro","url":"https://pokeapi.co/api/v2/pokemon/675/"},{"name":"furfrou","url":"https://pokeapi.co/api/v2/pokemon/676/"},{"name":"espurr","url":"https://pokeapi.co/api/v2/pokemon/677/"},{"name":"meowstic-male","url":"https://pokeapi.co/api/v2/pokemon/678/"},{"name":"honedge","url":"https://pokeapi.co/api/v2/pokemon/679/"},{"name":"doublade","url":"https://pokeapi.co/api/v2/pokemon/680/"},{"name":"aegislash-shield","url":"https://pokeapi.co/api/v2/pokemon/681/"},{"name":"spritzee","url":"https://pokeapi.co/api/v2/pokemon/682/"},{"name":"aromatisse","url":"https://pokeapi.co/api/v2/pokemon/683/"},{"name":"swirlix","url":"https://pokeapi.co/api/v2/pokemon/684/"},{"name":"slurpuff","url":"https://pokeapi.co/api/v2/pokemon/685/"},{"name":"inkay","url":"https://pokeapi.co/api/v2/pokemon/686/"},{"name":"malamar","url":"https://pokeapi.co/api/v2/pokemon/687/"},{"name":"binacle","url":"https://pokeapi.co/api/v2/pokemon/688/"},{"name":"barbaracle","url":"https://pokeapi.co/api/v2/pokemon/689/"},{"name":"skrelp","url":"https://pokeapi.co/api/v2/pokemon/690/"},{"name":"dragalge","url":"https://pokeapi.co/api/v2/pokemon/691/"},{"name":"clauncher","url":"https://pokeapi.co/api/v2/pokemon/692/"},{"name":"clawitzer","url":"https://pokeapi.co/api/v2/pokemon/693/"},{"name":"helioptile","url":"https://pokeapi.co/api/v2/pokemon/694/"},{"name":"heliolisk","url":"https://pokeapi.co/api/v2/pokemon/695/"},{"name":"tyrunt","url":"https://pokeapi.co/api/v2/pokemon/696/"},{"name":"tyrantrum","url":"https://pokeapi.co/api/v2/pokemon/697/"},{"name":"amaura","url":"https://pokeapi.co/api/v2/pokemon/698/"},{"name":"aurorus","url":"https://pokeapi.co/api/v2/pokemon/699/"},{"name":"sylveon","url":"https://pokeapi.co/api/v2/pokemon/700/"},{"name":"hawlucha","url":"https://pokeapi.co/api/v2/pokemon/701/"},{"name":"dedenne","url":"https://pokeapi.co/api/v2/pokemon/702/"},{"name":"carbink","url":"https://pokeapi.co/api/v2/pokemon/703/"},{"name":"goomy","url":"https://pokeapi.co/api/v2/pokemon/704/"},{"name":"sliggoo","url":"https://pokeapi.co/api/v2/pokemon/705/"},{"name":"goodra","url":"https://pokeapi.co/api/v2/pokemon/706/"},{"name":"klefki","url":"https://pokeapi.co/api/v2/pokemon/707/"},{"name":"phantump","url":"https://pokeapi.co/api/v2/pokemon/708/"},{"name":"trevenant","url":"https://pokeapi.co/api/v2/pokemon/709/"},{"name":"pumpkaboo-average","url":"https://pokeapi.co/api/v2/pokemon/710/"},{"name":"gourgeist-average","url":"https://pokeapi.co/api/v2/pokemon/711/"},{"name":"bergmite","url":"https://pokeapi.co/api/v2/pokemon/712/"},{"name":"avalugg","url":"https://pokeapi.co/api/v2/pokemon/713/"},{"name":"noibat","url":"https://pokeapi.co/api/v2/pokemon/714/"},{"name":"noivern","url":"https://pokeapi.co/api/v2/pokemon/715/"},{"name":"xerneas","url":"https://pokeapi.co/api/v2/pokemon/716/"},{"name":"yveltal","url":"https://pokeapi.co/api/v2/pokemon/717/"},{"name":"zygarde","url":"https://pokeapi.co/api/v2/pokemon/718/"},{"name":"diancie","url":"https://pokeapi.co/api/v2/pokemon/719/"},{"name":"hoopa","url":"https://pokeapi.co/api/v2/pokemon/720/"},{"name":"volcanion","url":"https://pokeapi.co/api/v2/pokemon/721/"},{"name":"rowlet","url":"https://pokeapi.co/api/v2/pokemon/722/"},{"name":"dartrix","url":"https://pokeapi.co/api/v2/pokemon/723/"},{"name":"decidueye","url":"https://pokeapi.co/api/v2/pokemon/724/"},{"name":"litten","url":"https://pokeapi.co/api/v2/pokemon/725/"},{"name":"torracat","url":"https://pokeapi.co/api/v2/pokemon/726/"},{"name":"incineroar","url":"https://pokeapi.co/api/v2/pokemon/727/"},{"name":"popplio","url":"https://pokeapi.co/api/v2/pokemon/728/"},{"name":"brionne","url":"https://pokeapi.co/api/v2/pokemon/729/"},{"name":"primarina","url":"https://pokeapi.co/api/v2/pokemon/730/"},{"name":"pikipek","url":"https://pokeapi.co/api/v2/pokemon/731/"},{"name":"trumbeak","url":"https://pokeapi.co/api/v2/pokemon/732/"},{"name":"toucannon","url":"https://pokeapi.co/api/v2/pokemon/733/"},{"name":"yungoos","url":"https://pokeapi.co/api/v2/pokemon/734/"},{"name":"gumshoos","url":"https://pokeapi.co/api/v2/pokemon/735/"},{"name":"grubbin","url":"https://pokeapi.co/api/v2/pokemon/736/"},{"name":"charjabug","url":"https://pokeapi.co/api/v2/pokemon/737/"},{"name":"vikavolt","url":"https://pokeapi.co/api/v2/pokemon/738/"},{"name":"crabrawler","url":"https://pokeapi.co/api/v2/pokemon/739/"},{"name":"crabominable","url":"https://pokeapi.co/api/v2/pokemon/740/"},{"name":"oricorio-baile","url":"https://pokeapi.co/api/v2/pokemon/741/"},{"name":"cutiefly","url":"https://pokeapi.co/api/v2/pokemon/742/"},{"name":"ribombee","url":"https://pokeapi.co/api/v2/pokemon/743/"},{"name":"rockruff","url":"https://pokeapi.co/api/v2/pokemon/744/"},{"name":"lycanroc-midday","url":"https://pokeapi.co/api/v2/pokemon/745/"},{"name":"wishiwashi-solo","url":"https://pokeapi.co/api/v2/pokemon/746/"},{"name":"mareanie","url":"https://pokeapi.co/api/v2/pokemon/747/"},{"name":"toxapex","url":"https://pokeapi.co/api/v2/pokemon/748/"},{"name":"mudbray","url":"https://pokeapi.co/api/v2/pokemon/749/"},{"name":"mudsdale","url":"https://pokeapi.co/api/v2/pokemon/750/"},{"name":"dewpider","url":"https://pokeapi.co/api/v2/pokemon/751/"},{"name":"araquanid","url":"https://pokeapi.co/api/v2/pokemon/752/"},{"name":"fomantis","url":"https://pokeapi.co/api/v2/pokemon/753/"},{"name":"lurantis","url":"https://pokeapi.co/api/v2/pokemon/754/"},{"name":"morelull","url":"https://pokeapi.co/api/v2/pokemon/755/"},{"name":"shiinotic","url":"https://pokeapi.co/api/v2/pokemon/756/"},{"name":"salandit","url":"https://pokeapi.co/api/v2/pokemon/757/"},{"name":"salazzle","url":"https://pokeapi.co/api/v2/pokemon/758/"},{"name":"stufful","url":"https://pokeapi.co/api/v2/pokemon/759/"},{"name":"bewear","url":"https://pokeapi.co/api/v2/pokemon/760/"},{"name":"bounsweet","url":"https://pokeapi.co/api/v2/pokemon/761/"},{"name":"steenee","url":"https://pokeapi.co/api/v2/pokemon/762/"},{"name":"tsareena","url":"https://pokeapi.co/api/v2/pokemon/763/"},{"name":"comfey","url":"https://pokeapi.co/api/v2/pokemon/764/"},{"name":"oranguru","url":"https://pokeapi.co/api/v2/pokemon/765/"},{"name":"passimian","url":"https://pokeapi.co/api/v2/pokemon/766/"},{"name":"wimpod","url":"https://pokeapi.co/api/v2/pokemon/767/"},{"name":"golisopod","url":"https://pokeapi.co/api/v2/pokemon/768/"},{"name":"sandygast","url":"https://pokeapi.co/api/v2/pokemon/769/"},{"name":"palossand","url":"https://pokeapi.co/api/v2/pokemon/770/"},{"name":"pyukumuku","url":"https://pokeapi.co/api/v2/pokemon/771/"},{"name":"type-null","url":"https://pokeapi.co/api/v2/pokemon/772/"},{"name":"silvally","url":"https://pokeapi.co/api/v2/pokemon/773/"},{"name":"minior-red-meteor","url":"https://pokeapi.co/api/v2/pokemon/774/"},{"name":"komala","url":"https://pokeapi.co/api/v2/pokemon/775/"},{"name":"turtonator","url":"https://pokeapi.co/api/v2/pokemon/776/"},{"name":"togedemaru","url":"https://pokeapi.co/api/v2/pokemon/777/"},{"name":"mimikyu-disguised","url":"https://pokeapi.co/api/v2/pokemon/778/"},{"name":"bruxish","url":"https://pokeapi.co/api/v2/pokemon/779/"},{"name":"drampa","url":"https://pokeapi.co/api/v2/pokemon/780/"},{"name":"dhelmise","url":"https://pokeapi.co/api/v2/pokemon/781/"},{"name":"jangmo-o","url":"https://pokeapi.co/api/v2/pokemon/782/"},{"name":"hakamo-o","url":"https://pokeapi.co/api/v2/pokemon/783/"},{"name":"kommo-o","url":"https://pokeapi.co/api/v2/pokemon/784/"},{"name":"tapu-koko","url":"https://pokeapi.co/api/v2/pokemon/785/"},{"name":"tapu-lele","url":"https://pokeapi.co/api/v2/pokemon/786/"},{"name":"tapu-bulu","url":"https://pokeapi.co/api/v2/pokemon/787/"},{"name":"tapu-fini","url":"https://pokeapi.co/api/v2/pokemon/788/"},{"name":"cosmog","url":"https://pokeapi.co/api/v2/pokemon/789/"},{"name":"cosmoem","url":"https://pokeapi.co/api/v2/pokemon/790/"},{"name":"solgaleo","url":"https://pokeapi.co/api/v2/pokemon/791/"},{"name":"lunala","url":"https://pokeapi.co/api/v2/pokemon/792/"},{"name":"nihilego","url":"https://pokeapi.co/api/v2/pokemon/793/"},{"name":"buzzwole","url":"https://pokeapi.co/api/v2/pokemon/794/"},{"name":"pheromosa","url":"https://pokeapi.co/api/v2/pokemon/795/"},{"name":"xurkitree","url":"https://pokeapi.co/api/v2/pokemon/796/"},{"name":"celesteela","url":"https://pokeapi.co/api/v2/pokemon/797/"},{"name":"kartana","url":"https://pokeapi.co/api/v2/pokemon/798/"},{"name":"guzzlord","url":"https://pokeapi.co/api/v2/pokemon/799/"},{"name":"necrozma","url":"https://pokeapi.co/api/v2/pokemon/800/"},{"name":"magearna","url":"https://pokeapi.co/api/v2/pokemon/801/"},{"name":"marshadow","url":"https://pokeapi.co/api/v2/pokemon/802/"},{"name":"poipole","url":"https://pokeapi.co/api/v2/pokemon/803/"},{"name":"naganadel","url":"https://pokeapi.co/api/v2/pokemon/804/"},{"name":"stakataka","url":"https://pokeapi.co/api/v2/pokemon/805/"},{"name":"blacephalon","url":"https://pokeapi.co/api/v2/pokemon/806/"},{"name":"zeraora","url":"https://pokeapi.co/api/v2/pokemon/807/"},{"name":"deoxys-attack","url":"https://pokeapi.co/api/v2/pokemon/10001/"},{"name":"deoxys-defense","url":"https://pokeapi.co/api/v2/pokemon/10002/"},{"name":"deoxys-speed","url":"https://pokeapi.co/api/v2/pokemon/10003/"},{"name":"wormadam-sandy","url":"https://pokeapi.co/api/v2/pokemon/10004/"},{"name":"wormadam-trash","url":"https://pokeapi.co/api/v2/pokemon/10005/"},{"name":"shaymin-sky","url":"https://pokeapi.co/api/v2/pokemon/10006/"},{"name":"giratina-origin","url":"https://pokeapi.co/api/v2/pokemon/10007/"},{"name":"rotom-heat","url":"https://pokeapi.co/api/v2/pokemon/10008/"},{"name":"rotom-wash","url":"https://pokeapi.co/api/v2/pokemon/10009/"},{"name":"rotom-frost","url":"https://pokeapi.co/api/v2/pokemon/10010/"},{"name":"rotom-fan","url":"https://pokeapi.co/api/v2/pokemon/10011/"},{"name":"rotom-mow","url":"https://pokeapi.co/api/v2/pokemon/10012/"},{"name":"castform-sunny","url":"https://pokeapi.co/api/v2/pokemon/10013/"},{"name":"castform-rainy","url":"https://pokeapi.co/api/v2/pokemon/10014/"},{"name":"castform-snowy","url":"https://pokeapi.co/api/v2/pokemon/10015/"},{"name":"basculin-blue-striped","url":"https://pokeapi.co/api/v2/pokemon/10016/"},{"name":"darmanitan-zen","url":"https://pokeapi.co/api/v2/pokemon/10017/"},{"name":"meloetta-pirouette","url":"https://pokeapi.co/api/v2/pokemon/10018/"},{"name":"tornadus-therian","url":"https://pokeapi.co/api/v2/pokemon/10019/"},{"name":"thundurus-therian","url":"https://pokeapi.co/api/v2/pokemon/10020/"},{"name":"landorus-therian","url":"https://pokeapi.co/api/v2/pokemon/10021/"},{"name":"kyurem-black","url":"https://pokeapi.co/api/v2/pokemon/10022/"},{"name":"kyurem-white","url":"https://pokeapi.co/api/v2/pokemon/10023/"},{"name":"keldeo-resolute","url":"https://pokeapi.co/api/v2/pokemon/10024/"},{"name":"meowstic-female","url":"https://pokeapi.co/api/v2/pokemon/10025/"},{"name":"aegislash-blade","url":"https://pokeapi.co/api/v2/pokemon/10026/"},{"name":"pumpkaboo-small","url":"https://pokeapi.co/api/v2/pokemon/10027/"},{"name":"pumpkaboo-large","url":"https://pokeapi.co/api/v2/pokemon/10028/"},{"name":"pumpkaboo-super","url":"https://pokeapi.co/api/v2/pokemon/10029/"},{"name":"gourgeist-small","url":"https://pokeapi.co/api/v2/pokemon/10030/"},{"name":"gourgeist-large","url":"https://pokeapi.co/api/v2/pokemon/10031/"},{"name":"gourgeist-super","url":"https://pokeapi.co/api/v2/pokemon/10032/"},{"name":"venusaur-mega","url":"https://pokeapi.co/api/v2/pokemon/10033/"},{"name":"charizard-mega-x","url":"https://pokeapi.co/api/v2/pokemon/10034/"},{"name":"charizard-mega-y","url":"https://pokeapi.co/api/v2/pokemon/10035/"},{"name":"blastoise-mega","url":"https://pokeapi.co/api/v2/pokemon/10036/"},{"name":"alakazam-mega","url":"https://pokeapi.co/api/v2/pokemon/10037/"},{"name":"gengar-mega","url":"https://pokeapi.co/api/v2/pokemon/10038/"},{"name":"kangaskhan-mega","url":"https://pokeapi.co/api/v2/pokemon/10039/"},{"name":"pinsir-mega","url":"https://pokeapi.co/api/v2/pokemon/10040/"},{"name":"gyarados-mega","url":"https://pokeapi.co/api/v2/pokemon/10041/"},{"name":"aerodactyl-mega","url":"https://pokeapi.co/api/v2/pokemon/10042/"},{"name":"mewtwo-mega-x","url":"https://pokeapi.co/api/v2/pokemon/10043/"},{"name":"mewtwo-mega-y","url":"https://pokeapi.co/api/v2/pokemon/10044/"},{"name":"ampharos-mega","url":"https://pokeapi.co/api/v2/pokemon/10045/"},{"name":"scizor-mega","url":"https://pokeapi.co/api/v2/pokemon/10046/"},{"name":"heracross-mega","url":"https://pokeapi.co/api/v2/pokemon/10047/"},{"name":"houndoom-mega","url":"https://pokeapi.co/api/v2/pokemon/10048/"},{"name":"tyranitar-mega","url":"https://pokeapi.co/api/v2/pokemon/10049/"},{"name":"blaziken-mega","url":"https://pokeapi.co/api/v2/pokemon/10050/"},{"name":"gardevoir-mega","url":"https://pokeapi.co/api/v2/pokemon/10051/"},{"name":"mawile-mega","url":"https://pokeapi.co/api/v2/pokemon/10052/"},{"name":"aggron-mega","url":"https://pokeapi.co/api/v2/pokemon/10053/"},{"name":"medicham-mega","url":"https://pokeapi.co/api/v2/pokemon/10054/"},{"name":"manectric-mega","url":"https://pokeapi.co/api/v2/pokemon/10055/"},{"name":"banette-mega","url":"https://pokeapi.co/api/v2/pokemon/10056/"},{"name":"absol-mega","url":"https://pokeapi.co/api/v2/pokemon/10057/"},{"name":"garchomp-mega","url":"https://pokeapi.co/api/v2/pokemon/10058/"},{"name":"lucario-mega","url":"https://pokeapi.co/api/v2/pokemon/10059/"},{"name":"abomasnow-mega","url":"https://pokeapi.co/api/v2/pokemon/10060/"},{"name":"floette-eternal","url":"https://pokeapi.co/api/v2/pokemon/10061/"},{"name":"latias-mega","url":"https://pokeapi.co/api/v2/pokemon/10062/"},{"name":"latios-mega","url":"https://pokeapi.co/api/v2/pokemon/10063/"},{"name":"swampert-mega","url":"https://pokeapi.co/api/v2/pokemon/10064/"},{"name":"sceptile-mega","url":"https://pokeapi.co/api/v2/pokemon/10065/"},{"name":"sableye-mega","url":"https://pokeapi.co/api/v2/pokemon/10066/"},{"name":"altaria-mega","url":"https://pokeapi.co/api/v2/pokemon/10067/"},{"name":"gallade-mega","url":"https://pokeapi.co/api/v2/pokemon/10068/"},{"name":"audino-mega","url":"https://pokeapi.co/api/v2/pokemon/10069/"},{"name":"sharpedo-mega","url":"https://pokeapi.co/api/v2/pokemon/10070/"},{"name":"slowbro-mega","url":"https://pokeapi.co/api/v2/pokemon/10071/"},{"name":"steelix-mega","url":"https://pokeapi.co/api/v2/pokemon/10072/"},{"name":"pidgeot-mega","url":"https://pokeapi.co/api/v2/pokemon/10073/"},{"name":"glalie-mega","url":"https://pokeapi.co/api/v2/pokemon/10074/"},{"name":"diancie-mega","url":"https://pokeapi.co/api/v2/pokemon/10075/"},{"name":"metagross-mega","url":"https://pokeapi.co/api/v2/pokemon/10076/"},{"name":"kyogre-primal","url":"https://pokeapi.co/api/v2/pokemon/10077/"},{"name":"groudon-primal","url":"https://pokeapi.co/api/v2/pokemon/10078/"},{"name":"rayquaza-mega","url":"https://pokeapi.co/api/v2/pokemon/10079/"},{"name":"pikachu-rock-star","url":"https://pokeapi.co/api/v2/pokemon/10080/"},{"name":"pikachu-belle","url":"https://pokeapi.co/api/v2/pokemon/10081/"},{"name":"pikachu-pop-star","url":"https://pokeapi.co/api/v2/pokemon/10082/"},{"name":"pikachu-phd","url":"https://pokeapi.co/api/v2/pokemon/10083/"},{"name":"pikachu-libre","url":"https://pokeapi.co/api/v2/pokemon/10084/"},{"name":"pikachu-cosplay","url":"https://pokeapi.co/api/v2/pokemon/10085/"},{"name":"hoopa-unbound","url":"https://pokeapi.co/api/v2/pokemon/10086/"},{"name":"camerupt-mega","url":"https://pokeapi.co/api/v2/pokemon/10087/"},{"name":"lopunny-mega","url":"https://pokeapi.co/api/v2/pokemon/10088/"},{"name":"salamence-mega","url":"https://pokeapi.co/api/v2/pokemon/10089/"},{"name":"beedrill-mega","url":"https://pokeapi.co/api/v2/pokemon/10090/"},{"name":"rattata-alola","url":"https://pokeapi.co/api/v2/pokemon/10091/"},{"name":"raticate-alola","url":"https://pokeapi.co/api/v2/pokemon/10092/"},{"name":"raticate-totem-alola","url":"https://pokeapi.co/api/v2/pokemon/10093/"},{"name":"pikachu-original-cap","url":"https://pokeapi.co/api/v2/pokemon/10094/"},{"name":"pikachu-hoenn-cap","url":"https://pokeapi.co/api/v2/pokemon/10095/"},{"name":"pikachu-sinnoh-cap","url":"https://pokeapi.co/api/v2/pokemon/10096/"},{"name":"pikachu-unova-cap","url":"https://pokeapi.co/api/v2/pokemon/10097/"},{"name":"pikachu-kalos-cap","url":"https://pokeapi.co/api/v2/pokemon/10098/"},{"name":"pikachu-alola-cap","url":"https://pokeapi.co/api/v2/pokemon/10099/"},{"name":"raichu-alola","url":"https://pokeapi.co/api/v2/pokemon/10100/"},{"name":"sandshrew-alola","url":"https://pokeapi.co/api/v2/pokemon/10101/"},{"name":"sandslash-alola","url":"https://pokeapi.co/api/v2/pokemon/10102/"},{"name":"vulpix-alola","url":"https://pokeapi.co/api/v2/pokemon/10103/"},{"name":"ninetales-alola","url":"https://pokeapi.co/api/v2/pokemon/10104/"},{"name":"diglett-alola","url":"https://pokeapi.co/api/v2/pokemon/10105/"},{"name":"dugtrio-alola","url":"https://pokeapi.co/api/v2/pokemon/10106/"},{"name":"meowth-alola","url":"https://pokeapi.co/api/v2/pokemon/10107/"},{"name":"persian-alola","url":"https://pokeapi.co/api/v2/pokemon/10108/"},{"name":"geodude-alola","url":"https://pokeapi.co/api/v2/pokemon/10109/"},{"name":"graveler-alola","url":"https://pokeapi.co/api/v2/pokemon/10110/"},{"name":"golem-alola","url":"https://pokeapi.co/api/v2/pokemon/10111/"},{"name":"grimer-alola","url":"https://pokeapi.co/api/v2/pokemon/10112/"},{"name":"muk-alola","url":"https://pokeapi.co/api/v2/pokemon/10113/"},{"name":"exeggutor-alola","url":"https://pokeapi.co/api/v2/pokemon/10114/"},{"name":"marowak-alola","url":"https://pokeapi.co/api/v2/pokemon/10115/"},{"name":"greninja-battle-bond","url":"https://pokeapi.co/api/v2/pokemon/10116/"},{"name":"greninja-ash","url":"https://pokeapi.co/api/v2/pokemon/10117/"},{"name":"zygarde-10","url":"https://pokeapi.co/api/v2/pokemon/10118/"},{"name":"zygarde-50","url":"https://pokeapi.co/api/v2/pokemon/10119/"},{"name":"zygarde-complete","url":"https://pokeapi.co/api/v2/pokemon/10120/"},{"name":"gumshoos-totem","url":"https://pokeapi.co/api/v2/pokemon/10121/"},{"name":"vikavolt-totem","url":"https://pokeapi.co/api/v2/pokemon/10122/"},{"name":"oricorio-pom-pom","url":"https://pokeapi.co/api/v2/pokemon/10123/"},{"name":"oricorio-pau","url":"https://pokeapi.co/api/v2/pokemon/10124/"},{"name":"oricorio-sensu","url":"https://pokeapi.co/api/v2/pokemon/10125/"},{"name":"lycanroc-midnight","url":"https://pokeapi.co/api/v2/pokemon/10126/"},{"name":"wishiwashi-school","url":"https://pokeapi.co/api/v2/pokemon/10127/"},{"name":"lurantis-totem","url":"https://pokeapi.co/api/v2/pokemon/10128/"},{"name":"salazzle-totem","url":"https://pokeapi.co/api/v2/pokemon/10129/"},{"name":"minior-orange-meteor","url":"https://pokeapi.co/api/v2/pokemon/10130/"},{"name":"minior-yellow-meteor","url":"https://pokeapi.co/api/v2/pokemon/10131/"},{"name":"minior-green-meteor","url":"https://pokeapi.co/api/v2/pokemon/10132/"},{"name":"minior-blue-meteor","url":"https://pokeapi.co/api/v2/pokemon/10133/"},{"name":"minior-indigo-meteor","url":"https://pokeapi.co/api/v2/pokemon/10134/"},{"name":"minior-violet-meteor","url":"https://pokeapi.co/api/v2/pokemon/10135/"},{"name":"minior-red","url":"https://pokeapi.co/api/v2/pokemon/10136/"},{"name":"minior-orange","url":"https://pokeapi.co/api/v2/pokemon/10137/"},{"name":"minior-yellow","url":"https://pokeapi.co/api/v2/pokemon/10138/"},{"name":"minior-green","url":"https://pokeapi.co/api/v2/pokemon/10139/"},{"name":"minior-blue","url":"https://pokeapi.co/api/v2/pokemon/10140/"},{"name":"minior-indigo","url":"https://pokeapi.co/api/v2/pokemon/10141/"},{"name":"minior-violet","url":"https://pokeapi.co/api/v2/pokemon/10142/"},{"name":"mimikyu-busted","url":"https://pokeapi.co/api/v2/pokemon/10143/"},{"name":"mimikyu-totem-disguised","url":"https://pokeapi.co/api/v2/pokemon/10144/"},{"name":"mimikyu-totem-busted","url":"https://pokeapi.co/api/v2/pokemon/10145/"},{"name":"kommo-o-totem","url":"https://pokeapi.co/api/v2/pokemon/10146/"},{"name":"magearna-original","url":"https://pokeapi.co/api/v2/pokemon/10147/"},{"name":"pikachu-partner-cap","url":"https://pokeapi.co/api/v2/pokemon/10148/"},{"name":"marowak-totem","url":"https://pokeapi.co/api/v2/pokemon/10149/"},{"name":"ribombee-totem","url":"https://pokeapi.co/api/v2/pokemon/10150/"},{"name":"rockruff-own-tempo","url":"https://pokeapi.co/api/v2/pokemon/10151/"},{"name":"lycanroc-dusk","url":"https://pokeapi.co/api/v2/pokemon/10152/"},{"name":"araquanid-totem","url":"https://pokeapi.co/api/v2/pokemon/10153/"},{"name":"togedemaru-totem","url":"https://pokeapi.co/api/v2/pokemon/10154/"},{"name":"necrozma-dusk","url":"https://pokeapi.co/api/v2/pokemon/10155/"},{"name":"necrozma-dawn","url":"https://pokeapi.co/api/v2/pokemon/10156/"},{"name":"necrozma-ultra","url":"https://pokeapi.co/api/v2/pokemon/10157/"}]}"#;

// https://pokeapi.co/api/v2/pokemon-color/?offset=0&limit=9999
static FULL_POKEMON_COLOR_LIST_JSON: &str = r#"{"count":10,"next":null,"previous":null,"results":[{"name":"black","url":"https://pokeapi.co/api/v2/pokemon-color/1/"},{"name":"blue","url":"https://pokeapi.co/api/v2/pokemon-color/2/"},{"name":"brown","url":"https://pokeapi.co/api/v2/pokemon-color/3/"},{"name":"gray","url":"https://pokeapi.co/api/v2/pokemon-color/4/"},{"name":"green","url":"https://pokeapi.co/api/v2/pokemon-color/5/"},{"name":"pink","url":"https://pokeapi.co/api/v2/pokemon-color/6/"},{"name":"purple","url":"https://pokeapi.co/api/v2/pokemon-color/7/"},{"name":"red","url":"https://pokeapi.co/api/v2/pokemon-color/8/"},{"name":"white","url":"https://pokeapi.co/api/v2/pokemon-color/9/"},{"name":"yellow","url":"https://pokeapi.co/api/v2/pokemon-color/10/"}]}"#;

// https://pokeapi.co/api/v2/pokemon-form/?offset=0&limit=9999
static FULL_POKEMON_FORM_LIST_JSON: &str = r#"{"count":1123,"next":null,"previous":null,"results":[{"name":"bulbasaur","url":"https://pokeapi.co/api/v2/pokemon-form/1/"},{"name":"ivysaur","url":"https://pokeapi.co/api/v2/pokemon-form/2/"},{"name":"venusaur","url":"https://pokeapi.co/api/v2/pokemon-form/3/"},{"name":"charmander","url":"https://pokeapi.co/api/v2/pokemon-form/4/"},{"name":"charmeleon","url":"https://pokeapi.co/api/v2/pokemon-form/5/"},{"name":"charizard","url":"https://pokeapi.co/api/v2/pokemon-form/6/"},{"name":"squirtle","url":"https://pokeapi.co/api/v2/pokemon-form/7/"},{"name":"wartortle","url":"https://pokeapi.co/api/v2/pokemon-form/8/"},{"name":"blastoise","url":"https://pokeapi.co/api/v2/pokemon-form/9/"},{"name":"caterpie","url":"https://pokeapi.co/api/v2/pokemon-form/10/"},{"name":"metapod","url":"https://pokeapi.co/api/v2/pokemon-form/11/"},{"name":"butterfree","url":"https://pokeapi.co/api/v2/pokemon-form/12/"},{"name":"weedle","url":"https://pokeapi.co/api/v2/pokemon-form/13/"},{"name":"kakuna","url":"https://pokeapi.co/api/v2/pokemon-form/14/"},{"name":"beedrill","url":"https://pokeapi.co/api/v2/pokemon-form/15/"},{"name":"pidgey","url":"https://pokeapi.co/api/v2/pokemon-form/16/"},{"name":"pidgeotto","url":"https://pokeapi.co/api/v2/pokemon-form/17/"},{"name":"pidgeot","url":"https://pokeapi.co/api/v2/pokemon-form/18/"},{"name":"rattata","url":"https://pokeapi.co/api/v2/pokemon-form/19/"},{"name":"raticate","url":"https://pokeapi.co/api/v2/pokemon-form/20/"},{"name":"spearow","url":"https://pokeapi.co/api/v2/pokemon-form/21/"},{"name":"fearow","url":"https://pokeapi.co/api/v2/pokemon-form/22/"},{"name":"ekans","url":"https://pokeapi.co/api/v2/pokemon-form/23/"},{"name":"arbok","url":"https://pokeapi.co/api/v2/pokemon-form/24/"},{"name":"pikachu","url":"https://pokeapi.co/api/v2/pokemon-form/25/"},{"name":"raichu","url":"https://pokeapi.co/api/v2/pokemon-form/26/"},{"name":"sandshrew","url":"https://pokeapi.co/api/v2/pokemon-form/27/"},{"name":"sandslash","url":"https://pokeapi.co/api/v2/pokemon-form/28/"},{"name":"nidoran-f","url":"https://pokeapi.co/api/v2/pokemon-form/29/"},{"name":"nidorina","url":"https://pokeapi.co/api/v2/pokemon-form/30/"},{"name":"nidoqueen","url":"https://pokeapi.co/api/v2/pokemon-form/31/"},{"name":"nidoran-m","url":"https://pokeapi.co/api/v2/pokemon-form/32/"},{"name":"nidorino","url":"https://pokeapi.co/api/v2/pokemon-form/33/"},{"name":"nidoking","url":"https://pokeapi.co/api/v2/pokemon-form/34/"},{"name":"clefairy","url":"https://pokeapi.co/api/v2/pokemon-form/35/"},{"name":"clefable","url":"https://pokeapi.co/api/v2/pokemon-form/36/"},{"name":"vulpix","url":"https://pokeapi.co/api/v2/pokemon-form/37/"},{"name":"ninetales","url":"https://pokeapi.co/api/v2/pokemon-form/38/"},{"name":"jigglypuff","url":"https://pokeapi.co/api/v2/pokemon-form/39/"},{"name":"wigglytuff","url":"https://pokeapi.co/api/v2/pokemon-form/40/"},{"name":"zubat","url":"https://pokeapi.co/api/v2/pokemon-form/41/"},{"name":"golbat","url":"https://pokeapi.co/api/v2/pokemon-form/42/"},{"name":"oddish","url":"https://pokeapi.co/api/v2/pokemon-form/43/"},{"name":"gloom","url":"https://pokeapi.co/api/v2/pokemon-form/44/"},{"name":"vileplume","url":"https://pokeapi.co/api/v2/pokemon-form/45/"},{"name":"paras","url":"https://pokeapi.co/api/v2/pokemon-form/46/"},{"name":"parasect","url":"https://pokeapi.co/api/v2/pokemon-form/47/"},{"name":"venonat","url":"https://pokeapi.co/api/v2/pokemon-form/48/"},{"name":"venomoth","url":"https://pokeapi.co/api/v2/pokemon-form/49/"},{"name":"diglett","url":"https://pokeapi.co/api/v2/pokemon-form/50/"},{"name":"dugtrio","url":"https://pokeapi.co/api/v2/pokemon-form/51/"},{"name":"meowth","url":"https://pokeapi.co/api/v2/pokemon-form/52/"},{"name":"persian","url":"https://pokeapi.co/api/v2/pokemon-form/53/"},{"name":"psyduck","url":"https://pokeapi.co/api/v2/pokemon-form/54/"},{"name":"golduck","url":"https://pokeapi.co/api/v2/pokemon-form/55/"},{"name":"mankey","url":"https://pokeapi.co/api/v2/pokemon-form/56/"},{"name":"primeape","url":"https://pokeapi.co/api/v2/pokemon-form/57/"},{"name":"growlithe","url":"https://pokeapi.co/api/v2/pokemon-form/58/"},{"name":"arcanine","url":"https://pokeapi.co/api/v2/pokemon-form/59/"},{"name":"poliwag","url":"https://pokeapi.co/api/v2/pokemon-form/60/"},{"name":"poliwhirl","url":"https://pokeapi.co/api/v2/pokemon-form/61/"},{"name":"poliwrath","url":"https://pokeapi.co/api/v2/pokemon-form/62/"},{"name":"abra","url":"https://pokeapi.co/api/v2/pokemon-form/63/"},{"name":"kadabra","url":"https://pokeapi.co/api/v2/pokemon-form/64/"},{"name":"alakazam","url":"https://pokeapi.co/api/v2/pokemon-form/65/"},{"name":"machop","url":"https://pokeapi.co/api/v2/pokemon-form/66/"},{"name":"machoke","url":"https://pokeapi.co/api/v2/pokemon-form/67/"},{"name":"machamp","url":"https://pokeapi.co/api/v2/pokemon-form/68/"},{"name":"bellsprout","url":"https://pokeapi.co/api/v2/pokemon-form/69/"},{"name":"weepinbell","url":"https://pokeapi.co/api/v2/pokemon-form/70/"},{"name":"victreebel","url":"https://pokeapi.co/api/v2/pokemon-form/71/"},{"name":"tentacool","url":"https://pokeapi.co/api/v2/pokemon-form/72/"},{"name":"tentacruel","url":"https://pokeapi.co/api/v2/pokemon-form/73/"},{"name":"geodude","url":"https://pokeapi.co/api/v2/pokemon-form/74/"},{"name":"graveler","url":"https://pokeapi.co/api/v2/pokemon-form/75/"},{"name":"golem","url":"https://pokeapi.co/api/v2/pokemon-form/76/"},{"name":"ponyta","url":"https://pokeapi.co/api/v2/pokemon-form/77/"},{"name":"rapidash","url":"https://pokeapi.co/api/v2/pokemon-form/78/"},{"name":"slowpoke","url":"https://pokeapi.co/api/v2/pokemon-form/79/"},{"name":"slowbro","url":"https://pokeapi.co/api/v2/pokemon-form/80/"},{"name":"magnemite","url":"https://pokeapi.co/api/v2/pokemon-form/81/"},{"name":"magneton","url":"https://pokeapi.co/api/v2/pokemon-form/82/"},{"name":"farfetchd","url":"https://pokeapi.co/api/v2/pokemon-form/83/"},{"name":"doduo","url":"https://pokeapi.co/api/v2/pokemon-form/84/"},{"name":"dodrio","url":"https://pokeapi.co/api/v2/pokemon-form/85/"},{"name":"seel","url":"https://pokeapi.co/api/v2/pokemon-form/86/"},{"name":"dewgong","url":"https://pokeapi.co/api/v2/pokemon-form/87/"},{"name":"grimer","url":"https://pokeapi.co/api/v2/pokemon-form/88/"},{"name":"muk","url":"https://pokeapi.co/api/v2/pokemon-form/89/"},{"name":"shellder","url":"https://pokeapi.co/api/v2/pokemon-form/90/"},{"name":"cloyster","url":"https://pokeapi.co/api/v2/pokemon-form/91/"},{"name":"gastly","url":"https://pokeapi.co/api/v2/pokemon-form/92/"},{"name":"haunter","url":"https://pokeapi.co/api/v2/pokemon-form/93/"},{"name":"gengar","url":"https://pokeapi.co/api/v2/pokemon-form/94/"},{"name":"onix","url":"https://pokeapi.co/api/v2/pokemon-form/95/"},{"name":"drowzee","url":"https://pokeapi.co/api/v2/pokemon-form/96/"},{"name":"hypno","url":"https://pokeapi.co/api/v2/pokemon-form/97/"},{"name":"krabby","url":"https://pokeapi.co/api/v2/pokemon-form/98/"},{"name":"kingler","url":"https://pokeapi.co/api/v2/pokemon-form/99/"},{"name":"voltorb","url":"https://pokeapi.co/api/v2/pokemon-form/100/"},{"name":"electrode","url":"https://pokeapi.co/api/v2/pokemon-form/101/"},{"name":"exeggcute","url":"https://pokeapi.co/api/v2/pokemon-form/102/"},{"name":"exeggutor","url":"https://pokeapi.co/api/v2/pokemon-form/103/"},{"name":"cubone","url":"https://pokeapi.co/api/v2/pokemon-form/104/"},{"name":"marowak","url":"https://pokeapi.co/api/v2/pokemon-form/105/"},{"name":"hitmonlee","url":"https://pokeapi.co/api/v2/pokemon-form/106/"},{"name":"hitmonchan","url":"https://pokeapi.co/api/v2/pokemon-form/107/"},{"name":"lickitung","url":"https://pokeapi.co/api/v2/pokemon-form/108/"},{"name":"koffing","url":"https://pokeapi.co/api/v2/pokemon-form/109/"},{"name":"weezing","url":"https://pokeapi.co/api/v2/pokemon-form/110/"},{"name":"rhyhorn","url":"https://pokeapi.co/api/v2/pokemon-form/111/"},{"name":"rhydon","url":"https://pokeapi.co/api/v2/pokemon-form/112/"},{"name":"chansey","url":"https://pokeapi.co/api/v2/pokemon-form/113/"},{"name":"tangela","url":"https://pokeapi.co/api/v2/pokemon-form/114/"},{"name":"kangaskhan","url":"https://pokeapi.co/api/v2/pokemon-form/115/"},{"name":"horsea","url":"https://pokeapi.co/api/v2/pokemon-form/116/"},{"name":"seadra","url":"https://pokeapi.co/api/v2/pokemon-form/117/"},{"name":"goldeen","url":"https://pokeapi.co/api/v2/pokemon-form/118/"},{"name":"seaking","url":"https://pokeapi.co/api/v2/pokemon-form/119/"},{"name":"staryu","url":"https://pokeapi.co/api/v2/pokemon-form/120/"},{"name":"starmie","url":"https://pokeapi.co/api/v2/pokemon-form/121/"},{"name":"mr-mime","url":"https://pokeapi.co/api/v2/pokemon-form/122/"},{"name":"scyther","url":"https://pokeapi.co/api/v2/pokemon-form/123/"},{"name":"jynx","url":"https://pokeapi.co/api/v2/pokemon-form/124/"},{"name":"electabuzz","url":"https://pokeapi.co/api/v2/pokemon-form/125/"},{"name":"magmar","url":"https://pokeapi.co/api/v2/pokemon-form/126/"},{"name":"pinsir","url":"https://pokeapi.co/api/v2/pokemon-form/127/"},{"name":"tauros","url":"https://pokeapi.co/api/v2/pokemon-form/128/"},{"name":"magikarp","url":"https://pokeapi.co/api/v2/pokemon-form/129/"},{"name":"gyarados","url":"https://pokeapi.co/api/v2/pokemon-form/130/"},{"name":"lapras","url":"https://pokeapi.co/api/v2/pokemon-form/131/"},{"name":"ditto","url":"https://pokeapi.co/api/v2/pokemon-form/132/"},{"name":"eevee","url":"https://pokeapi.co/api/v2/pokemon-form/133/"},{"name":"vaporeon","url":"https://pokeapi.co/api/v2/pokemon-form/134/"},{"name":"jolteon","url":"https://pokeapi.co/api/v2/pokemon-form/135/"},{"name":"flareon","url":"https://pokeapi.co/api/v2/pokemon-form/136/"},{"name":"porygon","url":"https://pokeapi.co/api/v2/pokemon-form/137/"},{"name":"omanyte","url":"https://pokeapi.co/api/v2/pokemon-form/138/"},{"name":"omastar","url":"https://pokeapi.co/api/v2/pokemon-form/139/"},{"name":"kabuto","url":"https://pokeapi.co/api/v2/pokemon-form/140/"},{"name":"kabutops","url":"https://pokeapi.co/api/v2/pokemon-form/141/"},{"name":"aerodactyl","url":"https://pokeapi.co/api/v2/pokemon-form/142/"},{"name":"snorlax","url":"https://pokeapi.co/api/v2/pokemon-form/143/"},{"name":"articuno","url":"https://pokeapi.co/api/v2/pokemon-form/144/"},{"name":"zapdos","url":"https://pokeapi.co/api/v2/pokemon-form/145/"},{"name":"moltres","url":"https://pokeapi.co/api/v2/pokemon-form/146/"},{"name":"dratini","url":"https://pokeapi.co/api/v2/pokemon-form/147/"},{"name":"dragonair","url":"https://pokeapi.co/api/v2/pokemon-form/148/"},{"name":"dragonite","url":"https://pokeapi.co/api/v2/pokemon-form/149/"},{"name":"mewtwo","url":"https://pokeapi.co/api/v2/pokemon-form/150/"},{"name":"mew","url":"https://pokeapi.co/api/v2/pokemon-form/151/"},{"name":"chikorita","url":"https://pokeapi.co/api/v2/pokemon-form/152/"},{"name":"bayleef","url":"https://pokeapi.co/api/v2/pokemon-form/153/"},{"name":"meganium","url":"https://pokeapi.co/api/v2/pokemon-form/154/"},{"name":"cyndaquil","url":"https://pokeapi.co/api/v2/pokemon-form/155/"},{"name":"quilava","url":"https://pokeapi.co/api/v2/pokemon-form/156/"},{"name":"typhlosion","url":"https://pokeapi.co/api/v2/pokemon-form/157/"},{"name":"totodile","url":"https://pokeapi.co/api/v2/pokemon-form/158/"},{"name":"croconaw","url":"https://pokeapi.co/api/v2/pokemon-form/159/"},{"name":"feraligatr","url":"https://pokeapi.co/api/v2/pokemon-form/160/"},{"name":"sentret","url":"https://pokeapi.co/api/v2/pokemon-form/161/"},{"name":"furret","url":"https://pokeapi.co/api/v2/pokemon-form/162/"},{"name":"hoothoot","url":"https://pokeapi.co/api/v2/pokemon-form/163/"},{"name":"noctowl","url":"https://pokeapi.co/api/v2/pokemon-form/164/"},{"name":"ledyba","url":"https://pokeapi.co/api/v2/pokemon-form/165/"},{"name":"ledian","url":"https://pokeapi.co/api/v2/pokemon-form/166/"},{"name":"spinarak","url":"https://pokeapi.co/api/v2/pokemon-form/167/"},{"name":"ariados","url":"https://pokeapi.co/api/v2/pokemon-form/168/"},{"name":"crobat","url":"https://pokeapi.co/api/v2/pokemon-form/169/"},{"name":"chinchou","url":"https://pokeapi.co/api/v2/pokemon-form/170/"},{"name":"lanturn","url":"https://pokeapi.co/api/v2/pokemon-form/171/"},{"name":"pichu","url":"https://pokeapi.co/api/v2/pokemon-form/172/"},{"name":"cleffa","url":"https://pokeapi.co/api/v2/pokemon-form/173/"},{"name":"igglybuff","url":"https://pokeapi.co/api/v2/pokemon-form/174/"},{"name":"togepi","url":"https://pokeapi.co/api/v2/pokemon-form/175/"},{"name":"togetic","url":"https://pokeapi.co/api/v2/pokemon-form/176/"},{"name":"natu","url":"https://pokeapi.co/api/v2/pokemon-form/177/"},{"name":"xatu","url":"https://pokeapi.co/api/v2/pokemon-form/178/"},{"name":"mareep","url":"https://pokeapi.co/api/v2/pokemon-form/179/"},{"name":"flaaffy","url":"https://pokeapi.co/api/v2/pokemon-form/180/"},{"name":"ampharos","url":"https://pokeapi.co/api/v2/pokemon-form/181/"},{"name":"bellossom","url":"https://pokeapi.co/api/v2/pokemon-form/182/"},{"name":"marill","url":"https://pokeapi.co/api/v2/pokemon-form/183/"},{"name":"azumarill","url":"https://pokeapi.co/api/v2/pokemon-form/184/"},{"name":"sudowoodo","url":"https://pokeapi.co/api/v2/pokemon-form/185/"},{"name":"politoed","url":"https://pokeapi.co/api/v2/pokemon-form/186/"},{"name":"hoppip","url":"https://pokeapi.co/api/v2/pokemon-form/187/"},{"name":"skiploom","url":"https://pokeapi.co/api/v2/pokemon-form/188/"},{"name":"jumpluff","url":"https://pokeapi.co/api/v2/pokemon-form/189/"},{"name":"aipom","url":"https://pokeapi.co/api/v2/pokemon-form/190/"},{"name":"sunkern","url":"https://pokeapi.co/api/v2/pokemon-form/191/"},{"name":"sunflora","url":"https://pokeapi.co/api/v2/pokemon-form/192/"},{"name":"yanma","url":"https://pokeapi.co/api/v2/pokemon-form/193/"},{"name":"wooper","url":"https://pokeapi.co/api/v2/pokemon-form/194/"},{"name":"quagsire","url":"https://pokeapi.co/api/v2/pokemon-form/195/"},{"name":"espeon","url":"https://pokeapi.co/api/v2/pokemon-form/196/"},{"name":"umbreon","url":"https://pokeapi.co/api/v2/pokemon-form/197/"},{"name":"murkrow","url":"https://pokeapi.co/api/v2/pokemon-form/198/"},{"name":"slowking","url":"https://pokeapi.co/api/v2/pokemon-form/199/"},{"name":"misdreavus","url":"https://pokeapi.co/api/v2/pokemon-form/200/"},{"name":"unown-a","url":"https://pokeapi.co/api/v2/pokemon-form/201/"},{"name":"wobbuffet","url":"https://pokeapi.co/api/v2/pokemon-form/202/"},{"name":"girafarig","url":"https://pokeapi.co/api/v2/pokemon-form/203/"},{"name":"pineco","url":"https://pokeapi.co/api/v2/pokemon-form/204/"},{"name":"forretress","url":"https://pokeapi.co/api/v2/pokemon-form/205/"},{"name":"dunsparce","url":"https://pokeapi.co/api/v2/pokemon-form/206/"},{"name":"gligar","url":"https://pokeapi.co/api/v2/pokemon-form/207/"},{"name":"steelix","url":"https://pokeapi.co/api/v2/pokemon-form/208/"},{"name":"snubbull","url":"https://pokeapi.co/api/v2/pokemon-form/209/"},{"name":"granbull","url":"https://pokeapi.co/api/v2/pokemon-form/210/"},{"name":"qwilfish","url":"https://pokeapi.co/api/v2/pokemon-form/211/"},{"name":"scizor","url":"https://pokeapi.co/api/v2/pokemon-form/212/"},{"name":"shuckle","url":"https://pokeapi.co/api/v2/pokemon-form/213/"},{"name":"heracross","url":"https://pokeapi.co/api/v2/pokemon-form/214/"},{"name":"sneasel","url":"https://pokeapi.co/api/v2/pokemon-form/215/"},{"name":"teddiursa","url":"https://pokeapi.co/api/v2/pokemon-form/216/"},{"name":"ursaring","url":"https://pokeapi.co/api/v2/pokemon-form/217/"},{"name":"slugma","url":"https://pokeapi.co/api/v2/pokemon-form/218/"},{"name":"magcargo","url":"https://pokeapi.co/api/v2/pokemon-form/219/"},{"name":"swinub","url":"https://pokeapi.co/api/v2/pokemon-form/220/"},{"name":"piloswine","url":"https://pokeapi.co/api/v2/pokemon-form/221/"},{"name":"corsola","url":"https://pokeapi.co/api/v2/pokemon-form/222/"},{"name":"remoraid","url":"https://pokeapi.co/api/v2/pokemon-form/223/"},{"name":"octillery","url":"https://pokeapi.co/api/v2/pokemon-form/224/"},{"name":"delibird","url":"https://pokeapi.co/api/v2/pokemon-form/225/"},{"name":"mantine","url":"https://pokeapi.co/api/v2/pokemon-form/226/"},{"name":"skarmory","url":"https://pokeapi.co/api/v2/pokemon-form/227/"},{"name":"houndour","url":"https://pokeapi.co/api/v2/pokemon-form/228/"},{"name":"houndoom","url":"https://pokeapi.co/api/v2/pokemon-form/229/"},{"name":"kingdra","url":"https://pokeapi.co/api/v2/pokemon-form/230/"},{"name":"phanpy","url":"https://pokeapi.co/api/v2/pokemon-form/231/"},{"name":"donphan","url":"https://pokeapi.co/api/v2/pokemon-form/232/"},{"name":"porygon2","url":"https://pokeapi.co/api/v2/pokemon-form/233/"},{"name":"stantler","url":"https://pokeapi.co/api/v2/pokemon-form/234/"},{"name":"smeargle","url":"https://pokeapi.co/api/v2/pokemon-form/235/"},{"name":"tyrogue","url":"https://pokeapi.co/api/v2/pokemon-form/236/"},{"name":"hitmontop","url":"https://pokeapi.co/api/v2/pokemon-form/237/"},{"name":"smoochum","url":"https://pokeapi.co/api/v2/pokemon-form/238/"},{"name":"elekid","url":"https://pokeapi.co/api/v2/pokemon-form/239/"},{"name":"magby","url":"https://pokeapi.co/api/v2/pokemon-form/240/"},{"name":"miltank","url":"https://pokeapi.co/api/v2/pokemon-form/241/"},{"name":"blissey","url":"https://pokeapi.co/api/v2/pokemon-form/242/"},{"name":"raikou","url":"https://pokeapi.co/api/v2/pokemon-form/243/"},{"name":"entei","url":"https://pokeapi.co/api/v2/pokemon-form/244/"},{"name":"suicune","url":"https://pokeapi.co/api/v2/pokemon-form/245/"},{"name":"larvitar","url":"https://pokeapi.co/api/v2/pokemon-form/246/"},{"name":"pupitar","url":"https://pokeapi.co/api/v2/pokemon-form/247/"},{"name":"tyranitar","url":"https://pokeapi.co/api/v2/pokemon-form/248/"},{"name":"lugia","url":"https://pokeapi.co/api/v2/pokemon-form/249/"},{"name":"ho-oh","url":"https://pokeapi.co/api/v2/pokemon-form/250/"},{"name":"celebi","url":"https://pokeapi.co/api/v2/pokemon-form/251/"},{"name":"treecko","url":"https://pokeapi.co/api/v2/pokemon-form/252/"},{"name":"grovyle","url":"https://pokeapi.co/api/v2/pokemon-form/253/"},{"name":"sceptile","url":"https://pokeapi.co/api/v2/pokemon-form/254/"},{"name":"torchic","url":"https://pokeapi.co/api/v2/pokemon-form/255/"},{"name":"combusken","url":"https://pokeapi.co/api/v2/pokemon-form/256/"},{"name":"blaziken","url":"https://pokeapi.co/api/v2/pokemon-form/257/"},{"name":"mudkip","url":"https://pokeapi.co/api/v2/pokemon-form/258/"},{"name":"marshtomp","url":"https://pokeapi.co/api/v2/pokemon-form/259/"},{"name":"swampert","url":"https://pokeapi.co/api/v2/pokemon-form/260/"},{"name":"poochyena","url":"https://pokeapi.co/api/v2/pokemon-form/261/"},{"name":"mightyena","url":"https://pokeapi.co/api/v2/pokemon-form/262/"},{"name":"zigzagoon","url":"https://pokeapi.co/api/v2/pokemon-form/263/"},{"name":"linoone","url":"https://pokeapi.co/api/v2/pokemon-form/264/"},{"name":"wurmple","url":"https://pokeapi.co/api/v2/pokemon-form/265/"},{"name":"silcoon","url":"https://pokeapi.co/api/v2/pokemon-form/266/"},{"name":"beautifly","url":"https://pokeapi.co/api/v2/pokemon-form/267/"},{"name":"cascoon","url":"https://pokeapi.co/api/v2/pokemon-form/268/"},{"name":"dustox","url":"https://pokeapi.co/api/v2/pokemon-form/269/"},{"name":"lotad","url":"https://pokeapi.co/api/v2/pokemon-form/270/"},{"name":"lombre","url":"https://pokeapi.co/api/v2/pokemon-form/271/"},{"name":"ludicolo","url":"https://pokeapi.co/api/v2/pokemon-form/272/"},{"name":"seedot","url":"https://pokeapi.co/api/v2/pokemon-form/273/"},{"name":"nuzleaf","url":"https://pokeapi.co/api/v2/pokemon-form/274/"},{"name":"shiftry","url":"https://pokeapi.co/api/v2/pokemon-form/275/"},{"name":"taillow","url":"https://pokeapi.co/api/v2/pokemon-form/276/"},{"name":"swellow","url":"https://pokeapi.co/api/v2/pokemon-form/277/"},{"name":"wingull","url":"https://pokeapi.co/api/v2/pokemon-form/278/"},{"name":"pelipper","url":"https://pokeapi.co/api/v2/pokemon-form/279/"},{"name":"ralts","url":"https://pokeapi.co/api/v2/pokemon-form/280/"},{"name":"kirlia","url":"https://pokeapi.co/api/v2/pokemon-form/281/"},{"name":"gardevoir","url":"https://pokeapi.co/api/v2/pokemon-form/282/"},{"name":"surskit","url":"https://pokeapi.co/api/v2/pokemon-form/283/"},{"name":"masquerain","url":"https://pokeapi.co/api/v2/pokemon-form/284/"},{"name":"shroomish","url":"https://pokeapi.co/api/v2/pokemon-form/285/"},{"name":"breloom","url":"https://pokeapi.co/api/v2/pokemon-form/286/"},{"name":"slakoth","url":"https://pokeapi.co/api/v2/pokemon-form/287/"},{"name":"vigoroth","url":"https://pokeapi.co/api/v2/pokemon-form/288/"},{"name":"slaking","url":"https://pokeapi.co/api/v2/pokemon-form/289/"},{"name":"nincada","url":"https://pokeapi.co/api/v2/pokemon-form/290/"},{"name":"ninjask","url":"https://pokeapi.co/api/v2/pokemon-form/291/"},{"name":"shedinja","url":"https://pokeapi.co/api/v2/pokemon-form/292/"},{"name":"whismur","url":"https://pokeapi.co/api/v2/pokemon-form/293/"},{"name":"loudred","url":"https://pokeapi.co/api/v2/pokemon-form/294/"},{"name":"exploud","url":"https://pokeapi.co/api/v2/pokemon-form/295/"},{"name":"makuhita","url":"https://pokeapi.co/api/v2/pokemon-form/296/"},{"name":"hariyama","url":"https://pokeapi.co/api/v2/pokemon-form/297/"},{"name":"azurill","url":"https://pokeapi.co/api/v2/pokemon-form/298/"},{"name":"nosepass","url":"https://pokeapi.co/api/v2/pokemon-form/299/"},{"name":"skitty","url":"https://pokeapi.co/api/v2/pokemon-form/300/"},{"name":"delcatty","url":"https://pokeapi.co/api/v2/pokemon-form/301/"},{"name":"sableye","url":"https://pokeapi.co/api/v2/pokemon-form/302/"},{"name":"mawile","url":"https://pokeapi.co/api/v2/pokemon-form/303/"},{"name":"aron","url":"https://pokeapi.co/api/v2/pokemon-form/304/"},{"name":"lairon","url":"https://pokeapi.co/api/v2/pokemon-form/305/"},{"name":"aggron","url":"https://pokeapi.co/api/v2/pokemon-form/306/"},{"name":"meditite","url":"https://pokeapi.co/api/v2/pokemon-form/307/"},{"name":"medicham","url":"https://pokeapi.co/api/v2/pokemon-form/308/"},{"name":"electrike","url":"https://pokeapi.co/api/v2/pokemon-form/309/"},{"name":"manectric","url":"https://pokeapi.co/api/v2/pokemon-form/310/"},{"name":"plusle","url":"https://pokeapi.co/api/v2/pokemon-form/311/"},{"name":"minun","url":"https://pokeapi.co/api/v2/pokemon-form/312/"},{"name":"volbeat","url":"https://pokeapi.co/api/v2/pokemon-form/313/"},{"name":"illumise","url":"https://pokeapi.co/api/v2/pokemon-form/314/"},{"name":"roselia","url":"https://pokeapi.co/api/v2/pokemon-form/315/"},{"name":"gulpin","url":"https://pokeapi.co/api/v2/pokemon-form/316/"},{"name":"swalot","url":"https://pokeapi.co/api/v2/pokemon-form/317/"},{"name":"carvanha","url":"https://pokeapi.co/api/v2/pokemon-form/318/"},{"name":"sharpedo","url":"https://pokeapi.co/api/v2/pokemon-form/319/"},{"name":"wailmer","url":"https://pokeapi.co/api/v2/pokemon-form/320/"},{"name":"wailord","url":"https://pokeapi.co/api/v2/pokemon-form/321/"},{"name":"numel","url":"https://pokeapi.co/api/v2/pokemon-form/322/"},{"name":"camerupt","url":"https://pokeapi.co/api/v2/pokemon-form/323/"},{"name":"torkoal","url":"https://pokeapi.co/api/v2/pokemon-form/324/"},{"name":"spoink","url":"https://pokeapi.co/api/v2/pokemon-form/325/"},{"name":"grumpig","url":"https://pokeapi.co/api/v2/pokemon-form/326/"},{"name":"spinda","url":"https://pokeapi.co/api/v2/pokemon-form/327/"},{"name":"trapinch","url":"https://pokeapi.co/api/v2/pokemon-form/328/"},{"name":"vibrava","url":"https://pokeapi.co/api/v2/pokemon-form/329/"},{"name":"flygon","url":"https://pokeapi.co/api/v2/pokemon-form/330/"},{"name":"cacnea","url":"https://pokeapi.co/api/v2/pokemon-form/331/"},{"name":"cacturne","url":"https://pokeapi.co/api/v2/pokemon-form/332/"},{"name":"swablu","url":"https://pokeapi.co/api/v2/pokemon-form/333/"},{"name":"altaria","url":"https://pokeapi.co/api/v2/pokemon-form/334/"},{"name":"zangoose","url":"https://pokeapi.co/api/v2/pokemon-form/335/"},{"name":"seviper","url":"https://pokeapi.co/api/v2/pokemon-form/336/"},{"name":"lunatone","url":"https://pokeapi.co/api/v2/pokemon-form/337/"},{"name":"solrock","url":"https://pokeapi.co/api/v2/pokemon-form/338/"},{"name":"barboach","url":"https://pokeapi.co/api/v2/pokemon-form/339/"},{"name":"whiscash","url":"https://pokeapi.co/api/v2/pokemon-form/340/"},{"name":"corphish","url":"https://pokeapi.co/api/v2/pokemon-form/341/"},{"name":"crawdaunt","url":"https://pokeapi.co/api/v2/pokemon-form/342/"},{"name":"baltoy","url":"https://pokeapi.co/api/v2/pokemon-form/343/"},{"name":"claydol","url":"https://pokeapi.co/api/v2/pokemon-form/344/"},{"name":"lileep","url":"https://pokeapi.co/api/v2/pokemon-form/345/"},{"name":"cradily","url":"https://pokeapi.co/api/v2/pokemon-form/346/"},{"name":"anorith","url":"https://pokeapi.co/api/v2/pokemon-form/347/"},{"name":"armaldo","url":"https://pokeapi.co/api/v2/pokemon-form/348/"},{"name":"feebas","url":"https://pokeapi.co/api/v2/pokemon-form/349/"},{"name":"milotic","url":"https://pokeapi.co/api/v2/pokemon-form/350/"},{"name":"castform","url":"https://pokeapi.co/api/v2/pokemon-form/351/"},{"name":"kecleon","url":"https://pokeapi.co/api/v2/pokemon-form/352/"},{"name":"shuppet","url":"https://pokeapi.co/api/v2/pokemon-form/353/"},{"name":"banette","url":"https://pokeapi.co/api/v2/pokemon-form/354/"},{"name":"duskull","url":"https://pokeapi.co/api/v2/pokemon-form/355/"},{"name":"dusclops","url":"https://pokeapi.co/api/v2/pokemon-form/356/"},{"name":"tropius","url":"https://pokeapi.co/api/v2/pokemon-form/357/"},{"name":"chimecho","url":"https://pokeapi.co/api/v2/pokemon-form/358/"},{"name":"absol","url":"https://pokeapi.co/api/v2/pokemon-form/359/"},{"name":"wynaut","url":"https://pokeapi.co/api/v2/pokemon-form/360/"},{"name":"snorunt","url":"https://pokeapi.co/api/v2/pokemon-form/361/"},{"name":"glalie","url":"https://pokeapi.co/api/v2/pokemon-form/362/"},{"name":"spheal","url":"https://pokeapi.co/api/v2/pokemon-form/363/"},{"name":"sealeo","url":"https://pokeapi.co/api/v2/pokemon-form/364/"},{"name":"walrein","url":"https://pokeapi.co/api/v2/pokemon-form/365/"},{"name":"clamperl","url":"https://pokeapi.co/api/v2/pokemon-form/366/"},{"name":"huntail","url":"https://pokeapi.co/api/v2/pokemon-form/367/"},{"name":"gorebyss","url":"https://pokeapi.co/api/v2/pokemon-form/368/"},{"name":"relicanth","url":"https://pokeapi.co/api/v2/pokemon-form/369/"},{"name":"luvdisc","url":"https://pokeapi.co/api/v2/pokemon-form/370/"},{"name":"bagon","url":"https://pokeapi.co/api/v2/pokemon-form/371/"},{"name":"shelgon","url":"https://pokeapi.co/api/v2/pokemon-form/372/"},{"name":"salamence","url":"https://pokeapi.co/api/v2/pokemon-form/373/"},{"name":"beldum","url":"https://pokeapi.co/api/v2/pokemon-form/374/"},{"name":"metang","url":"https://pokeapi.co/api/v2/pokemon-form/375/"},{"name":"metagross","url":"https://pokeapi.co/api/v2/pokemon-form/376/"},{"name":"regirock","url":"https://pokeapi.co/api/v2/pokemon-form/377/"},{"name":"regice","url":"https://pokeapi.co/api/v2/pokemon-form/378/"},{"name":"registeel","url":"https://pokeapi.co/api/v2/pokemon-form/379/"},{"name":"latias","url":"https://pokeapi.co/api/v2/pokemon-form/380/"},{"name":"latios","url":"https://pokeapi.co/api/v2/pokemon-form/381/"},{"name":"kyogre","url":"https://pokeapi.co/api/v2/pokemon-form/382/"},{"name":"groudon","url":"https://pokeapi.co/api/v2/pokemon-form/383/"},{"name":"rayquaza","url":"https://pokeapi.co/api/v2/pokemon-form/384/"},{"name":"jirachi","url":"https://pokeapi.co/api/v2/pokemon-form/385/"},{"name":"pansage","url":"https://pokeapi.co/api/v2/pokemon-form/511/"},{"name":"deoxys-normal","url":"https://pokeapi.co/api/v2/pokemon-form/386/"},{"name":"turtwig","url":"https://pokeapi.co/api/v2/pokemon-form/387/"},{"name":"grotle","url":"https://pokeapi.co/api/v2/pokemon-form/388/"},{"name":"torterra","url":"https://pokeapi.co/api/v2/pokemon-form/389/"},{"name":"chimchar","url":"https://pokeapi.co/api/v2/pokemon-form/390/"},{"name":"monferno","url":"https://pokeapi.co/api/v2/pokemon-form/391/"},{"name":"infernape","url":"https://pokeapi.co/api/v2/pokemon-form/392/"},{"name":"piplup","url":"https://pokeapi.co/api/v2/pokemon-form/393/"},{"name":"prinplup","url":"https://pokeapi.co/api/v2/pokemon-form/394/"},{"name":"empoleon","url":"https://pokeapi.co/api/v2/pokemon-form/395/"},{"name":"starly","url":"https://pokeapi.co/api/v2/pokemon-form/396/"},{"name":"staravia","url":"https://pokeapi.co/api/v2/pokemon-form/397/"},{"name":"staraptor","url":"https://pokeapi.co/api/v2/pokemon-form/398/"},{"name":"bidoof","url":"https://pokeapi.co/api/v2/pokemon-form/399/"},{"name":"bibarel","url":"https://pokeapi.co/api/v2/pokemon-form/400/"},{"name":"kricketot","url":"https://pokeapi.co/api/v2/pokemon-form/401/"},{"name":"kricketune","url":"https://pokeapi.co/api/v2/pokemon-form/402/"},{"name":"shinx","url":"https://pokeapi.co/api/v2/pokemon-form/403/"},{"name":"luxio","url":"https://pokeapi.co/api/v2/pokemon-form/404/"},{"name":"luxray","url":"https://pokeapi.co/api/v2/pokemon-form/405/"},{"name":"budew","url":"https://pokeapi.co/api/v2/pokemon-form/406/"},{"name":"roserade","url":"https://pokeapi.co/api/v2/pokemon-form/407/"},{"name":"cranidos","url":"https://pokeapi.co/api/v2/pokemon-form/408/"},{"name":"rampardos","url":"https://pokeapi.co/api/v2/pokemon-form/409/"},{"name":"shieldon","url":"https://pokeapi.co/api/v2/pokemon-form/410/"},{"name":"bastiodon","url":"https://pokeapi.co/api/v2/pokemon-form/411/"},{"name":"burmy-plant","url":"https://pokeapi.co/api/v2/pokemon-form/412/"},{"name":"wormadam-plant","url":"https://pokeapi.co/api/v2/pokemon-form/413/"},{"name":"mothim-plant","url":"https://pokeapi.co/api/v2/pokemon-form/414/"},{"name":"combee","url":"https://pokeapi.co/api/v2/pokemon-form/415/"},{"name":"vespiquen","url":"https://pokeapi.co/api/v2/pokemon-form/416/"},{"name":"pachirisu","url":"https://pokeapi.co/api/v2/pokemon-form/417/"},{"name":"buizel","url":"https://pokeapi.co/api/v2/pokemon-form/418/"},{"name":"floatzel","url":"https://pokeapi.co/api/v2/pokemon-form/419/"},{"name":"cherubi","url":"https://pokeapi.co/api/v2/pokemon-form/420/"},{"name":"cherrim-overcast","url":"https://pokeapi.co/api/v2/pokemon-form/421/"},{"name":"shellos-west","url":"https://pokeapi.co/api/v2/pokemon-form/422/"},{"name":"gastrodon-west","url":"https://pokeapi.co/api/v2/pokemon-form/423/"},{"name":"ambipom","url":"https://pokeapi.co/api/v2/pokemon-form/424/"},{"name":"drifloon","url":"https://pokeapi.co/api/v2/pokemon-form/425/"},{"name":"drifblim","url":"https://pokeapi.co/api/v2/pokemon-form/426/"},{"name":"buneary","url":"https://pokeapi.co/api/v2/pokemon-form/427/"},{"name":"lopunny","url":"https://pokeapi.co/api/v2/pokemon-form/428/"},{"name":"mismagius","url":"https://pokeapi.co/api/v2/pokemon-form/429/"},{"name":"honchkrow","url":"https://pokeapi.co/api/v2/pokemon-form/430/"},{"name":"glameow","url":"https://pokeapi.co/api/v2/pokemon-form/431/"},{"name":"purugly","url":"https://pokeapi.co/api/v2/pokemon-form/432/"},{"name":"chingling","url":"https://pokeapi.co/api/v2/pokemon-form/433/"},{"name":"stunky","url":"https://pokeapi.co/api/v2/pokemon-form/434/"},{"name":"skuntank","url":"https://pokeapi.co/api/v2/pokemon-form/435/"},{"name":"bronzor","url":"https://pokeapi.co/api/v2/pokemon-form/436/"},{"name":"bronzong","url":"https://pokeapi.co/api/v2/pokemon-form/437/"},{"name":"bonsly","url":"https://pokeapi.co/api/v2/pokemon-form/438/"},{"name":"mime-jr","url":"https://pokeapi.co/api/v2/pokemon-form/439/"},{"name":"happiny","url":"https://pokeapi.co/api/v2/pokemon-form/440/"},{"name":"chatot","url":"https://pokeapi.co/api/v2/pokemon-form/441/"},{"name":"spiritomb","url":"https://pokeapi.co/api/v2/pokemon-form/442/"},{"name":"gible","url":"https://pokeapi.co/api/v2/pokemon-form/443/"},{"name":"gabite","url":"https://pokeapi.co/api/v2/pokemon-form/444/"},{"name":"garchomp","url":"https://pokeapi.co/api/v2/pokemon-form/445/"},{"name":"munchlax","url":"https://pokeapi.co/api/v2/pokemon-form/446/"},{"name":"riolu","url":"https://pokeapi.co/api/v2/pokemon-form/447/"},{"name":"lucario","url":"https://pokeapi.co/api/v2/pokemon-form/448/"},{"name":"hippopotas","url":"https://pokeapi.co/api/v2/pokemon-form/449/"},{"name":"hippowdon","url":"https://pokeapi.co/api/v2/pokemon-form/450/"},{"name":"skorupi","url":"https://pokeapi.co/api/v2/pokemon-form/451/"},{"name":"drapion","url":"https://pokeapi.co/api/v2/pokemon-form/452/"},{"name":"croagunk","url":"https://pokeapi.co/api/v2/pokemon-form/453/"},{"name":"toxicroak","url":"https://pokeapi.co/api/v2/pokemon-form/454/"},{"name":"carnivine","url":"https://pokeapi.co/api/v2/pokemon-form/455/"},{"name":"finneon","url":"https://pokeapi.co/api/v2/pokemon-form/456/"},{"name":"lumineon","url":"https://pokeapi.co/api/v2/pokemon-form/457/"},{"name":"mantyke","url":"https://pokeapi.co/api/v2/pokemon-form/458/"},{"name":"snover","url":"https://pokeapi.co/api/v2/pokemon-form/459/"},{"name":"abomasnow","url":"https://pokeapi.co/api/v2/pokemon-form/460/"},{"name":"weavile","url":"https://pokeapi.co/api/v2/pokemon-form/461/"},{"name":"magnezone","url":"https://pokeapi.co/api/v2/pokemon-form/462/"},{"name":"lickilicky","url":"https://pokeapi.co/api/v2/pokemon-form/463/"},{"name":"rhyperior","url":"https://pokeapi.co/api/v2/pokemon-form/464/"},{"name":"tangrowth","url":"https://pokeapi.co/api/v2/pokemon-form/465/"},{"name":"electivire","url":"https://pokeapi.co/api/v2/pokemon-form/466/"},{"name":"magmortar","url":"https://pokeapi.co/api/v2/pokemon-form/467/"},{"name":"togekiss","url":"https://pokeapi.co/api/v2/pokemon-form/468/"},{"name":"yanmega","url":"https://pokeapi.co/api/v2/pokemon-form/469/"},{"name":"leafeon","url":"https://pokeapi.co/api/v2/pokemon-form/470/"},{"name":"glaceon","url":"https://pokeapi.co/api/v2/pokemon-form/471/"},{"name":"gliscor","url":"https://pokeapi.co/api/v2/pokemon-form/472/"},{"name":"mamoswine","url":"https://pokeapi.co/api/v2/pokemon-form/473/"},{"name":"porygon-z","url":"https://pokeapi.co/api/v2/pokemon-form/474/"},{"name":"gallade","url":"https://pokeapi.co/api/v2/pokemon-form/475/"},{"name":"probopass","url":"https://pokeapi.co/api/v2/pokemon-form/476/"},{"name":"dusknoir","url":"https://pokeapi.co/api/v2/pokemon-form/477/"},{"name":"froslass","url":"https://pokeapi.co/api/v2/pokemon-form/478/"},{"name":"rotom","url":"https://pokeapi.co/api/v2/pokemon-form/479/"},{"name":"uxie","url":"https://pokeapi.co/api/v2/pokemon-form/480/"},{"name":"mesprit","url":"https://pokeapi.co/api/v2/pokemon-form/481/"},{"name":"azelf","url":"https://pokeapi.co/api/v2/pokemon-form/482/"},{"name":"dialga","url":"https://pokeapi.co/api/v2/pokemon-form/483/"},{"name":"palkia","url":"https://pokeapi.co/api/v2/pokemon-form/484/"},{"name":"heatran","url":"https://pokeapi.co/api/v2/pokemon-form/485/"},{"name":"regigigas","url":"https://pokeapi.co/api/v2/pokemon-form/486/"},{"name":"giratina-altered","url":"https://pokeapi.co/api/v2/pokemon-form/487/"},{"name":"cresselia","url":"https://pokeapi.co/api/v2/pokemon-form/488/"},{"name":"phione","url":"https://pokeapi.co/api/v2/pokemon-form/489/"},{"name":"manaphy","url":"https://pokeapi.co/api/v2/pokemon-form/490/"},{"name":"darkrai","url":"https://pokeapi.co/api/v2/pokemon-form/491/"},{"name":"shaymin-land","url":"https://pokeapi.co/api/v2/pokemon-form/492/"},{"name":"arceus-normal","url":"https://pokeapi.co/api/v2/pokemon-form/493/"},{"name":"victini","url":"https://pokeapi.co/api/v2/pokemon-form/494/"},{"name":"snivy","url":"https://pokeapi.co/api/v2/pokemon-form/495/"},{"name":"servine","url":"https://pokeapi.co/api/v2/pokemon-form/496/"},{"name":"serperior","url":"https://pokeapi.co/api/v2/pokemon-form/497/"},{"name":"tepig","url":"https://pokeapi.co/api/v2/pokemon-form/498/"},{"name":"pignite","url":"https://pokeapi.co/api/v2/pokemon-form/499/"},{"name":"emboar","url":"https://pokeapi.co/api/v2/pokemon-form/500/"},{"name":"oshawott","url":"https://pokeapi.co/api/v2/pokemon-form/501/"},{"name":"dewott","url":"https://pokeapi.co/api/v2/pokemon-form/502/"},{"name":"samurott","url":"https://pokeapi.co/api/v2/pokemon-form/503/"},{"name":"patrat","url":"https://pokeapi.co/api/v2/pokemon-form/504/"},{"name":"watchog","url":"https://pokeapi.co/api/v2/pokemon-form/505/"},{"name":"lillipup","url":"https://pokeapi.co/api/v2/pokemon-form/506/"},{"name":"herdier","url":"https://pokeapi.co/api/v2/pokemon-form/507/"},{"name":"stoutland","url":"https://pokeapi.co/api/v2/pokemon-form/508/"},{"name":"purrloin","url":"https://pokeapi.co/api/v2/pokemon-form/509/"},{"name":"liepard","url":"https://pokeapi.co/api/v2/pokemon-form/510/"},{"name":"simisage","url":"https://pokeapi.co/api/v2/pokemon-form/512/"},{"name":"pansear","url":"https://pokeapi.co/api/v2/pokemon-form/513/"},{"name":"simisear","url":"https://pokeapi.co/api/v2/pokemon-form/514/"},{"name":"panpour","url":"https://pokeapi.co/api/v2/pokemon-form/515/"},{"name":"simipour","url":"https://pokeapi.co/api/v2/pokemon-form/516/"},{"name":"munna","url":"https://pokeapi.co/api/v2/pokemon-form/517/"},{"name":"musharna","url":"https://pokeapi.co/api/v2/pokemon-form/518/"},{"name":"pidove","url":"https://pokeapi.co/api/v2/pokemon-form/519/"},{"name":"tranquill","url":"https://pokeapi.co/api/v2/pokemon-form/520/"},{"name":"unfezant","url":"https://pokeapi.co/api/v2/pokemon-form/521/"},{"name":"blitzle","url":"https://pokeapi.co/api/v2/pokemon-form/522/"},{"name":"zebstrika","url":"https://pokeapi.co/api/v2/pokemon-form/523/"},{"name":"roggenrola","url":"https://pokeapi.co/api/v2/pokemon-form/524/"},{"name":"boldore","url":"https://pokeapi.co/api/v2/pokemon-form/525/"},{"name":"gigalith","url":"https://pokeapi.co/api/v2/pokemon-form/526/"},{"name":"woobat","url":"https://pokeapi.co/api/v2/pokemon-form/527/"},{"name":"swoobat","url":"https://pokeapi.co/api/v2/pokemon-form/528/"},{"name":"drilbur","url":"https://pokeapi.co/api/v2/pokemon-form/529/"},{"name":"excadrill","url":"https://pokeapi.co/api/v2/pokemon-form/530/"},{"name":"audino","url":"https://pokeapi.co/api/v2/pokemon-form/531/"},{"name":"timburr","url":"https://pokeapi.co/api/v2/pokemon-form/532/"},{"name":"gurdurr","url":"https://pokeapi.co/api/v2/pokemon-form/533/"},{"name":"conkeldurr","url":"https://pokeapi.co/api/v2/pokemon-form/534/"},{"name":"tympole","url":"https://pokeapi.co/api/v2/pokemon-form/535/"},{"name":"palpitoad","url":"https://pokeapi.co/api/v2/pokemon-form/536/"},{"name":"seismitoad","url":"https://pokeapi.co/api/v2/pokemon-form/537/"},{"name":"throh","url":"https://pokeapi.co/api/v2/pokemon-form/538/"},{"name":"sawk","url":"https://pokeapi.co/api/v2/pokemon-form/539/"},{"name":"sewaddle","url":"https://pokeapi.co/api/v2/pokemon-form/540/"},{"name":"swadloon","url":"https://pokeapi.co/api/v2/pokemon-form/541/"},{"name":"leavanny","url":"https://pokeapi.co/api/v2/pokemon-form/542/"},{"name":"venipede","url":"https://pokeapi.co/api/v2/pokemon-form/543/"},{"name":"whirlipede","url":"https://pokeapi.co/api/v2/pokemon-form/544/"},{"name":"scolipede","url":"https://pokeapi.co/api/v2/pokemon-form/545/"},{"name":"cottonee","url":"https://pokeapi.co/api/v2/pokemon-form/546/"},{"name":"whimsicott","url":"https://pokeapi.co/api/v2/pokemon-form/547/"},{"name":"petilil","url":"https://pokeapi.co/api/v2/pokemon-form/548/"},{"name":"lilligant","url":"https://pokeapi.co/api/v2/pokemon-form/549/"},{"name":"basculin-red-striped","url":"https://pokeapi.co/api/v2/pokemon-form/550/"},{"name":"sandile","url":"https://pokeapi.co/api/v2/pokemon-form/551/"},{"name":"krokorok","url":"https://pokeapi.co/api/v2/pokemon-form/552/"},{"name":"krookodile","url":"https://pokeapi.co/api/v2/pokemon-form/553/"},{"name":"darumaka","url":"https://pokeapi.co/api/v2/pokemon-form/554/"},{"name":"darmanitan-standard","url":"https://pokeapi.co/api/v2/pokemon-form/555/"},{"name":"maractus","url":"https://pokeapi.co/api/v2/pokemon-form/556/"},{"name":"dwebble","url":"https://pokeapi.co/api/v2/pokemon-form/557/"},{"name":"crustle","url":"https://pokeapi.co/api/v2/pokemon-form/558/"},{"name":"scraggy","url":"https://pokeapi.co/api/v2/pokemon-form/559/"},{"name":"scrafty","url":"https://pokeapi.co/api/v2/pokemon-form/560/"},{"name":"sigilyph","url":"https://pokeapi.co/api/v2/pokemon-form/561/"},{"name":"yamask","url":"https://pokeapi.co/api/v2/pokemon-form/562/"},{"name":"cofagrigus","url":"https://pokeapi.co/api/v2/pokemon-form/563/"},{"name":"tirtouga","url":"https://pokeapi.co/api/v2/pokemon-form/564/"},{"name":"carracosta","url":"https://pokeapi.co/api/v2/pokemon-form/565/"},{"name":"archen","url":"https://pokeapi.co/api/v2/pokemon-form/566/"},{"name":"archeops","url":"https://pokeapi.co/api/v2/pokemon-form/567/"},{"name":"trubbish","url":"https://pokeapi.co/api/v2/pokemon-form/568/"},{"name":"garbodor","url":"https://pokeapi.co/api/v2/pokemon-form/569/"},{"name":"zorua","url":"https://pokeapi.co/api/v2/pokemon-form/570/"},{"name":"zoroark","url":"https://pokeapi.co/api/v2/pokemon-form/571/"},{"name":"minccino","url":"https://pokeapi.co/api/v2/pokemon-form/572/"},{"name":"cinccino","url":"https://pokeapi.co/api/v2/pokemon-form/573/"},{"name":"gothita","url":"https://pokeapi.co/api/v2/pokemon-form/574/"},{"name":"gothorita","url":"https://pokeapi.co/api/v2/pokemon-form/575/"},{"name":"gothitelle","url":"https://pokeapi.co/api/v2/pokemon-form/576/"},{"name":"solosis","url":"https://pokeapi.co/api/v2/pokemon-form/577/"},{"name":"duosion","url":"https://pokeapi.co/api/v2/pokemon-form/578/"},{"name":"reuniclus","url":"https://pokeapi.co/api/v2/pokemon-form/579/"},{"name":"ducklett","url":"https://pokeapi.co/api/v2/pokemon-form/580/"},{"name":"swanna","url":"https://pokeapi.co/api/v2/pokemon-form/581/"},{"name":"vanillite","url":"https://pokeapi.co/api/v2/pokemon-form/582/"},{"name":"vanillish","url":"https://pokeapi.co/api/v2/pokemon-form/583/"},{"name":"vanilluxe","url":"https://pokeapi.co/api/v2/pokemon-form/584/"},{"name":"deerling-spring","url":"https://pokeapi.co/api/v2/pokemon-form/585/"},{"name":"sawsbuck-spring","url":"https://pokeapi.co/api/v2/pokemon-form/586/"},{"name":"emolga","url":"https://pokeapi.co/api/v2/pokemon-form/587/"},{"name":"karrablast","url":"https://pokeapi.co/api/v2/pokemon-form/588/"},{"name":"escavalier","url":"https://pokeapi.co/api/v2/pokemon-form/589/"},{"name":"foongus","url":"https://pokeapi.co/api/v2/pokemon-form/590/"},{"name":"amoonguss","url":"https://pokeapi.co/api/v2/pokemon-form/591/"},{"name":"frillish","url":"https://pokeapi.co/api/v2/pokemon-form/592/"},{"name":"jellicent","url":"https://pokeapi.co/api/v2/pokemon-form/593/"},{"name":"alomomola","url":"https://pokeapi.co/api/v2/pokemon-form/594/"},{"name":"joltik","url":"https://pokeapi.co/api/v2/pokemon-form/595/"},{"name":"galvantula","url":"https://pokeapi.co/api/v2/pokemon-form/596/"},{"name":"ferroseed","url":"https://pokeapi.co/api/v2/pokemon-form/597/"},{"name":"ferrothorn","url":"https://pokeapi.co/api/v2/pokemon-form/598/"},{"name":"klink","url":"https://pokeapi.co/api/v2/pokemon-form/599/"},{"name":"klang","url":"https://pokeapi.co/api/v2/pokemon-form/600/"},{"name":"klinklang","url":"https://pokeapi.co/api/v2/pokemon-form/601/"},{"name":"tynamo","url":"https://pokeapi.co/api/v2/pokemon-form/602/"},{"name":"eelektrik","url":"https://pokeapi.co/api/v2/pokemon-form/603/"},{"name":"eelektross","url":"https://pokeapi.co/api/v2/pokemon-form/604/"},{"name":"elgyem","url":"https://pokeapi.co/api/v2/pokemon-form/605/"},{"name":"beheeyem","url":"https://pokeapi.co/api/v2/pokemon-form/606/"},{"name":"litwick","url":"https://pokeapi.co/api/v2/pokemon-form/607/"},{"name":"lampent","url":"https://pokeapi.co/api/v2/pokemon-form/608/"},{"name":"chandelure","url":"https://pokeapi.co/api/v2/pokemon-form/609/"},{"name":"axew","url":"https://pokeapi.co/api/v2/pokemon-form/610/"},{"name":"fraxure","url":"https://pokeapi.co/api/v2/pokemon-form/611/"},{"name":"haxorus","url":"https://pokeapi.co/api/v2/pokemon-form/612/"},{"name":"cubchoo","url":"https://pokeapi.co/api/v2/pokemon-form/613/"},{"name":"beartic","url":"https://pokeapi.co/api/v2/pokemon-form/614/"},{"name":"cryogonal","url":"https://pokeapi.co/api/v2/pokemon-form/615/"},{"name":"shelmet","url":"https://pokeapi.co/api/v2/pokemon-form/616/"},{"name":"accelgor","url":"https://pokeapi.co/api/v2/pokemon-form/617/"},{"name":"stunfisk","url":"https://pokeapi.co/api/v2/pokemon-form/618/"},{"name":"mienfoo","url":"https://pokeapi.co/api/v2/pokemon-form/619/"},{"name":"mienshao","url":"https://pokeapi.co/api/v2/pokemon-form/620/"},{"name":"druddigon","url":"https://pokeapi.co/api/v2/pokemon-form/621/"},{"name":"golett","url":"https://pokeapi.co/api/v2/pokemon-form/622/"},{"name":"golurk","url":"https://pokeapi.co/api/v2/pokemon-form/623/"},{"name":"pawniard","url":"https://pokeapi.co/api/v2/pokemon-form/624/"},{"name":"bisharp","url":"https://pokeapi.co/api/v2/pokemon-form/625/"},{"name":"bouffalant","url":"https://pokeapi.co/api/v2/pokemon-form/626/"},{"name":"rufflet","url":"https://pokeapi.co/api/v2/pokemon-form/627/"},{"name":"braviary","url":"https://pokeapi.co/api/v2/pokemon-form/628/"},{"name":"vullaby","url":"https://pokeapi.co/api/v2/pokemon-form/629/"},{"name":"mandibuzz","url":"https://pokeapi.co/api/v2/pokemon-form/630/"},{"name":"heatmor","url":"https://pokeapi.co/api/v2/pokemon-form/631/"},{"name":"durant","url":"https://pokeapi.co/api/v2/pokemon-form/632/"},{"name":"deino","url":"https://pokeapi.co/api/v2/pokemon-form/633/"},{"name":"zweilous","url":"https://pokeapi.co/api/v2/pokemon-form/634/"},{"name":"hydreigon","url":"https://pokeapi.co/api/v2/pokemon-form/635/"},{"name":"larvesta","url":"https://pokeapi.co/api/v2/pokemon-form/636/"},{"name":"volcarona","url":"https://pokeapi.co/api/v2/pokemon-form/637/"},{"name":"cobalion","url":"https://pokeapi.co/api/v2/pokemon-form/638/"},{"name":"terrakion","url":"https://pokeapi.co/api/v2/pokemon-form/639/"},{"name":"virizion","url":"https://pokeapi.co/api/v2/pokemon-form/640/"},{"name":"tornadus-incarnate","url":"https://pokeapi.co/api/v2/pokemon-form/641/"},{"name":"thundurus-incarnate","url":"https://pokeapi.co/api/v2/pokemon-form/642/"},{"name":"reshiram","url":"https://pokeapi.co/api/v2/pokemon-form/643/"},{"name":"zekrom","url":"https://pokeapi.co/api/v2/pokemon-form/644/"},{"name":"landorus-incarnate","url":"https://pokeapi.co/api/v2/pokemon-form/645/"},{"name":"kyurem","url":"https://pokeapi.co/api/v2/pokemon-form/646/"},{"name":"keldeo-ordinary","url":"https://pokeapi.co/api/v2/pokemon-form/647/"},{"name":"meloetta-aria","url":"https://pokeapi.co/api/v2/pokemon-form/648/"},{"name":"genesect","url":"https://pokeapi.co/api/v2/pokemon-form/649/"},{"name":"chespin","url":"https://pokeapi.co/api/v2/pokemon-form/650/"},{"name":"quilladin","url":"https://pokeapi.co/api/v2/pokemon-form/651/"},{"name":"chesnaught","url":"https://pokeapi.co/api/v2/pokemon-form/652/"},{"name":"fennekin","url":"https://pokeapi.co/api/v2/pokemon-form/653/"},{"name":"braixen","url":"https://pokeapi.co/api/v2/pokemon-form/654/"},{"name":"delphox","url":"https://pokeapi.co/api/v2/pokemon-form/655/"},{"name":"froakie","url":"https://pokeapi.co/api/v2/pokemon-form/656/"},{"name":"frogadier","url":"https://pokeapi.co/api/v2/pokemon-form/657/"},{"name":"greninja","url":"https://pokeapi.co/api/v2/pokemon-form/658/"},{"name":"bunnelby","url":"https://pokeapi.co/api/v2/pokemon-form/659/"},{"name":"diggersby","url":"https://pokeapi.co/api/v2/pokemon-form/660/"},{"name":"fletchling","url":"https://pokeapi.co/api/v2/pokemon-form/661/"},{"name":"fletchinder","url":"https://pokeapi.co/api/v2/pokemon-form/662/"},{"name":"talonflame","url":"https://pokeapi.co/api/v2/pokemon-form/663/"},{"name":"scatterbug-icy-snow","url":"https://pokeapi.co/api/v2/pokemon-form/664/"},{"name":"spewpa-icy-snow","url":"https://pokeapi.co/api/v2/pokemon-form/665/"},{"name":"vivillon-meadow","url":"https://pokeapi.co/api/v2/pokemon-form/666/"},{"name":"litleo","url":"https://pokeapi.co/api/v2/pokemon-form/667/"},{"name":"pyroar","url":"https://pokeapi.co/api/v2/pokemon-form/668/"},{"name":"flabebe-red","url":"https://pokeapi.co/api/v2/pokemon-form/669/"},{"name":"floette-red","url":"https://pokeapi.co/api/v2/pokemon-form/670/"},{"name":"florges-red","url":"https://pokeapi.co/api/v2/pokemon-form/671/"},{"name":"skiddo","url":"https://pokeapi.co/api/v2/pokemon-form/672/"},{"name":"gogoat","url":"https://pokeapi.co/api/v2/pokemon-form/673/"},{"name":"pancham","url":"https://pokeapi.co/api/v2/pokemon-form/674/"},{"name":"pangoro","url":"https://pokeapi.co/api/v2/pokemon-form/675/"},{"name":"furfrou-natural","url":"https://pokeapi.co/api/v2/pokemon-form/676/"},{"name":"espurr","url":"https://pokeapi.co/api/v2/pokemon-form/677/"},{"name":"meowstic-male","url":"https://pokeapi.co/api/v2/pokemon-form/678/"},{"name":"honedge","url":"https://pokeapi.co/api/v2/pokemon-form/679/"},{"name":"doublade","url":"https://pokeapi.co/api/v2/pokemon-form/680/"},{"name":"aegislash-shield","url":"https://pokeapi.co/api/v2/pokemon-form/681/"},{"name":"spritzee","url":"https://pokeapi.co/api/v2/pokemon-form/682/"},{"name":"aromatisse","url":"https://pokeapi.co/api/v2/pokemon-form/683/"},{"name":"swirlix","url":"https://pokeapi.co/api/v2/pokemon-form/684/"},{"name":"slurpuff","url":"https://pokeapi.co/api/v2/pokemon-form/685/"},{"name":"inkay","url":"https://pokeapi.co/api/v2/pokemon-form/686/"},{"name":"malamar","url":"https://pokeapi.co/api/v2/pokemon-form/687/"},{"name":"binacle","url":"https://pokeapi.co/api/v2/pokemon-form/688/"},{"name":"barbaracle","url":"https://pokeapi.co/api/v2/pokemon-form/689/"},{"name":"skrelp","url":"https://pokeapi.co/api/v2/pokemon-form/690/"},{"name":"dragalge","url":"https://pokeapi.co/api/v2/pokemon-form/691/"},{"name":"clauncher","url":"https://pokeapi.co/api/v2/pokemon-form/692/"},{"name":"clawitzer","url":"https://pokeapi.co/api/v2/pokemon-form/693/"},{"name":"helioptile","url":"https://pokeapi.co/api/v2/pokemon-form/694/"},{"name":"heliolisk","url":"https://pokeapi.co/api/v2/pokemon-form/695/"},{"name":"tyrunt","url":"https://pokeapi.co/api/v2/pokemon-form/696/"},{"name":"tyrantrum","url":"https://pokeapi.co/api/v2/pokemon-form/697/"},{"name":"amaura","url":"https://pokeapi.co/api/v2/pokemon-form/698/"},{"name":"aurorus","url":"https://pokeapi.co/api/v2/pokemon-form/699/"},{"name":"sylveon","url":"https://pokeapi.co/api/v2/pokemon-form/700/"},{"name":"hawlucha","url":"https://pokeapi.co/api/v2/pokemon-form/701/"},{"name":"dedenne","url":"https://pokeapi.co/api/v2/pokemon-form/702/"},{"name":"carbink","url":"https://pokeapi.co/api/v2/pokemon-form/703/"},{"name":"goomy","url":"https://pokeapi.co/api/v2/pokemon-form/704/"},{"name":"sliggoo","url":"https://pokeapi.co/api/v2/pokemon-form/705/"},{"name":"goodra","url":"https://pokeapi.co/api/v2/pokemon-form/706/"},{"name":"klefki","url":"https://pokeapi.co/api/v2/pokemon-form/707/"},{"name":"phantump","url":"https://pokeapi.co/api/v2/pokemon-form/708/"},{"name":"trevenant","url":"https://pokeapi.co/api/v2/pokemon-form/709/"},{"name":"pumpkaboo-average","url":"https://pokeapi.co/api/v2/pokemon-form/710/"},{"name":"gourgeist-average","url":"https://pokeapi.co/api/v2/pokemon-form/711/"},{"name":"bergmite","url":"https://pokeapi.co/api/v2/pokemon-form/712/"},{"name":"avalugg","url":"https://pokeapi.co/api/v2/pokemon-form/713/"},{"name":"noibat","url":"https://pokeapi.co/api/v2/pokemon-form/714/"},{"name":"noivern","url":"https://pokeapi.co/api/v2/pokemon-form/715/"},{"name":"xerneas-active","url":"https://pokeapi.co/api/v2/pokemon-form/716/"},{"name":"yveltal","url":"https://pokeapi.co/api/v2/pokemon-form/717/"},{"name":"zygarde","url":"https://pokeapi.co/api/v2/pokemon-form/718/"},{"name":"diancie","url":"https://pokeapi.co/api/v2/pokemon-form/719/"},{"name":"hoopa","url":"https://pokeapi.co/api/v2/pokemon-form/720/"},{"name":"volcanion","url":"https://pokeapi.co/api/v2/pokemon-form/721/"},{"name":"rowlet","url":"https://pokeapi.co/api/v2/pokemon-form/722/"},{"name":"dartrix","url":"https://pokeapi.co/api/v2/pokemon-form/723/"},{"name":"decidueye","url":"https://pokeapi.co/api/v2/pokemon-form/724/"},{"name":"litten","url":"https://pokeapi.co/api/v2/pokemon-form/725/"},{"name":"torracat","url":"https://pokeapi.co/api/v2/pokemon-form/726/"},{"name":"incineroar","url":"https://pokeapi.co/api/v2/pokemon-form/727/"},{"name":"popplio","url":"https://pokeapi.co/api/v2/pokemon-form/728/"},{"name":"brionne","url":"https://pokeapi.co/api/v2/pokemon-form/729/"},{"name":"primarina","url":"https://pokeapi.co/api/v2/pokemon-form/730/"},{"name":"pikipek","url":"https://pokeapi.co/api/v2/pokemon-form/731/"},{"name":"trumbeak","url":"https://pokeapi.co/api/v2/pokemon-form/732/"},{"name":"toucannon","url":"https://pokeapi.co/api/v2/pokemon-form/733/"},{"name":"yungoos","url":"https://pokeapi.co/api/v2/pokemon-form/734/"},{"name":"gumshoos","url":"https://pokeapi.co/api/v2/pokemon-form/735/"},{"name":"grubbin","url":"https://pokeapi.co/api/v2/pokemon-form/736/"},{"name":"charjabug","url":"https://pokeapi.co/api/v2/pokemon-form/737/"},{"name":"vikavolt","url":"https://pokeapi.co/api/v2/pokemon-form/738/"},{"name":"crabrawler","url":"https://pokeapi.co/api/v2/pokemon-form/739/"},{"name":"crabominable","url":"https://pokeapi.co/api/v2/pokemon-form/740/"},{"name":"oricorio-baile","url":"https://pokeapi.co/api/v2/pokemon-form/741/"},{"name":"cutiefly","url":"https://pokeapi.co/api/v2/pokemon-form/742/"},{"name":"ribombee","url":"https://pokeapi.co/api/v2/pokemon-form/743/"},{"name":"rockruff","url":"https://pokeapi.co/api/v2/pokemon-form/744/"},{"name":"lycanroc-midday","url":"https://pokeapi.co/api/v2/pokemon-form/745/"},{"name":"wishiwashi-solo","url":"https://pokeapi.co/api/v2/pokemon-form/746/"},{"name":"mareanie","url":"https://pokeapi.co/api/v2/pokemon-form/747/"},{"name":"toxapex","url":"https://pokeapi.co/api/v2/pokemon-form/748/"},{"name":"mudbray","url":"https://pokeapi.co/api/v2/pokemon-form/749/"},{"name":"mudsdale","url":"https://pokeapi.co/api/v2/pokemon-form/750/"},{"name":"dewpider","url":"https://pokeapi.co/api/v2/pokemon-form/751/"},{"name":"araquanid","url":"https://pokeapi.co/api/v2/pokemon-form/752/"},{"name":"fomantis","url":"https://pokeapi.co/api/v2/pokemon-form/753/"},{"name":"lurantis","url":"https://pokeapi.co/api/v2/pokemon-form/754/"},{"name":"morelull","url":"https://pokeapi.co/api/v2/pokemon-form/755/"},{"name":"shiinotic","url":"https://pokeapi.co/api/v2/pokemon-form/756/"},{"name":"salandit","url":"https://pokeapi.co/api/v2/pokemon-form/757/"},{"name":"salazzle","url":"https://pokeapi.co/api/v2/pokemon-form/758/"},{"name":"stufful","url":"https://pokeapi.co/api/v2/pokemon-form/759/"},{"name":"bewear","url":"https://pokeapi.co/api/v2/pokemon-form/760/"},{"name":"bounsweet","url":"https://pokeapi.co/api/v2/pokemon-form/761/"},{"name":"steenee","url":"https://pokeapi.co/api/v2/pokemon-form/762/"},{"name":"tsareena","url":"https://pokeapi.co/api/v2/pokemon-form/763/"},{"name":"comfey","url":"https://pokeapi.co/api/v2/pokemon-form/764/"},{"name":"oranguru","url":"https://pokeapi.co/api/v2/pokemon-form/765/"},{"name":"passimian","url":"https://pokeapi.co/api/v2/pokemon-form/766/"},{"name":"wimpod","url":"https://pokeapi.co/api/v2/pokemon-form/767/"},{"name":"golisopod","url":"https://pokeapi.co/api/v2/pokemon-form/768/"},{"name":"sandygast","url":"https://pokeapi.co/api/v2/pokemon-form/769/"},{"name":"palossand","url":"https://pokeapi.co/api/v2/pokemon-form/770/"},{"name":"pyukumuku","url":"https://pokeapi.co/api/v2/pokemon-form/771/"},{"name":"type-null","url":"https://pokeapi.co/api/v2/pokemon-form/772/"},{"name":"silvally-normal","url":"https://pokeapi.co/api/v2/pokemon-form/773/"},{"name":"minior-red-meteor","url":"https://pokeapi.co/api/v2/pokemon-form/774/"},{"name":"komala","url":"https://pokeapi.co/api/v2/pokemon-form/775/"},{"name":"turtonator","url":"https://pokeapi.co/api/v2/pokemon-form/776/"},{"name":"togedemaru","url":"https://pokeapi.co/api/v2/pokemon-form/777/"},{"name":"mimikyu-disguised","url":"https://pokeapi.co/api/v2/pokemon-form/778/"},{"name":"bruxish","url":"https://pokeapi.co/api/v2/pokemon-form/779/"},{"name":"drampa","url":"https://pokeapi.co/api/v2/pokemon-form/780/"},{"name":"dhelmise","url":"https://pokeapi.co/api/v2/pokemon-form/781/"},{"name":"jangmo-o","url":"https://pokeapi.co/api/v2/pokemon-form/782/"},{"name":"hakamo-o","url":"https://pokeapi.co/api/v2/pokemon-form/783/"},{"name":"kommo-o","url":"https://pokeapi.co/api/v2/pokemon-form/784/"},{"name":"tapu-koko","url":"https://pokeapi.co/api/v2/pokemon-form/785/"},{"name":"tapu-lele","url":"https://pokeapi.co/api/v2/pokemon-form/786/"},{"name":"tapu-bulu","url":"https://pokeapi.co/api/v2/pokemon-form/787/"},{"name":"tapu-fini","url":"https://pokeapi.co/api/v2/pokemon-form/788/"},{"name":"cosmog","url":"https://pokeapi.co/api/v2/pokemon-form/789/"},{"name":"cosmoem","url":"https://pokeapi.co/api/v2/pokemon-form/790/"},{"name":"solgaleo","url":"https://pokeapi.co/api/v2/pokemon-form/791/"},{"name":"lunala","url":"https://pokeapi.co/api/v2/pokemon-form/792/"},{"name":"nihilego","url":"https://pokeapi.co/api/v2/pokemon-form/793/"},{"name":"buzzwole","url":"https://pokeapi.co/api/v2/pokemon-form/794/"},{"name":"pheromosa","url":"https://pokeapi.co/api/v2/pokemon-form/795/"},{"name":"xurkitree","url":"https://pokeapi.co/api/v2/pokemon-form/796/"},{"name":"celesteela","url":"https://pokeapi.co/api/v2/pokemon-form/797/"},{"name":"kartana","url":"https://pokeapi.co/api/v2/pokemon-form/798/"},{"name":"guzzlord","url":"https://pokeapi.co/api/v2/pokemon-form/799/"},{"name":"necrozma","url":"https://pokeapi.co/api/v2/pokemon-form/800/"},{"name":"magearna","url":"https://pokeapi.co/api/v2/pokemon-form/801/"},{"name":"marshadow","url":"https://pokeapi.co/api/v2/pokemon-form/802/"},{"name":"poipole","url":"https://pokeapi.co/api/v2/pokemon-form/803/"},{"name":"naganadel","url":"https://pokeapi.co/api/v2/pokemon-form/804/"},{"name":"stakataka","url":"https://pokeapi.co/api/v2/pokemon-form/805/"},{"name":"blacephalon","url":"https://pokeapi.co/api/v2/pokemon-form/806/"},{"name":"zeraora","url":"https://pokeapi.co/api/v2/pokemon-form/807/"},{"name":"unown-b","url":"https://pokeapi.co/api/v2/pokemon-form/10001/"},{"name":"unown-c","url":"https://pokeapi.co/api/v2/pokemon-form/10002/"},{"name":"unown-d","url":"https://pokeapi.co/api/v2/pokemon-form/10003/"},{"name":"unown-e","url":"https://pokeapi.co/api/v2/pokemon-form/10004/"},{"name":"unown-f","url":"https://pokeapi.co/api/v2/pokemon-form/10005/"},{"name":"unown-g","url":"https://pokeapi.co/api/v2/pokemon-form/10006/"},{"name":"unown-h","url":"https://pokeapi.co/api/v2/pokemon-form/10007/"},{"name":"unown-i","url":"https://pokeapi.co/api/v2/pokemon-form/10008/"},{"name":"unown-j","url":"https://pokeapi.co/api/v2/pokemon-form/10009/"},{"name":"unown-k","url":"https://pokeapi.co/api/v2/pokemon-form/10010/"},{"name":"unown-l","url":"https://pokeapi.co/api/v2/pokemon-form/10011/"},{"name":"unown-m","url":"https://pokeapi.co/api/v2/pokemon-form/10012/"},{"name":"unown-n","url":"https://pokeapi.co/api/v2/pokemon-form/10013/"},{"name":"unown-o","url":"https://pokeapi.co/api/v2/pokemon-form/10014/"},{"name":"unown-p","url":"https://pokeapi.co/api/v2/pokemon-form/10015/"},{"name":"unown-q","url":"https://pokeapi.co/api/v2/pokemon-form/10016/"},{"name":"unown-r","url":"https://pokeapi.co/api/v2/pokemon-form/10017/"},{"name":"unown-s","url":"https://pokeapi.co/api/v2/pokemon-form/10018/"},{"name":"unown-t","url":"https://pokeapi.co/api/v2/pokemon-form/10019/"},{"name":"unown-u","url":"https://pokeapi.co/api/v2/pokemon-form/10020/"},{"name":"unown-v","url":"https://pokeapi.co/api/v2/pokemon-form/10021/"},{"name":"unown-w","url":"https://pokeapi.co/api/v2/pokemon-form/10022/"},{"name":"unown-x","url":"https://pokeapi.co/api/v2/pokemon-form/10023/"},{"name":"unown-y","url":"https://pokeapi.co/api/v2/pokemon-form/10024/"},{"name":"unown-z","url":"https://pokeapi.co/api/v2/pokemon-form/10025/"},{"name":"unown-exclamation","url":"https://pokeapi.co/api/v2/pokemon-form/10026/"},{"name":"unown-question","url":"https://pokeapi.co/api/v2/pokemon-form/10027/"},{"name":"castform-sunny","url":"https://pokeapi.co/api/v2/pokemon-form/10028/"},{"name":"castform-rainy","url":"https://pokeapi.co/api/v2/pokemon-form/10029/"},{"name":"castform-snowy","url":"https://pokeapi.co/api/v2/pokemon-form/10030/"},{"name":"deoxys-attack","url":"https://pokeapi.co/api/v2/pokemon-form/10031/"},{"name":"deoxys-defense","url":"https://pokeapi.co/api/v2/pokemon-form/10032/"},{"name":"deoxys-speed","url":"https://pokeapi.co/api/v2/pokemon-form/10033/"},{"name":"burmy-sandy","url":"https://pokeapi.co/api/v2/pokemon-form/10034/"},{"name":"burmy-trash","url":"https://pokeapi.co/api/v2/pokemon-form/10035/"},{"name":"wormadam-sandy","url":"https://pokeapi.co/api/v2/pokemon-form/10036/"},{"name":"wormadam-trash","url":"https://pokeapi.co/api/v2/pokemon-form/10037/"},{"name":"cherrim-sunshine","url":"https://pokeapi.co/api/v2/pokemon-form/10038/"},{"name":"shellos-east","url":"https://pokeapi.co/api/v2/pokemon-form/10039/"},{"name":"gastrodon-east","url":"https://pokeapi.co/api/v2/pokemon-form/10040/"},{"name":"arceus-bug","url":"https://pokeapi.co/api/v2/pokemon-form/10041/"},{"name":"arceus-dark","url":"https://pokeapi.co/api/v2/pokemon-form/10042/"},{"name":"arceus-dragon","url":"https://pokeapi.co/api/v2/pokemon-form/10043/"},{"name":"arceus-electric","url":"https://pokeapi.co/api/v2/pokemon-form/10044/"},{"name":"arceus-fighting","url":"https://pokeapi.co/api/v2/pokemon-form/10045/"},{"name":"arceus-fire","url":"https://pokeapi.co/api/v2/pokemon-form/10046/"},{"name":"arceus-flying","url":"https://pokeapi.co/api/v2/pokemon-form/10047/"},{"name":"arceus-ghost","url":"https://pokeapi.co/api/v2/pokemon-form/10048/"},{"name":"arceus-grass","url":"https://pokeapi.co/api/v2/pokemon-form/10049/"},{"name":"arceus-ground","url":"https://pokeapi.co/api/v2/pokemon-form/10050/"},{"name":"arceus-ice","url":"https://pokeapi.co/api/v2/pokemon-form/10051/"},{"name":"arceus-poison","url":"https://pokeapi.co/api/v2/pokemon-form/10052/"},{"name":"arceus-psychic","url":"https://pokeapi.co/api/v2/pokemon-form/10053/"},{"name":"arceus-rock","url":"https://pokeapi.co/api/v2/pokemon-form/10054/"},{"name":"arceus-steel","url":"https://pokeapi.co/api/v2/pokemon-form/10055/"},{"name":"arceus-water","url":"https://pokeapi.co/api/v2/pokemon-form/10056/"},{"name":"arceus-unknown","url":"https://pokeapi.co/api/v2/pokemon-form/10057/"},{"name":"rotom-heat","url":"https://pokeapi.co/api/v2/pokemon-form/10058/"},{"name":"rotom-wash","url":"https://pokeapi.co/api/v2/pokemon-form/10059/"},{"name":"rotom-frost","url":"https://pokeapi.co/api/v2/pokemon-form/10060/"},{"name":"rotom-fan","url":"https://pokeapi.co/api/v2/pokemon-form/10061/"},{"name":"rotom-mow","url":"https://pokeapi.co/api/v2/pokemon-form/10062/"},{"name":"giratina-origin","url":"https://pokeapi.co/api/v2/pokemon-form/10063/"},{"name":"shaymin-sky","url":"https://pokeapi.co/api/v2/pokemon-form/10064/"},{"name":"pichu-spiky-eared","url":"https://pokeapi.co/api/v2/pokemon-form/10065/"},{"name":"basculin-blue-striped","url":"https://pokeapi.co/api/v2/pokemon-form/10066/"},{"name":"darmanitan-zen","url":"https://pokeapi.co/api/v2/pokemon-form/10067/"},{"name":"deerling-summer","url":"https://pokeapi.co/api/v2/pokemon-form/10068/"},{"name":"deerling-autumn","url":"https://pokeapi.co/api/v2/pokemon-form/10069/"},{"name":"deerling-winter","url":"https://pokeapi.co/api/v2/pokemon-form/10070/"},{"name":"sawsbuck-summer","url":"https://pokeapi.co/api/v2/pokemon-form/10071/"},{"name":"sawsbuck-autumn","url":"https://pokeapi.co/api/v2/pokemon-form/10072/"},{"name":"sawsbuck-winter","url":"https://pokeapi.co/api/v2/pokemon-form/10073/"},{"name":"meloetta-pirouette","url":"https://pokeapi.co/api/v2/pokemon-form/10074/"},{"name":"genesect-douse","url":"https://pokeapi.co/api/v2/pokemon-form/10075/"},{"name":"genesect-shock","url":"https://pokeapi.co/api/v2/pokemon-form/10076/"},{"name":"genesect-burn","url":"https://pokeapi.co/api/v2/pokemon-form/10077/"},{"name":"genesect-chill","url":"https://pokeapi.co/api/v2/pokemon-form/10078/"},{"name":"tornadus-therian","url":"https://pokeapi.co/api/v2/pokemon-form/10079/"},{"name":"thundurus-therian","url":"https://pokeapi.co/api/v2/pokemon-form/10080/"},{"name":"landorus-therian","url":"https://pokeapi.co/api/v2/pokemon-form/10081/"},{"name":"kyurem-black","url":"https://pokeapi.co/api/v2/pokemon-form/10082/"},{"name":"kyurem-white","url":"https://pokeapi.co/api/v2/pokemon-form/10083/"},{"name":"keldeo-resolute","url":"https://pokeapi.co/api/v2/pokemon-form/10084/"},{"name":"arceus-fairy","url":"https://pokeapi.co/api/v2/pokemon-form/10085/"},{"name":"vivillon-icy-snow","url":"https://pokeapi.co/api/v2/pokemon-form/10086/"},{"name":"vivillon-polar","url":"https://pokeapi.co/api/v2/pokemon-form/10087/"},{"name":"vivillon-tundra","url":"https://pokeapi.co/api/v2/pokemon-form/10088/"},{"name":"vivillon-continental","url":"https://pokeapi.co/api/v2/pokemon-form/10089/"},{"name":"vivillon-garden","url":"https://pokeapi.co/api/v2/pokemon-form/10090/"},{"name":"vivillon-elegant","url":"https://pokeapi.co/api/v2/pokemon-form/10091/"},{"name":"vivillon-modern","url":"https://pokeapi.co/api/v2/pokemon-form/10092/"},{"name":"vivillon-marine","url":"https://pokeapi.co/api/v2/pokemon-form/10093/"},{"name":"vivillon-archipelago","url":"https://pokeapi.co/api/v2/pokemon-form/10094/"},{"name":"vivillon-high-plains","url":"https://pokeapi.co/api/v2/pokemon-form/10095/"},{"name":"vivillon-sandstorm","url":"https://pokeapi.co/api/v2/pokemon-form/10096/"},{"name":"vivillon-river","url":"https://pokeapi.co/api/v2/pokemon-form/10097/"},{"name":"vivillon-monsoon","url":"https://pokeapi.co/api/v2/pokemon-form/10098/"},{"name":"vivillon-savanna","url":"https://pokeapi.co/api/v2/pokemon-form/10099/"},{"name":"vivillon-sun","url":"https://pokeapi.co/api/v2/pokemon-form/10100/"},{"name":"vivillon-ocean","url":"https://pokeapi.co/api/v2/pokemon-form/10101/"},{"name":"vivillon-jungle","url":"https://pokeapi.co/api/v2/pokemon-form/10102/"},{"name":"flabebe-yellow","url":"https://pokeapi.co/api/v2/pokemon-form/10103/"},{"name":"flabebe-orange","url":"https://pokeapi.co/api/v2/pokemon-form/10104/"},{"name":"flabebe-blue","url":"https://pokeapi.co/api/v2/pokemon-form/10105/"},{"name":"flabebe-white","url":"https://pokeapi.co/api/v2/pokemon-form/10106/"},{"name":"floette-yellow","url":"https://pokeapi.co/api/v2/pokemon-form/10107/"},{"name":"floette-orange","url":"https://pokeapi.co/api/v2/pokemon-form/10108/"},{"name":"floette-blue","url":"https://pokeapi.co/api/v2/pokemon-form/10109/"},{"name":"floette-white","url":"https://pokeapi.co/api/v2/pokemon-form/10110/"},{"name":"florges-yellow","url":"https://pokeapi.co/api/v2/pokemon-form/10111/"},{"name":"florges-orange","url":"https://pokeapi.co/api/v2/pokemon-form/10112/"},{"name":"florges-blue","url":"https://pokeapi.co/api/v2/pokemon-form/10113/"},{"name":"florges-white","url":"https://pokeapi.co/api/v2/pokemon-form/10114/"},{"name":"furfrou-heart","url":"https://pokeapi.co/api/v2/pokemon-form/10115/"},{"name":"furfrou-star","url":"https://pokeapi.co/api/v2/pokemon-form/10116/"},{"name":"furfrou-diamond","url":"https://pokeapi.co/api/v2/pokemon-form/10117/"},{"name":"furfrou-debutante","url":"https://pokeapi.co/api/v2/pokemon-form/10118/"},{"name":"furfrou-matron","url":"https://pokeapi.co/api/v2/pokemon-form/10119/"},{"name":"furfrou-dandy","url":"https://pokeapi.co/api/v2/pokemon-form/10120/"},{"name":"furfrou-la-reine","url":"https://pokeapi.co/api/v2/pokemon-form/10121/"},{"name":"furfrou-kabuki","url":"https://pokeapi.co/api/v2/pokemon-form/10122/"},{"name":"furfrou-pharaoh","url":"https://pokeapi.co/api/v2/pokemon-form/10123/"},{"name":"meowstic-female","url":"https://pokeapi.co/api/v2/pokemon-form/10124/"},{"name":"aegislash-blade","url":"https://pokeapi.co/api/v2/pokemon-form/10125/"},{"name":"pumpkaboo-small","url":"https://pokeapi.co/api/v2/pokemon-form/10126/"},{"name":"pumpkaboo-large","url":"https://pokeapi.co/api/v2/pokemon-form/10127/"},{"name":"pumpkaboo-super","url":"https://pokeapi.co/api/v2/pokemon-form/10128/"},{"name":"gourgeist-small","url":"https://pokeapi.co/api/v2/pokemon-form/10129/"},{"name":"gourgeist-large","url":"https://pokeapi.co/api/v2/pokemon-form/10130/"},{"name":"gourgeist-super","url":"https://pokeapi.co/api/v2/pokemon-form/10131/"},{"name":"xerneas-neutral","url":"https://pokeapi.co/api/v2/pokemon-form/10132/"},{"name":"venusaur-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10133/"},{"name":"charizard-mega-x","url":"https://pokeapi.co/api/v2/pokemon-form/10134/"},{"name":"charizard-mega-y","url":"https://pokeapi.co/api/v2/pokemon-form/10135/"},{"name":"blastoise-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10136/"},{"name":"alakazam-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10137/"},{"name":"gengar-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10138/"},{"name":"kangaskhan-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10139/"},{"name":"pinsir-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10140/"},{"name":"gyarados-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10141/"},{"name":"aerodactyl-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10142/"},{"name":"mewtwo-mega-x","url":"https://pokeapi.co/api/v2/pokemon-form/10143/"},{"name":"mewtwo-mega-y","url":"https://pokeapi.co/api/v2/pokemon-form/10144/"},{"name":"ampharos-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10145/"},{"name":"scizor-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10146/"},{"name":"heracross-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10147/"},{"name":"houndoom-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10148/"},{"name":"tyranitar-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10149/"},{"name":"blaziken-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10150/"},{"name":"gardevoir-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10151/"},{"name":"mawile-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10152/"},{"name":"aggron-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10153/"},{"name":"medicham-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10154/"},{"name":"manectric-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10155/"},{"name":"banette-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10156/"},{"name":"absol-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10157/"},{"name":"garchomp-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10158/"},{"name":"lucario-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10159/"},{"name":"abomasnow-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10160/"},{"name":"vivillon-fancy","url":"https://pokeapi.co/api/v2/pokemon-form/10161/"},{"name":"vivillon-poke-ball","url":"https://pokeapi.co/api/v2/pokemon-form/10162/"},{"name":"floette-eternal","url":"https://pokeapi.co/api/v2/pokemon-form/10163/"},{"name":"latias-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10164/"},{"name":"latios-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10165/"},{"name":"swampert-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10166/"},{"name":"sceptile-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10167/"},{"name":"sableye-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10168/"},{"name":"altaria-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10169/"},{"name":"gallade-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10170/"},{"name":"audino-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10171/"},{"name":"sharpedo-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10172/"},{"name":"slowbro-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10173/"},{"name":"steelix-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10174/"},{"name":"pidgeot-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10175/"},{"name":"glalie-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10176/"},{"name":"diancie-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10177/"},{"name":"metagross-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10178/"},{"name":"kyogre-primal","url":"https://pokeapi.co/api/v2/pokemon-form/10179/"},{"name":"groudon-primal","url":"https://pokeapi.co/api/v2/pokemon-form/10180/"},{"name":"rayquaza-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10181/"},{"name":"pikachu-rock-star","url":"https://pokeapi.co/api/v2/pokemon-form/10182/"},{"name":"pikachu-belle","url":"https://pokeapi.co/api/v2/pokemon-form/10183/"},{"name":"pikachu-pop-star","url":"https://pokeapi.co/api/v2/pokemon-form/10184/"},{"name":"pikachu-phd","url":"https://pokeapi.co/api/v2/pokemon-form/10185/"},{"name":"pikachu-libre","url":"https://pokeapi.co/api/v2/pokemon-form/10186/"},{"name":"pikachu-cosplay","url":"https://pokeapi.co/api/v2/pokemon-form/10187/"},{"name":"hoopa-unbound","url":"https://pokeapi.co/api/v2/pokemon-form/10188/"},{"name":"camerupt-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10189/"},{"name":"lopunny-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10190/"},{"name":"salamence-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10191/"},{"name":"beedrill-mega","url":"https://pokeapi.co/api/v2/pokemon-form/10192/"},{"name":"rattata-alola","url":"https://pokeapi.co/api/v2/pokemon-form/10193/"},{"name":"raticate-alola","url":"https://pokeapi.co/api/v2/pokemon-form/10194/"},{"name":"raticate-totem-alola","url":"https://pokeapi.co/api/v2/pokemon-form/10195/"},{"name":"pikachu-original-cap","url":"https://pokeapi.co/api/v2/pokemon-form/10196/"},{"name":"pikachu-hoenn-cap","url":"https://pokeapi.co/api/v2/pokemon-form/10197/"},{"name":"pikachu-sinnoh-cap","url":"https://pokeapi.co/api/v2/pokemon-form/10198/"},{"name":"pikachu-unova-cap","url":"https://pokeapi.co/api/v2/pokemon-form/10199/"},{"name":"pikachu-kalos-cap","url":"https://pokeapi.co/api/v2/pokemon-form/10200/"},{"name":"pikachu-alola-cap","url":"https://pokeapi.co/api/v2/pokemon-form/10201/"},{"name":"raichu-alola","url":"https://pokeapi.co/api/v2/pokemon-form/10202/"},{"name":"sandshrew-alola","url":"https://pokeapi.co/api/v2/pokemon-form/10203/"},{"name":"sandslash-alola","url":"https://pokeapi.co/api/v2/pokemon-form/10204/"},{"name":"vulpix-alola","url":"https://pokeapi.co/api/v2/pokemon-form/10205/"},{"name":"ninetales-alola","url":"https://pokeapi.co/api/v2/pokemon-form/10206/"},{"name":"diglett-alola","url":"https://pokeapi.co/api/v2/pokemon-form/10207/"},{"name":"dugtrio-alola","url":"https://pokeapi.co/api/v2/pokemon-form/10208/"},{"name":"meowth-alola","url":"https://pokeapi.co/api/v2/pokemon-form/10209/"},{"name":"persian-alola","url":"https://pokeapi.co/api/v2/pokemon-form/10210/"},{"name":"geodude-alola","url":"https://pokeapi.co/api/v2/pokemon-form/10211/"},{"name":"graveler-alola","url":"https://pokeapi.co/api/v2/pokemon-form/10212/"},{"name":"golem-alola","url":"https://pokeapi.co/api/v2/pokemon-form/10213/"},{"name":"grimer-alola","url":"https://pokeapi.co/api/v2/pokemon-form/10214/"},{"name":"muk-alola","url":"https://pokeapi.co/api/v2/pokemon-form/10215/"},{"name":"exeggutor-alola","url":"https://pokeapi.co/api/v2/pokemon-form/10216/"},{"name":"marowak-alola","url":"https://pokeapi.co/api/v2/pokemon-form/10217/"},{"name":"greninja-battle-bond","url":"https://pokeapi.co/api/v2/pokemon-form/10218/"},{"name":"greninja-ash","url":"https://pokeapi.co/api/v2/pokemon-form/10219/"},{"name":"zygarde-10","url":"https://pokeapi.co/api/v2/pokemon-form/10220/"},{"name":"zygarde-50","url":"https://pokeapi.co/api/v2/pokemon-form/10221/"},{"name":"zygarde-complete","url":"https://pokeapi.co/api/v2/pokemon-form/10222/"},{"name":"gumshoos-totem","url":"https://pokeapi.co/api/v2/pokemon-form/10223/"},{"name":"vikavolt-totem","url":"https://pokeapi.co/api/v2/pokemon-form/10224/"},{"name":"oricorio-pom-pom","url":"https://pokeapi.co/api/v2/pokemon-form/10225/"},{"name":"oricorio-pau","url":"https://pokeapi.co/api/v2/pokemon-form/10226/"},{"name":"oricorio-sensu","url":"https://pokeapi.co/api/v2/pokemon-form/10227/"},{"name":"lycanroc-midnight","url":"https://pokeapi.co/api/v2/pokemon-form/10228/"},{"name":"wishiwashi-school","url":"https://pokeapi.co/api/v2/pokemon-form/10229/"},{"name":"lurantis-totem","url":"https://pokeapi.co/api/v2/pokemon-form/10230/"},{"name":"salazzle-totem","url":"https://pokeapi.co/api/v2/pokemon-form/10231/"},{"name":"silvally-fighting","url":"https://pokeapi.co/api/v2/pokemon-form/10232/"},{"name":"silvally-flying","url":"https://pokeapi.co/api/v2/pokemon-form/10233/"},{"name":"silvally-poison","url":"https://pokeapi.co/api/v2/pokemon-form/10234/"},{"name":"silvally-ground","url":"https://pokeapi.co/api/v2/pokemon-form/10235/"},{"name":"silvally-rock","url":"https://pokeapi.co/api/v2/pokemon-form/10236/"},{"name":"silvally-bug","url":"https://pokeapi.co/api/v2/pokemon-form/10237/"},{"name":"silvally-ghost","url":"https://pokeapi.co/api/v2/pokemon-form/10238/"},{"name":"silvally-steel","url":"https://pokeapi.co/api/v2/pokemon-form/10239/"},{"name":"silvally-fire","url":"https://pokeapi.co/api/v2/pokemon-form/10240/"},{"name":"silvally-water","url":"https://pokeapi.co/api/v2/pokemon-form/10241/"},{"name":"silvally-grass","url":"https://pokeapi.co/api/v2/pokemon-form/10242/"},{"name":"silvally-electric","url":"https://pokeapi.co/api/v2/pokemon-form/10243/"},{"name":"silvally-psychic","url":"https://pokeapi.co/api/v2/pokemon-form/10244/"},{"name":"silvally-ice","url":"https://pokeapi.co/api/v2/pokemon-form/10245/"},{"name":"silvally-dragon","url":"https://pokeapi.co/api/v2/pokemon-form/10246/"},{"name":"silvally-dark","url":"https://pokeapi.co/api/v2/pokemon-form/10247/"},{"name":"silvally-fairy","url":"https://pokeapi.co/api/v2/pokemon-form/10248/"},{"name":"minior-orange-meteor","url":"https://pokeapi.co/api/v2/pokemon-form/10249/"},{"name":"minior-yellow-meteor","url":"https://pokeapi.co/api/v2/pokemon-form/10250/"},{"name":"minior-green-meteor","url":"https://pokeapi.co/api/v2/pokemon-form/10251/"},{"name":"minior-blue-meteor","url":"https://pokeapi.co/api/v2/pokemon-form/10252/"},{"name":"minior-indigo-meteor","url":"https://pokeapi.co/api/v2/pokemon-form/10253/"},{"name":"minior-violet-meteor","url":"https://pokeapi.co/api/v2/pokemon-form/10254/"},{"name":"minior-red","url":"https://pokeapi.co/api/v2/pokemon-form/10255/"},{"name":"minior-orange","url":"https://pokeapi.co/api/v2/pokemon-form/10256/"},{"name":"minior-yellow","url":"https://pokeapi.co/api/v2/pokemon-form/10257/"},{"name":"minior-green","url":"https://pokeapi.co/api/v2/pokemon-form/10258/"},{"name":"minior-blue","url":"https://pokeapi.co/api/v2/pokemon-form/10259/"},{"name":"minior-indigo","url":"https://pokeapi.co/api/v2/pokemon-form/10260/"},{"name":"minior-violet","url":"https://pokeapi.co/api/v2/pokemon-form/10261/"},{"name":"mimikyu-busted","url":"https://pokeapi.co/api/v2/pokemon-form/10262/"},{"name":"mimikyu-totem-disguised","url":"https://pokeapi.co/api/v2/pokemon-form/10263/"},{"name":"mimikyu-totem-busted","url":"https://pokeapi.co/api/v2/pokemon-form/10264/"},{"name":"kommo-o-totem","url":"https://pokeapi.co/api/v2/pokemon-form/10265/"},{"name":"magearna-original","url":"https://pokeapi.co/api/v2/pokemon-form/10266/"},{"name":"pikachu-partner-cap","url":"https://pokeapi.co/api/v2/pokemon-form/10267/"},{"name":"marowak-totem","url":"https://pokeapi.co/api/v2/pokemon-form/10268/"},{"name":"mothim-sandy","url":"https://pokeapi.co/api/v2/pokemon-form/10269/"},{"name":"mothim-trash","url":"https://pokeapi.co/api/v2/pokemon-form/10270/"},{"name":"scatterbug-polar","url":"https://pokeapi.co/api/v2/pokemon-form/10271/"},{"name":"scatterbug-tundra","url":"https://pokeapi.co/api/v2/pokemon-form/10272/"},{"name":"scatterbug-continental","url":"https://pokeapi.co/api/v2/pokemon-form/10273/"},{"name":"scatterbug-garden","url":"https://pokeapi.co/api/v2/pokemon-form/10274/"},{"name":"scatterbug-elegant","url":"https://pokeapi.co/api/v2/pokemon-form/10275/"},{"name":"scatterbug-meadow","url":"https://pokeapi.co/api/v2/pokemon-form/10276/"},{"name":"scatterbug-modern","url":"https://pokeapi.co/api/v2/pokemon-form/10277/"},{"name":"scatterbug-marine","url":"https://pokeapi.co/api/v2/pokemon-form/10278/"},{"name":"scatterbug-archipelago","url":"https://pokeapi.co/api/v2/pokemon-form/10279/"},{"name":"scatterbug-high-plains","url":"https://pokeapi.co/api/v2/pokemon-form/10280/"},{"name":"scatterbug-sandstorm","url":"https://pokeapi.co/api/v2/pokemon-form/10281/"},{"name":"scatterbug-river","url":"https://pokeapi.co/api/v2/pokemon-form/10282/"},{"name":"scatterbug-monsoon","url":"https://pokeapi.co/api/v2/pokemon-form/10283/"},{"name":"scatterbug-savanna","url":"https://pokeapi.co/api/v2/pokemon-form/10284/"},{"name":"scatterbug-sun","url":"https://pokeapi.co/api/v2/pokemon-form/10285/"},{"name":"scatterbug-ocean","url":"https://pokeapi.co/api/v2/pokemon-form/10286/"},{"name":"scatterbug-jungle","url":"https://pokeapi.co/api/v2/pokemon-form/10287/"},{"name":"scatterbug-fancy","url":"https://pokeapi.co/api/v2/pokemon-form/10288/"},{"name":"scatterbug-poke-ball","url":"https://pokeapi.co/api/v2/pokemon-form/10289/"},{"name":"spewpa-polar","url":"https://pokeapi.co/api/v2/pokemon-form/10290/"},{"name":"spewpa-tundra","url":"https://pokeapi.co/api/v2/pokemon-form/10291/"},{"name":"spewpa-continental","url":"https://pokeapi.co/api/v2/pokemon-form/10292/"},{"name":"spewpa-garden","url":"https://pokeapi.co/api/v2/pokemon-form/10293/"},{"name":"spewpa-elegant","url":"https://pokeapi.co/api/v2/pokemon-form/10294/"},{"name":"spewpa-meadow","url":"https://pokeapi.co/api/v2/pokemon-form/10295/"},{"name":"spewpa-modern","url":"https://pokeapi.co/api/v2/pokemon-form/10296/"},{"name":"spewpa-marine","url":"https://pokeapi.co/api/v2/pokemon-form/10297/"},{"name":"spewpa-archipelago","url":"https://pokeapi.co/api/v2/pokemon-form/10298/"},{"name":"spewpa-high-plains","url":"https://pokeapi.co/api/v2/pokemon-form/10299/"},{"name":"spewpa-sandstorm","url":"https://pokeapi.co/api/v2/pokemon-form/10300/"},{"name":"spewpa-river","url":"https://pokeapi.co/api/v2/pokemon-form/10301/"},{"name":"spewpa-monsoon","url":"https://pokeapi.co/api/v2/pokemon-form/10302/"},{"name":"spewpa-savanna","url":"https://pokeapi.co/api/v2/pokemon-form/10303/"},{"name":"spewpa-sun","url":"https://pokeapi.co/api/v2/pokemon-form/10304/"},{"name":"spewpa-ocean","url":"https://pokeapi.co/api/v2/pokemon-form/10305/"},{"name":"spewpa-jungle","url":"https://pokeapi.co/api/v2/pokemon-form/10306/"},{"name":"spewpa-fancy","url":"https://pokeapi.co/api/v2/pokemon-form/10307/"},{"name":"spewpa-poke-ball","url":"https://pokeapi.co/api/v2/pokemon-form/10308/"},{"name":"ribombee-totem","url":"https://pokeapi.co/api/v2/pokemon-form/10309/"},{"name":"rockruff-own-tempo","url":"https://pokeapi.co/api/v2/pokemon-form/10310/"},{"name":"lycanroc-dusk","url":"https://pokeapi.co/api/v2/pokemon-form/10311/"},{"name":"araquanid-totem","url":"https://pokeapi.co/api/v2/pokemon-form/10312/"},{"name":"togedemaru-totem","url":"https://pokeapi.co/api/v2/pokemon-form/10313/"},{"name":"necrozma-dusk","url":"https://pokeapi.co/api/v2/pokemon-form/10314/"},{"name":"necrozma-dawn","url":"https://pokeapi.co/api/v2/pokemon-form/10315/"},{"name":"necrozma-ultra","url":"https://pokeapi.co/api/v2/pokemon-form/10316/"}]}"#;

// https://pokeapi.co/api/v2/pokemon-habitat/?offset=0&limit=9999
static FULL_POKEMON_HABITAT_LIST_JSON: &str = r#"{"count":9,"next":null,"previous":null,"results":[{"name":"cave","url":"https://pokeapi.co/api/v2/pokemon-habitat/1/"},{"name":"forest","url":"https://pokeapi.co/api/v2/pokemon-habitat/2/"},{"name":"grassland","url":"https://pokeapi.co/api/v2/pokemon-habitat/3/"},{"name":"mountain","url":"https://pokeapi.co/api/v2/pokemon-habitat/4/"},{"name":"rare","url":"https://pokeapi.co/api/v2/pokemon-habitat/5/"},{"name":"rough-terrain","url":"https://pokeapi.co/api/v2/pokemon-habitat/6/"},{"name":"sea","url":"https://pokeapi.co/api/v2/pokemon-habitat/7/"},{"name":"urban","url":"https://pokeapi.co/api/v2/pokemon-habitat/8/"},{"name":"waters-edge","url":"https://pokeapi.co/api/v2/pokemon-habitat/9/"}]}"#;

// https://pokeapi.co/api/v2/pokemon-shape/?offset=0&limit=9999
static FULL_POKEMON_SHAPE_LIST_JSON: &str = r#"{"count":14,"next":null,"previous":null,"results":[{"name":"ball","url":"https://pokeapi.co/api/v2/pokemon-shape/1/"},{"name":"squiggle","url":"https://pokeapi.co/api/v2/pokemon-shape/2/"},{"name":"fish","url":"https://pokeapi.co/api/v2/pokemon-shape/3/"},{"name":"arms","url":"https://pokeapi.co/api/v2/pokemon-shape/4/"},{"name":"blob","url":"https://pokeapi.co/api/v2/pokemon-shape/5/"},{"name":"upright","url":"https://pokeapi.co/api/v2/pokemon-shape/6/"},{"name":"legs","url":"https://pokeapi.co/api/v2/pokemon-shape/7/"},{"name":"quadruped","url":"https://pokeapi.co/api/v2/pokemon-shape/8/"},{"name":"wings","url":"https://pokeapi.co/api/v2/pokemon-shape/9/"},{"name":"tentacles","url":"https://pokeapi.co/api/v2/pokemon-shape/10/"},{"name":"heads","url":"https://pokeapi.co/api/v2/pokemon-shape/11/"},{"name":"humanoid","url":"https://pokeapi.co/api/v2/pokemon-shape/12/"},{"name":"bug-wings","url":"https://pokeapi.co/api/v2/pokemon-shape/13/"},{"name":"armor","url":"https://pokeapi.co/api/v2/pokemon-shape/14/"}]}"#;

// https://pokeapi.co/api/v2/pokemon-species/?offset=0&limit=9999
static FULL_POKEMON_SPECIES_LIST_JSON: &str = r#"{"count":807,"next":null,"previous":null,"results":[{"name":"bulbasaur","url":"https://pokeapi.co/api/v2/pokemon-species/1/"},{"name":"ivysaur","url":"https://pokeapi.co/api/v2/pokemon-species/2/"},{"name":"venusaur","url":"https://pokeapi.co/api/v2/pokemon-species/3/"},{"name":"charmander","url":"https://pokeapi.co/api/v2/pokemon-species/4/"},{"name":"charmeleon","url":"https://pokeapi.co/api/v2/pokemon-species/5/"},{"name":"charizard","url":"https://pokeapi.co/api/v2/pokemon-species/6/"},{"name":"squirtle","url":"https://pokeapi.co/api/v2/pokemon-species/7/"},{"name":"wartortle","url":"https://pokeapi.co/api/v2/pokemon-species/8/"},{"name":"blastoise","url":"https://pokeapi.co/api/v2/pokemon-species/9/"},{"name":"caterpie","url":"https://pokeapi.co/api/v2/pokemon-species/10/"},{"name":"metapod","url":"https://pokeapi.co/api/v2/pokemon-species/11/"},{"name":"butterfree","url":"https://pokeapi.co/api/v2/pokemon-species/12/"},{"name":"weedle","url":"https://pokeapi.co/api/v2/pokemon-species/13/"},{"name":"kakuna","url":"https://pokeapi.co/api/v2/pokemon-species/14/"},{"name":"beedrill","url":"https://pokeapi.co/api/v2/pokemon-species/15/"},{"name":"pidgey","url":"https://pokeapi.co/api/v2/pokemon-species/16/"},{"name":"pidgeotto","url":"https://pokeapi.co/api/v2/pokemon-species/17/"},{"name":"pidgeot","url":"https://pokeapi.co/api/v2/pokemon-species/18/"},{"name":"rattata","url":"https://pokeapi.co/api/v2/pokemon-species/19/"},{"name":"raticate","url":"https://pokeapi.co/api/v2/pokemon-species/20/"},{"name":"spearow","url":"https://pokeapi.co/api/v2/pokemon-species/21/"},{"name":"fearow","url":"https://pokeapi.co/api/v2/pokemon-species/22/"},{"name":"ekans","url":"https://pokeapi.co/api/v2/pokemon-species/23/"},{"name":"arbok","url":"https://pokeapi.co/api/v2/pokemon-species/24/"},{"name":"pikachu","url":"https://pokeapi.co/api/v2/pokemon-species/25/"},{"name":"raichu","url":"https://pokeapi.co/api/v2/pokemon-species/26/"},{"name":"sandshrew","url":"https://pokeapi.co/api/v2/pokemon-species/27/"},{"name":"sandslash","url":"https://pokeapi.co/api/v2/pokemon-species/28/"},{"name":"nidoran-f","url":"https://pokeapi.co/api/v2/pokemon-species/29/"},{"name":"nidorina","url":"https://pokeapi.co/api/v2/pokemon-species/30/"},{"name":"nidoqueen","url":"https://pokeapi.co/api/v2/pokemon-species/31/"},{"name":"nidoran-m","url":"https://pokeapi.co/api/v2/pokemon-species/32/"},{"name":"nidorino","url":"https://pokeapi.co/api/v2/pokemon-species/33/"},{"name":"nidoking","url":"https://pokeapi.co/api/v2/pokemon-species/34/"},{"name":"clefairy","url":"https://pokeapi.co/api/v2/pokemon-species/35/"},{"name":"clefable","url":"https://pokeapi.co/api/v2/pokemon-species/36/"},{"name":"vulpix","url":"https://pokeapi.co/api/v2/pokemon-species/37/"},{"name":"ninetales","url":"https://pokeapi.co/api/v2/pokemon-species/38/"},{"name":"jigglypuff","url":"https://pokeapi.co/api/v2/pokemon-species/39/"},{"name":"wigglytuff","url":"https://pokeapi.co/api/v2/pokemon-species/40/"},{"name":"zubat","url":"https://pokeapi.co/api/v2/pokemon-species/41/"},{"name":"golbat","url":"https://pokeapi.co/api/v2/pokemon-species/42/"},{"name":"oddish","url":"https://pokeapi.co/api/v2/pokemon-species/43/"},{"name":"gloom","url":"https://pokeapi.co/api/v2/pokemon-species/44/"},{"name":"vileplume","url":"https://pokeapi.co/api/v2/pokemon-species/45/"},{"name":"paras","url":"https://pokeapi.co/api/v2/pokemon-species/46/"},{"name":"parasect","url":"https://pokeapi.co/api/v2/pokemon-species/47/"},{"name":"venonat","url":"https://pokeapi.co/api/v2/pokemon-species/48/"},{"name":"venomoth","url":"https://pokeapi.co/api/v2/pokemon-species/49/"},{"name":"diglett","url":"https://pokeapi.co/api/v2/pokemon-species/50/"},{"name":"dugtrio","url":"https://pokeapi.co/api/v2/pokemon-species/51/"},{"name":"meowth","url":"https://pokeapi.co/api/v2/pokemon-species/52/"},{"name":"persian","url":"https://pokeapi.co/api/v2/pokemon-species/53/"},{"name":"psyduck","url":"https://pokeapi.co/api/v2/pokemon-species/54/"},{"name":"golduck","url":"https://pokeapi.co/api/v2/pokemon-species/55/"},{"name":"mankey","url":"https://pokeapi.co/api/v2/pokemon-species/56/"},{"name":"primeape","url":"https://pokeapi.co/api/v2/pokemon-species/57/"},{"name":"growlithe","url":"https://pokeapi.co/api/v2/pokemon-species/58/"},{"name":"arcanine","url":"https://pokeapi.co/api/v2/pokemon-species/59/"},{"name":"poliwag","url":"https://pokeapi.co/api/v2/pokemon-species/60/"},{"name":"poliwhirl","url":"https://pokeapi.co/api/v2/pokemon-species/61/"},{"name":"poliwrath","url":"https://pokeapi.co/api/v2/pokemon-species/62/"},{"name":"abra","url":"https://pokeapi.co/api/v2/pokemon-species/63/"},{"name":"kadabra","url":"https://pokeapi.co/api/v2/pokemon-species/64/"},{"name":"alakazam","url":"https://pokeapi.co/api/v2/pokemon-species/65/"},{"name":"machop","url":"https://pokeapi.co/api/v2/pokemon-species/66/"},{"name":"machoke","url":"https://pokeapi.co/api/v2/pokemon-species/67/"},{"name":"machamp","url":"https://pokeapi.co/api/v2/pokemon-species/68/"},{"name":"bellsprout","url":"https://pokeapi.co/api/v2/pokemon-species/69/"},{"name":"weepinbell","url":"https://pokeapi.co/api/v2/pokemon-species/70/"},{"name":"victreebel","url":"https://pokeapi.co/api/v2/pokemon-species/71/"},{"name":"tentacool","url":"https://pokeapi.co/api/v2/pokemon-species/72/"},{"name":"tentacruel","url":"https://pokeapi.co/api/v2/pokemon-species/73/"},{"name":"geodude","url":"https://pokeapi.co/api/v2/pokemon-species/74/"},{"name":"graveler","url":"https://pokeapi.co/api/v2/pokemon-species/75/"},{"name":"golem","url":"https://pokeapi.co/api/v2/pokemon-species/76/"},{"name":"ponyta","url":"https://pokeapi.co/api/v2/pokemon-species/77/"},{"name":"rapidash","url":"https://pokeapi.co/api/v2/pokemon-species/78/"},{"name":"slowpoke","url":"https://pokeapi.co/api/v2/pokemon-species/79/"},{"name":"slowbro","url":"https://pokeapi.co/api/v2/pokemon-species/80/"},{"name":"magnemite","url":"https://pokeapi.co/api/v2/pokemon-species/81/"},{"name":"magneton","url":"https://pokeapi.co/api/v2/pokemon-species/82/"},{"name":"farfetchd","url":"https://pokeapi.co/api/v2/pokemon-species/83/"},{"name":"doduo","url":"https://pokeapi.co/api/v2/pokemon-species/84/"},{"name":"dodrio","url":"https://pokeapi.co/api/v2/pokemon-species/85/"},{"name":"seel","url":"https://pokeapi.co/api/v2/pokemon-species/86/"},{"name":"dewgong","url":"https://pokeapi.co/api/v2/pokemon-species/87/"},{"name":"grimer","url":"https://pokeapi.co/api/v2/pokemon-species/88/"},{"name":"muk","url":"https://pokeapi.co/api/v2/pokemon-species/89/"},{"name":"shellder","url":"https://pokeapi.co/api/v2/pokemon-species/90/"},{"name":"cloyster","url":"https://pokeapi.co/api/v2/pokemon-species/91/"},{"name":"gastly","url":"https://pokeapi.co/api/v2/pokemon-species/92/"},{"name":"haunter","url":"https://pokeapi.co/api/v2/pokemon-species/93/"},{"name":"gengar","url":"https://pokeapi.co/api/v2/pokemon-species/94/"},{"name":"onix","url":"https://pokeapi.co/api/v2/pokemon-species/95/"},{"name":"drowzee","url":"https://pokeapi.co/api/v2/pokemon-species/96/"},{"name":"hypno","url":"https://pokeapi.co/api/v2/pokemon-species/97/"},{"name":"krabby","url":"https://pokeapi.co/api/v2/pokemon-species/98/"},{"name":"kingler","url":"https://pokeapi.co/api/v2/pokemon-species/99/"},{"name":"voltorb","url":"https://pokeapi.co/api/v2/pokemon-species/100/"},{"name":"electrode","url":"https://pokeapi.co/api/v2/pokemon-species/101/"},{"name":"exeggcute","url":"https://pokeapi.co/api/v2/pokemon-species/102/"},{"name":"exeggutor","url":"https://pokeapi.co/api/v2/pokemon-species/103/"},{"name":"cubone","url":"https://pokeapi.co/api/v2/pokemon-species/104/"},{"name":"marowak","url":"https://pokeapi.co/api/v2/pokemon-species/105/"},{"name":"hitmonlee","url":"https://pokeapi.co/api/v2/pokemon-species/106/"},{"name":"hitmonchan","url":"https://pokeapi.co/api/v2/pokemon-species/107/"},{"name":"lickitung","url":"https://pokeapi.co/api/v2/pokemon-species/108/"},{"name":"koffing","url":"https://pokeapi.co/api/v2/pokemon-species/109/"},{"name":"weezing","url":"https://pokeapi.co/api/v2/pokemon-species/110/"},{"name":"rhyhorn","url":"https://pokeapi.co/api/v2/pokemon-species/111/"},{"name":"rhydon","url":"https://pokeapi.co/api/v2/pokemon-species/112/"},{"name":"chansey","url":"https://pokeapi.co/api/v2/pokemon-species/113/"},{"name":"tangela","url":"https://pokeapi.co/api/v2/pokemon-species/114/"},{"name":"kangaskhan","url":"https://pokeapi.co/api/v2/pokemon-species/115/"},{"name":"horsea","url":"https://pokeapi.co/api/v2/pokemon-species/116/"},{"name":"seadra","url":"https://pokeapi.co/api/v2/pokemon-species/117/"},{"name":"goldeen","url":"https://pokeapi.co/api/v2/pokemon-species/118/"},{"name":"seaking","url":"https://pokeapi.co/api/v2/pokemon-species/119/"},{"name":"staryu","url":"https://pokeapi.co/api/v2/pokemon-species/120/"},{"name":"starmie","url":"https://pokeapi.co/api/v2/pokemon-species/121/"},{"name":"mr-mime","url":"https://pokeapi.co/api/v2/pokemon-species/122/"},{"name":"scyther","url":"https://pokeapi.co/api/v2/pokemon-species/123/"},{"name":"jynx","url":"https://pokeapi.co/api/v2/pokemon-species/124/"},{"name":"electabuzz","url":"https://pokeapi.co/api/v2/pokemon-species/125/"},{"name":"magmar","url":"https://pokeapi.co/api/v2/pokemon-species/126/"},{"name":"pinsir","url":"https://pokeapi.co/api/v2/pokemon-species/127/"},{"name":"tauros","url":"https://pokeapi.co/api/v2/pokemon-species/128/"},{"name":"magikarp","url":"https://pokeapi.co/api/v2/pokemon-species/129/"},{"name":"gyarados","url":"https://pokeapi.co/api/v2/pokemon-species/130/"},{"name":"lapras","url":"https://pokeapi.co/api/v2/pokemon-species/131/"},{"name":"ditto","url":"https://pokeapi.co/api/v2/pokemon-species/132/"},{"name":"eevee","url":"https://pokeapi.co/api/v2/pokemon-species/133/"},{"name":"vaporeon","url":"https://pokeapi.co/api/v2/pokemon-species/134/"},{"name":"jolteon","url":"https://pokeapi.co/api/v2/pokemon-species/135/"},{"name":"flareon","url":"https://pokeapi.co/api/v2/pokemon-species/136/"},{"name":"porygon","url":"https://pokeapi.co/api/v2/pokemon-species/137/"},{"name":"omanyte","url":"https://pokeapi.co/api/v2/pokemon-species/138/"},{"name":"omastar","url":"https://pokeapi.co/api/v2/pokemon-species/139/"},{"name":"kabuto","url":"https://pokeapi.co/api/v2/pokemon-species/140/"},{"name":"kabutops","url":"https://pokeapi.co/api/v2/pokemon-species/141/"},{"name":"aerodactyl","url":"https://pokeapi.co/api/v2/pokemon-species/142/"},{"name":"snorlax","url":"https://pokeapi.co/api/v2/pokemon-species/143/"},{"name":"articuno","url":"https://pokeapi.co/api/v2/pokemon-species/144/"},{"name":"zapdos","url":"https://pokeapi.co/api/v2/pokemon-species/145/"},{"name":"moltres","url":"https://pokeapi.co/api/v2/pokemon-species/146/"},{"name":"dratini","url":"https://pokeapi.co/api/v2/pokemon-species/147/"},{"name":"dragonair","url":"https://pokeapi.co/api/v2/pokemon-species/148/"},{"name":"dragonite","url":"https://pokeapi.co/api/v2/pokemon-species/149/"},{"name":"mewtwo","url":"https://pokeapi.co/api/v2/pokemon-species/150/"},{"name":"mew","url":"https://pokeapi.co/api/v2/pokemon-species/151/"},{"name":"chikorita","url":"https://pokeapi.co/api/v2/pokemon-species/152/"},{"name":"bayleef","url":"https://pokeapi.co/api/v2/pokemon-species/153/"},{"name":"meganium","url":"https://pokeapi.co/api/v2/pokemon-species/154/"},{"name":"cyndaquil","url":"https://pokeapi.co/api/v2/pokemon-species/155/"},{"name":"quilava","url":"https://pokeapi.co/api/v2/pokemon-species/156/"},{"name":"typhlosion","url":"https://pokeapi.co/api/v2/pokemon-species/157/"},{"name":"totodile","url":"https://pokeapi.co/api/v2/pokemon-species/158/"},{"name":"croconaw","url":"https://pokeapi.co/api/v2/pokemon-species/159/"},{"name":"feraligatr","url":"https://pokeapi.co/api/v2/pokemon-species/160/"},{"name":"sentret","url":"https://pokeapi.co/api/v2/pokemon-species/161/"},{"name":"furret","url":"https://pokeapi.co/api/v2/pokemon-species/162/"},{"name":"hoothoot","url":"https://pokeapi.co/api/v2/pokemon-species/163/"},{"name":"noctowl","url":"https://pokeapi.co/api/v2/pokemon-species/164/"},{"name":"ledyba","url":"https://pokeapi.co/api/v2/pokemon-species/165/"},{"name":"ledian","url":"https://pokeapi.co/api/v2/pokemon-species/166/"},{"name":"spinarak","url":"https://pokeapi.co/api/v2/pokemon-species/167/"},{"name":"ariados","url":"https://pokeapi.co/api/v2/pokemon-species/168/"},{"name":"crobat","url":"https://pokeapi.co/api/v2/pokemon-species/169/"},{"name":"chinchou","url":"https://pokeapi.co/api/v2/pokemon-species/170/"},{"name":"lanturn","url":"https://pokeapi.co/api/v2/pokemon-species/171/"},{"name":"pichu","url":"https://pokeapi.co/api/v2/pokemon-species/172/"},{"name":"cleffa","url":"https://pokeapi.co/api/v2/pokemon-species/173/"},{"name":"igglybuff","url":"https://pokeapi.co/api/v2/pokemon-species/174/"},{"name":"togepi","url":"https://pokeapi.co/api/v2/pokemon-species/175/"},{"name":"togetic","url":"https://pokeapi.co/api/v2/pokemon-species/176/"},{"name":"natu","url":"https://pokeapi.co/api/v2/pokemon-species/177/"},{"name":"xatu","url":"https://pokeapi.co/api/v2/pokemon-species/178/"},{"name":"mareep","url":"https://pokeapi.co/api/v2/pokemon-species/179/"},{"name":"flaaffy","url":"https://pokeapi.co/api/v2/pokemon-species/180/"},{"name":"ampharos","url":"https://pokeapi.co/api/v2/pokemon-species/181/"},{"name":"bellossom","url":"https://pokeapi.co/api/v2/pokemon-species/182/"},{"name":"marill","url":"https://pokeapi.co/api/v2/pokemon-species/183/"},{"name":"azumarill","url":"https://pokeapi.co/api/v2/pokemon-species/184/"},{"name":"sudowoodo","url":"https://pokeapi.co/api/v2/pokemon-species/185/"},{"name":"politoed","url":"https://pokeapi.co/api/v2/pokemon-species/186/"},{"name":"hoppip","url":"https://pokeapi.co/api/v2/pokemon-species/187/"},{"name":"skiploom","url":"https://pokeapi.co/api/v2/pokemon-species/188/"},{"name":"jumpluff","url":"https://pokeapi.co/api/v2/pokemon-species/189/"},{"name":"aipom","url":"https://pokeapi.co/api/v2/pokemon-species/190/"},{"name":"sunkern","url":"https://pokeapi.co/api/v2/pokemon-species/191/"},{"name":"sunflora","url":"https://pokeapi.co/api/v2/pokemon-species/192/"},{"name":"yanma","url":"https://pokeapi.co/api/v2/pokemon-species/193/"},{"name":"wooper","url":"https://pokeapi.co/api/v2/pokemon-species/194/"},{"name":"quagsire","url":"https://pokeapi.co/api/v2/pokemon-species/195/"},{"name":"espeon","url":"https://pokeapi.co/api/v2/pokemon-species/196/"},{"name":"umbreon","url":"https://pokeapi.co/api/v2/pokemon-species/197/"},{"name":"murkrow","url":"https://pokeapi.co/api/v2/pokemon-species/198/"},{"name":"slowking","url":"https://pokeapi.co/api/v2/pokemon-species/199/"},{"name":"misdreavus","url":"https://pokeapi.co/api/v2/pokemon-species/200/"},{"name":"unown","url":"https://pokeapi.co/api/v2/pokemon-species/201/"},{"name":"wobbuffet","url":"https://pokeapi.co/api/v2/pokemon-species/202/"},{"name":"girafarig","url":"https://pokeapi.co/api/v2/pokemon-species/203/"},{"name":"pineco","url":"https://pokeapi.co/api/v2/pokemon-species/204/"},{"name":"forretress","url":"https://pokeapi.co/api/v2/pokemon-species/205/"},{"name":"dunsparce","url":"https://pokeapi.co/api/v2/pokemon-species/206/"},{"name":"gligar","url":"https://pokeapi.co/api/v2/pokemon-species/207/"},{"name":"steelix","url":"https://pokeapi.co/api/v2/pokemon-species/208/"},{"name":"snubbull","url":"https://pokeapi.co/api/v2/pokemon-species/209/"},{"name":"granbull","url":"https://pokeapi.co/api/v2/pokemon-species/210/"},{"name":"qwilfish","url":"https://pokeapi.co/api/v2/pokemon-species/211/"},{"name":"scizor","url":"https://pokeapi.co/api/v2/pokemon-species/212/"},{"name":"shuckle","url":"https://pokeapi.co/api/v2/pokemon-species/213/"},{"name":"heracross","url":"https://pokeapi.co/api/v2/pokemon-species/214/"},{"name":"sneasel","url":"https://pokeapi.co/api/v2/pokemon-species/215/"},{"name":"teddiursa","url":"https://pokeapi.co/api/v2/pokemon-species/216/"},{"name":"ursaring","url":"https://pokeapi.co/api/v2/pokemon-species/217/"},{"name":"slugma","url":"https://pokeapi.co/api/v2/pokemon-species/218/"},{"name":"magcargo","url":"https://pokeapi.co/api/v2/pokemon-species/219/"},{"name":"swinub","url":"https://pokeapi.co/api/v2/pokemon-species/220/"},{"name":"piloswine","url":"https://pokeapi.co/api/v2/pokemon-species/221/"},{"name":"corsola","url":"https://pokeapi.co/api/v2/pokemon-species/222/"},{"name":"remoraid","url":"https://pokeapi.co/api/v2/pokemon-species/223/"},{"name":"octillery","url":"https://pokeapi.co/api/v2/pokemon-species/224/"},{"name":"delibird","url":"https://pokeapi.co/api/v2/pokemon-species/225/"},{"name":"mantine","url":"https://pokeapi.co/api/v2/pokemon-species/226/"},{"name":"skarmory","url":"https://pokeapi.co/api/v2/pokemon-species/227/"},{"name":"houndour","url":"https://pokeapi.co/api/v2/pokemon-species/228/"},{"name":"houndoom","url":"https://pokeapi.co/api/v2/pokemon-species/229/"},{"name":"kingdra","url":"https://pokeapi.co/api/v2/pokemon-species/230/"},{"name":"phanpy","url":"https://pokeapi.co/api/v2/pokemon-species/231/"},{"name":"donphan","url":"https://pokeapi.co/api/v2/pokemon-species/232/"},{"name":"porygon2","url":"https://pokeapi.co/api/v2/pokemon-species/233/"},{"name":"stantler","url":"https://pokeapi.co/api/v2/pokemon-species/234/"},{"name":"smeargle","url":"https://pokeapi.co/api/v2/pokemon-species/235/"},{"name":"tyrogue","url":"https://pokeapi.co/api/v2/pokemon-species/236/"},{"name":"hitmontop","url":"https://pokeapi.co/api/v2/pokemon-species/237/"},{"name":"smoochum","url":"https://pokeapi.co/api/v2/pokemon-species/238/"},{"name":"elekid","url":"https://pokeapi.co/api/v2/pokemon-species/239/"},{"name":"magby","url":"https://pokeapi.co/api/v2/pokemon-species/240/"},{"name":"miltank","url":"https://pokeapi.co/api/v2/pokemon-species/241/"},{"name":"blissey","url":"https://pokeapi.co/api/v2/pokemon-species/242/"},{"name":"raikou","url":"https://pokeapi.co/api/v2/pokemon-species/243/"},{"name":"entei","url":"https://pokeapi.co/api/v2/pokemon-species/244/"},{"name":"suicune","url":"https://pokeapi.co/api/v2/pokemon-species/245/"},{"name":"larvitar","url":"https://pokeapi.co/api/v2/pokemon-species/246/"},{"name":"pupitar","url":"https://pokeapi.co/api/v2/pokemon-species/247/"},{"name":"tyranitar","url":"https://pokeapi.co/api/v2/pokemon-species/248/"},{"name":"lugia","url":"https://pokeapi.co/api/v2/pokemon-species/249/"},{"name":"ho-oh","url":"https://pokeapi.co/api/v2/pokemon-species/250/"},{"name":"celebi","url":"https://pokeapi.co/api/v2/pokemon-species/251/"},{"name":"treecko","url":"https://pokeapi.co/api/v2/pokemon-species/252/"},{"name":"grovyle","url":"https://pokeapi.co/api/v2/pokemon-species/253/"},{"name":"sceptile","url":"https://pokeapi.co/api/v2/pokemon-species/254/"},{"name":"torchic","url":"https://pokeapi.co/api/v2/pokemon-species/255/"},{"name":"combusken","url":"https://pokeapi.co/api/v2/pokemon-species/256/"},{"name":"blaziken","url":"https://pokeapi.co/api/v2/pokemon-species/257/"},{"name":"mudkip","url":"https://pokeapi.co/api/v2/pokemon-species/258/"},{"name":"marshtomp","url":"https://pokeapi.co/api/v2/pokemon-species/259/"},{"name":"swampert","url":"https://pokeapi.co/api/v2/pokemon-species/260/"},{"name":"poochyena","url":"https://pokeapi.co/api/v2/pokemon-species/261/"},{"name":"mightyena","url":"https://pokeapi.co/api/v2/pokemon-species/262/"},{"name":"zigzagoon","url":"https://pokeapi.co/api/v2/pokemon-species/263/"},{"name":"linoone","url":"https://pokeapi.co/api/v2/pokemon-species/264/"},{"name":"wurmple","url":"https://pokeapi.co/api/v2/pokemon-species/265/"},{"name":"silcoon","url":"https://pokeapi.co/api/v2/pokemon-species/266/"},{"name":"beautifly","url":"https://pokeapi.co/api/v2/pokemon-species/267/"},{"name":"cascoon","url":"https://pokeapi.co/api/v2/pokemon-species/268/"},{"name":"dustox","url":"https://pokeapi.co/api/v2/pokemon-species/269/"},{"name":"lotad","url":"https://pokeapi.co/api/v2/pokemon-species/270/"},{"name":"lombre","url":"https://pokeapi.co/api/v2/pokemon-species/271/"},{"name":"ludicolo","url":"https://pokeapi.co/api/v2/pokemon-species/272/"},{"name":"seedot","url":"https://pokeapi.co/api/v2/pokemon-species/273/"},{"name":"nuzleaf","url":"https://pokeapi.co/api/v2/pokemon-species/274/"},{"name":"shiftry","url":"https://pokeapi.co/api/v2/pokemon-species/275/"},{"name":"taillow","url":"https://pokeapi.co/api/v2/pokemon-species/276/"},{"name":"swellow","url":"https://pokeapi.co/api/v2/pokemon-species/277/"},{"name":"wingull","url":"https://pokeapi.co/api/v2/pokemon-species/278/"},{"name":"pelipper","url":"https://pokeapi.co/api/v2/pokemon-species/279/"},{"name":"ralts","url":"https://pokeapi.co/api/v2/pokemon-species/280/"},{"name":"kirlia","url":"https://pokeapi.co/api/v2/pokemon-species/281/"},{"name":"gardevoir","url":"https://pokeapi.co/api/v2/pokemon-species/282/"},{"name":"surskit","url":"https://pokeapi.co/api/v2/pokemon-species/283/"},{"name":"masquerain","url":"https://pokeapi.co/api/v2/pokemon-species/284/"},{"name":"shroomish","url":"https://pokeapi.co/api/v2/pokemon-species/285/"},{"name":"breloom","url":"https://pokeapi.co/api/v2/pokemon-species/286/"},{"name":"slakoth","url":"https://pokeapi.co/api/v2/pokemon-species/287/"},{"name":"vigoroth","url":"https://pokeapi.co/api/v2/pokemon-species/288/"},{"name":"slaking","url":"https://pokeapi.co/api/v2/pokemon-species/289/"},{"name":"nincada","url":"https://pokeapi.co/api/v2/pokemon-species/290/"},{"name":"ninjask","url":"https://pokeapi.co/api/v2/pokemon-species/291/"},{"name":"shedinja","url":"https://pokeapi.co/api/v2/pokemon-species/292/"},{"name":"whismur","url":"https://pokeapi.co/api/v2/pokemon-species/293/"},{"name":"loudred","url":"https://pokeapi.co/api/v2/pokemon-species/294/"},{"name":"exploud","url":"https://pokeapi.co/api/v2/pokemon-species/295/"},{"name":"makuhita","url":"https://pokeapi.co/api/v2/pokemon-species/296/"},{"name":"hariyama","url":"https://pokeapi.co/api/v2/pokemon-species/297/"},{"name":"azurill","url":"https://pokeapi.co/api/v2/pokemon-species/298/"},{"name":"nosepass","url":"https://pokeapi.co/api/v2/pokemon-species/299/"},{"name":"skitty","url":"https://pokeapi.co/api/v2/pokemon-species/300/"},{"name":"delcatty","url":"https://pokeapi.co/api/v2/pokemon-species/301/"},{"name":"sableye","url":"https://pokeapi.co/api/v2/pokemon-species/302/"},{"name":"mawile","url":"https://pokeapi.co/api/v2/pokemon-species/303/"},{"name":"aron","url":"https://pokeapi.co/api/v2/pokemon-species/304/"},{"name":"lairon","url":"https://pokeapi.co/api/v2/pokemon-species/305/"},{"name":"aggron","url":"https://pokeapi.co/api/v2/pokemon-species/306/"},{"name":"meditite","url":"https://pokeapi.co/api/v2/pokemon-species/307/"},{"name":"medicham","url":"https://pokeapi.co/api/v2/pokemon-species/308/"},{"name":"electrike","url":"https://pokeapi.co/api/v2/pokemon-species/309/"},{"name":"manectric","url":"https://pokeapi.co/api/v2/pokemon-species/310/"},{"name":"plusle","url":"https://pokeapi.co/api/v2/pokemon-species/311/"},{"name":"minun","url":"https://pokeapi.co/api/v2/pokemon-species/312/"},{"name":"volbeat","url":"https://pokeapi.co/api/v2/pokemon-species/313/"},{"name":"illumise","url":"https://pokeapi.co/api/v2/pokemon-species/314/"},{"name":"roselia","url":"https://pokeapi.co/api/v2/pokemon-species/315/"},{"name":"gulpin","url":"https://pokeapi.co/api/v2/pokemon-species/316/"},{"name":"swalot","url":"https://pokeapi.co/api/v2/pokemon-species/317/"},{"name":"carvanha","url":"https://pokeapi.co/api/v2/pokemon-species/318/"},{"name":"sharpedo","url":"https://pokeapi.co/api/v2/pokemon-species/319/"},{"name":"wailmer","url":"https://pokeapi.co/api/v2/pokemon-species/320/"},{"name":"wailord","url":"https://pokeapi.co/api/v2/pokemon-species/321/"},{"name":"numel","url":"https://pokeapi.co/api/v2/pokemon-species/322/"},{"name":"camerupt","url":"https://pokeapi.co/api/v2/pokemon-species/323/"},{"name":"torkoal","url":"https://pokeapi.co/api/v2/pokemon-species/324/"},{"name":"spoink","url":"https://pokeapi.co/api/v2/pokemon-species/325/"},{"name":"grumpig","url":"https://pokeapi.co/api/v2/pokemon-species/326/"},{"name":"spinda","url":"https://pokeapi.co/api/v2/pokemon-species/327/"},{"name":"trapinch","url":"https://pokeapi.co/api/v2/pokemon-species/328/"},{"name":"vibrava","url":"https://pokeapi.co/api/v2/pokemon-species/329/"},{"name":"flygon","url":"https://pokeapi.co/api/v2/pokemon-species/330/"},{"name":"cacnea","url":"https://pokeapi.co/api/v2/pokemon-species/331/"},{"name":"cacturne","url":"https://pokeapi.co/api/v2/pokemon-species/332/"},{"name":"swablu","url":"https://pokeapi.co/api/v2/pokemon-species/333/"},{"name":"altaria","url":"https://pokeapi.co/api/v2/pokemon-species/334/"},{"name":"zangoose","url":"https://pokeapi.co/api/v2/pokemon-species/335/"},{"name":"seviper","url":"https://pokeapi.co/api/v2/pokemon-species/336/"},{"name":"lunatone","url":"https://pokeapi.co/api/v2/pokemon-species/337/"},{"name":"solrock","url":"https://pokeapi.co/api/v2/pokemon-species/338/"},{"name":"barboach","url":"https://pokeapi.co/api/v2/pokemon-species/339/"},{"name":"whiscash","url":"https://pokeapi.co/api/v2/pokemon-species/340/"},{"name":"corphish","url":"https://pokeapi.co/api/v2/pokemon-species/341/"},{"name":"crawdaunt","url":"https://pokeapi.co/api/v2/pokemon-species/342/"},{"name":"baltoy","url":"https://pokeapi.co/api/v2/pokemon-species/343/"},{"name":"claydol","url":"https://pokeapi.co/api/v2/pokemon-species/344/"},{"name":"lileep","url":"https://pokeapi.co/api/v2/pokemon-species/345/"},{"name":"cradily","url":"https://pokeapi.co/api/v2/pokemon-species/346/"},{"name":"anorith","url":"https://pokeapi.co/api/v2/pokemon-species/347/"},{"name":"armaldo","url":"https://pokeapi.co/api/v2/pokemon-species/348/"},{"name":"feebas","url":"https://pokeapi.co/api/v2/pokemon-species/349/"},{"name":"milotic","url":"https://pokeapi.co/api/v2/pokemon-species/350/"},{"name":"castform","url":"https://pokeapi.co/api/v2/pokemon-species/351/"},{"name":"kecleon","url":"https://pokeapi.co/api/v2/pokemon-species/352/"},{"name":"shuppet","url":"https://pokeapi.co/api/v2/pokemon-species/353/"},{"name":"banette","url":"https://pokeapi.co/api/v2/pokemon-species/354/"},{"name":"duskull","url":"https://pokeapi.co/api/v2/pokemon-species/355/"},{"name":"dusclops","url":"https://pokeapi.co/api/v2/pokemon-species/356/"},{"name":"tropius","url":"https://pokeapi.co/api/v2/pokemon-species/357/"},{"name":"chimecho","url":"https://pokeapi.co/api/v2/pokemon-species/358/"},{"name":"absol","url":"https://pokeapi.co/api/v2/pokemon-species/359/"},{"name":"wynaut","url":"https://pokeapi.co/api/v2/pokemon-species/360/"},{"name":"snorunt","url":"https://pokeapi.co/api/v2/pokemon-species/361/"},{"name":"glalie","url":"https://pokeapi.co/api/v2/pokemon-species/362/"},{"name":"spheal","url":"https://pokeapi.co/api/v2/pokemon-species/363/"},{"name":"sealeo","url":"https://pokeapi.co/api/v2/pokemon-species/364/"},{"name":"walrein","url":"https://pokeapi.co/api/v2/pokemon-species/365/"},{"name":"clamperl","url":"https://pokeapi.co/api/v2/pokemon-species/366/"},{"name":"huntail","url":"https://pokeapi.co/api/v2/pokemon-species/367/"},{"name":"gorebyss","url":"https://pokeapi.co/api/v2/pokemon-species/368/"},{"name":"relicanth","url":"https://pokeapi.co/api/v2/pokemon-species/369/"},{"name":"luvdisc","url":"https://pokeapi.co/api/v2/pokemon-species/370/"},{"name":"bagon","url":"https://pokeapi.co/api/v2/pokemon-species/371/"},{"name":"shelgon","url":"https://pokeapi.co/api/v2/pokemon-species/372/"},{"name":"salamence","url":"https://pokeapi.co/api/v2/pokemon-species/373/"},{"name":"beldum","url":"https://pokeapi.co/api/v2/pokemon-species/374/"},{"name":"metang","url":"https://pokeapi.co/api/v2/pokemon-species/375/"},{"name":"metagross","url":"https://pokeapi.co/api/v2/pokemon-species/376/"},{"name":"regirock","url":"https://pokeapi.co/api/v2/pokemon-species/377/"},{"name":"regice","url":"https://pokeapi.co/api/v2/pokemon-species/378/"},{"name":"registeel","url":"https://pokeapi.co/api/v2/pokemon-species/379/"},{"name":"latias","url":"https://pokeapi.co/api/v2/pokemon-species/380/"},{"name":"latios","url":"https://pokeapi.co/api/v2/pokemon-species/381/"},{"name":"kyogre","url":"https://pokeapi.co/api/v2/pokemon-species/382/"},{"name":"groudon","url":"https://pokeapi.co/api/v2/pokemon-species/383/"},{"name":"rayquaza","url":"https://pokeapi.co/api/v2/pokemon-species/384/"},{"name":"jirachi","url":"https://pokeapi.co/api/v2/pokemon-species/385/"},{"name":"deoxys","url":"https://pokeapi.co/api/v2/pokemon-species/386/"},{"name":"turtwig","url":"https://pokeapi.co/api/v2/pokemon-species/387/"},{"name":"grotle","url":"https://pokeapi.co/api/v2/pokemon-species/388/"},{"name":"torterra","url":"https://pokeapi.co/api/v2/pokemon-species/389/"},{"name":"chimchar","url":"https://pokeapi.co/api/v2/pokemon-species/390/"},{"name":"monferno","url":"https://pokeapi.co/api/v2/pokemon-species/391/"},{"name":"infernape","url":"https://pokeapi.co/api/v2/pokemon-species/392/"},{"name":"piplup","url":"https://pokeapi.co/api/v2/pokemon-species/393/"},{"name":"prinplup","url":"https://pokeapi.co/api/v2/pokemon-species/394/"},{"name":"empoleon","url":"https://pokeapi.co/api/v2/pokemon-species/395/"},{"name":"starly","url":"https://pokeapi.co/api/v2/pokemon-species/396/"},{"name":"staravia","url":"https://pokeapi.co/api/v2/pokemon-species/397/"},{"name":"staraptor","url":"https://pokeapi.co/api/v2/pokemon-species/398/"},{"name":"bidoof","url":"https://pokeapi.co/api/v2/pokemon-species/399/"},{"name":"bibarel","url":"https://pokeapi.co/api/v2/pokemon-species/400/"},{"name":"kricketot","url":"https://pokeapi.co/api/v2/pokemon-species/401/"},{"name":"kricketune","url":"https://pokeapi.co/api/v2/pokemon-species/402/"},{"name":"shinx","url":"https://pokeapi.co/api/v2/pokemon-species/403/"},{"name":"luxio","url":"https://pokeapi.co/api/v2/pokemon-species/404/"},{"name":"luxray","url":"https://pokeapi.co/api/v2/pokemon-species/405/"},{"name":"budew","url":"https://pokeapi.co/api/v2/pokemon-species/406/"},{"name":"roserade","url":"https://pokeapi.co/api/v2/pokemon-species/407/"},{"name":"cranidos","url":"https://pokeapi.co/api/v2/pokemon-species/408/"},{"name":"rampardos","url":"https://pokeapi.co/api/v2/pokemon-species/409/"},{"name":"shieldon","url":"https://pokeapi.co/api/v2/pokemon-species/410/"},{"name":"bastiodon","url":"https://pokeapi.co/api/v2/pokemon-species/411/"},{"name":"burmy","url":"https://pokeapi.co/api/v2/pokemon-species/412/"},{"name":"wormadam","url":"https://pokeapi.co/api/v2/pokemon-species/413/"},{"name":"mothim","url":"https://pokeapi.co/api/v2/pokemon-species/414/"},{"name":"combee","url":"https://pokeapi.co/api/v2/pokemon-species/415/"},{"name":"vespiquen","url":"https://pokeapi.co/api/v2/pokemon-species/416/"},{"name":"pachirisu","url":"https://pokeapi.co/api/v2/pokemon-species/417/"},{"name":"buizel","url":"https://pokeapi.co/api/v2/pokemon-species/418/"},{"name":"floatzel","url":"https://pokeapi.co/api/v2/pokemon-species/419/"},{"name":"cherubi","url":"https://pokeapi.co/api/v2/pokemon-species/420/"},{"name":"cherrim","url":"https://pokeapi.co/api/v2/pokemon-species/421/"},{"name":"shellos","url":"https://pokeapi.co/api/v2/pokemon-species/422/"},{"name":"gastrodon","url":"https://pokeapi.co/api/v2/pokemon-species/423/"},{"name":"ambipom","url":"https://pokeapi.co/api/v2/pokemon-species/424/"},{"name":"drifloon","url":"https://pokeapi.co/api/v2/pokemon-species/425/"},{"name":"drifblim","url":"https://pokeapi.co/api/v2/pokemon-species/426/"},{"name":"buneary","url":"https://pokeapi.co/api/v2/pokemon-species/427/"},{"name":"lopunny","url":"https://pokeapi.co/api/v2/pokemon-species/428/"},{"name":"mismagius","url":"https://pokeapi.co/api/v2/pokemon-species/429/"},{"name":"honchkrow","url":"https://pokeapi.co/api/v2/pokemon-species/430/"},{"name":"glameow","url":"https://pokeapi.co/api/v2/pokemon-species/431/"},{"name":"purugly","url":"https://pokeapi.co/api/v2/pokemon-species/432/"},{"name":"chingling","url":"https://pokeapi.co/api/v2/pokemon-species/433/"},{"name":"stunky","url":"https://pokeapi.co/api/v2/pokemon-species/434/"},{"name":"skuntank","url":"https://pokeapi.co/api/v2/pokemon-species/435/"},{"name":"bronzor","url":"https://pokeapi.co/api/v2/pokemon-species/436/"},{"name":"bronzong","url":"https://pokeapi.co/api/v2/pokemon-species/437/"},{"name":"bonsly","url":"https://pokeapi.co/api/v2/pokemon-species/438/"},{"name":"mime-jr","url":"https://pokeapi.co/api/v2/pokemon-species/439/"},{"name":"happiny","url":"https://pokeapi.co/api/v2/pokemon-species/440/"},{"name":"chatot","url":"https://pokeapi.co/api/v2/pokemon-species/441/"},{"name":"spiritomb","url":"https://pokeapi.co/api/v2/pokemon-species/442/"},{"name":"gible","url":"https://pokeapi.co/api/v2/pokemon-species/443/"},{"name":"gabite","url":"https://pokeapi.co/api/v2/pokemon-species/444/"},{"name":"garchomp","url":"https://pokeapi.co/api/v2/pokemon-species/445/"},{"name":"munchlax","url":"https://pokeapi.co/api/v2/pokemon-species/446/"},{"name":"riolu","url":"https://pokeapi.co/api/v2/pokemon-species/447/"},{"name":"lucario","url":"https://pokeapi.co/api/v2/pokemon-species/448/"},{"name":"hippopotas","url":"https://pokeapi.co/api/v2/pokemon-species/449/"},{"name":"hippowdon","url":"https://pokeapi.co/api/v2/pokemon-species/450/"},{"name":"skorupi","url":"https://pokeapi.co/api/v2/pokemon-species/451/"},{"name":"drapion","url":"https://pokeapi.co/api/v2/pokemon-species/452/"},{"name":"croagunk","url":"https://pokeapi.co/api/v2/pokemon-species/453/"},{"name":"toxicroak","url":"https://pokeapi.co/api/v2/pokemon-species/454/"},{"name":"carnivine","url":"https://pokeapi.co/api/v2/pokemon-species/455/"},{"name":"finneon","url":"https://pokeapi.co/api/v2/pokemon-species/456/"},{"name":"lumineon","url":"https://pokeapi.co/api/v2/pokemon-species/457/"},{"name":"mantyke","url":"https://pokeapi.co/api/v2/pokemon-species/458/"},{"name":"snover","url":"https://pokeapi.co/api/v2/pokemon-species/459/"},{"name":"abomasnow","url":"https://pokeapi.co/api/v2/pokemon-species/460/"},{"name":"weavile","url":"https://pokeapi.co/api/v2/pokemon-species/461/"},{"name":"magnezone","url":"https://pokeapi.co/api/v2/pokemon-species/462/"},{"name":"lickilicky","url":"https://pokeapi.co/api/v2/pokemon-species/463/"},{"name":"rhyperior","url":"https://pokeapi.co/api/v2/pokemon-species/464/"},{"name":"tangrowth","url":"https://pokeapi.co/api/v2/pokemon-species/465/"},{"name":"electivire","url":"https://pokeapi.co/api/v2/pokemon-species/466/"},{"name":"magmortar","url":"https://pokeapi.co/api/v2/pokemon-species/467/"},{"name":"togekiss","url":"https://pokeapi.co/api/v2/pokemon-species/468/"},{"name":"yanmega","url":"https://pokeapi.co/api/v2/pokemon-species/469/"},{"name":"leafeon","url":"https://pokeapi.co/api/v2/pokemon-species/470/"},{"name":"glaceon","url":"https://pokeapi.co/api/v2/pokemon-species/471/"},{"name":"gliscor","url":"https://pokeapi.co/api/v2/pokemon-species/472/"},{"name":"mamoswine","url":"https://pokeapi.co/api/v2/pokemon-species/473/"},{"name":"porygon-z","url":"https://pokeapi.co/api/v2/pokemon-species/474/"},{"name":"gallade","url":"https://pokeapi.co/api/v2/pokemon-species/475/"},{"name":"probopass","url":"https://pokeapi.co/api/v2/pokemon-species/476/"},{"name":"dusknoir","url":"https://pokeapi.co/api/v2/pokemon-species/477/"},{"name":"froslass","url":"https://pokeapi.co/api/v2/pokemon-species/478/"},{"name":"rotom","url":"https://pokeapi.co/api/v2/pokemon-species/479/"},{"name":"uxie","url":"https://pokeapi.co/api/v2/pokemon-species/480/"},{"name":"mesprit","url":"https://pokeapi.co/api/v2/pokemon-species/481/"},{"name":"azelf","url":"https://pokeapi.co/api/v2/pokemon-species/482/"},{"name":"dialga","url":"https://pokeapi.co/api/v2/pokemon-species/483/"},{"name":"palkia","url":"https://pokeapi.co/api/v2/pokemon-species/484/"},{"name":"heatran","url":"https://pokeapi.co/api/v2/pokemon-species/485/"},{"name":"regigigas","url":"https://pokeapi.co/api/v2/pokemon-species/486/"},{"name":"giratina","url":"https://pokeapi.co/api/v2/pokemon-species/487/"},{"name":"cresselia","url":"https://pokeapi.co/api/v2/pokemon-species/488/"},{"name":"phione","url":"https://pokeapi.co/api/v2/pokemon-species/489/"},{"name":"manaphy","url":"https://pokeapi.co/api/v2/pokemon-species/490/"},{"name":"darkrai","url":"https://pokeapi.co/api/v2/pokemon-species/491/"},{"name":"shaymin","url":"https://pokeapi.co/api/v2/pokemon-species/492/"},{"name":"arceus","url":"https://pokeapi.co/api/v2/pokemon-species/493/"},{"name":"victini","url":"https://pokeapi.co/api/v2/pokemon-species/494/"},{"name":"snivy","url":"https://pokeapi.co/api/v2/pokemon-species/495/"},{"name":"servine","url":"https://pokeapi.co/api/v2/pokemon-species/496/"},{"name":"serperior","url":"https://pokeapi.co/api/v2/pokemon-species/497/"},{"name":"tepig","url":"https://pokeapi.co/api/v2/pokemon-species/498/"},{"name":"pignite","url":"https://pokeapi.co/api/v2/pokemon-species/499/"},{"name":"emboar","url":"https://pokeapi.co/api/v2/pokemon-species/500/"},{"name":"oshawott","url":"https://pokeapi.co/api/v2/pokemon-species/501/"},{"name":"dewott","url":"https://pokeapi.co/api/v2/pokemon-species/502/"},{"name":"samurott","url":"https://pokeapi.co/api/v2/pokemon-species/503/"},{"name":"patrat","url":"https://pokeapi.co/api/v2/pokemon-species/504/"},{"name":"watchog","url":"https://pokeapi.co/api/v2/pokemon-species/505/"},{"name":"lillipup","url":"https://pokeapi.co/api/v2/pokemon-species/506/"},{"name":"herdier","url":"https://pokeapi.co/api/v2/pokemon-species/507/"},{"name":"stoutland","url":"https://pokeapi.co/api/v2/pokemon-species/508/"},{"name":"purrloin","url":"https://pokeapi.co/api/v2/pokemon-species/509/"},{"name":"liepard","url":"https://pokeapi.co/api/v2/pokemon-species/510/"},{"name":"pansage","url":"https://pokeapi.co/api/v2/pokemon-species/511/"},{"name":"simisage","url":"https://pokeapi.co/api/v2/pokemon-species/512/"},{"name":"pansear","url":"https://pokeapi.co/api/v2/pokemon-species/513/"},{"name":"simisear","url":"https://pokeapi.co/api/v2/pokemon-species/514/"},{"name":"panpour","url":"https://pokeapi.co/api/v2/pokemon-species/515/"},{"name":"simipour","url":"https://pokeapi.co/api/v2/pokemon-species/516/"},{"name":"munna","url":"https://pokeapi.co/api/v2/pokemon-species/517/"},{"name":"musharna","url":"https://pokeapi.co/api/v2/pokemon-species/518/"},{"name":"pidove","url":"https://pokeapi.co/api/v2/pokemon-species/519/"},{"name":"tranquill","url":"https://pokeapi.co/api/v2/pokemon-species/520/"},{"name":"unfezant","url":"https://pokeapi.co/api/v2/pokemon-species/521/"},{"name":"blitzle","url":"https://pokeapi.co/api/v2/pokemon-species/522/"},{"name":"zebstrika","url":"https://pokeapi.co/api/v2/pokemon-species/523/"},{"name":"roggenrola","url":"https://pokeapi.co/api/v2/pokemon-species/524/"},{"name":"boldore","url":"https://pokeapi.co/api/v2/pokemon-species/525/"},{"name":"gigalith","url":"https://pokeapi.co/api/v2/pokemon-species/526/"},{"name":"woobat","url":"https://pokeapi.co/api/v2/pokemon-species/527/"},{"name":"swoobat","url":"https://pokeapi.co/api/v2/pokemon-species/528/"},{"name":"drilbur","url":"https://pokeapi.co/api/v2/pokemon-species/529/"},{"name":"excadrill","url":"https://pokeapi.co/api/v2/pokemon-species/530/"},{"name":"audino","url":"https://pokeapi.co/api/v2/pokemon-species/531/"},{"name":"timburr","url":"https://pokeapi.co/api/v2/pokemon-species/532/"},{"name":"gurdurr","url":"https://pokeapi.co/api/v2/pokemon-species/533/"},{"name":"conkeldurr","url":"https://pokeapi.co/api/v2/pokemon-species/534/"},{"name":"tympole","url":"https://pokeapi.co/api/v2/pokemon-species/535/"},{"name":"palpitoad","url":"https://pokeapi.co/api/v2/pokemon-species/536/"},{"name":"seismitoad","url":"https://pokeapi.co/api/v2/pokemon-species/537/"},{"name":"throh","url":"https://pokeapi.co/api/v2/pokemon-species/538/"},{"name":"sawk","url":"https://pokeapi.co/api/v2/pokemon-species/539/"},{"name":"sewaddle","url":"https://pokeapi.co/api/v2/pokemon-species/540/"},{"name":"swadloon","url":"https://pokeapi.co/api/v2/pokemon-species/541/"},{"name":"leavanny","url":"https://pokeapi.co/api/v2/pokemon-species/542/"},{"name":"venipede","url":"https://pokeapi.co/api/v2/pokemon-species/543/"},{"name":"whirlipede","url":"https://pokeapi.co/api/v2/pokemon-species/544/"},{"name":"scolipede","url":"https://pokeapi.co/api/v2/pokemon-species/545/"},{"name":"cottonee","url":"https://pokeapi.co/api/v2/pokemon-species/546/"},{"name":"whimsicott","url":"https://pokeapi.co/api/v2/pokemon-species/547/"},{"name":"petilil","url":"https://pokeapi.co/api/v2/pokemon-species/548/"},{"name":"lilligant","url":"https://pokeapi.co/api/v2/pokemon-species/549/"},{"name":"basculin","url":"https://pokeapi.co/api/v2/pokemon-species/550/"},{"name":"sandile","url":"https://pokeapi.co/api/v2/pokemon-species/551/"},{"name":"krokorok","url":"https://pokeapi.co/api/v2/pokemon-species/552/"},{"name":"krookodile","url":"https://pokeapi.co/api/v2/pokemon-species/553/"},{"name":"darumaka","url":"https://pokeapi.co/api/v2/pokemon-species/554/"},{"name":"darmanitan","url":"https://pokeapi.co/api/v2/pokemon-species/555/"},{"name":"maractus","url":"https://pokeapi.co/api/v2/pokemon-species/556/"},{"name":"dwebble","url":"https://pokeapi.co/api/v2/pokemon-species/557/"},{"name":"crustle","url":"https://pokeapi.co/api/v2/pokemon-species/558/"},{"name":"scraggy","url":"https://pokeapi.co/api/v2/pokemon-species/559/"},{"name":"scrafty","url":"https://pokeapi.co/api/v2/pokemon-species/560/"},{"name":"sigilyph","url":"https://pokeapi.co/api/v2/pokemon-species/561/"},{"name":"yamask","url":"https://pokeapi.co/api/v2/pokemon-species/562/"},{"name":"cofagrigus","url":"https://pokeapi.co/api/v2/pokemon-species/563/"},{"name":"tirtouga","url":"https://pokeapi.co/api/v2/pokemon-species/564/"},{"name":"carracosta","url":"https://pokeapi.co/api/v2/pokemon-species/565/"},{"name":"archen","url":"https://pokeapi.co/api/v2/pokemon-species/566/"},{"name":"archeops","url":"https://pokeapi.co/api/v2/pokemon-species/567/"},{"name":"trubbish","url":"https://pokeapi.co/api/v2/pokemon-species/568/"},{"name":"garbodor","url":"https://pokeapi.co/api/v2/pokemon-species/569/"},{"name":"zorua","url":"https://pokeapi.co/api/v2/pokemon-species/570/"},{"name":"zoroark","url":"https://pokeapi.co/api/v2/pokemon-species/571/"},{"name":"minccino","url":"https://pokeapi.co/api/v2/pokemon-species/572/"},{"name":"cinccino","url":"https://pokeapi.co/api/v2/pokemon-species/573/"},{"name":"gothita","url":"https://pokeapi.co/api/v2/pokemon-species/574/"},{"name":"gothorita","url":"https://pokeapi.co/api/v2/pokemon-species/575/"},{"name":"gothitelle","url":"https://pokeapi.co/api/v2/pokemon-species/576/"},{"name":"solosis","url":"https://pokeapi.co/api/v2/pokemon-species/577/"},{"name":"duosion","url":"https://pokeapi.co/api/v2/pokemon-species/578/"},{"name":"reuniclus","url":"https://pokeapi.co/api/v2/pokemon-species/579/"},{"name":"ducklett","url":"https://pokeapi.co/api/v2/pokemon-species/580/"},{"name":"swanna","url":"https://pokeapi.co/api/v2/pokemon-species/581/"},{"name":"vanillite","url":"https://pokeapi.co/api/v2/pokemon-species/582/"},{"name":"vanillish","url":"https://pokeapi.co/api/v2/pokemon-species/583/"},{"name":"vanilluxe","url":"https://pokeapi.co/api/v2/pokemon-species/584/"},{"name":"deerling","url":"https://pokeapi.co/api/v2/pokemon-species/585/"},{"name":"sawsbuck","url":"https://pokeapi.co/api/v2/pokemon-species/586/"},{"name":"emolga","url":"https://pokeapi.co/api/v2/pokemon-species/587/"},{"name":"karrablast","url":"https://pokeapi.co/api/v2/pokemon-species/588/"},{"name":"escavalier","url":"https://pokeapi.co/api/v2/pokemon-species/589/"},{"name":"foongus","url":"https://pokeapi.co/api/v2/pokemon-species/590/"},{"name":"amoonguss","url":"https://pokeapi.co/api/v2/pokemon-species/591/"},{"name":"frillish","url":"https://pokeapi.co/api/v2/pokemon-species/592/"},{"name":"jellicent","url":"https://pokeapi.co/api/v2/pokemon-species/593/"},{"name":"alomomola","url":"https://pokeapi.co/api/v2/pokemon-species/594/"},{"name":"joltik","url":"https://pokeapi.co/api/v2/pokemon-species/595/"},{"name":"galvantula","url":"https://pokeapi.co/api/v2/pokemon-species/596/"},{"name":"ferroseed","url":"https://pokeapi.co/api/v2/pokemon-species/597/"},{"name":"ferrothorn","url":"https://pokeapi.co/api/v2/pokemon-species/598/"},{"name":"klink","url":"https://pokeapi.co/api/v2/pokemon-species/599/"},{"name":"klang","url":"https://pokeapi.co/api/v2/pokemon-species/600/"},{"name":"klinklang","url":"https://pokeapi.co/api/v2/pokemon-species/601/"},{"name":"tynamo","url":"https://pokeapi.co/api/v2/pokemon-species/602/"},{"name":"eelektrik","url":"https://pokeapi.co/api/v2/pokemon-species/603/"},{"name":"eelektross","url":"https://pokeapi.co/api/v2/pokemon-species/604/"},{"name":"elgyem","url":"https://pokeapi.co/api/v2/pokemon-species/605/"},{"name":"beheeyem","url":"https://pokeapi.co/api/v2/pokemon-species/606/"},{"name":"litwick","url":"https://pokeapi.co/api/v2/pokemon-species/607/"},{"name":"lampent","url":"https://pokeapi.co/api/v2/pokemon-species/608/"},{"name":"chandelure","url":"https://pokeapi.co/api/v2/pokemon-species/609/"},{"name":"axew","url":"https://pokeapi.co/api/v2/pokemon-species/610/"},{"name":"fraxure","url":"https://pokeapi.co/api/v2/pokemon-species/611/"},{"name":"haxorus","url":"https://pokeapi.co/api/v2/pokemon-species/612/"},{"name":"cubchoo","url":"https://pokeapi.co/api/v2/pokemon-species/613/"},{"name":"beartic","url":"https://pokeapi.co/api/v2/pokemon-species/614/"},{"name":"cryogonal","url":"https://pokeapi.co/api/v2/pokemon-species/615/"},{"name":"shelmet","url":"https://pokeapi.co/api/v2/pokemon-species/616/"},{"name":"accelgor","url":"https://pokeapi.co/api/v2/pokemon-species/617/"},{"name":"stunfisk","url":"https://pokeapi.co/api/v2/pokemon-species/618/"},{"name":"mienfoo","url":"https://pokeapi.co/api/v2/pokemon-species/619/"},{"name":"mienshao","url":"https://pokeapi.co/api/v2/pokemon-species/620/"},{"name":"druddigon","url":"https://pokeapi.co/api/v2/pokemon-species/621/"},{"name":"golett","url":"https://pokeapi.co/api/v2/pokemon-species/622/"},{"name":"golurk","url":"https://pokeapi.co/api/v2/pokemon-species/623/"},{"name":"pawniard","url":"https://pokeapi.co/api/v2/pokemon-species/624/"},{"name":"bisharp","url":"https://pokeapi.co/api/v2/pokemon-species/625/"},{"name":"bouffalant","url":"https://pokeapi.co/api/v2/pokemon-species/626/"},{"name":"rufflet","url":"https://pokeapi.co/api/v2/pokemon-species/627/"},{"name":"braviary","url":"https://pokeapi.co/api/v2/pokemon-species/628/"},{"name":"vullaby","url":"https://pokeapi.co/api/v2/pokemon-species/629/"},{"name":"mandibuzz","url":"https://pokeapi.co/api/v2/pokemon-species/630/"},{"name":"heatmor","url":"https://pokeapi.co/api/v2/pokemon-species/631/"},{"name":"durant","url":"https://pokeapi.co/api/v2/pokemon-species/632/"},{"name":"deino","url":"https://pokeapi.co/api/v2/pokemon-species/633/"},{"name":"zweilous","url":"https://pokeapi.co/api/v2/pokemon-species/634/"},{"name":"hydreigon","url":"https://pokeapi.co/api/v2/pokemon-species/635/"},{"name":"larvesta","url":"https://pokeapi.co/api/v2/pokemon-species/636/"},{"name":"volcarona","url":"https://pokeapi.co/api/v2/pokemon-species/637/"},{"name":"cobalion","url":"https://pokeapi.co/api/v2/pokemon-species/638/"},{"name":"terrakion","url":"https://pokeapi.co/api/v2/pokemon-species/639/"},{"name":"virizion","url":"https://pokeapi.co/api/v2/pokemon-species/640/"},{"name":"tornadus","url":"https://pokeapi.co/api/v2/pokemon-species/641/"},{"name":"thundurus","url":"https://pokeapi.co/api/v2/pokemon-species/642/"},{"name":"reshiram","url":"https://pokeapi.co/api/v2/pokemon-species/643/"},{"name":"zekrom","url":"https://pokeapi.co/api/v2/pokemon-species/644/"},{"name":"landorus","url":"https://pokeapi.co/api/v2/pokemon-species/645/"},{"name":"kyurem","url":"https://pokeapi.co/api/v2/pokemon-species/646/"},{"name":"keldeo","url":"https://pokeapi.co/api/v2/pokemon-species/647/"},{"name":"meloetta","url":"https://pokeapi.co/api/v2/pokemon-species/648/"},{"name":"genesect","url":"https://pokeapi.co/api/v2/pokemon-species/649/"},{"name":"chespin","url":"https://pokeapi.co/api/v2/pokemon-species/650/"},{"name":"quilladin","url":"https://pokeapi.co/api/v2/pokemon-species/651/"},{"name":"chesnaught","url":"https://pokeapi.co/api/v2/pokemon-species/652/"},{"name":"fennekin","url":"https://pokeapi.co/api/v2/pokemon-species/653/"},{"name":"braixen","url":"https://pokeapi.co/api/v2/pokemon-species/654/"},{"name":"delphox","url":"https://pokeapi.co/api/v2/pokemon-species/655/"},{"name":"froakie","url":"https://pokeapi.co/api/v2/pokemon-species/656/"},{"name":"frogadier","url":"https://pokeapi.co/api/v2/pokemon-species/657/"},{"name":"greninja","url":"https://pokeapi.co/api/v2/pokemon-species/658/"},{"name":"bunnelby","url":"https://pokeapi.co/api/v2/pokemon-species/659/"},{"name":"diggersby","url":"https://pokeapi.co/api/v2/pokemon-species/660/"},{"name":"fletchling","url":"https://pokeapi.co/api/v2/pokemon-species/661/"},{"name":"fletchinder","url":"https://pokeapi.co/api/v2/pokemon-species/662/"},{"name":"talonflame","url":"https://pokeapi.co/api/v2/pokemon-species/663/"},{"name":"scatterbug","url":"https://pokeapi.co/api/v2/pokemon-species/664/"},{"name":"spewpa","url":"https://pokeapi.co/api/v2/pokemon-species/665/"},{"name":"vivillon","url":"https://pokeapi.co/api/v2/pokemon-species/666/"},{"name":"litleo","url":"https://pokeapi.co/api/v2/pokemon-species/667/"},{"name":"pyroar","url":"https://pokeapi.co/api/v2/pokemon-species/668/"},{"name":"flabebe","url":"https://pokeapi.co/api/v2/pokemon-species/669/"},{"name":"floette","url":"https://pokeapi.co/api/v2/pokemon-species/670/"},{"name":"florges","url":"https://pokeapi.co/api/v2/pokemon-species/671/"},{"name":"skiddo","url":"https://pokeapi.co/api/v2/pokemon-species/672/"},{"name":"gogoat","url":"https://pokeapi.co/api/v2/pokemon-species/673/"},{"name":"pancham","url":"https://pokeapi.co/api/v2/pokemon-species/674/"},{"name":"pangoro","url":"https://pokeapi.co/api/v2/pokemon-species/675/"},{"name":"furfrou","url":"https://pokeapi.co/api/v2/pokemon-species/676/"},{"name":"espurr","url":"https://pokeapi.co/api/v2/pokemon-species/677/"},{"name":"meowstic","url":"https://pokeapi.co/api/v2/pokemon-species/678/"},{"name":"honedge","url":"https://pokeapi.co/api/v2/pokemon-species/679/"},{"name":"doublade","url":"https://pokeapi.co/api/v2/pokemon-species/680/"},{"name":"aegislash","url":"https://pokeapi.co/api/v2/pokemon-species/681/"},{"name":"spritzee","url":"https://pokeapi.co/api/v2/pokemon-species/682/"},{"name":"aromatisse","url":"https://pokeapi.co/api/v2/pokemon-species/683/"},{"name":"swirlix","url":"https://pokeapi.co/api/v2/pokemon-species/684/"},{"name":"slurpuff","url":"https://pokeapi.co/api/v2/pokemon-species/685/"},{"name":"inkay","url":"https://pokeapi.co/api/v2/pokemon-species/686/"},{"name":"malamar","url":"https://pokeapi.co/api/v2/pokemon-species/687/"},{"name":"binacle","url":"https://pokeapi.co/api/v2/pokemon-species/688/"},{"name":"barbaracle","url":"https://pokeapi.co/api/v2/pokemon-species/689/"},{"name":"skrelp","url":"https://pokeapi.co/api/v2/pokemon-species/690/"},{"name":"dragalge","url":"https://pokeapi.co/api/v2/pokemon-species/691/"},{"name":"clauncher","url":"https://pokeapi.co/api/v2/pokemon-species/692/"},{"name":"clawitzer","url":"https://pokeapi.co/api/v2/pokemon-species/693/"},{"name":"helioptile","url":"https://pokeapi.co/api/v2/pokemon-species/694/"},{"name":"heliolisk","url":"https://pokeapi.co/api/v2/pokemon-species/695/"},{"name":"tyrunt","url":"https://pokeapi.co/api/v2/pokemon-species/696/"},{"name":"tyrantrum","url":"https://pokeapi.co/api/v2/pokemon-species/697/"},{"name":"amaura","url":"https://pokeapi.co/api/v2/pokemon-species/698/"},{"name":"aurorus","url":"https://pokeapi.co/api/v2/pokemon-species/699/"},{"name":"sylveon","url":"https://pokeapi.co/api/v2/pokemon-species/700/"},{"name":"hawlucha","url":"https://pokeapi.co/api/v2/pokemon-species/701/"},{"name":"dedenne","url":"https://pokeapi.co/api/v2/pokemon-species/702/"},{"name":"carbink","url":"https://pokeapi.co/api/v2/pokemon-species/703/"},{"name":"goomy","url":"https://pokeapi.co/api/v2/pokemon-species/704/"},{"name":"sliggoo","url":"https://pokeapi.co/api/v2/pokemon-species/705/"},{"name":"goodra","url":"https://pokeapi.co/api/v2/pokemon-species/706/"},{"name":"klefki","url":"https://pokeapi.co/api/v2/pokemon-species/707/"},{"name":"phantump","url":"https://pokeapi.co/api/v2/pokemon-species/708/"},{"name":"trevenant","url":"https://pokeapi.co/api/v2/pokemon-species/709/"},{"name":"pumpkaboo","url":"https://pokeapi.co/api/v2/pokemon-species/710/"},{"name":"gourgeist","url":"https://pokeapi.co/api/v2/pokemon-species/711/"},{"name":"bergmite","url":"https://pokeapi.co/api/v2/pokemon-species/712/"},{"name":"avalugg","url":"https://pokeapi.co/api/v2/pokemon-species/713/"},{"name":"noibat","url":"https://pokeapi.co/api/v2/pokemon-species/714/"},{"name":"noivern","url":"https://pokeapi.co/api/v2/pokemon-species/715/"},{"name":"xerneas","url":"https://pokeapi.co/api/v2/pokemon-species/716/"},{"name":"yveltal","url":"https://pokeapi.co/api/v2/pokemon-species/717/"},{"name":"zygarde","url":"https://pokeapi.co/api/v2/pokemon-species/718/"},{"name":"diancie","url":"https://pokeapi.co/api/v2/pokemon-species/719/"},{"name":"hoopa","url":"https://pokeapi.co/api/v2/pokemon-species/720/"},{"name":"volcanion","url":"https://pokeapi.co/api/v2/pokemon-species/721/"},{"name":"rowlet","url":"https://pokeapi.co/api/v2/pokemon-species/722/"},{"name":"dartrix","url":"https://pokeapi.co/api/v2/pokemon-species/723/"},{"name":"decidueye","url":"https://pokeapi.co/api/v2/pokemon-species/724/"},{"name":"litten","url":"https://pokeapi.co/api/v2/pokemon-species/725/"},{"name":"torracat","url":"https://pokeapi.co/api/v2/pokemon-species/726/"},{"name":"incineroar","url":"https://pokeapi.co/api/v2/pokemon-species/727/"},{"name":"popplio","url":"https://pokeapi.co/api/v2/pokemon-species/728/"},{"name":"brionne","url":"https://pokeapi.co/api/v2/pokemon-species/729/"},{"name":"primarina","url":"https://pokeapi.co/api/v2/pokemon-species/730/"},{"name":"pikipek","url":"https://pokeapi.co/api/v2/pokemon-species/731/"},{"name":"trumbeak","url":"https://pokeapi.co/api/v2/pokemon-species/732/"},{"name":"toucannon","url":"https://pokeapi.co/api/v2/pokemon-species/733/"},{"name":"yungoos","url":"https://pokeapi.co/api/v2/pokemon-species/734/"},{"name":"gumshoos","url":"https://pokeapi.co/api/v2/pokemon-species/735/"},{"name":"grubbin","url":"https://pokeapi.co/api/v2/pokemon-species/736/"},{"name":"charjabug","url":"https://pokeapi.co/api/v2/pokemon-species/737/"},{"name":"vikavolt","url":"https://pokeapi.co/api/v2/pokemon-species/738/"},{"name":"crabrawler","url":"https://pokeapi.co/api/v2/pokemon-species/739/"},{"name":"crabominable","url":"https://pokeapi.co/api/v2/pokemon-species/740/"},{"name":"oricorio","url":"https://pokeapi.co/api/v2/pokemon-species/741/"},{"name":"cutiefly","url":"https://pokeapi.co/api/v2/pokemon-species/742/"},{"name":"ribombee","url":"https://pokeapi.co/api/v2/pokemon-species/743/"},{"name":"rockruff","url":"https://pokeapi.co/api/v2/pokemon-species/744/"},{"name":"lycanroc","url":"https://pokeapi.co/api/v2/pokemon-species/745/"},{"name":"wishiwashi","url":"https://pokeapi.co/api/v2/pokemon-species/746/"},{"name":"mareanie","url":"https://pokeapi.co/api/v2/pokemon-species/747/"},{"name":"toxapex","url":"https://pokeapi.co/api/v2/pokemon-species/748/"},{"name":"mudbray","url":"https://pokeapi.co/api/v2/pokemon-species/749/"},{"name":"mudsdale","url":"https://pokeapi.co/api/v2/pokemon-species/750/"},{"name":"dewpider","url":"https://pokeapi.co/api/v2/pokemon-species/751/"},{"name":"araquanid","url":"https://pokeapi.co/api/v2/pokemon-species/752/"},{"name":"fomantis","url":"https://pokeapi.co/api/v2/pokemon-species/753/"},{"name":"lurantis","url":"https://pokeapi.co/api/v2/pokemon-species/754/"},{"name":"morelull","url":"https://pokeapi.co/api/v2/pokemon-species/755/"},{"name":"shiinotic","url":"https://pokeapi.co/api/v2/pokemon-species/756/"},{"name":"salandit","url":"https://pokeapi.co/api/v2/pokemon-species/757/"},{"name":"salazzle","url":"https://pokeapi.co/api/v2/pokemon-species/758/"},{"name":"stufful","url":"https://pokeapi.co/api/v2/pokemon-species/759/"},{"name":"bewear","url":"https://pokeapi.co/api/v2/pokemon-species/760/"},{"name":"bounsweet","url":"https://pokeapi.co/api/v2/pokemon-species/761/"},{"name":"steenee","url":"https://pokeapi.co/api/v2/pokemon-species/762/"},{"name":"tsareena","url":"https://pokeapi.co/api/v2/pokemon-species/763/"},{"name":"comfey","url":"https://pokeapi.co/api/v2/pokemon-species/764/"},{"name":"oranguru","url":"https://pokeapi.co/api/v2/pokemon-species/765/"},{"name":"passimian","url":"https://pokeapi.co/api/v2/pokemon-species/766/"},{"name":"wimpod","url":"https://pokeapi.co/api/v2/pokemon-species/767/"},{"name":"golisopod","url":"https://pokeapi.co/api/v2/pokemon-species/768/"},{"name":"sandygast","url":"https://pokeapi.co/api/v2/pokemon-species/769/"},{"name":"palossand","url":"https://pokeapi.co/api/v2/pokemon-species/770/"},{"name":"pyukumuku","url":"https://pokeapi.co/api/v2/pokemon-species/771/"},{"name":"type-null","url":"https://pokeapi.co/api/v2/pokemon-species/772/"},{"name":"silvally","url":"https://pokeapi.co/api/v2/pokemon-species/773/"},{"name":"minior","url":"https://pokeapi.co/api/v2/pokemon-species/774/"},{"name":"komala","url":"https://pokeapi.co/api/v2/pokemon-species/775/"},{"name":"turtonator","url":"https://pokeapi.co/api/v2/pokemon-species/776/"},{"name":"togedemaru","url":"https://pokeapi.co/api/v2/pokemon-species/777/"},{"name":"mimikyu","url":"https://pokeapi.co/api/v2/pokemon-species/778/"},{"name":"bruxish","url":"https://pokeapi.co/api/v2/pokemon-species/779/"},{"name":"drampa","url":"https://pokeapi.co/api/v2/pokemon-species/780/"},{"name":"dhelmise","url":"https://pokeapi.co/api/v2/pokemon-species/781/"},{"name":"jangmo-o","url":"https://pokeapi.co/api/v2/pokemon-species/782/"},{"name":"hakamo-o","url":"https://pokeapi.co/api/v2/pokemon-species/783/"},{"name":"kommo-o","url":"https://pokeapi.co/api/v2/pokemon-species/784/"},{"name":"tapu-koko","url":"https://pokeapi.co/api/v2/pokemon-species/785/"},{"name":"tapu-lele","url":"https://pokeapi.co/api/v2/pokemon-species/786/"},{"name":"tapu-bulu","url":"https://pokeapi.co/api/v2/pokemon-species/787/"},{"name":"tapu-fini","url":"https://pokeapi.co/api/v2/pokemon-species/788/"},{"name":"cosmog","url":"https://pokeapi.co/api/v2/pokemon-species/789/"},{"name":"cosmoem","url":"https://pokeapi.co/api/v2/pokemon-species/790/"},{"name":"solgaleo","url":"https://pokeapi.co/api/v2/pokemon-species/791/"},{"name":"lunala","url":"https://pokeapi.co/api/v2/pokemon-species/792/"},{"name":"nihilego","url":"https://pokeapi.co/api/v2/pokemon-species/793/"},{"name":"buzzwole","url":"https://pokeapi.co/api/v2/pokemon-species/794/"},{"name":"pheromosa","url":"https://pokeapi.co/api/v2/pokemon-species/795/"},{"name":"xurkitree","url":"https://pokeapi.co/api/v2/pokemon-species/796/"},{"name":"celesteela","url":"https://pokeapi.co/api/v2/pokemon-species/797/"},{"name":"kartana","url":"https://pokeapi.co/api/v2/pokemon-species/798/"},{"name":"guzzlord","url":"https://pokeapi.co/api/v2/pokemon-species/799/"},{"name":"necrozma","url":"https://pokeapi.co/api/v2/pokemon-species/800/"},{"name":"magearna","url":"https://pokeapi.co/api/v2/pokemon-species/801/"},{"name":"marshadow","url":"https://pokeapi.co/api/v2/pokemon-species/802/"},{"name":"poipole","url":"https://pokeapi.co/api/v2/pokemon-species/803/"},{"name":"naganadel","url":"https://pokeapi.co/api/v2/pokemon-species/804/"},{"name":"stakataka","url":"https://pokeapi.co/api/v2/pokemon-species/805/"},{"name":"blacephalon","url":"https://pokeapi.co/api/v2/pokemon-species/806/"},{"name":"zeraora","url":"https://pokeapi.co/api/v2/pokemon-species/807/"}]}"#;

// https://pokeapi.co/api/v2/region/?offset=0&limit=9999
static FULL_REGION_LIST_JSON: &str = r#"{"count":7,"next":null,"previous":null,"results":[{"name":"kanto","url":"https://pokeapi.co/api/v2/region/1/"},{"name":"johto","url":"https://pokeapi.co/api/v2/region/2/"},{"name":"hoenn","url":"https://pokeapi.co/api/v2/region/3/"},{"name":"sinnoh","url":"https://pokeapi.co/api/v2/region/4/"},{"name":"unova","url":"https://pokeapi.co/api/v2/region/5/"},{"name":"kalos","url":"https://pokeapi.co/api/v2/region/6/"},{"name":"alola","url":"https://pokeapi.co/api/v2/region/7/"}]}"#;

// https://pokeapi.co/api/v2/stat/?offset=0&limit=9999
static FULL_STAT_LIST_JSON: &str = r#"{"count":8,"next":null,"previous":null,"results":[{"name":"hp","url":"https://pokeapi.co/api/v2/stat/1/"},{"name":"attack","url":"https://pokeapi.co/api/v2/stat/2/"},{"name":"defense","url":"https://pokeapi.co/api/v2/stat/3/"},{"name":"special-attack","url":"https://pokeapi.co/api/v2/stat/4/"},{"name":"special-defense","url":"https://pokeapi.co/api/v2/stat/5/"},{"name":"speed","url":"https://pokeapi.co/api/v2/stat/6/"},{"name":"accuracy","url":"https://pokeapi.co/api/v2/stat/7/"},{"name":"evasion","url":"https://pokeapi.co/api/v2/stat/8/"}]}"#;

// https://pokeapi.co/api/v2/super-contest-effect/?offset=0&limit=9999
static FULL_SUPER_CONTEST_EFFECT_LIST_JSON: &str = r#"{"count":22,"next":null,"previous":null,"results":[{"url":"https://pokeapi.co/api/v2/super-contest-effect/1/"},{"url":"https://pokeapi.co/api/v2/super-contest-effect/2/"},{"url":"https://pokeapi.co/api/v2/super-contest-effect/4/"},{"url":"https://pokeapi.co/api/v2/super-contest-effect/5/"},{"url":"https://pokeapi.co/api/v2/super-contest-effect/6/"},{"url":"https://pokeapi.co/api/v2/super-contest-effect/7/"},{"url":"https://pokeapi.co/api/v2/super-contest-effect/8/"},{"url":"https://pokeapi.co/api/v2/super-contest-effect/9/"},{"url":"https://pokeapi.co/api/v2/super-contest-effect/10/"},{"url":"https://pokeapi.co/api/v2/super-contest-effect/11/"},{"url":"https://pokeapi.co/api/v2/super-contest-effect/12/"},{"url":"https://pokeapi.co/api/v2/super-contest-effect/13/"},{"url":"https://pokeapi.co/api/v2/super-contest-effect/14/"},{"url":"https://pokeapi.co/api/v2/super-contest-effect/15/"},{"url":"https://pokeapi.co/api/v2/super-contest-effect/16/"},{"url":"https://pokeapi.co/api/v2/super-contest-effect/17/"},{"url":"https://pokeapi.co/api/v2/super-contest-effect/18/"},{"url":"https://pokeapi.co/api/v2/super-contest-effect/19/"},{"url":"https://pokeapi.co/api/v2/super-contest-effect/20/"},{"url":"https://pokeapi.co/api/v2/super-contest-effect/21/"},{"url":"https://pokeapi.co/api/v2/super-contest-effect/22/"},{"url":"https://pokeapi.co/api/v2/super-contest-effect/23/"}]}"#;

// https://pokeapi.co/api/v2/type/?offset=0&limit=9999
static FULL_TYPE_LIST_JSON: &str = r#"{"count":20,"next":null,"previous":null,"results":[{"name":"normal","url":"https://pokeapi.co/api/v2/type/1/"},{"name":"fighting","url":"https://pokeapi.co/api/v2/type/2/"},{"name":"flying","url":"https://pokeapi.co/api/v2/type/3/"},{"name":"poison","url":"https://pokeapi.co/api/v2/type/4/"},{"name":"ground","url":"https://pokeapi.co/api/v2/type/5/"},{"name":"rock","url":"https://pokeapi.co/api/v2/type/6/"},{"name":"bug","url":"https://pokeapi.co/api/v2/type/7/"},{"name":"ghost","url":"https://pokeapi.co/api/v2/type/8/"},{"name":"steel","url":"https://pokeapi.co/api/v2/type/9/"},{"name":"fire","url":"https://pokeapi.co/api/v2/type/10/"},{"name":"water","url":"https://pokeapi.co/api/v2/type/11/"},{"name":"grass","url":"https://pokeapi.co/api/v2/type/12/"},{"name":"electric","url":"https://pokeapi.co/api/v2/type/13/"},{"name":"psychic","url":"https://pokeapi.co/api/v2/type/14/"},{"name":"ice","url":"https://pokeapi.co/api/v2/type/15/"},{"name":"dragon","url":"https://pokeapi.co/api/v2/type/16/"},{"name":"dark","url":"https://pokeapi.co/api/v2/type/17/"},{"name":"fairy","url":"https://pokeapi.co/api/v2/type/18/"},{"name":"unknown","url":"https://pokeapi.co/api/v2/type/10001/"},{"name":"shadow","url":"https://pokeapi.co/api/v2/type/10002/"}]}"#;

// https://pokeapi.co/api/v2/version/?offset=0&limit=9999
static FULL_VERSION_LIST_JSON: &str = r#"{"count":30,"next":null,"previous":null,"results":[{"name":"red","url":"https://pokeapi.co/api/v2/version/1/"},{"name":"blue","url":"https://pokeapi.co/api/v2/version/2/"},{"name":"yellow","url":"https://pokeapi.co/api/v2/version/3/"},{"name":"gold","url":"https://pokeapi.co/api/v2/version/4/"},{"name":"silver","url":"https://pokeapi.co/api/v2/version/5/"},{"name":"crystal","url":"https://pokeapi.co/api/v2/version/6/"},{"name":"ruby","url":"https://pokeapi.co/api/v2/version/7/"},{"name":"sapphire","url":"https://pokeapi.co/api/v2/version/8/"},{"name":"emerald","url":"https://pokeapi.co/api/v2/version/9/"},{"name":"firered","url":"https://pokeapi.co/api/v2/version/10/"},{"name":"leafgreen","url":"https://pokeapi.co/api/v2/version/11/"},{"name":"diamond","url":"https://pokeapi.co/api/v2/version/12/"},{"name":"pearl","url":"https://pokeapi.co/api/v2/version/13/"},{"name":"platinum","url":"https://pokeapi.co/api/v2/version/14/"},{"name":"heartgold","url":"https://pokeapi.co/api/v2/version/15/"},{"name":"soulsilver","url":"https://pokeapi.co/api/v2/version/16/"},{"name":"black","url":"https://pokeapi.co/api/v2/version/17/"},{"name":"white","url":"https://pokeapi.co/api/v2/version/18/"},{"name":"colosseum","url":"https://pokeapi.co/api/v2/version/19/"},{"name":"xd","url":"https://pokeapi.co/api/v2/version/20/"},{"name":"black-2","url":"https://pokeapi.co/api/v2/version/21/"},{"name":"white-2","url":"https://pokeapi.co/api/v2/version/22/"},{"name":"x","url":"https://pokeapi.co/api/v2/version/23/"},{"name":"y","url":"https://pokeapi.co/api/v2/version/24/"},{"name":"omega-ruby","url":"https://pokeapi.co/api/v2/version/25/"},{"name":"alpha-sapphire","url":"https://pokeapi.co/api/v2/version/26/"},{"name":"sun","url":"https://pokeapi.co/api/v2/version/27/"},{"name":"moon","url":"https://pokeapi.co/api/v2/version/28/"},{"name":"ultra-sun","url":"https://pokeapi.co/api/v2/version/29/"},{"name":"ultra-moon","url":"https://pokeapi.co/api/v2/version/30/"}]}"#;

// https://pokeapi.co/api/v2/version-group/?offset=0&limit=9999
static FULL_VERSION_GROUP_LIST_JSON: &str = r#"{"count":18,"next":null,"previous":null,"results":[{"name":"red-blue","url":"https://pokeapi.co/api/v2/version-group/1/"},{"name":"yellow","url":"https://pokeapi.co/api/v2/version-group/2/"},{"name":"gold-silver","url":"https://pokeapi.co/api/v2/version-group/3/"},{"name":"crystal","url":"https://pokeapi.co/api/v2/version-group/4/"},{"name":"ruby-sapphire","url":"https://pokeapi.co/api/v2/version-group/5/"},{"name":"emerald","url":"https://pokeapi.co/api/v2/version-group/6/"},{"name":"firered-leafgreen","url":"https://pokeapi.co/api/v2/version-group/7/"},{"name":"diamond-pearl","url":"https://pokeapi.co/api/v2/version-group/8/"},{"name":"platinum","url":"https://pokeapi.co/api/v2/version-group/9/"},{"name":"heartgold-soulsilver","url":"https://pokeapi.co/api/v2/version-group/10/"},{"name":"black-white","url":"https://pokeapi.co/api/v2/version-group/11/"},{"name":"colosseum","url":"https://pokeapi.co/api/v2/version-group/12/"},{"name":"xd","url":"https://pokeapi.co/api/v2/version-group/13/"},{"name":"black-2-white-2","url":"https://pokeapi.co/api/v2/version-group/14/"},{"name":"x-y","url":"https://pokeapi.co/api/v2/version-group/15/"},{"name":"omega-ruby-alpha-sapphire","url":"https://pokeapi.co/api/v2/version-group/16/"},{"name":"sun-moon","url":"https://pokeapi.co/api/v2/version-group/17/"},{"name":"ultra-sun-ultra-moon","url":"https://pokeapi.co/api/v2/version-group/18/"}]}"#;

#[test]
fn get_full_ability_list() {
    test_full_list::<Ability>(FULL_ABILITY_LIST_JSON);
}

#[test]
fn get_full_berry_list() {
    test_full_list::<Berry>(FULL_BERRY_LIST_JSON);
}

#[test]
fn get_full_berry_firmness_list() {
    test_full_list::<BerryFirmness>(FULL_BERRY_FIRMNESS_LIST_JSON);
}

#[test]
fn get_full_berry_flavor_list() {
    test_full_list::<BerryFlavor>(FULL_BERRY_FLAVOR_LIST_JSON);
}

#[test]
fn get_full_characteristic_list() {
    test_full_list::<Characteristic>(FULL_CHARACTERISTIC_LIST_JSON);
}

#[test]
fn get_full_contest_effect_list() {
    test_full_list::<ContestEffect>(FULL_CONTEST_EFFECT_LIST_JSON);
}

#[test]
fn get_full_contest_type_list() {
    test_full_list::<ContestType>(FULL_CONTEST_TYPE_LIST_JSON);
}

#[test]
fn get_full_egg_group_list() {
    test_full_list::<EggGroup>(FULL_EGG_GROUP_LIST_JSON);
}

#[test]
fn get_full_encounter_condition_list() {
    test_full_list::<EncounterCondition>(FULL_ENCOUNTER_CONDITION_LIST_JSON);
}

#[test]
fn get_full_encounter_condition_value_list() {
    test_full_list::<EncounterConditionValue>(FULL_ENCOUNTER_CONDITION_VALUE_LIST_JSON);
}

#[test]
fn get_full_encounter_method_list() {
    test_full_list::<EncounterMethod>(FULL_ENCOUNTER_METHOD_LIST_JSON);
}

#[test]
fn get_full_evolution_chain_list() {
    test_full_list::<EvolutionChain>(FULL_EVOLUTION_CHAIN_LIST_JSON);
}

#[test]
fn get_full_evolution_trigger_list() {
    test_full_list::<EvolutionTrigger>(FULL_EVOLUTION_TRIGGER_LIST_JSON);
}

#[test]
fn get_full_gender_list() {
    test_full_list::<Gender>(FULL_GENDER_LIST_JSON);
}

#[test]
fn get_full_generation_list() {
    test_full_list::<Generation>(FULL_GENERATION_LIST_JSON);
}

#[test]
fn get_full_growth_rate_list() {
    test_full_list::<GrowthRate>(FULL_GROWTH_RATE_LIST_JSON);
}

#[test]
fn get_full_item_list() {
    test_full_list::<Item>(FULL_ITEM_LIST_JSON);
}

#[test]
fn get_full_item_attribute_list() {
    test_full_list::<ItemAttribute>(FULL_ITEM_ATTRIBUTE_LIST_JSON);
}

#[test]
fn get_full_item_category_list() {
    test_full_list::<ItemCategory>(FULL_ITEM_CATEGORY_LIST_JSON);
}

#[test]
fn get_full_item_fling_effect_list() {
    test_full_list::<ItemFlingEffect>(FULL_ITEM_FLING_EFFECT_LIST_JSON);
}

#[test]
fn get_full_item_pocket_list() {
    test_full_list::<ItemPocket>(FULL_ITEM_POCKET_LIST_JSON);
}

#[test]
fn get_full_language_list() {
    test_full_list::<Language>(FULL_LANGUAGE_LIST_JSON);
}

#[test]
fn get_full_location_list() {
    test_full_list::<Location>(FULL_LOCATION_LIST_JSON);
}

#[test]
fn get_full_location_area_list() {
    test_full_list::<LocationArea>(FULL_LOCATION_AREA_LIST_JSON);
}

#[test]
fn get_full_machine_list() {
    test_full_list::<Machine>(FULL_MACHINE_LIST_JSON);
}

#[test]
fn get_full_move_list() {
    test_full_list::<Move>(FULL_MOVE_LIST_JSON);
}

#[test]
fn get_full_move_ailment_list() {
    test_full_list::<MoveAilment>(FULL_MOVE_AILMENT_LIST_JSON);
}

#[test]
fn get_full_move_battle_style_list() {
    test_full_list::<MoveBattleStyle>(FULL_MOVE_BATTLE_STYLE_LIST_JSON);
}

#[test]
fn get_full_move_category_list() {
    test_full_list::<MoveCategory>(FULL_MOVE_CATEGORY_LIST_JSON);
}

#[test]
fn get_full_move_damage_class_list() {
    test_full_list::<MoveDamageClass>(FULL_MOVE_DAMAGE_CLASS_LIST_JSON);
}

#[test]
fn get_full_move_learn_method_list() {
    test_full_list::<MoveLearnMethod>(FULL_MOVE_LEARN_METHOD_LIST_JSON);
}

#[test]
fn get_full_move_target_list() {
    test_full_list::<MoveTarget>(FULL_MOVE_TARGET_LIST_JSON);
}

#[test]
fn get_full_nature_list() {
    test_full_list::<Nature>(FULL_NATURE_LIST_JSON);
}

#[test]
fn get_full_pal_park_area_list() {
    test_full_list::<PalParkArea>(FULL_PAL_PARK_AREA_LIST_JSON);
}

#[test]
fn get_full_pokeathlon_stat_list() {
    test_full_list::<PokeathlonStat>(FULL_POKEATHLON_STAT_LIST_JSON);
}

#[test]
fn get_full_pokedex_list() {
    test_full_list::<Pokedex>(FULL_POKEDEX_LIST_JSON);
}

#[test]
fn get_full_pokemon_list() {
    test_full_list::<Pokemon>(FULL_POKEMON_LIST_JSON);
}

#[test]
fn get_full_pokemon_color_list() {
    test_full_list::<PokemonColor>(FULL_POKEMON_COLOR_LIST_JSON);
}

#[test]
fn get_full_pokemon_form_list() {
    test_full_list::<PokemonForm>(FULL_POKEMON_FORM_LIST_JSON);
}

#[test]
fn get_full_pokemon_habitat_list() {
    test_full_list::<PokemonHabitat>(FULL_POKEMON_HABITAT_LIST_JSON);
}

#[test]
fn get_full_pokemon_shape_list() {
    test_full_list::<PokemonShape>(FULL_POKEMON_SHAPE_LIST_JSON);
}

#[test]
fn get_full_pokemon_species_list() {
    test_full_list::<PokemonSpecies>(FULL_POKEMON_SPECIES_LIST_JSON);
}

#[test]
fn get_full_region_list() {
    test_full_list::<Region>(FULL_REGION_LIST_JSON);
}

#[test]
fn get_full_stat_list() {
    test_full_list::<Stat>(FULL_STAT_LIST_JSON);
}

#[test]
fn get_full_super_contest_effect_list() {
    test_full_list::<SuperContestEffect>(FULL_SUPER_CONTEST_EFFECT_LIST_JSON);
}

#[test]
fn get_full_type_list() {
    test_full_list::<Type>(FULL_TYPE_LIST_JSON);
}

#[test]
fn get_full_version_list() {
    test_full_list::<Version>(FULL_VERSION_LIST_JSON);
}

#[test]
fn get_full_version_group_list() {
    test_full_list::<VersionGroup>(FULL_VERSION_GROUP_LIST_JSON);
}

// https://pokeapi.co/api/v2/item/?offset=100&limit=10
static ITEM_LIST_JSON_OFFSET_100_LIMIT_10: &str = r#"{"count":954,"next":"https://pokeapi.co/api/v2/item/?offset=110&limit=10","previous":"https://pokeapi.co/api/v2/item/?offset=90&limit=10","results":[{"name":"helix-fossil","url":"https://pokeapi.co/api/v2/item/101/"},{"name":"dome-fossil","url":"https://pokeapi.co/api/v2/item/102/"},{"name":"old-amber","url":"https://pokeapi.co/api/v2/item/103/"},{"name":"armor-fossil","url":"https://pokeapi.co/api/v2/item/104/"},{"name":"skull-fossil","url":"https://pokeapi.co/api/v2/item/105/"},{"name":"rare-bone","url":"https://pokeapi.co/api/v2/item/106/"},{"name":"shiny-stone","url":"https://pokeapi.co/api/v2/item/107/"},{"name":"dusk-stone","url":"https://pokeapi.co/api/v2/item/108/"},{"name":"dawn-stone","url":"https://pokeapi.co/api/v2/item/109/"},{"name":"oval-stone","url":"https://pokeapi.co/api/v2/item/110/"}]}"#;

#[test]
fn get_list() {
    // https://pokeapi.co/api/v2/item/?offset=110&limit=10
    let _m = common::make_mock(
        "/api/v2/item/?offset=100&limit=10",
        ITEM_LIST_JSON_OFFSET_100_LIMIT_10,
    );
    let _ = Item::list(100, 10).unwrap();
}

#[test]
fn get_next_list() {
    // https://pokeapi.co/api/v2/item/?offset=110&limit=10
    static ITEM_LIST_JSON_OFFSET_110_LIMIT_10: &str = r#"{"count":954,"next":"https://pokeapi.co/api/v2/item/?offset=120&limit=10","previous":"https://pokeapi.co/api/v2/item/?offset=100&limit=10","results":[{"name":"odd-keystone","url":"https://pokeapi.co/api/v2/item/111/"},{"name":"adamant-orb","url":"https://pokeapi.co/api/v2/item/112/"},{"name":"lustrous-orb","url":"https://pokeapi.co/api/v2/item/113/"},{"name":"grass-mail","url":"https://pokeapi.co/api/v2/item/114/"},{"name":"flame-mail","url":"https://pokeapi.co/api/v2/item/115/"},{"name":"bubble-mail","url":"https://pokeapi.co/api/v2/item/116/"},{"name":"bloom-mail","url":"https://pokeapi.co/api/v2/item/117/"},{"name":"tunnel-mail","url":"https://pokeapi.co/api/v2/item/118/"},{"name":"steel-mail","url":"https://pokeapi.co/api/v2/item/119/"},{"name":"heart-mail","url":"https://pokeapi.co/api/v2/item/120/"}]}"#;

    let _m = common::make_mock(
        "/api/v2/item/?offset=100&limit=10",
        ITEM_LIST_JSON_OFFSET_100_LIMIT_10,
    );
    let item_list = Item::list(100, 10).unwrap();

    let _m_next = common::make_mock(
        "/api/v2/item/?offset=110&limit=10",
        ITEM_LIST_JSON_OFFSET_110_LIMIT_10,
    );
    let _ = item_list.next_list().unwrap().unwrap();
}

#[test]
fn get_previous_list() {
    // https://pokeapi.co/api/v2/item/?offset=90&limit=10
    static ITEM_LIST_JSON_OFFSET_90_LIMIT_10: &str = r#"{"count":954,"next":"https://pokeapi.co/api/v2/item/?offset=100&limit=10","previous":"https://pokeapi.co/api/v2/item/?offset=80&limit=10","results":[{"name":"star-piece","url":"https://pokeapi.co/api/v2/item/91/"},{"name":"nugget","url":"https://pokeapi.co/api/v2/item/92/"},{"name":"heart-scale","url":"https://pokeapi.co/api/v2/item/93/"},{"name":"honey","url":"https://pokeapi.co/api/v2/item/94/"},{"name":"growth-mulch","url":"https://pokeapi.co/api/v2/item/95/"},{"name":"damp-mulch","url":"https://pokeapi.co/api/v2/item/96/"},{"name":"stable-mulch","url":"https://pokeapi.co/api/v2/item/97/"},{"name":"gooey-mulch","url":"https://pokeapi.co/api/v2/item/98/"},{"name":"root-fossil","url":"https://pokeapi.co/api/v2/item/99/"},{"name":"claw-fossil","url":"https://pokeapi.co/api/v2/item/100/"}]}"#;

    let _m = common::make_mock(
        "/api/v2/item/?offset=100&limit=10",
        ITEM_LIST_JSON_OFFSET_100_LIMIT_10,
    );
    let item_list = Item::list(100, 10).unwrap();

    let _m_previous = common::make_mock(
        "/api/v2/item/?offset=90&limit=10",
        ITEM_LIST_JSON_OFFSET_90_LIMIT_10,
    );
    let _ = item_list.previous_list().unwrap().unwrap();
}
